-- Copyright (C) 2017 McAfee, Inc. All Rights Reserved
if exists (select * from sysobjects where id = object_id(N'[dbo].[EPOEvents_InsertGSDEvent]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[EPOEvents_InsertGSDEvent]
GO
-----------------------------------EPOReports_AddGSDEvent-------------------------------------------

CREATE  PROCEDURE dbo.EPOEvents_InsertGSDEvent
(
	@EventID int,
	@AgentGUID uniqueidentifier,
	@SoftwareName nvarchar(64),
	@SoftwareVersion nvarchar(20),
	@GMTTime datetime,
	@Severity tinyint,
	@ComputerName nvarchar(128),
	@SourceIP int,
	@EngineVersion nvarchar(20),
	@DatVersion nvarchar(20),
	@EngineStatus nvarchar(24),
	@VirusName nvarchar(128),
	@VirusType nvarchar(128),
	@FileName nvarchar(266),
	@UserName nvarchar(128),
	@TaskName nvarchar(128), 
	@ThreatType nvarchar(32),
	@ThreatCategory nvarchar(128),
	@ThreatHandled tinyint,
	@Action nvarchar(24)
)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @AtID INT;
	DECLARE @Analyzer nvarchar(16)
	
	SET @Analyzer = 'MSME____8600'
	
	EXEC EPOEvents_InsertEvent
			DEFAULT,					-- @ServerID nvarchar(16) = 'ePO_SERVERNAME',
			@GMTTime,					-- @DetectedUTC datetime,
			@AgentGUID,					-- @AgentGUID uniqueidentifier,
			
			@Analyzer,					-- @Analyzer nvarchar(16),
			@SoftwareName,				-- @AnalyzerName nvarchar(64),
			@SoftwareVersion,			-- @AnalyzerVersion nvarchar(20),         
			@ComputerName,				-- @AnalyzerHostName nvarchar(128),
			@SourceIP,					-- @AnalyzerIPV4 int,
			DEFAULT,					-- @AnalyzerIPV6 binary(16) = NULL,
			DEFAULT,					-- @AnalyzerMAC nvarchar(16) = NULL,
			@DatVersion,				-- @AnalyzerDATVersion nvarchar(20),
			@EngineStatus,				-- @AnalyzerEngineVersion nvarchar(20),
			
			DEFAULT,					-- @SourceHostName nvarchar(128),
			DEFAULT,					-- @SourceIPV4 int = NULL,
    		DEFAULT,					-- @SourceIPV6 binary(16) = NULL,
    		DEFAULT,					-- @SourceMAC nvarchar(16) = NULL,
    		@VirusType,					-- @SourceUserName nvarchar(128) = NULL,
    		@TaskName,					-- @SourceProcessName nvarchar(128) = NULL,
    		DEFAULT,					-- @SourceURL nvarchar(256) = NULL,
    		
    		DEFAULT,					-- @TargetHostName nvarchar(128) = NULL,
    		DEFAULT,					-- @TargetIPV4 int = NULL,
    		DEFAULT,					-- @TargetIPV6 binary(16) = NULL,
    		DEFAULT,					-- @TargetMAC nvarchar(16) = NULL,
    		@UserName,			-- @TargetUserName nvarchar(128) = NULL,
    		DEFAULT,					-- @TargetPort smallint = NULL,
    		DEFAULT,					-- @TargetProtocol nvarchar(16) = NULL,
    		DEFAULT,					-- @TargetProcessName nvarchar(128) = NULL,
    		@FileName,			-- @TargetFileName nvarchar(266) = NULL,
    		
    		@ThreatCategory,			-- @ThreatCategory nvarchar(128),    ==> @SignatureID???
    		@EventID,			    -- @ThreatEventID int,
    		@VirusName,				-- @ThreatName nvarchar(128),
    		@ThreatType,				-- @ThreatType nvarchar(32),
    		@Severity,			-- @ThreatSeverity tinyint = 1,
    		@Action,			-- @ThreatActionTaken nvarchar(24) = 'none',
    		@ThreatHandled,				-- @ThreatHandled tinyint = 1,
    		
    		@AtID OUTPUT,				-- @AutoID int = NULL ,
    		DEFAULT;					-- @AutoGUID uniqueidentifier = NULL OUTPUT
    		
    	
    	SELECT @AtID AS nResult;	
END
GO