/**
 * FileCategories.js
 * Categorized lists of file types
 *
 * Copyright (C) 2015 McAfee, Inc. All rights reserved.
 */

var fileCats = [];
var subCats = null;

// Documents
fileCats.push({name:"Dokumente", context:"CF", metatag:"FF:DOC:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Microsoft Word", context:"CF", metatag:"FF:DOC:1001"});
subCats.push({name:"Wordstar", context:"F", metatag:""});
subCats.push({name:"WordPerfect", context:"CF", metatag:"FF:DOC:1003"});
subCats.push({name:"Multimate", context:"F", metatag:"FF:DOC:1004"});
subCats.push({name:"IBM DCA/RFT", context:"CF", metatag:"FF:DOC:1005"});
subCats.push({name:"DisplayWrite", context:"CF", metatag:"FF:DOC:1006"});
subCats.push({name:"SmartWare", context:"F", metatag:"FF:DOC:1007"});
subCats.push({name:"Samna", context:"F", metatag:"FF:DOC:1008"});
subCats.push({name:"IBM Writing Assistant", context:"F", metatag:"FF:DOC:1011"});
subCats.push({name:"WordMarc", context:"F", metatag:"FF:DOC:1013"});
subCats.push({name:"Navy DIF", context:"F", metatag:"FF:DOC:1014"});
subCats.push({name:"Volkswriter", context:"F", metatag:"FF:DOC:1015"});
subCats.push({name:"Wang IWP", context:"F", metatag:"FF:DOC:1019"});
subCats.push({name:"Rich Text Format", context:"CF", metatag:"FF:DOC:1020"});
subCats.push({name:"Mass 11 PC", context:"F", metatag:"FF:DOC:1021"});
subCats.push({name:"MacWrite II", context:"F", metatag:"FF:DOC:1022"});
subCats.push({name:"XyWrite / Nota Bene", context:"CF", metatag:"FF:DOC:1023"});
subCats.push({name:"Q&A Write", context:"F", metatag:"FF:DOC:1024"});
subCats.push({name:"Enable WP", context:"F", metatag:"FF:DOC:1027"});
subCats.push({name:"Microsoft Windows Write", context:"CF", metatag:"FF:DOC:1028"});
subCats.push({name:"Microsoft Works", context:"F", metatag:"FF:DOC:1029"});
subCats.push({name:"OfficeWriter", context:"F", metatag:"FF:DOC:1030"});
subCats.push({name:"Ami Pro", context:"CF", metatag:"FF:DOC:1031"});
subCats.push({name:"CEO", context:"F", metatag:"FF:DOC:1035"});
subCats.push({name:"Ichitaro", context:"CF", metatag:"FF:DOC:1036"});
subCats.push({name:"IBM Lotus Symphony Document", context:"F", metatag:"FF:DOC:1043"});
subCats.push({name:"Digital WPS Plus", context:"F", metatag:"FF:DOC:1046"});
subCats.push({name:"Interleaf", context:"F", metatag:"FF:DOC:1048"});
subCats.push({name:"Framemaker", context:"CF", metatag:"FF:DOC:1049"});
subCats.push({name:"vCard", context:"CF", metatag:"FF:DOC:1051"});
subCats.push({name:"Microsoft Outlook (.msg)", context:"CF", metatag:"FF:DOC:1053"});
subCats.push({name:"Extensible Markup Language (XML)", context:"CF", metatag:"FF:DOC:1054"});
subCats.push({name:"StarOffice/OpenOffice Writer", context:"CF", metatag:"FF:DOC:1056"})
subCats.push({name:"OpenOffice Writer / StarOffice Writer (IBM Lotus Symphony)", context:"CF", metatag:"FF:DOC:1066", metatagref:"FF:DOC:1056"});
subCats.push({name:"OpenOffice Writer / StarOffice Writer (Oracle OpenOffice)", context:"CF", metatag:"FF:DOC:1067", metatagref:"FF:DOC:1056"});
subCats.push({name:"XHTML Basic", context:"CF", metatag:"FF:DOC:1059"});
subCats.push({name:"Hangul Word Processor", context:"CF", metatag:"FF:DOC:1062"});
subCats.push({name:"Hangul Word Processor (Arehangeul)", context:"CF", metatag:"FF:DOC:1041", metatagref:"FF:DOC:1062"});
subCats.push({name:"Microsoft Outlook (.pst/.ost)", context:"CF", metatag:"FF:DOC:1063"});
subCats.push({name:"vCalendar", context:"CF", metatag:"FF:DOC:1064"});
subCats.push({name:"Samsung JungUm Global", context:"F", metatag:"FF:DOC:1068"});
//subCats.push({name:"PFS: Write", context:"CF", metatag:"FF:DOC:1009"}); Below ones not supported by CSE 48
//subCats.push({name:"Professional Write", context:"CF", metatag:"FF:DOC:1010"}); 
//subCats.push({name:"First Choice", context:"CF", metatag:"FF:DOC:1012"});
//subCats.push({name:"DEC DX", context:"CF", metatag:"FF:DOC:1016"});
//subCats.push({name:"Sprint", context:"CF", metatag:"FF:DOC:1017"});
//subCats.push({name:"Total Word", context:"CF", metatag:"FF:DOC:1018"});
//subCats.push({name:"PC File", context:"CF", metatag:"FF:DOC:1025"});
//subCats.push({name:"Lotus Manuscript", context:"CF", metatag:"FF:DOC:1026"});
//subCats.push({name:"Legacy", context:"CF", metatag:"FF:DOC:1032"});
//subCats.push({name:"Signature", context:"CF", metatag:"FF:DOC:1033"});
//subCats.push({name:"JustWrite", context:"CF", metatag:"FF:DOC:1034"});
//subCats.push({name:"Matsu", context:"CF", metatag:"FF:DOC:1037"});
//subCats.push({name:"P1 Japan", context:"CF", metatag:"FF:DOC:1038"});
//subCats.push({name:"Microsoft WordPad", context:"CF", metatag:"FF:DOC:1039"});
//subCats.push({name:"Fulcrum Document Format", context:"CF", metatag:"FF:DOC:1040"});
//subCats.push({name:"Hana", context:"CF", metatag:"FF:DOC:1042"});
//subCats.push({name:"Cyrillic Text (ANSI 1251)", context:"C", metatag:"FF:DOC:1044"});
//subCats.push({name:"Cyrillic Text (KOI8-R)", context:"C", metatag:"FF:DOC:1045"});
//subCats.push({name:"Rainbow", context:"CF", metatag:"FF:DOC:1047"});
//subCats.push({name:"Text Mail", context:"CF", metatag:"FF:DOC:1050"});
//subCats.push({name:"HTML - Cascading Style Sheets", context:"CF", metatag:"FF:DOC:1052"});
//subCats.push({name:"Wireless Markup Language (WML)", context:"C", metatag:"FF:DOC:1055"});
//subCats.push({name:"Handheld Device Markup Language (HDML)", context:"CF", metatag:"FF:DOC:1057"});
//subCats.push({name:"Compact HTML (CHTML)", context:"CF", metatag:"FF:DOC:1058"});
//subCats.push({name:"AvantGo HTML", context:"C", metatag:"FF:DOC:1060"});
//subCats.push({name:"Web Clipping Application (WCA) HTML", context:"C", metatag:"FF:DOC:1061"});
//subCats.push({name:"Outlook PAB", context:"F", metatag:"FF:DOC:1065"});

// Databases
fileCats.push({name:"Datenbanken", context:"CF", metatag:"FF:DB:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Smart DataBase", context:"F", metatag:"FF:DB:2001"});
subCats.push({name:"DBase", context:"CF", metatag:"FF:DB:2002"});
subCats.push({name:"Framework III", context:"F", metatag:"FF:DB:2003"});
subCats.push({name:"Microsoft Works DB", context:"F", metatag:"FF:DB:2004"});
subCats.push({name:"Windows Works DB", context:"F", metatag:"FF:DB:2011", metatagref:"FF:DB:2004"});
subCats.push({name:"Paradox", context:"F", metatag:"FF:DB:2006"});
subCats.push({name:"Reflex", context:"CF", metatag:"FF:DB:2008"});
subCats.push({name:"Microsoft Access", context:"CF", metatag:"FF:DB:2012"});
subCats.push({name:"Microsoft Project", context:"CF", metatag:"FF:DB:2014"});
subCats.push({name:"IBM Lotus Notes NSF", context:"F", metatag:"FF:DB:2015"});
subCats.push({name:"IBM Lotus Notes DXL", context:"F", metatag:"FF:DB:2018"});
subCats.push({name:"IBM Lotus Notes DXL (Mail Archive)", context:"F", metatag:"FF:DB:2016", metatagref:"FF:DB:2018"});
subCats.push({name:"IBM Lotus Notes DXL (Mail Message)", context:"F", metatag:"FF:DB:2017", metatagref:"FF:DB:2018"});
//subCats.push({name:"DataEase", context:"CF", metatag:"FF:DB:2005"});Below ones not supported by CSE 48
//subCats.push({name:"Q&A Database", context:"CF", metatag:"FF:DB:2007"});
//subCats.push({name:"R:Base", context:"CF", metatag:"FF:DB:2009"});
//subCats.push({name:"First Choice DB", context:"CF", metatag:"FF:DB:2010"});
//subCats.push({name:"CEO Decision Base", context:"CF", metatag:"FF:DB:2013"});
//subCats.push({name:"Microsoft Access Report Snapshot", context:"F", metatag:"FF:DB:2019"});

// Spreadsheets
fileCats.push({name:"Tabellen", context:"CF", metatag:"FF:SS:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Symphony", context:"F", metatag:"FF:SS:3001"});
subCats.push({name:"Lotus 123", context:"F", metatag:"FF:SS:3002"});
subCats.push({name:"Smart Spreadsheet", context:"F", metatag:"FF:SS:3003"});
subCats.push({name:"Microsoft Excel", context:"CF", metatag:"FF:SS:3004"});
subCats.push({name:"Enable Spreadsheet", context:"F", metatag:"FF:SS:3005"});
subCats.push({name:"Microsoft Works SS", context:"F", metatag:"FF:SS:3006"});
subCats.push({name:"SuperCalc", context:"F", metatag:"FF:SS:3009"});
subCats.push({name:"Quattro Pro", context:"CF", metatag:"FF:SS:3010"});
subCats.push({name:"Multiplan 4.0", context:"F", metatag:"FF:SS:3015"});
subCats.push({name:"OpenOffice Calc/StarOffice Calc", context:"CF", metatag:"FF:SS:3016"});
subCats.push({name:"OpenOffice Calc/StarOffice Calc (IBM Lotus Symphony)", context:"CF", metatag:"FF:SS:3017", metatagref:"FF:SS:3016"});
subCats.push({name:"OpenOffice Calc/StarOffice Calc (Oracle OpenOffice)", context:"CF", metatag:"FF:SS:3018", metatagref:"FF:SS:3016"});
//subCats.push({name:"VP-Planner", context:"CF", metatag:"FF:SS:3007"});Below ones not supported by CSE 48
//subCats.push({name:"Mosaic Twin", context:"CF", metatag:"FF:SS:3008"});
//subCats.push({name:"PFS: Plan", context:"CF", metatag:"FF:SS:3011"});
//subCats.push({name:"First Choice SS", context:"CF", metatag:"FF:SS:3012"});
//subCats.push({name:"Generic WKS", context:"CF", metatag:"FF:SS:3013"});
//subCats.push({name:"CEO Spreadsheet", context:"CF", metatag:"FF:SS:3014"});


// Multimedia
fileCats.push({name:"Multimedia", context:"F", metatag:"FF:MM:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Windows Sound", context:"F", metatag:"FF:MM:4001"});
subCats.push({name:"Windows Video", context:"F", metatag:"FF:MM:4002"});
subCats.push({name:"MIDI File", context:"F", metatag:"FF:MM:4003"});
subCats.push({name:"Macromedia Director", context:"F", metatag:"FF:MM:4004"});
subCats.push({name:"Macromedia Flash", context:"CF", metatag:"FF:MM:4005"});
subCats.push({name:"Quicktime/3GPP", context:"F", metatag:"FF:MM:4006"});
subCats.push({name:"Quicktime/3GPP (ISO Base Media File)", context:"F", metatag:"FF:MM:4011", metatagref:"FF:MM:4006"});
subCats.push({name:"MP3", context:"F", metatag:"FF:MM:4007"});
subCats.push({name:"MPEG/3GPP", context:"F", metatag:"FF:MM:4008"});
subCats.push({name:"Advanced System Format (ASF)", context:"F", metatag:"FF:MM:4009"});
subCats.push({name:"Real Audio/Video", context:"F", metatag:"FF:MM:4010"});
//subCats.push({name:"Windows Media Playlist", context:"F", metatag:"FF:MM:4012"});Not supported by CSE 48

// Graphics/Presentation
fileCats.push({name:"Grafiken/Präsentation", context:"CF", metatag:"FF:IMG:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Windows Bitmap", context:"F", metatag:"FF:IMG:5001"});
subCats.push({name:"Bitmap (OS/2)", context:"F", metatag:"FF:IMG:5015", metatagref:"FF:IMG:5001"});
subCats.push({name:"Tagged Image File Format", context:"F", metatag:"FF:IMG:5002"});
subCats.push({name:"Paintbrush", context:"F", metatag:"FF:IMG:5003"});
subCats.push({name:"Paintbrush (Multipage PCX)", context:"F", metatag:"FF:IMG:5025", metatagref:"FF:IMG:5003"});
subCats.push({name:"Compuserve GIF", context:"F", metatag:"FF:IMG:5004"});
subCats.push({name:"Post Script EPS (TIFF Header)", context:"F", metatag:"FF:IMG:5005"});
subCats.push({name:"Post Script", context:"F", metatag:"FF:IMG:5051", metatagref:"FF:IMG:5005"});
subCats.push({name:"CCITT Group 3 Fax", context:"F", metatag:"FF:IMG:5006"});
subCats.push({name:"Mac PICT", context:"F", metatag:"FF:IMG:5007"});
subCats.push({name:"Mac PICT (PICT2)", context:"F", metatag:"FF:IMG:5011", metatagref:"FF:IMG:5007"});
subCats.push({name:"WordPerfect Graphic", context:"F", metatag:"FF:IMG:5008"});
subCats.push({name:"Windows Metafile", context:"CF", metatag:"FF:IMG:5009"});
subCats.push({name:"Lotus PIC", context:"CF", metatag:"FF:IMG:5010"});
subCats.push({name:"Ami Draw", context:"F", metatag:"FF:IMG:5012"});
subCats.push({name:"Targa", context:"F", metatag:"FF:IMG:5013"});
subCats.push({name:"GEM Image", context:"F", metatag:"FF:IMG:5014"});
subCats.push({name:"GEM Image (Vector)", context:"F", metatag:"FF:IMG:5038", metatagref:"FF:IMG:5014"});
subCats.push({name:"Windows Icon", context:"F", metatag:"FF:IMG:5016"});
subCats.push({name:"Windows Cursor", context:"F", metatag:"FF:IMG:5017"});
subCats.push({name:"Micrografx Windows product", context:"F", metatag:"FF:IMG:5018"});
subCats.push({name:"MacPaint", context:"F", metatag:"FF:IMG:5019"});
subCats.push({name:"Corel Draw", context:"F", metatag:"FF:IMG:5020"});
subCats.push({name:"CorelDraw (ClipArt)", context:"F", metatag:"FF:IMG:5047", metatagref:"FF:IMG:5020"});
subCats.push({name:"Microsoft PowerPoint", context:"CF", metatag:"FF:IMG:5021"});
subCats.push({name:"Harvard Graphics Chart", context:"F", metatag:"FF:IMG:5022"});
subCats.push({name:"Freelance", context:"F", metatag:"FF:IMG:5024"});
subCats.push({name:"OS/2 Metafile", context:"F", metatag:"FF:IMG:5026"});
subCats.push({name:"AutoCAD", context:"CF", metatag:"FF:IMG:5027"});
subCats.push({name:"Corel Presentations", context:"F", metatag:"FF:IMG:5031"});
subCats.push({name:"Adobe Acrobat (PDF)", context:"CF", metatag:"FF:IMG:5032"});
subCats.push({name:"Adobe PDF (Adobe Illustrator)", context:"F", metatag:"FF:IMG:5030", metatagref:"FF:IMG:5032"});
subCats.push({name:"Adobe PDF (Image)", context:"F", metatag:"FF:IMG:5063", metatagref:"FF:IMG:5032"});
subCats.push({name:"Framemaker", context:"F", metatag:"FF:IMG:5033"});
subCats.push({name:"RAS - Sun Raster", context:"F", metatag:"FF:IMG:5034"});
subCats.push({name:"AutoShade Rendering", context:"F", metatag:"FF:IMG:5035"});
subCats.push({name:"Kodak Photo CD", context:"F", metatag:"FF:IMG:5036"});
subCats.push({name:"Enhanced Windows Metafile", context:"CF", metatag:"FF:IMG:5037"});
subCats.push({name:"Harvard Graphics for Windows", context:"F", metatag:"FF:IMG:5039"});
subCats.push({name:"X-Windows Bitmap", context:"F", metatag:"FF:IMG:5042"});
subCats.push({name:"X-Windows Pixmap", context:"F", metatag:"FF:IMG:5043"});
subCats.push({name:"Portable Network Graphics Format", context:"F", metatag:"FF:IMG:5045"});
subCats.push({name:"Micrografx Designer", context:"F", metatag:"FF:IMG:5050"});
subCats.push({name:"Micrografx Designer (Older versions)", context:"F", metatag:"FF:IMG:5062", metatagref:"FF:IMG:5050"});
subCats.push({name:"Visio", context:"CF", metatag:"FF:IMG:5052"});
subCats.push({name:"PBM (Portable Bitmap)", context:"F", metatag:"FF:IMG:5053"});
subCats.push({name:"PGM (Portable Graymap)", context:"F", metatag:"FF:IMG:5054"});
subCats.push({name:"PPM (Portable Pixmap)", context:"F", metatag:"FF:IMG:5055"});
subCats.push({name:"Adobe Photoshop", context:"F", metatag:"FF:IMG:5056"});
subCats.push({name:"Kodak FlashPix", context:"F", metatag:"FF:IMG:5058"});
subCats.push({name:"Bentley Microstation DGN", context:"F", metatag:"FF:IMG:5059"});
subCats.push({name:"StarOffice/OpenOffice Impress", context:"CF", metatag:"FF:IMG:5064"});
subCats.push({name:"StarOffice/OpenOffice Impress (Oracle)", context:"CF", metatag:"FF:IMG:5078", metatagref:"FF:IMG:5064"});
subCats.push({name:"Quark Express", context:"F", metatag:"FF:IMG:5065"});
subCats.push({name:"Adobe Acrobat JBIG2 Embeddings", context:"CF", metatag:"FF:IMG:5066"});
subCats.push({name:"Microsoft XPS", context:"CF", metatag:"FF:IMG:5067"});
subCats.push({name:"Efax", context:"F", metatag:"FF:IMG:5069"});
subCats.push({name:"StarOffice/OpenOffice Draw", context:"CF", metatag:"FF:IMG:5070"});
subCats.push({name:"StarOffice/OpenOffice Draw (Oracle)", context:"CF", metatag:"FF:IMG:5079", metatagref:"FF:IMG:5070"});
subCats.push({name:"HP Graphics Language", context:"F", metatag:"FF:IMG:5071"});
subCats.push({name:"JPEG 2000", context:"F", metatag:"FF:IMG:5073"});
subCats.push({name:"Microsoft Publisher", context:"CF", metatag:"FF:IMG:5075"});
subCats.push({name:"JPEG", context:"F", metatag:"FF:IMG:5080"});
//subCats.push({name:"Harvard Presentation", context:"F", metatag:"FF:IMG:5023"});Below ones not supported by CSE 48
//subCats.push({name:"WordPerfect Presentations", context:"F", metatag:"FF:IMG:5028"});
//subCats.push({name:"OS/2 Warp Bitmap", context:"F", metatag:"FF:IMG:5029"});
//subCats.push({name:"IGES Drawing File Format", context:"F", metatag:"FF:IMG:5040"});
//subCats.push({name:"IBM Picture Interchange Format", context:"F", metatag:"FF:IMG:5041"});
//subCats.push({name:"CALS Raster File Format", context:"F", metatag:"FF:IMG:5044"});
//subCats.push({name:"X-Windows Dump", context:"F", metatag:"FF:IMG:5046"});
//subCats.push({name:"HP Gallery", context:"F", metatag:"FF:IMG:5048"});
//subCats.push({name:"Graphics Data Format", context:"F", metatag:"FF:IMG:5049"});
//subCats.push({name:"Paint Shop Pro", context:"F", metatag:"FF:IMG:5057"});
//subCats.push({name:"Wireless Bitmap", context:"F", metatag:"FF:IMG:5060"});
//subCats.push({name:"MIFF Graphic", context:"F", metatag:"FF:IMG:5061"});
//subCats.push({name:"Starview Metafile", context:"F", metatag:"FF:IMG:5068"});
//subCats.push({name:"AutoDesk DWF", context:"F", metatag:"FF:IMG:5072"});
//subCats.push({name:"Adobe InDesign", context:"F", metatag:"FF:IMG:5074"});
//subCats.push({name:"IBM Lotus Symphony Presentation", context:"CF", metatag:"FF:IMG:5076"});
//subCats.push({name:"Oracle Multimedia Raw Pixel (RPIX) Format", context:"F", metatag:"FF:IMG:5077"});


// Other specific formats
fileCats.push({name:"Andere spezielle Formate", context:"F", metatag:"FF:OTR:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Windows Executables", context:"F", metatag:"FF:OTR:6001"});
subCats.push({name:"Envoy", context:"F", metatag:"FF:OTR:6003"});
subCats.push({name:"Envoy 7", context:"F", metatag:"FF:OTR:6006", metatagref:"FF:OTR:6003"});
subCats.push({name:"StuffIt", context:"F", metatag:"FF:OTR:6007"});
subCats.push({name:"Java Class", context:"F", metatag:"FF:OTR:6008"});
//subCats.push({name:"Microsoft InfoPath", context:"F", metatag:"FF:OTR:6009"});
//subCats.push({name:"MS Office Binder", context:"F", metatag:"FF:OTR:6002"});Below ones not supported by CSE 48
//subCats.push({name:"QuickFinder", context:"F", metatag:"FF:OTR:6004"});
//subCats.push({name:"Windows Clipboard File", context:"F", metatag:"FF:OTR:6005"});
subCats.push({name:"Microsoft OneNote", context:"F", metatag:"FF:OTR:6010"});


// Archive/Compressed files
fileCats.push({name:"Archiv-/Komprimierte Dateien", context:"F", metatag:"ARCHIVE:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"ACE", context:"F", metatag:"ARCHIVE:ACE"});
subCats.push({name:"ARJ", context:"F", metatag:"ARCHIVE:ARJ"});
subCats.push({name:"Unix gzip", context:"F", metatag:"ARCHIVE:GZIP"});
subCats.push({name:"LZH/LHA", context:"F", metatag:"ARCHIVE:LHA"});
subCats.push({name:"PKArc", context:"F", metatag:"ARCHIVE:PKARC"});
subCats.push({name:"RAR", context:"F", metatag:"ARCHIVE:RAR"});
subCats.push({name:"Tar", context:"F", metatag:"ARCHIVE:TAR"});
subCats.push({name:"Unix Z Compression", context:"F", metatag:"ARCHIVE:Z"});
subCats.push({name:"Zip", context:"F", metatag:"ARCHIVE:ZIP"});
subCats.push({name:"7z", context:"F", metatag:"ARCHIVE:7ZIP"});


// E-Mail messages
fileCats.push({name:"E-Mail-Nachrichten", context:"C", metatag:"MAILMSG:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Text attachments", context:"C", metatag:"MAILMSG:ATT"});
subCats.push({name:"Body", context:"C", metatag:"MAILMSG:BODY"});
subCats.push({name:"Epilogue", context:"C", metatag:"MAILMSG:EPILOGUE"});
subCats.push({name:"Attachment file name", context:"C", metatag:"MAILMSG:FNAME"});
subCats.push({name:"All Headers", context:"C", metatag:"MAILMSG:HDR"});
subCats.push({name:"MIME Mail Messages", context:"C", metatag:"MAILMSG:MIME"});
subCats.push({name:"Preamble", context:"C", metatag:"MAILMSG:PREAMBLE"});
subCats.push({name:"Recipients", context:"C", metatag:"MAILMSG:RCP"});
subCats.push({name:"Sender", context:"C", metatag:"MAILMSG:SNDR"});
subCats.push({name:"Subject line", context:"C", metatag:"MAILMSG:SUBJ"});
subCats.push({name:"Microsoft TNEF (Rich Text) Messages", context:"C", metatag:"MAILMSG:TNEF"});
subCats.push({name:"Signature", context:"C", metatag:"MAILMSG:SIG"});
subCats.push({name:"Envelope From", context:"C", metatag:"MAILMSG:ENVELOPE:ENVFROM"});
subCats.push({name:"Envelope To", context:"C", metatag:"MAILMSG:ENVELOPE:ENVTO"});
subCats.push({name:"Envelope Connection IP", context:"C", metatag:"MAILMSG:ENVELOPE:ENVIP"});

// Message Formats
fileCats.push({name:"Nachrichtenformate", context:"F", metatag:"MAILMSG:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"MIME Based Attachments", context:"F", metatag:"MAILMSG:MIME"});
subCats.push({name:"Microsoft TNEF (Rich Text) Messages", context:"F", metatag:"MAILMSG:TNEF"});

// HTML content
fileCats.push({name:"HTML-Inhalt", context:"CF", metatag:"HTML:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"HTML Files", context:"F", metatag:"HTML:HTML"});
subCats.push({name:"Comment", context:"C", metatag:"HTML:HTML-CMT"});
subCats.push({name:"Meta data", context:"C", metatag:"HTML:HTML-META"});
subCats.push({name:"Script block", context:"C", metatag:"HTML:HTML-SCRIPT"});
subCats.push({name:"Text", context:"C", metatag:"HTML:HTML-TXT"});
subCats.push({name:"URL", context:"C", metatag:"HTML:HTML-URL"});
subCats.push({name:"Raw HTML", context:"C", metatag:"HTML:HTML-RAW"});

// UUE and BASE64 encoded files
fileCats.push({name:"UUE- und BASE64-codierte Dateien", context:"F", metatag:"UUEFILE:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"Standalone UUEncoded/Base64 files", context:"F", metatag:"UUEFILE:UUEFILE"});

// McAfee virus definition file
fileCats.push({name:"McAfee-Virusdefinitionsdatei", context:"F", metatag:"MAGICBYTE:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"McAfee Virus Definition File", context:"F", metatag:"MAGICBYTE:OLYMPUSDRIVER"});


// General text formats
fileCats.push({name:"Allgemeine Textformate", context:"CF", metatag:"FF:TXT:", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
subCats.push({name:"General text formats", context:"CF", metatag:"FF:TXT:GENERAL_TEXT"});

// Everything
fileCats.push({name:"Alles", context:"C", metatag:"ALL", subcats:[]});
subCats = fileCats[fileCats.length - 1].subcats;
