//
// PolicyRes.js
// String resources for CSE policy management and settings pages.
//
// Copyright (C) 2005 McAfee, Inc. All rights reserved.
//

// The following string table is for settings the display names of built-in PolicySet
var cse_pp_ps_st = new Object();
cse_pp_ps_st["__default"] = "Email Policies (SMTP)";
cse_pp_ps_st["on_access"] = "On-Access Policies";
cse_pp_ps_st["od_default"] = "On-Demand (Default)";
cse_pp_ps_st["od_findviruses"] = "On-Demand (Find Viruses)";
cse_pp_ps_st["od_removeviruses"] = "On-Demand (Remove Viruses)";
cse_pp_ps_st["od_find_bannedcontent"] = "On-Demand (Find Non-Compliant Content)";
cse_pp_ps_st["od_remove_bannedcontent"] = "On-Demand (Remove Non-Compliant Content)";
cse_pp_ps_st["od_fullscan"] = "On-Demand (Full Scan)";
cse_pp_ps_st["outbreakmanager"] = "Outbreak Manager Policies";
cse_pp_ps_st["gateway"] = "Gateway Policies";

// The following string table is for settings the names of built-in
// policies, services and settings blobs in CSE config
var cse_pp_st = new Object();

// Type strings
cse_pp_st["AV"] = "Anti-Virus Scanner";
cse_pp_st["AS"] = "Anti-Spam";
cse_pp_st["AF"] = "Anti-Phishing";
cse_pp_st["SS"] = "Scanner Control";
cse_pp_st["CS"] = "DLP and Compliance Scanner";
cse_pp_st["FF"] = "File Filtering";
cse_pp_st["URL"] = "URL-Filtering";
cse_pp_st["SM"] = "Signed Content";
cse_pp_st["EM"] = "Encrypted Content";
cse_pp_st["PM"] = "Protected Content";
cse_pp_st["CM"] = "Corrupt Content";
cse_pp_st["PPF"] = "Password-Protected Files";
cse_pp_st["ALERT"] = "Alert Settings";
cse_pp_st["DISC"] = "Disclaimer Text";
cse_pp_st["MF"] = "Mail Size Filtering";
cse_pp_st["MIME"] = "MIME Mail Settings";
cse_pp_st["HTML"] = "HTML Files";
cse_pp_st["MAILURL"] = cse_pp_st["MailURL"] = "Mail URL Reputation";
cse_pp_st["PX"] = "Email Compliancy";

//some more predefined display names for policies
cse_pp_st["__from_inside"] = "From Inside";
cse_pp_st["__from_outside"] = "From Outside";
cse_pp_st["__on_access"] = "On Access";
cse_pp_st["__on_demand"] = "On Demand";
cse_pp_st["__default"] = "Default";
cse_pp_st["__smtp"] = "SMTP";
cse_pp_st["__http"] = "HTTP";
cse_pp_st["__ftp"] = "FTP";
cse_pp_st["__pop3"] = "POP3";
cse_pp_st["__icap"] = "ICAP";


//General Purpose strings (in alphabetical order)
cse_pp_st["__actions"] = " Actions";
cse_pp_st["__alerts"] = " Alerts";
cse_pp_st["__alert_selection"] = " Alert selection";
cse_pp_st["__alert_settings"] = " Alert Settings";
cse_pp_st["__change"] = "Change";
cse_pp_st["__create"] = "Create";
cse_pp_st["__delete"] = "Delete";
cse_pp_st["__edit"] = "Edit";
cse_pp_st["__enabled"] = "Enabled";
cse_pp_st["__html"] = "HTML";
cse_pp_st["__name"] = "Name";
cse_pp_st["__no"] = "No";
cse_pp_st["__none"] = "None";
cse_pp_st["__notapplicable"] = "N/A";
cse_pp_st["__nothing_to_display"] = "Nothing to display";
cse_pp_st["__plain_text"] = "Plain text";
cse_pp_st["__rename"] = "Rename";
cse_pp_st["__save_cse_prompt"] = "Please save or cancel the changes on this page";
cse_pp_st["__selectOne"] = "Select one";
cse_pp_st["__selectMulti"] = "Select one or more";
cse_pp_st["__view_hide"] = "View / Hide";
cse_pp_st["__yes"] = "Yes";


// Master Policy vs. Sub Policy title, used for table headers, selection labels and breadcrumbs
cse_pp_st["__master_policy"] = "Master policy";
cse_pp_st["__policy"] = "Policy";
cse_pp_st["__sub_policy"] = "Sub Policy";
cse_pp_st["__parent_policy"] = "Parent Policy";
cse_pp_st["__policy_details"] = "Details";
cse_pp_st["__set_title1"] = "Master policy and sub-policies";
cse_pp_st["__set_title2"] = "List of policies sorted by priority";
cse_pp_st["__priority"] = "Priority";
cse_pp_st["__move"] = "Move";
cse_pp_st["__active"] = "Active";
cse_pp_st["__inherits"] = "Inherits";
cse_pp_st["__default_applies"] = "This policy applies by default if no sub-policy applies";
cse_pp_st["__always_applies"] = "This policy applies to everyone";

cse_pp_st["__parameters"] = "Parameters";
cse_pp_st["__settings_list"] = "list of settings";
cse_pp_st["__users"] = "users";
cse_pp_st["__select_policy"] = "Policy";
cse_pp_st["__select_settings"] = "Selection";
cse_pp_st["__select_options"] = "Options";
cse_pp_st["__rules"] = "Rules";
cse_pp_st["__create_instance"] = "create new set of options";
cse_pp_st["__new_settings"] = "New Settings";
cse_pp_st["__add_new_rule"] = "Add rule";
cse_pp_st["__rule"] = "Rule";
cse_pp_st["__rules_group"] = "Rules group";


// Various Strings for the policy pages
cse_pp_st["__delete_policy_prompt"] = "Deleting policy %1 ?"
cse_pp_st["__delete_scanner_prompt"] = "Deleting scanner %1 ?"
cse_pp_st["__delete_rule_prompt"] = "Deleting this rule?"
cse_pp_st["__select_rule_prompt"] = "Please select a rule";
cse_pp_st["__rest_of_time"] = "All the time except when specified below";
cse_pp_st["__master_policy_descr"] = "Master policy, used by default if no sub-policy applies";
cse_pp_st["__what_time"] = " What time would you like this to apply";
cse_pp_st["__time_clash"] = "Settings are already defined for this period of time"
cse_pp_st["RefRuleGroup"] = "Rules group: "
cse_pp_st["RefRule"] = "Rule: "

//table headers for the settings list page
cse_pp_st["__basic_settings"] = " Core Scanners";
cse_pp_st["__filters_settings"] = " Filters";
cse_pp_st["__miscellaneous"] = " Miscellaneous";

// Action page or table title
cse_pp_st["ACT_PAGE_TITLE"] = "%1 Actions";
cse_pp_st["MIME_ACT_PAGE_TITLE"] = "Incomplete Message Actions";

// Action table title
cse_pp_st["ACTTITLE_AF"] = cse_pp_st["ACTTITLE_SS"] = cse_pp_st["ACTTITLE_SM"] =
    cse_pp_st["ACTTITLE_EM"] = cse_pp_st["ACTTITLE_PM"] = cse_pp_st["ACTTITLE_CM"] =
    cse_pp_st["ACTTITLE_PPF"] = cse_pp_st["ACTTITLE_MF"] = "Actions";
cse_pp_st["ACTTITLE_AV"] = "Actions to take";
cse_pp_st["ACTTITLE_AS"] = "Actions to take if spam is detected";
cse_pp_st["ACTTITLE_CS"] = "DLP and Compliance rules and associated actions";
cse_pp_st["ACTTITLE_MIME"] = "Incomplete message actions";
cse_pp_st["ACTTITLE_PX"] = "If non-compliant email is detected";
cse_pp_st["ACTTITLE_MailURL"] = "Actions to take";

//Action labels
// Format: "ACT_" + settingtype + pptempleave  [+ "_" + additional number]
cse_pp_st["ACT_AV_Action"] = "If a virus or trojan is found";
cse_pp_st["ACT_AV_Action_1"] = "&nbsp; &nbsp; If cleaning succeeds";
cse_pp_st["ACT_AV_Action_2"] = "&nbsp; &nbsp; If cleaning fails";
cse_pp_st["ACT_AV_MaliciousActions"] = "Alternative action for custom malware categories";
cse_pp_st["ACT_AV_PackerActions"] = " Action if a packer is found";
cse_pp_st["ACT_AV_PupActions"] = " Action if a potentially unwanted program is found";
cse_pp_st["ACT_AS_Action"] = "If spam score is %1";
cse_pp_st["ACT_AS_Score"] = "If spam score is at least";
cse_pp_st["ACT_AS_Thresholds"] = "High=%1, Medium=%2, Low=%3,  Reporting=%4";
cse_pp_st["ACT_AF_Action"] = "When a possible phishing message is detected";
cse_pp_st["ACT_SS_MaxDepthAction"] = "When the maximum nesting level is exceeded";
cse_pp_st["ACT_SS_MaxWidthAction"] = "When the maximum file size is exceeded";
cse_pp_st["ACT_SS_TimeoutAction"] = "When the maximum scanning time is exceeded";
cse_pp_st["ACT_SM_SignedMailAction"] = "When signed content is detected";
cse_pp_st["ACT_EM_EncryptedObjAction"] = "When encrypted content is detected";
cse_pp_st["ACT_PM_ProtectedObjAction"] = "When protected content is detected";
cse_pp_st["ACT_CM_CorruptedObjAction"] = "When corrupt content is detected";
cse_pp_st["ACT_PPF_PwdProtectedObjAction"] = "When a password-protected file is found";
cse_pp_st["ACT_MF_MaxSizeAction"] = "When the maximum message size is exceeded";
cse_pp_st["ACT_MF_BiggerThanAction"] = "When the maximum attachment size is exceeded";
cse_pp_st["ACT_MF_MoreThanAction"] = "When the maximum number of attachments is exceeded";
cse_pp_st["ACT_MIME_BlockExternal"] = "When a message/external MIME type is encountered";
cse_pp_st["ACT_MIME_BlockPartial"] = "When a message/partial MIME type is encountered";
cse_pp_st["ACT_MAILURL_HighThresholdAction"] = cse_pp_st["ACT_MailURL_HighThresholdAction"] = "When Mail URL reputation score is above the higher threshold";
cse_pp_st["ACT_MAILURL_LowThresholdAction"] = cse_pp_st["ACT_MailURL_LowThresholdAction"] = "When Mail URL reputation score is above the lower threshold";
cse_pp_st["ACT_MAILURL_MAXURLExceededAction"] = cse_pp_st["ACT_MailURL_MAXURLExceededAction"] = "When Mail URL lookup count exceeds the limit";
cse_pp_st["__alert"] = "Alert";
cse_pp_st["__custom"] = "Custom";
cse_pp_st["ACT_PX_ActionHIPAA"] = "HIPAA threshold exceeded";
cse_pp_st["ACT_PX_ActionPrivacy"] = "Privacy threshold exceeded";

//Options labels for Anti virus
cse_pp_st["OPT_AVP_SCANWHAT_ALL"] = "All files";
cse_pp_st["OPT_AVP_SCANWHAT_DEFAULT"] = "Default file types";
cse_pp_st["OPT_AVP_SCANWHAT_SELECTED"] = "Defined file types";
cse_pp_st["OPT_AVP_DECOMPARCHIVES"] = "Scan archive files (ZIP, ARJ, RAR ...) ";
cse_pp_st["OPT_AVP_HEURISTICANALYSIS"] = "Find unknown file viruses";
cse_pp_st["OPT_AVP_MACROANALYSIS"] = "Find unknown macro viruses";
cse_pp_st["OPT_ArtemisSensitivityLevel"] = "Enable McAfee Global Threat Intelligence file reputation";
cse_pp_st["OPT_AVP_SCANALLMACROS"] = "Scan all files for macros";
cse_pp_st["OPT_AVP_FINDALLMACROS"] = "Find all macros and treat as infected";
cse_pp_st["OPT_AVP_DELETEALLMACROS"] = "Remove all macros from document files";

//Options labels for Special Cases Malware
cse_pp_st["OPT_BackdoorProtection"] = "Backdoor access";
cse_pp_st["OPT_DropperProtection"] = "Droppers";
cse_pp_st["OPT_DownloaderProtection"] = "Downloaders";
cse_pp_st["OPT_HtmlProtection"] = "Malicious HTML";
cse_pp_st["OPT_IrcProtection"] = "Internet relay chat";
cse_pp_st["OPT_JscriptProtection"] = "Malicious JavaScript";
cse_pp_st["OPT_MassMailerProtection"] = "Mass mailers";
cse_pp_st["OPT_PasswordStealerProtection"] = "Password stealers";
cse_pp_st["OPT_ProxyProtection"] = "Malicious proxies";
cse_pp_st["OPT_ReplyMailerProtection"] = "Reply mailers";
cse_pp_st["OPT_TrojanProtection"] = "Trojans";
cse_pp_st["OPT_WormProtection"] = "Worms";

//Options labels for pup and packers
cse_pp_st["__none_specified"] = "None specified";
cse_pp_st["__no_detection"] = "Detection Disabled";

cse_pp_st["OPT_PUP_SPYWARE"] = "Spyware";
cse_pp_st["OPT_PUP_SPYWARE"] = "Spyware";
cse_pp_st["OPT_PUP_ADWARE"] = "Adware";
cse_pp_st["OPT_PUP_REMOTE_ADMIN"] = "Remote Administration Tools";
cse_pp_st["OPT_PUP_DIALERS"] = "Dialers";
cse_pp_st["OPT_PUP_PWD_CRACKERS"] = "Password Crackers";
cse_pp_st["OPT_PUP_JOKE_PROGRAMS"] = "Jokes";
cse_pp_st["OPT_PUP_COOKIES"] = "Cookies";
cse_pp_st["OPT_PUP_OTHER"] = "Other potentially unwanted programs";
cse_pp_st["OPT_PCK_DETECT"] = "Detect";
cse_pp_st["OPT_PCK_EXCLUDE"] = "Exclude";

//Options labels for Anti spam
cse_pp_st["Low"] = "Low";
cse_pp_st["Med"] = "Medium";
cse_pp_st["High"] = "High";
cse_pp_st["Custom"]= "Custom";
cse_pp_st["Never"]= "Never";
cse_pp_st["Always"]= "Always";
cse_pp_st["SpamOnly"]= "to spam only";
cse_pp_st["NonSpamOnly"]= "to non-spam only ";
cse_pp_st["OPT_VERBOSE"] = "Verbose reporting";
cse_pp_st["OPT_WLST"] = "%1 sender(s) and %2 recipient(s) in whitelist";
cse_pp_st["OPT_BLST"] = "%1 sender(s) and %2 recipient(s) in blacklist";

// Option strings for anti-phishing
cse_pp_st["AF_SP_YES"] = "Yes, \"%1\"";
cse_pp_st["AF_SP_NO"] = "No";
cse_pp_st["PINDICATOR"] = "Phish indicator added to messages";
cse_pp_st["PREPORT"] = "Phish report attached to mail";
cse_pp_st["OO_NONE"] = "None";
cse_pp_st["S_PREFIX"] = "Add subject prefix";
cse_pp_st["OTHER_OPTS"] = "Other options";

//Options strings for scanner control
cse_pp_st["OPT_maxdepth"] = "Maximum nesting level";
cse_pp_st["OPT_maxwidth"] = "Maximum expanded file size (MB)";
cse_pp_st["OPT_ScannerTimeout"] = "Maximum scanning time (minutes)";

// Options strings for alert settings
cse_pp_st["OPT_PlainText"] = "Alert format";
cse_pp_st["OPT_Charset"] = "Character encoding";
cse_pp_st["OPT_ASCIIFILENAME"] = "Alert filename";
cse_pp_st["OPT_ALERTHEADER"] = "Alert header";
cse_pp_st["OPT_ALERTFOOTER"] = "Alert footer";
cse_pp_st["__default_ALERTHEADER"] = "Default header";
cse_pp_st["__default_ALERTFOOTER"] = "Default footer";
cse_pp_st["__custom_ALERTHEADER"] = "Custom header";
cse_pp_st["__custom_ALERTFOOTER"] = "Custom footer";
cse_pp_st["__default"] = "Default alert";

// Options strings for disclaimer text
cse_pp_st["__disclaimer_header"] = "Edit Disclaimer content:";
cse_pp_st["OPT_DisclaimerText"] = "Disclaimer Text";
cse_pp_st["OPT_DisclaimerType"] = "Disclaimer Placement";
cse_pp_st["OPT_UseHTML"] = "Disclaimer Format";
cse_pp_st["DisclaimerType1"] = "Before any message text";
cse_pp_st["DisclaimerType2"] = "After any message text";
cse_pp_st["DisclaimerType3"] = "As an attachment to a message";

// Options strings for mail size filtering
cse_pp_st["OPT_MaxSize"] = "Maximum overall message size (KB)";
cse_pp_st["OPT_BiggerThanVal"] = "Maximum attachment size (KB)";
cse_pp_st["OPT_MoreThanVal"] = "Maximum number of attachments";

// Option strings for mail settings
cse_pp_st["OPT_ModSubjPrefix"] = "Subject prefix";
cse_pp_st["__msg_corruption"] = "Message corruption:";
cse_pp_st["OPT_HdrCorruptionCheck"] = "Header corruption";
cse_pp_st["OPT_QPCorruptionDetection"] = "Quoted-printable character encoding corruption:";

cse_pp_st["OPT_HdrNULLCheck"] = "NULL characters in headers";
cse_pp_st["OPT_MaxBoundariesExceededAsDoS"] = "MIME boundaries > %1";
cse_pp_st["__treat_as_corrupt"] = "Treat as corrupt content";
cse_pp_st["__do_not_treat_as_corrupt"] = "Do not treat as corrupt content";
cse_pp_st["__treat_as_DoS"] = "Treat as a potential denial of service attack";
cse_pp_st["__mail_encoding"] = "Mail encoding:";
cse_pp_st["OPT_ReEncodingScheme"] = "Modified attachments";
cse_pp_st["OPT_HeaderEncodingScheme"] = "Modified headers";
cse_pp_st["__reencode_original"] = "Use the original encoding (%1)";
cse_pp_st["__reencode_html"] = "Use HTML and numeric references";
cse_pp_st["__reencode_charset"] = "Use %2 (%1)";
cse_pp_st["__h_reencode_original"] = "Use the original encoding (%1)";
cse_pp_st["__h_reencode_charset"] = "Use %2 (%1)";
cse_pp_st["__h_reencode_utf8"] = "Use UTF-8 (%1)";
cse_pp_st["__invalid_encoding_value"] = "Unrecognized encoding scheme";
cse_pp_st["__fail_on_err"] = "fail on error";
cse_pp_st["__utf8_on_err"] = "use UTF-8 on error";
cse_pp_st["OPT_InlineReplacementText"] = "Alert and disclaimer attachments"
cse_pp_st["__inline_yes"] = "Inline attachments where possible";
cse_pp_st["__inline_no"] = "Do not inline attachments";
cse_pp_st["__onemapping"] = "1 character set mapping defined";
cse_pp_st["__nmappings"] = "%1 character set mappings defined";

// Option strings for HTML files
cse_pp_st["__scan_elements"] = "Elements to scan";
cse_pp_st["__strip_elements"] = "Executable elements to remove";
cse_pp_st["OPT_ScanComments"] = "Comments";
cse_pp_st["OPT_ScanLinkURLs"] = "Link URLs";
cse_pp_st["OPT_ScanSourceURLs"] = "Source URLs";
cse_pp_st["OPT_ScanMetaData"] = "Metadata";
cse_pp_st["OPT_ScanScript"] = "Script";
cse_pp_st["OPT_StripScript"] = cse_pp_st["OPT_ScanScript"];
cse_pp_st["OPT_StripApplets"] = "Java applets";
cse_pp_st["OPT_StripActiveX"] = "ActiveX controls";
cse_pp_st["OPT_StripFlash"] = "Macromedia Flash";

// Option strings for Mail URL filtering
cse_pp_st["OPT_HighThresholdValue"] = "Higher URL reputation threshold";
cse_pp_st["OPT_LowThresholdValue"] = "Lower URL reputation threshold";
cse_pp_st["OPT_MaxNetworkURLLookup"] = "Max Network URL Lookup Limit";
cse_pp_st["OPT_MaxOverallURLLookup"] = "Maximum number of URLs per email";

// Options strings for compliancy settings
cse_pp_st["OPT_ScanType_1"] = "Scan using the following ruleset";
cse_pp_st["OPT_ScanType_MT1"] = "Scan using the following rulesets";
cse_pp_st["OPT_ScanType_HIPAA"] = "HIPAA";
cse_pp_st["OPT_ScanType_Privacy"] = "Privacy";
cse_pp_st["OPT_ThresholdHIPAA"] = "HIPAA threshold";
cse_pp_st["OPT_ThresholdPrivacy"] = "Privacy threshold";

// Default spam message prefix
cse_pp_st["__def_spam_pfx"] = "****SPAM****";
// Default phish message prefix
cse_pp_st["__def_phish_pfx"] = "****Possible Phish****";

// Strings for the Settings portal page
cse_pp_st["__err_unknown_id"] = "Unknown settings ID: \"%1\"";
cse_pp_st["__del_prompt"] = "Please confirm that you wish to delete this instance";
cse_pp_st["__del_rule_prompt"] = "Please confirm that you wish to delete this rule";
cse_pp_st["__del_crule_prompt"] = "Please confirm that you wish to delete this DLP and Compliance scanner rule";
cse_pp_st["__del_category_prompt"] = "Please confirm that you wish to delete category \"%1\""
cse_pp_st["__name"] = "Name";
cse_pp_st["__refcount"] = "Used By";
cse_pp_st["__one_policy"] = "1 policy";
cse_pp_st["__n_policies"] = "%1 policies";
cse_pp_st["__timerefcount"] = "Used for";
cse_pp_st["__one_scanner"] = "1 scanner";
cse_pp_st["__n_scanners"] = "%1 scanners";

cse_pp_st["__scanners"] = "Scanners";
cse_pp_st["__new_instance"] = "New Instance";
cse_pp_st["__cat_sel_directive"] = "Category:";
cse_pp_st["__MultiLangOpt"] = "Select a Language:";
cse_pp_st["__create_new"] = "Create New";
cse_pp_st["__new_category"] = "New Category"
cse_pp_st["__specify_category_name"] = "Specify a category name:"
cse_pp_st["__rename_category"] = "Rename category \"%1\" to:"

// Strings for the Alerts portal page
cse_pp_st["__defalert"] = "Default %1 Alert";
cse_pp_st["__view"] = "View";
cse_pp_st["__close"] = "Close";
cse_pp_st["__custom_alert"] = "Custom Alert";
cse_pp_st["__del_alert_prompt"] = "Please confirm that you wish to delete this custom alert";

// Table headers for the spam rules table
cse_pp_st["__flag"] = "Flag";
cse_pp_st["__rule_name"] = "Rule Name";
cse_pp_st["__enabled"] = "Enabled";
cse_pp_st["__description"] = "Description";
cse_pp_st["__score"] = "Score";
cse_pp_st["__no_description"] = "No description";

// Spam profile usage report
cse_pp_st["__profile_usage"] = "(%1 out of %2 available profiles used)";
cse_pp_st["__profile_usage_one_only"] = "(No new profiles may be created)";
cse_pp_st["__prof_name"] = "Profile %1";

// Spam rule table labels
cse_pp_st["__spam_showing"] = "Showing <span class=\"bold\">%1 - %2</span> of <span class=\"bold\">%3</span>";
cse_pp_st["__per_page"] = " per page";
cse_pp_st["__no_rules"] = "There are no rules to display";
cse_pp_st["__network_rules"] = "Network Rules";

// Spam rule actions
cse_pp_st["__cancel"] = "Cancel";
cse_pp_st["__reset"] = "Reset";
cse_pp_st["__save"] = "Save";

// Rule delete prompt
cse_pp_st["__del_spam_rule_prompt"] = "Please confirm that you wish to delete this rule";

// Rule exists error for add rule form
cse_pp_st["__rule_exists"] = "A rule with that name already exists";

// ALTs for rule flags
cse_pp_st["__unknown_rule"] = "Unrecognized";
cse_pp_st["__overridden_rule"] = "Modified";
cse_pp_st["__unmodified_rule"] = "Unmodified";
// ALTs for navigation controls
cse_pp_st["__start"] = "Start";
cse_pp_st["__prev"] = "Previous";
cse_pp_st["__next"] = "Next";
cse_pp_st["__end"] = "End";
// ALTs for ascending / descending markers
cse_pp_st["__asc"] = "Ascending order";
cse_pp_st["__desc"] = "Descending order";
// Black / white list strings
cse_pp_st["black_list_from"] = "Blacklisted senders:";
cse_pp_st["black_list_to"] = "Blacklisted recipients:";
cse_pp_st["white_list_from"] = "Whitelisted senders:";
cse_pp_st["white_list_to"] = "Whitelisted recipients:";

// Progress messages for loading the anti-spam page
cse_pp_st["as_pm_rules_msg"] = "Processing <b>%1 - %2</b> of <b>%3</b> spam rules";
cse_pp_st["as_pm_sort_rules"] = "Sorting rules...";
cse_pp_st["as_pm_sort_rules_done"] = "Sorting rules...done";
cse_pp_st["as_pm_std_rules"] = "Tabulating standard rules...";
cse_pp_st["as_pm_std_rules_done"] = "Tabulating standard rules...done";
cse_pp_st["as_pm_net_rules"] = "Tabulating network rules...";
cse_pp_st["as_pm_net_rules_done"] = "Tabulating network rules...done";

// Header for the alert editor
cse_pp_st["__alert_header_text"] = "%1 Alert";
cse_pp_st["__alert_header_text_read_only"] = "%1 Alert - [Read Only]";
cse_pp_st["__alert_header_text_read_only2"] = "%1 Alert (%2) - [Read Only]";
cse_pp_st["__err_unknown_alert"] = "Unknown alert ID: \"%1\"";
cse_pp_st["__select_alert"] = "select an alert document";
// Names of settings blobs
cse_pp_st["__core_av_settings"] = "Core Anti-Virus Settings";
cse_pp_st["__core_av_settings_high"] = "High Protection";
cse_pp_st["__core_av_settings_med"] = "Medium Protection";
cse_pp_st["__core_av_settings_low"] = "Low Protection";
cse_pp_st["__core_spam_settings"] = "Core Anti-Spam Settings";
cse_pp_st["__core_phish_settings"] = "Core Anti-Phishing Settings";
cse_pp_st["__core_scanner_settings"] = "Core Scanner Control Settings";
cse_pp_st["__default_alert_settings"] = "Default Alert Settings";
cse_pp_st["__default_settings"] = "Default Settings";
cse_pp_st["__default_gateway_settings"] = "Default Gateway Settings";
cse_pp_st["__core_mail_settings"] = "Core Mail Settings";
cse_pp_st["__default_mf_settings"] = "Default Mail Size Filter Settings";
cse_pp_st["__default_disc_settings"] = "Default Disclaimer Settings";
cse_pp_st["__default_html_settings"] = "Default HTML Settings";
cse_pp_st["__default_mailURL_settings"] = "Default Mail URL Settings";
cse_pp_st["__default_http_settings"] = "Default HTTP Settings";
cse_pp_st["__hipaa_compliancy"] = "HIPAA Compliancy";
cse_pp_st["__privacy_compliancy"] = "Privacy Compliancy";
cse_pp_st["__full_compliancy"] = "Full Compliancy";

// Alert settings dialog resources
cse_pp_st["__alert_header:"] = "Alert header:";
cse_pp_st["__alert_footer:"] = "Alert footer:";

// Mail size filtering resources
cse_pp_st["__max_size_err"] = "Please enter a value between 2KB and 2GB (2097152 KB)";
cse_pp_st["__bigger_than_err"] = "Please enter a value between 1KB and 2GB (2097152 KB)";

// Filter rule resources
cse_pp_st["__new_rule"] = "New Rule";
cse_pp_st["size_limit_err"] = "Please enter a positive value up to 2GB in size";
cse_pp_st["ff_option_select_1"] = "Please select at least one filtering category";

// File filtering resources
cse_pp_st["__ff_sample_rule"] = "Sample Rule";
cse_pp_st["__catch_all_rule"] = "When no rule applies";
cse_pp_st["__ppf_bypass_rule"] = "Password protected bypass rule";
cse_pp_st["File"] = "File Filtering Rule";
cse_pp_st["File_Hdr"] = "File Filtering Rules";
cse_pp_st["__rule_name"] = "Rule Name";
cse_pp_st["__err_unknown_frule"] = "Unknown file filtering rule: \"%1\"";

// File filtering policy settings
cse_pp_st["__ff_alert_directive"] = "When content is replaced due to a rule being triggered, use the following alert:";
cse_pp_st["__ff_rules_table_header"] = "File filtering rules and associated actions";
cse_pp_st["__ff_rulelist"] = "Available rules:";
cse_pp_st["__ff_selectOne"] = "Select one";
cse_pp_st["__add"] = "Add";
cse_pp_st["__move_up"] = "Move up";
cse_pp_st["__move_down"] = "Move down";
cse_pp_st["__no_rules_selected"] = "No rules have been selected";
cse_pp_st["__create_new_rule"] = "<Create new rule...>";

// MIME settings resources
cse_pp_st["__charset"] = "Character Set";
cse_pp_st["__maps_to"] = "Alternatives";
cse_pp_st["__fixed"] = "Fixed";
cse_pp_st["__del_map_prompt"] = "Are you sure that you want to delete this mapping?";

// Alert settings prompts
cse_pp_st["__use_following_alert"] = "Use the following alert:";
cse_pp_st["FILE_FILTER_BLOCK_Alert_directive"] = "When content is replaced due to a rule being triggered, use the following alert:";
cse_pp_st["DOS_PROTECTION_MSG_Alert_directive"] = "When content is replaced due to a scanner control action, use the following alert:";
cse_pp_st["BLOCKEDMSGTYPE_DESC_HighRiskAlert_directive"] = "When message/external and message/partial types are replaced, use the following alert:";
cse_pp_st["POSTX_MSG_Alert_directive"] = "When content is replaced due to compliancy violation, use the following alert:";

// Content filtering resources
cse_pp_st["Content"] = "Content Rule";
// Scanner control resources
cse_pp_st["__max_width_err"] = "You must enter a value between 1 and 2047MB";
cse_pp_st["__scanner_timeout_err"] = "You must enter a value between 1 and 999 minutes";

// Strings for reference count reporting
cse_pp_st["__dependent_policies"] = "Dependent policies: %1";

// Built-in identity
cse_pp_st["__everyone"] = "Everyone";

// Time restrictions
cse_pp_st["__time_slot"] = "Time Slot";
cse_pp_st["__time_slots"] = "Time Slots";
cse_pp_st["__del_time_prompt"] = "Please confirm that you wish to delete this time slot";
cse_pp_st["__create_time"] = "Specify a new time period";
cse_pp_st["__all_the_time"] = "All the time";
cse_pp_st["__weekdays"] = "Weekdays";
cse_pp_st["__weekends"] = "Weekends";
cse_pp_st["__working_hours"] = "Working hours";
cse_pp_st["__sunday"] = "Sunday"
cse_pp_st["__monday"] = "Monday"
cse_pp_st["__tuesday"] = "Tuesday"
cse_pp_st["__wednesday"] = "Wednesday"
cse_pp_st["__thursday"] = "Thursday"
cse_pp_st["__friday"] = "Friday"
cse_pp_st["__saturday"] = "Saturday"
cse_pp_st["__all_day"] = "All day"
cse_pp_st["__from"] = "From"
cse_pp_st["__to"] = "To"

// Resources for the generic actions page
cse_pp_st["FF_Action"] = "When the file filtering rule \"%1\" is triggered";
cse_pp_st["__sel_doc_directive"] = "Alert document:";
cse_pp_st["__preview"] = "Alert preview";
cse_pp_st["__def_primary_text"] = "Take the following action:";
cse_pp_st["__def_secondary_text"] = "And also:";
cse_pp_st["__cleaning_succeeds"] = "If cleaning succeeds:";
cse_pp_st["__cleaning_succeeds_action"] = "If cleaning succeeds, take the following action:";
cse_pp_st["__no_malware_configured"] = "No custom malware categories configured in the selected anti-virus scanner";

// Resources for important character sets
cse_pp_st["NCR"] = "Numeric character references";
cse_pp_st["unicode"] = "Unicode";
cse_pp_st["utf-8"] = "UTF-8";
cse_pp_st["utf-7"] = "UTF-7";
cse_pp_st["us-ascii"] = "US ASCII";
cse_pp_st["big5"] = "Big5";
cse_pp_st["shift_jis"] = "Shift-JIS";
cse_pp_st["cp850"] = "Codepage 850";
cse_pp_st["cp851"] = "Codepage 851";
cse_pp_st["cp856"] = "Codepage 856";
cse_pp_st["cp857"] = "Codepage 857";
cse_pp_st["cp858"] = "Codepage 858";
cse_pp_st["cp860"] = "Codepage 860";
cse_pp_st["cp861"] = "Codepage 861";
cse_pp_st["cp862"] = "Codepage 862";
cse_pp_st["cp863"] = "Codepage 863";
cse_pp_st["cp864"] = "Codepage 864";
cse_pp_st["cp865"] = "Codepage 865";
cse_pp_st["cp866"] = "Codepage 866";
cse_pp_st["cp868"] = "Codepage 868";
cse_pp_st["cp869"] = "Codepage 869";
cse_pp_st["cp922"] = "Codepage 922";
cse_pp_st["euc-jp"] = "EUC-JP";
cse_pp_st["euc-kr"] = "EUC-KR";
cse_pp_st["gb18030"] = "GB 18030";
cse_pp_st["gb2312"] = "GB 2312";
cse_pp_st["hz-gb-2312"] = "HZ GB 2312";
cse_pp_st["iso-2022-cn"] = "ISO-2022-CN";
cse_pp_st["iso-2022-cn-ext"] = "ISO-2022-CN-EXT";
cse_pp_st["iso-2022-jp"] = "ISO-2022-JP";
cse_pp_st["iso-2022-jp-2"] = "ISO-2022-JP-2";
cse_pp_st["iso-2022-kr"] = "ISO-2022-KR";
cse_pp_st["iso-8859-1"] = "ISO-8859-1";
cse_pp_st["iso-8859-2"] = "ISO-8859-2";
cse_pp_st["iso-8859-3"] = "ISO-8859-3";
cse_pp_st["iso-8859-4"] = "ISO-8859-4";
cse_pp_st["iso-8859-5"] = "ISO-8859-5";
cse_pp_st["iso-8859-6"] = "ISO-8859-6";
cse_pp_st["iso-8859-7"] = "ISO-8859-7";
cse_pp_st["iso-8859-8"] = "ISO-8859-8";
cse_pp_st["iso-8859-9"] = "ISO-8859-9";
cse_pp_st["iso-8859-13"] = "ISO-8859-13";
cse_pp_st["iso-8859-15"] = "ISO-8859-15";
cse_pp_st["koi8-r"] = "KOI8-R";
cse_pp_st["ksc_5601"] = "KSC 5601";
cse_pp_st["macintosh"] = "Macintosh";
cse_pp_st["x-mac-centraleurroman"] = "Mac CER";
cse_pp_st["x-mac-cyrillic"] = "Mac Cyrillic";
cse_pp_st["x-mac-greek"] = "Mac Greek";
cse_pp_st["x-mac-turkish"] = "Mac Turkish";



// String table for cse specific validation messages
cse_pp_vf_st = new Object();
cse_pp_vf_st["__existing_time"]="The specified time slot already exists under a different name - Do you want to create a duplicate time slot with this new name?"
cse_pp_vf_st["__existing_name"]="This name is already used by an existing time slot. Do you want to update the existing time slot with the new time period?"
cse_pp_vf_st["__invalid_days"]="Please select at least one day"
cse_pp_vf_st["__invalid_hours"]="This time period is not valid"


// String table for holding field label names (displayed by validationframework)
cse_pp_field_st = new Object();
cse_pp_field_st["__TimeSlotName"] = "Time Slot Name";
cse_pp_field_st["__TimeSlotHrs"] = "Selected Hours";
cse_pp_field_st["__TimeSlotDays"] = "Time Slot Days";
cse_pp_field_st["__instancename"] = "Instance Name";


// Stringtable for holding action names (reproduced from actions.xml)
cse_pp_actions_st = new Object();

// Generic action strings (same for all settings)
cse_pp_actions_st["NOTIFYADM"] = "Notify administrator";
cse_pp_actions_st["NOTIFYSENDER"] = "Notify sender";
cse_pp_actions_st["NOTIFYINTSDR"] = "Notify internal sender";
cse_pp_actions_st["NOTIFYEXTSDR"] = "Notify external sender";
cse_pp_actions_st["NOTIFYRECIPIENTS"] = "Notify recipient";
cse_pp_actions_st["NOTIFYINTRPT"] ="Notify internal recipient";
cse_pp_actions_st["NOTIFYEXTRPT"] ="Notify external recipient";
cse_pp_actions_st["FORWARD"] ="Forward Quarantined email";

cse_pp_actions_st["LOG"] = "Log";
cse_pp_actions_st["QUARANTINE"] = "Quarantine";
cse_pp_actions_st["QUARANTINEDOC"] = "Quarantine message";

cse_pp_actions_st["ESERVICES:ALLOWTHRU"] = "Allow through";
cse_pp_actions_st["ESERVICES:REPLACE"] = "Replace item with an alert";
cse_pp_actions_st["ESERVICES:REMOVE"] = "Delete embedded item";
cse_pp_actions_st["REMOVECONTAINER"] = "Delete message";
cse_pp_actions_st["ESERVICES:CLEAN"] = "Attempt to clean";
cse_pp_actions_st["ESERVICES:BREAKSIG"] = "Allow changes to break the signature";
cse_pp_actions_st["ESERVICES:DONTBREAKSIG"] = "Do not allow changes to break the signature";
cse_pp_actions_st["SYSJUNKFOLDER"] = "Route to System Junk Folder";
cse_pp_actions_st["USERJUNKFOLDER"] = "Route to User Junk Folder";
cse_pp_actions_st["REJECT"] = "Reject the Message";



cse_pp_actions_st["REMOVECONTAINER[SAFE:CORRUPTED]"]		= "Delete message";
cse_pp_actions_st["ESERVICES:REMOVE[SAFE:CORRUPTED]"]		= "Delete embedded item";
cse_pp_actions_st["ESERVICES:REPLACE[SAFE:CORRUPTED]"]		= "Replace item with an alert";
cse_pp_actions_st["ESERVICES:ALLOWTHRU[SAFE:CORRUPTED]"]	= "Allow through";


cse_pp_actions_st["REMOVECONTAINER[SAFE:ENCRYPTED]"]		= "Delete message";
cse_pp_actions_st["ESERVICES:REMOVE[SAFE:ENCRYPTED]"]		= "Delete embedded item";
cse_pp_actions_st["ESERVICES:REPLACE[SAFE:ENCRYPTED]"]		= "Replace item with an alert";
cse_pp_actions_st["ESERVICES:ALLOWTHRU[SAFE:ENCRYPTED]"]	= "Allow through";

cse_pp_actions_st["REMOVECONTAINER[SAFE:PWDPROTECTED]"]		= "Delete message";
cse_pp_actions_st["ESERVICES:REMOVE[SAFE:PWDPROTECTED]"]	= "Delete embedded item";
cse_pp_actions_st["ESERVICES:REPLACE[SAFE:PWDPROTECTED]"]	= "Replace item with an alert";
cse_pp_actions_st["ESERVICES:ALLOWTHRU[SAFE:PWDPROTECTED]"]	= "Allow through";

cse_pp_actions_st["REMOVECONTAINER[SAFE:PROTECTEDCNT]"]		= "Delete message";
cse_pp_actions_st["ESERVICES:REMOVE[SAFE:PROTECTEDCNT]"]	= "Delete embedded item";
cse_pp_actions_st["ESERVICES:REPLACE[SAFE:PROTECTEDCNT]"]	= "Replace item with an alert";
cse_pp_actions_st["ESERVICES:ALLOWTHRU[SAFE:PROTECTEDCNT]"]	= "Allow through";

// Custom action strings for specific types
cse_pp_actions_st["AV.ESERVICES:REPLACE"] = "Replace item with an alert";

cse_pp_actions_st["AS.REMOVECONTAINER"] = "Delete message";
cse_pp_actions_st["AF.REMOVECONTAINER"] = "Delete message";


cse_pp_actions_st["AV.BLOCK"] = "Block detected item";
cse_pp_actions_st["AS.QUARANTINE"] = "Quarantine message";
cse_pp_actions_st["AS.BLOCK"] = "Block message";
cse_pp_actions_st["AF.QUARANTINE"] = "Quarantine message";
cse_pp_actions_st["AF.BLOCK"] = "Block message";
cse_pp_actions_st["MF.ESERVICES:REPLACE_MaxSizeAction"] = "Replace item with an alert";
cse_pp_actions_st["MF.ESERVICES:REPLACE_MoreThanAction"] = "Replace all attachments with a single alert";
cse_pp_actions_st["MF.ESERVICES:REPLACE_BiggerThanAction"] = "Replace the attachment with an alert";
cse_pp_actions_st["MF.ESERVICES:REMOVE_BiggerThanAction"] = "Remove the attachment";
cse_pp_actions_st["MF.ESERVICES:REMOVE_MoreThanAction"] = "Remove all attachments";
cse_pp_actions_st["MIME.ESERVICES:REPLACE"] = "Replace message with an alert";
cse_pp_actions_st["MIME.REMOVECONTAINER"] = "Delete message";

// Sample PP-specific action strings, taken from the WebShield SMTP service
cse_pp_actions_st["WEBSHIELD:DENYCONNECTION[ESERVICES:REPLACE]"] = "Deny Connection";
cse_pp_actions_st["WEBSHIELD:REFUSEORIGINAL[ESERVICES:REPLACE]"] =
    "Return a rejection code";
cse_pp_actions_st["WEBSHIELD:ACCEPTANDDROP[ESERVICES:REPLACE]"] =
    "Accept and then drop the data"
cse_pp_actions_st["AV.smtp.ESERVICES:REPLACE"] = "Replace the content with an HTML alert";
cse_pp_actions_st["smtp.DELIVERMODIFIEDSENDER"] = "Deliver modified E-mail to the sender";
cse_pp_actions_st["smtp.DELIVERNOTIFICATION"] = "Notify the original recipient(s) by E-mail";
cse_pp_actions_st["smtp.DELIVERNOTIFICATIONSENDER"] =
    "Notify the sender by E-mail";
cse_pp_actions_st["smtp.QUARANTINEORIGINAL"] = "Quarantine the original E-mail";
cse_pp_actions_st["smtp.QUARANTINEMODIFIED"] = "Quarantine the modified E-mail";
cse_pp_actions_st["smtp.FORWARDMODIFIED"] = "Forward the modified E-mail";
cse_pp_actions_st["smtp.DELIVERANNOTATEDORIGINAL"] = "Deliver an annotated original E-mail";
cse_pp_actions_st["smtp.DELIVERANNOTATEDMODIFIED"] = "Deliver an annotated modified E-mail";
cse_pp_actions_st["smtp.DELIVERALERT"] = "Deliver an alert E-mail";

// Creation Wizard
cse_pp_actions_st["POLICYWIZPAGE1"] = "Initial configuration";
cse_pp_actions_st["POLICYWIZPAGE2"] = "Trigger rules";
cse_pp_actions_st["POLICYWIZPAGE3"] = "Scanners and filters";
cse_pp_actions_st["POLICYWIZTITLE"] = "Create a sub-policy";




// String table for holding alert names
cse_pp_alerts_st = new Object();
cse_pp_alerts_st["PROTECTED_DESC"] = cse_pp_alerts_st["PROTECTED_DESC_S"] = "Protected Content";
cse_pp_alerts_st["PWDPROTECTED_DESC"] = "Password-Protected File";
cse_pp_alerts_st["PWDPROTECTED_DESC_S"] = "Password-Protected";
cse_pp_alerts_st["FILE_FILTER_BLOCK"] = cse_pp_alerts_st["FILE_FILTER_BLOCK_S"] = "File Filtering";
cse_pp_alerts_st["AV_REPLACEMENT"] = cse_pp_alerts_st["AV_REPLACEMENT_S"] = "Anti-Virus Scanner";
cse_pp_alerts_st["AV_MALWARE_REPLACEMENT"] = cse_pp_alerts_st["AV_MALWARE_REPLACEMENT_S"] = "Anti-Virus Scanner(Default Malware)";
cse_pp_alerts_st["AV_PACKER_REPLACEMENT"] = cse_pp_alerts_st["AV_PACKER_REPLACEMENT_S"] = "Anti-Virus Scanner(Default Packer)";
cse_pp_alerts_st["AV_PUP_REPLACEMENT"] = cse_pp_alerts_st["AV_PUP_REPLACEMENT_S"] = "Anti-Virus Scanner(Default PUP)";
cse_pp_alerts_st["CONTENT_RULE_REPLACEMENT"] = cse_pp_alerts_st["CONTENT_RULE_REPLACEMENT_S"] = "DLP and Compliance Scanning";
cse_pp_alerts_st["SIGNED_DESC"] = cse_pp_alerts_st["SIGNED_DESC_S"] = "Signed Content";
cse_pp_alerts_st["ENCRYPTED_DESC"] = cse_pp_alerts_st["ENCRYPTED_DESC_S"] = "Encrypted Content";
cse_pp_alerts_st["BLOCKEDMSGTYPE_DESC"] = cse_pp_alerts_st["BLOCKEDMSGTYPE_DESC_S"] = "Blocked MIME Type";
cse_pp_alerts_st["CORRUPT_DESC"] = cse_pp_alerts_st["CORRUPT_DESC_S"] = "Corrupt Content";
cse_pp_alerts_st["MAXMSGSIZEMSG"] = "Mail Size Filtering (Message Length)";
cse_pp_alerts_st["MAXMSGSIZEMSG_S"] =  "Mail Size Filtering (Message Length)";
cse_pp_alerts_st["MAXATTSIZEMSG"] = "Mail Size Filtering (Attachment Size)";
cse_pp_alerts_st["MAXATTSIZEMSG_S"] = "Mail Size Filtering (Attachment Size)";
cse_pp_alerts_st["ATTSTRIPMSG"] = "Mail Size Filtering (Attachments Count)";
cse_pp_alerts_st["ATTSTRIPMSG_S"] = "Mail Size Filtering (Attachments Count)";
cse_pp_alerts_st["SPAM_MSG"] = "Spam Report";
cse_pp_alerts_st["SPAM_MSG_S"] = "Spam";
cse_pp_alerts_st["PHISH_MSG"] = "Anti-Phishing";
cse_pp_alerts_st["PHISH_MSG_S"] = "Anti-Phishing";
cse_pp_alerts_st["DOS_PROTECTION_MSG"] = "Denial of Service Protection";
cse_pp_alerts_st["DOS_PROTECTION_MSG_S"] = "DoS Protection";
cse_pp_alerts_st["URL_MSG"] = cse_pp_alerts_st["URL_MSG_S"] = "URL-Filtering";
cse_pp_alerts_st["URL_MSG_COACH"] = "URL-Filtering (Coach)";
cse_pp_alerts_st["URL_MSG_COACH_S"] = "Coached";
cse_pp_alerts_st["URL_MSG_DENY"] = "URL-Filtering (Deny)";
cse_pp_alerts_st["URL_MSG_DENY_S"] = "Denied";
cse_pp_alerts_st["POSTX_MSG"] = cse_pp_alerts_st["POSTX_MSG_S"] = "Email Compliancy";
cse_pp_alerts_st["MAILURL_MSG"] = cse_pp_alerts_st["MAILURL_MSG_S"] = "Mail URL Reputation";
cse_pp_alerts_st["MAILURL_MSG_MAXURL"] = cse_pp_alerts_st["MAILURL_MSG_MAXURL_S"] = "Mail URL Reputation (URL Count)";


//string for content scanner rule display
cse_pp_cs_st = new Object();
cse_pp_cs_st["__category"] = "Category : ";
cse_pp_cs_st["__cs_rules"] = "DLP and Compliance Rules";
cse_pp_cs_st["__dlp_rules"] = "DLP and Compliance Rules";
cse_pp_cs_st["__cs_rule"] = "DLP and Compliance Scanner Rule";
cse_pp_cs_st["__rule_triggered"] = "This rule is triggered when :";
cse_pp_cs_st["__simple_phrase"] = "the simple phrase : %1";
cse_pp_cs_st["__complex_phrase"] = "the complex phrase : %1";
cse_pp_cs_st["__any_simple_phrase"] = "any of the simple phrases :";
cse_pp_cs_st["__any_complex_phrase"] = "any of the complex phrases :";
cse_pp_cs_st["__or"] = "or ";
cse_pp_cs_st["__and_when"] = "and when :";
cse_pp_cs_st["__found"] = "is found in ";
cse_pp_cs_st["__add_phrase"] = "Add Phrase";
cse_pp_cs_st["__del_condition"] = "Delete Condition";
cse_pp_cs_st["__edit_condition"] = "Edit Condition";
cse_pp_cs_st["__new_condition"] = "New Condition";
cse_pp_cs_st["__anywere"] = "Anywhere";
cse_pp_cs_st["__condition"] = "Condition";
cse_pp_cs_st["__phrase"] = "Word or Phrase";
cse_pp_cs_st["__rulegroup_includes"] = "Rules Group (includes the selected rules below)";
cse_pp_cs_st["__create_condition"] = "Please choose atleast one subcategory";
cse_pp_cs_st["__create_phrase"] = "Please specify at least one word or phrase";
cse_pp_cs_st["__word_or_phrase"] = "word or phrase";
cse_pp_cs_st["__score"] = "Score";

// Tab strings
cse_pp_st["__tab_scanners_alerts"] = "Scanners &amp; Alerts";
cse_pp_st["__tab_filter_rules"] = "DLP and Compliance Dictionaries";
cse_pp_st["__tab_time_slots"] = "Time Slots";
cse_pp_st["__blacklists"] = "Blacklists";
cse_pp_st["__whitelists"] = "Whitelists";
cse_pp_st["__tab_message_size"] = "Message Size";
cse_pp_st["__tab_attachment_size"] = "Attachment Size";
cse_pp_st["__tab_attachment_count"] = "Attachment Count";
cse_pp_st["__tab_cleaning"] = "Cleaning";
cse_pp_st["__tab_default_actions"] = "Default Actions";
cse_pp_st["__tab_custom_malware"] = "Custom Malware";
cse_pp_st["__tab_packers"] = "Packers";
cse_pp_st["__tab_pups"] = "PUPs";
cse_pp_st["__tab_high_score"] = "High Score";
cse_pp_st["__tab_medium_score"] = "Medium Score";
cse_pp_st["__tab_low_score"] = "Low Score";
cse_pp_st["__tab_options"] = "Options";
cse_pp_st["__tab_advanced"] = "Advanced";
cse_pp_st["__tab_mime_types"] = "MIME Types";
cse_pp_st["__tab_charsets"] = "Character Sets";
cse_pp_st["__tab_file_format"] = "File Format";
cse_pp_st["__tab_phrases"] = "Phrases";
cse_pp_st["__tab_word_or_phrase"] = "Word or Phrase";
cse_pp_st["__tab_basic_options"] = "Basic Options";
cse_pp_st["__tab_mail_lists"] = "Mail Lists";
cse_pp_st["__tab_rules"] = "Rules";

// Resources for validation alerts
var page_st = {};
page_st["lm_rule_name"] = "Rule Name";
page_st["lm_alert_name"] = "Alert Name";
page_st['lm_MaxBoundaries'] = "Maximum MIME parts";
page_st["lm_MaxMessageSize"] = "Maximum message size";
page_st["lm_MaxHeaderWidth"] = "Maximum header width";
page_st["lm_MaxReportedRules"] = "Maximum reported rules";
page_st["lm_header_name"] = "Header Name";
page_st["lm_header_value"] = "Header Value";
page_st["mms_err"] = "You must enter an integer value greater than 0";
page_st["ftl_directive"] = "Enter extension (maximum three characters), '*' and '?' are not allowed.";
page_st["ftl_displayName"] = "File extensions";
page_st["ftl_inputNamePattern"] = "Extension %1";
page_st["lm_SpamThreshold"] = "Custom score";
page_st["lm_PrefixSubjectText"] = "Spam prefix";
page_st["lm_SpamIndicatorText"] = "Indicator text";
page_st["lm_TimeoutRBLTests"] = "RBL timeout";
page_st["lm_ScoreLevel"] = "Score level %1";
page_st["lm_fNamePattern"] = "File name %1";
page_st["fnl_displayName"] = "File names";
page_st["lm_fSize"] = "File size";
page_st["lm_vNamePattern"] = "Virus name %1";
page_st["svt_displayName"] = "Virus names";
page_st["lm_MaxSize"] = "Maximum message size";
page_st["lm_BiggerThanVal"] = "Maximum attachment size";
page_st["lm_MoreThanVal"] = "Maximum attachment count";
page_st["atl_displayName"] = "Text MIME types";
page_st["lm_MailPrefixSubjectText"]="Mail Prefix";
page_st["atl_inputNamePattern"] = "Text type %1";
page_st["btl_displayName"] = "Binary MIME types";
page_st["btl_inputNamePattern"] = "Binary type %1";
page_st["lm_rulename"] = "Rule name";
page_st["lm_score"] = "Score";
page_st["pnl_inputNamePattern"] = "Packer name %1";
page_st["lm_PrefixSubjectText"] = "Phish prefix";
page_st["lm_ThresholdHIPAA"] = "HIPAA threshold";
page_st["lm_ThresholdPrivacy"] = "Privacy threshold";
page_st["PUP_SPYWARE"] = "Spyware";
page_st["PUP_ADWARE"] = "Adware";
page_st["PUP_REMOTE_ADMIN"] = "Remote administration tools";
page_st["PUP_DIALERS"] = "Dialers";
page_st["PUP_PWD_CRACKERS"] = "Password crackers";
page_st["PUP_JOKE_PROGRAMS"] = "Joke programs";
page_st["PUP_COOKIES"] = "Cookies";
page_st["PUP_OTHER"] = "Other PUPs";
page_st["PUP_Directive"] = "Select the program types to detect:";
page_st["pupl_inputNamePattern"] = "PUP name %1";
page_st["lm_maxdepth"] = "Maximum depth";
page_st["lm_maxwidth"] = "Maximum file size";
page_st["lm_ScannerTimeout"] = "Scanner timeout";
page_st["lm_rulename"] = "Rule name";
page_st["lm_score"] = "Score";
page_st["il_directive"] = "[You may use '*' and '?' as wildcard characters to match multiple addresses]";
page_st["sender_pattern"] = "Sender %1";
page_st["recipient_pattern"] = "Recipient %1"; 
page_st["lm_MaxMailScanSize"] = "Maximum message size";
page_st["lm_highscore"] = "High score threshold should be greater that medium and low";
page_st["lm_mediumscore"] = "Medium score threshold should be less than high and greater than low";
page_st["lm_lowscore"] = "Low score threshold should be less than high and medium";
