// Copyright (C) 2016 McAfee, Inc.  All rights reserved.

////////////////////////////////////////////
//
// Distinguishes between IE and NS
//
var browserName = navigator.appName
var IEBrowser=1
var NSBrowser=2
var OPBrowser=3
function TestForIEorNS()
{
	if(browserName=="Microsoft Internet Explorer")
	{
		return IEBrowser
	}
	else if(browserName=="Netscape")
	{
		return NSBrowser
	}
	return UnknownBrowser
}

////////////////////////////////////////////
//
// Gets type of browser
//
var _info = navigator.userAgent
function GetBrowserType()
{
	if(_info.indexOf("Opera") < 0)
	{
		return TestForIEorNS()
	}
    	else
	{
		browserName="Opera"
		return OPBrowser
	}
}

//////////////////////////////////////////////////////
//
// Gets language of browser
//
function GetBrowserLanguage()
{
	var browserType = GetBrowserType();

	var language = "en";

	if(browserType==IEBrowser)
	{
		language = navigator.browserLanguage;
	}
	else if(browserType==NSBrowser)
	{
		language = navigator.language;
	}

	// Map to primary lang
	var primary=language.substr(0,2);
	if (primary!="zh")
		language=primary;

	// return the language identifier.
	return language;
}

//////////////////////////////////////////////////////
//
// Check browser ver required for
//
function CheckBrowserVer()
{
	var ok = true

	var appver = navigator.appVersion
	var i = appver.indexOf("MSIE ")
	if (i > 0)
	{ // IE...
		var ver = appver.substr(i + 5)
		i = ver.indexOf(";")
		if (i > 0)
			ver = ver.substr(0, i)
		var v = parseFloat(ver)

		if (v < 5.5) // uses the real app ver listed after "MSIE" text in the brackets
			ok = false
	}
	else
	{ // NS...
		i = _info.indexOf("Gecko/")
		if (i > 0)
		{
			var ver = _info.substr(i+8)
			var v = parseFloat(ver)

			if (v >= 1.0)
				ok = true
			else
				ok = false
		}
		else
		{
			// Netscape is currently unsupported.
			ok=false
		}
	}

	return ok
}

//////////////////////////////////////////////////////
//
// Gets locale sub-folder appropriate to browser locale
//
function GetLocale()
{
    // See whether this function has been overriddent by the PP;
    // this will be true if PointProductSpecifc.js has been included in
    // the page AND pp_getLocale is defined by the PP
    if (this.pp_GetLocale)
        return pp_GetLocale();
	var cp = "0409"
	var lang = GetBrowserLanguage()

	if(LanguageSupported(lang))
	{
		if (lang == "zh-cn" || lang=="zh-CN") cp = "0804"
		if (lang == "zh-tw" || lang=="zh-TW") cp = "0404"
		if (lang == "de") cp = "0407"
		if (lang == "fr") cp = "040C"
		if (lang == "es") cp = "040A"
		if (lang == "ja") cp = "0411"
		if (lang == "ko") cp = "0412"
	}

	return cp
}

function LanguageSupported(lang)
{
	var bSupported = false

	if(gForeignLanguages == McUndefined)
		return false

	for(var i = 0; i < gForeignLanguages.length && bSupported == false; i++)
	{
		if (lang == "zh-CN")
		{
			lang = "zh-cn";
		}
		if (lang == "zh-TW")
		{
			lang = "zh-tw";
		}
		if(lang== gForeignLanguages[i])
			bSupported = true
	}

	return bSupported
}

/**
 * Identifies the browser
 * @return a keyed Object; the keys are "isIE", "isGecko", etc, for quick testing; there is
 * also a property called "browser", which contains a browser code, name and version.
 */
function IdentifyBrowser() {
    var ret = {isIE:false, isGecko:false, isOpera:false, isSafari:false, isKonqueror:false, isChrome:false};
    var ua = navigator.userAgent.toLowerCase();
    ret.isIE = ((ua.indexOf("msie") != -1) && (ua.indexOf("opera") == -1) && (ua.indexOf("webtv") == -1));
    ret.isGecko = (ua.indexOf("gecko") != -1);
    ret.isOpera = (ua.indexOf("opera") != -1);
    ret.isSafari = (ua.indexOf("safari") != -1);
    ret.isKonqueror = (ua.indexOf("konqueror") != -1);
	ret.isChrome = (ua.indexOf("chrome") != -1);
	if((ret.isChrome)&&(ret.isSafari)) {ret.isSafari=false;}
    ret.browser = GetBrowserInfo();
    ret.toString = function() { return this.browser.name +
        (this.browser.version ? (" " + this.browser.version) : ""); }
    return ret;
}

/**
 * Gets code, name and version for a browser (may be "unknown")
 * @return keyed object
 */
function GetBrowserInfo() {
    var ret = {code:"U"};
    // Browser code : name mappings
    var bcMap = {KQ:"Konqueror", IE:"Internet Explorer", NS:"Netscape", NS2:"Netscape", GK:"Gecko",
        FF:"Firefox", SF:"Safari", OP:"Opera", CR:"Chrome", U:navigator.userAgent};
    // Browser code : version pattern match
    var vpMap = {KQ:"konqueror/(\\S+)[;)]", IE:"msie\\s+(\\S+);", NS:"netscape6?/(\\S+)", NS2:"navigator/(\\S+)$", GK:"rv:([\\.\\d]+)",
        FF:"firefox/(\\S+)$", SF:"version/(\\S+)", OP:"version/(\\S+)", CR:"chrome/(\\S+)"};
    var ua = navigator.userAgent.toLowerCase();
    if (-1 != ua.indexOf("gecko")) {
        if (-1 != ua.indexOf("netscape"))//Check netscape and navigator before checking for firefox
            ret.code = "NS";
		else if (-1 != ua.indexOf("navigator"))
            ret.code = "NS2";
        else if (-1 != ua.indexOf("firefox"))
            ret.code = "FF";
		else if (-1 != ua.indexOf("chrome"))
            ret.code = "CR";
		else if (-1 != ua.indexOf("safari"))
            ret.code = "SF";
		else if (-1 != ua.indexOf("konqueror"))
            ret.code = "KQ";
		else if (-1 != ua.indexOf("opera"))
			ret.code = "OP";
        else{
            ret.code = "GK"; // unidentifiable Gecko browser
			//As the browser was unidentified,checking if the browser is IE11 or more
			var isIEInfo = IdentifyIEVersionGreaterThan10();
			if (isIEInfo.code == "IE") {
				return isIEInfo;
			}	
		}
    }
    else if (-1 != ua.indexOf("opera"))
        ret.code = "OP";
    else if (-1 != ua.indexOf("msie") && -1 == ua.indexOf("webtv"))
        ret.code = "IE";
    else if (-1 != ua.indexOf("konqueror"))
        ret.code = "KQ";
    /*Uncommenting this to ignore this check since Safari useragent always has the string "gecko"
    else if (-1 != ua.indexOf("safari"))
			ret.code = "SF";*/
    ret.name = bcMap[ret.code];
    if (vpMap[ret.code]) {
        var versionPattern = new RegExp(vpMap[ret.code]);
        var match = versionPattern.exec(ua);
        if (match) {
            var versionStr = match[1];
            ret.version = versionStr;
            // "Canonicalize" the version number by stripping the periods and
            // dividing by an appropriate number to get a number of the form "X.abc"
            var versionC = versionStr.split(".").join("");
            var divisor = Math.pow(10, versionC.length - 1);
            ret.versionNum = versionC / divisor;
        }
    }
    return ret;
}

/**
 * Gets code, name and version for a IE browser when IE versions are greater than 10
 * From IE11 onwards ,it has completely different User Agent string to previous IE versions; it no longer includes the "MSIE" text.
 * The user agent string is similar to - Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko 
 * @return keyed object
 */
function IdentifyIEVersionGreaterThan10()
{
	var ret = {code:"U"};

	var ua = navigator.userAgent;
	var regexp  = new RegExp("Trident/.*rv:([0-9]{1,}[\.0-9]{0,})");
	if (regexp.exec(ua) != null) {
		ret.code = "IE";
		ret.version = RegExp.$1;
	}
	
	return ret;
}

//////////////////////////////////////////////////////
//
// Checks if the browser is supported or not by the product
//
function IsBrowserSupported(browserInfo)
{
	var browserSupport = false;
	var code = browserInfo.code;
	var version = parseFloat(browserInfo.version);
	
	if(code == "IE" && version >= 10 && version <= 11)
	{
		browserSupport = true;
	}
	else if(code == "FF" && version >= 52 && version <= 54)
	{
		browserSupport = true;
	}
	else if(code == "CR" && version >= 57 && version <= 59)
	{
		browserSupport = true;
	}
	
	return browserSupport;
}