// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Edit One CS rule
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================

var gCondition;

function CSRCondition(pbIn, ppIn)
{
	if ("string" == typeof(ppIn))
    {   this.pp_str = ppIn;
    }
    else
    {   this.pp_str = ppIn.GetPath();
    }

    this.pb = CSRules_MakePb(pbIn, this.pp_str)
    this.LocalRestore();
	this.CreateNode();

    this.filesel=CSRFFPanel_InitFF();
}

//create new node in a temporary property bag
CSRCondition.prototype.CreateNode = function()
{
    var ppT = new PropertyPath(this.pp_str);

	if( undefined !== this.pb.GetProperty(ppT) )
	{   //the path already exists
        //csr_condition_tabs.handler(0);
	    return;
	}

    //create the condition node with the file format element
    this.pb.SetProperty(ppT);

	ppT.Append("Applies");
    this.pb.SetProperty(ppT);
	ppT.SetTempLeaf("section")
    this.pb.SetProperty(ppT, "ALL");
	ppT=new PropertyPath (this.pp_str);
    top.gPageStack.Active().SetModified(true);
    //csr_condition_tabs.handler(1);
}


//store data from this page
CSRCondition.prototype.LocalStore = function()
{
     //nothing to store if there was no change
	 if( ! top.gPageStack.Active().Modified() )
	 return;

     //make sure we don't store in the top pb
	 var pbT = CSRules_GetTopPb();
     if (gCondition.pb==pbT)
     {   gCondition.pb= CSRules_MakePb(pbT)
     }
     else if(gCondition.pb==CSRules_IsStorePb("rule"))
     {   gCondition.pb= CSRules_MakePb(gCondition.pb)
     }

	 //save parameters from the page
     CSRFFPanel_Apply(this.pp_str, this.pb)

	 //store pb
     CSRules_SetStorePb(this.pb, "condition")
}

//restore saved data - keep storeage if path does not exist yet in top pb.
CSRCondition.prototype.LocalRestore = function()
{
   if(CSRules_IsStorePb("condition"))
   {
       this.pb=CSRules_GetStorePb("condition", true)
       top.gPageStack.Active().SetModified(true);
	   return;
   }

   if(CSRules_IsStorePb("rule"))
   {
       this.pb=CSRules_GetStorePb("rule", false)
	   return;
   }
}


//create a new property path
//assumes phrases are created as simple phrases with no wildcards
CSRCondition.prototype.GetNextPhrasePP = function(node)
{
    var pp_str=this.pp_str+".RERule."+node;
	var res= this.pb.GetNextElementEnum(pp_str);

	if (pp_str == res)
	{
		// This is the first element
		pp_str=this.pp_str+".CFRule."+node;
		res= this.pb.GetNextElementEnum(pp_str);
	}

	return res;
}

function  CSRCondition_GetPhraseSep(ndx,  node )
{
   	var txt_tpl = "__complex_phrase";


	if (CSRules_IsSimplePhrase(node)  )
	{   txt_tpl = "__simple_phrase";
	}

    var txt =resolveString(cse_pp_cs_st,txt_tpl,[""]);
    return txt;

}


//Populate page with data from property bag
function CSRCondition_DelPhrase(pp_str)
{
   //make sure we don't delete in top propertybag

   var pbT = CSRules_IsStorePb("rule")
   if (gCondition.pb==pbT)
   {   gCondition.pb= CSRules_MakePb(pbT)
   }
   else if (gCondition.pb==CSRules_GetTopPb())
   {   gCondition.pb= CSRules_MakePb(null)
   }

   gCondition.pb.DeleteElementEx(pp_str);
   CSRCondition_DrawPhrases(gCondition.pb, gCondition.pp_str);
   top.gPageStack.Active().SetModified(true);

}

//call the phrase page
function CSRCondition_EditPhrase(create, pp_str, node)
{
    var title= resolveString(cse_pp_cs_st, "__phrase" );

    if(create)
    {   node="Match";
        pp_str=gCondition.GetNextPhrasePP(node);
    }

	gCondition.LocalStore();

	var target= 'CSRPhrase.html?node='+node;
    var page = new DialogPage(target, title);
    top.gPageStack.Forward(page, pp_str);

}

//Retrieve "found in " infromation from the propertybag
//@pbIn = propertybag
//pp_str: pp to the condition node
function CSRCondition_FoundIn(pbIn, pp_str)
{
   var ppT= new PropertyPath(pp_str);
   ppT.Append("Applies")
   ppT.SetTempLeaf("section");
   var txt=resolveString(cse_pp_cs_st,"__anywere");

   var res=pbIn.GetProperty(ppT);
   //if(res!="All")

   return txt;

}

//Build table of all phrases in this condition
//@ppIn: pp to the condition node
function  CSRCondition_DrawPhrases(pbIn, pp_str)
{

   var tbl_div=document.getElementById("phrases_div");
   tbl_div.innerHTML="";

   //find list of words
   var res = CSRules_GetAllSortedPhrases(pbIn, pp_str, "")

   var tbl=document.createElement("table");
   tbl_div.appendChild(tbl);
   tbl.width="100%";
   tbl.id="tbl_phrases";
   

   var tbody=document.createElement("tbody");
   tbl.appendChild(tbody);

   for (var i=0;i<res.length ;i++ )
   {
      var row=document.createElement("tr");
  	  tbody.appendChild(row);

      //add first cell
      var cell=document.createElement("td");
      row.appendChild(cell);
      cell.vAlign="top";
      cell.noWrap=true;
      var txt=CSRCondition_GetPhraseSep(i, res[i][2])
      var content=document.createTextNode(txt+'\u00A0');
	  cell.appendChild(content);

      //add content cell
      cell=document.createElement("td");
  	  row.appendChild(cell);
	  cell.className="noLeft";
      cell.vAlign="top";
      txt= CSRules_GetPhraseTxt(pbIn, res[i][0], res[i][2]);
      content=document.createTextNode(txt)
      cell.appendChild(content);

      //add edit/delete cell
      cell=document.createElement("td");
  	  row.appendChild(cell);
      cell.noWrap="true"
      cell.vAlign="top";
      var edit_lnk='"javascript:CSRCondition_EditPhrase(false, \'' + res[i][0] + '\', \''+ res[i][2] + '\')"';
      var del_lnk='"javascript:CSRCondition_DelPhrase(\'' + res[i][0] + '\', \''+ res[i][2] + '\')"';
      var content='<a href=' + edit_lnk +' class="blueLink"> '+resolveString(cse_pp_st, "__edit")+' </a>'
      content+="&nbsp;|&nbsp;"
      content+='<a href='+ del_lnk+' class="blueLink"> '+resolveString(cse_pp_st, "__delete")+' </a>';
      cell.innerHTML=content;
   }

//apply style
makeSDL(tbl.id, false);
}

//Populate page with data from property bag
//@pp_str: pp ending up with "ConditionRule"
function CSRCondition_DrawData(pbIn, pp_str)
{
var name_fld=document.getElementById("_name");
var cat_div=document.getElementById("cat_div");

     CSRCondition_DrawPhrases(pbIn, pp_str);
     CSRFFPanel_DrawFF(pbIn, pp_str);
}

function page_init()
{
      try
      {
      	top.gPageStack.OnLoad();
      	//only file_format tab validation required in this page.
      	csr_condition_tabs.addValidation(1,vframeworks["file_format"]);
      }
      catch(e)
      {  alert(e.message);
      }
}

/**
 * Asynchronous data load function
 */

// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function Show(pb_null, ppIn)
{

var rules_pb = CSRules_GetTopPb();

//display rule name, category and description, then the list of conditions
gCondition=new CSRCondition(rules_pb, ppIn);
CSRCondition_DrawData(gCondition.pb, ppIn);

}

/**
 * Asynchronous data validation function
 */
function Validate() {

    //check there are phrases registered in this condition
    //new validation for file format.
    var ok = CSRFF_Validate();
    if(!ok) return false;

    var res = CSRules_GetAllPhrasesPP(gCondition.pb, gCondition.pp_str, null)

	if (res.length==0)
	{
	      alert(resolveString(cse_pp_cs_st,"__create_phrase"));
	      csr_condition_tabs.handler(0);
	      return false;
	}
	return true;
}

/**
 * Asynchronous data save function
 */
function Apply(pb_null,pp_null,save)
{
    //save data
    changed=CSRFFPanel_Apply(gCondition.pp_str, gCondition.pb)

    //update real pb if needed
	var pbOut =  CSRules_GetTopPb();
    if(CSRules_IsStorePb("rule"))
    {
       pbOut=CSRules_GetStorePb("rule", false)
    }
	if (gCondition.pb != pbOut)
	{
	     pbOut.DeleteList(gCondition.pp_str+".CFRule");
		 pbOut.DeleteList(gCondition.pp_str+".RERule");
         pbOut.DeleteList(gCondition.pp_str+".Applies");
         gCondition.pb.GetElement(gCondition.pp_str, pbOut);
		 change=true;
	}

	return top.gPageStack.Active().pb
}

