// Copyright (C) 2016 McAfee, Inc.  All rights reserved.
// Edit One CS rule
// (description of a phrase (simple or complex)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================

var csw_vframeworks = new Object();
var gPhrase;
var gPharseEnable = false;
var gIsScoreBased = false;
//=====================================================================
// utilities
//====================================================================

function abs_offset(e, pos) {

    var parent = e.parentNode;
    var y=e.offsetTop-0;
    while(parent!=undefined && parent.offsetTop!=undefined)
    { var pad=parent.offsetTop-0
      y+=pad;
      parent=parent.parentNode;
    }
    return y;
}



function CSRP_Validation_Init(IsScore)
{
   var doc_forms = ["main_form", "ctx_form"];
   var reqV=new RequiredValidator();
   //var scriptV = new ScriptValidator();
   var scriptV = new InputTextValidator();

   for(var i=0;i<doc_forms.length;i++)
   {  var form=doc_forms[i];
      if (document.forms[form])
      {
            csw_vframeworks[form] = new ValidationFramework(form);
            csw_vframeworks[form].formAction = std_val_form_action;
            csw_vframeworks[form].fieldAction = std_val_field_action;
            csw_vframeworks[form].addValidator("text",reqV);
            csw_vframeworks[form].addValidator("text",new WildCardValidator(form));
            csw_vframeworks[form].addValidator("text",scriptV);
            csw_vframeworks[form].labelMap["text"] = resolveString(cse_pp_cs_st,"__word_or_phrase");

			
			if(IsScore)
			{
			
				{
					
					csw_vframeworks[form].addValidator("score",reqV);
					
					csw_vframeworks[form].addValidator("score",scriptV);
					csw_vframeworks[form].labelMap["score"] = resolveString(cse_pp_cs_st,"__score");
				}
				
			}
			
      }
   }
}


//Return the node key depending on parameters:
//@complex=0 if it is a simple phrase or pattern
//@wildcard =1 if wildcard are used
//@distance >0  if context is within a block of chars
//@logic = relationship with contextual words
function  CSRPhrase_GetPhraseNode(complex, wildcard, distance_str, logic)
{
    var distance=0;

    if(complex)
    {   distance= distance_str-0;
        wildcard=false;
        if (distance==NaN)
        {  distance=0;
        }
    }

    for (var i=0;i<CSRules_PhraseStruct.length ; i++ )
    {
        if ( (CSRules_PhraseStruct[i].logic==logic) &&
             (CSRules_PhraseStruct[i].dist==(distance>0)) &&
             (CSRules_PhraseStruct[i].wildcard==wildcard )
           )
        {
            var n=CSRules_PhraseStruct[i].node;
            return n;
        }
    }

    //catchall
    return "Match";
}


function CSRPhrase_ToggleComplex(chk)
{
    var div=document.getElementById("complex_div");
    if (div)
    {
        div.style.display=chk?"":"none";
    }
}


//disable isstart and isend checkbox if pattern is selected
//@pp_str: path to the Match node
function CSRPhrase_ToggleDistance(chk)
{
    var form= document.forms["main_form"];

    if (chk)
    {
        form.distance.value=form.distance_shadow.value;
        form.distance.disabled=false;
		//setting the field as numeric only
		setNumeric(	"main_form",["_distance"],false,false);
    }
    else
    {
        form.distance.value="";
        form.distance.disabled=true;
    }
}



//==========================================================
//Match object: stores simple phrase data
//==========================================================

//constructor for a simple phrase data object
//pb: property bag holding the item (in and out)
//form : either a documtnt form or any other javascript object with the same structire

function CSMatchItem(pb, form_name)
{
this.form_name=form_name;
this.pb=pb;
this.caselabel="nocare";
}

//reads data fromthe property bag and set up the form elements
//@pp_str: path to the Match node (including the "Match")
CSMatchItem.prototype.draw = function(pp_str, node)
{

   var chk=(node=="MatchPattern");
   var form = document.forms[this.form_name]
	form.simplestring.checked = "checked"
  // form.exact_match.checked = "checked"
   
CSRPhrase_ToggleRegXSimpStr(true)
   form.wildcard.checked=chk;
   form.regexp.checked=(pp_str.search("RERule") != -1);
   form.old_pp.value= pp_str;
   form.old_node.value= node;

   gIsScoreBased = false;

   var ppT = new PropertyPath(pp_str);
   if(undefined == this.pb || undefined == this.pb.GetProperty(ppT))
   {   return;
   }

	if (gPharseEnable == true)
	{
		if (pp_str.search("RERule") != -1) 
		{
			//form.exact_match.disabled=true;
			form.wildcard.disabled=true;
			form.isstart.disabled=true;
			form.isend.disabled=true;
			form.simplestring.disabled=true;
		}
		if (pp_str.search("CFRule") != -1)
			form.regexp.disabled=true;
	}
   ppT.SetTempLeaf("text");
   form.text.value= this.pb.GetProperty(ppT);
	
	ppT.SetTempLeaf("score");
	if(this.pb.GetProperty(ppT) != undefined)
	{
		
		form.score.value= this.pb.GetProperty(ppT);
		gIsScoreBased = true;
				
	}
	else
	{
		
		if(isNaN(this.pb.ShowScoreValues(form.regexp.checked)))
		{
			
			gIsScoreBased = false;
			var div1 = document.getElementById("scr")
			if(div1)
			{
				div1.style.display="none";
				
			}
		}
		else
		{
			if(form.regexp.checked || this.pb.ShowScoreValues(form.regexp.checked) != "")
				gIsScoreBased = true;
		}
	
	}

	if(gIsScoreBased)
	{
		CSRP_Validation_Init(true);
	}
	
    
	
	
   var prop=[ {key:"case", chk:"care"}, {key:"isstart",chk:"care"}, {key:"isend",chk:"care"}]
   for (var i=0; i<prop.length; i++)
   {
		ppT.SetTempLeaf(prop[i].key);
		form[prop[i].key].checked= (this.pb.GetProperty(ppT)==prop[i].chk?true:false);
   }

   UpdateRuleControls();
}

//write data in propertybag. remove old data if any.
//@pp_str: path to the Match container (does not includes "Match")
CSMatchItem.prototype.Save = function(parent_pp_str, mainElt,complex)
{
    var form = document.forms[this.form_name]
	var wildcard=form.wildcard.checked;
	var regexp=form.regexp.checked;
	var simplestr=form.simplestring.checked;
	var old_node = form.old_node.value;
    var old_pp = form.old_pp.value;
    var node = CSRPhrase_GetPhraseNode(false, wildcard, "", "");
    var pp_str = parent_pp_str + "." + node;

    if(false == complex)         //do only for a non-complex phrase
		pp_str = this.pb.GetNextElementEnum(pp_str)

    //cleanup and set node pp for storage
    var non_enum_pp =  RemoveLeafEnum(old_pp)
    if (pp_str == non_enum_pp )
    {   pp_str = old_pp;
    }
    else
    {
		if(!mainElt)       // do these only if it is not the main element.//delete useful incase of contextual phrases editing.
	    {
		  this.pb.DeleteElementEx(old_pp);
		  pp_str = this.pb.GetNextElementEnum(pp_str);
        }
    }

    //save
	var ppT= new PropertyPath(pp_str);
	this.pb.SetProperty(ppT);
	ppT.SetTempLeaf("text");
	this.pb.SetProperty(ppT, form.text.value);
	ppT.SetTempLeaf("case");
    this.pb.SetProperty(ppT, form["case"].checked?"care":"nocare");
	
	if(form._score)
	{
		if(form._score.value != "")
		{
			ppT.SetTempLeaf("score");
			this.pb.SetProperty(ppT, form._score.value);
		}
	}
	//if(!(wildcard || regexp))
	if(simplestr)
	{  
		
			//ppT.SetTempLeaf("exact_match");
	        //this.pb.SetProperty(ppT, form.exact_match.checked?"care":"nocare");
			ppT.SetTempLeaf("isstart");
	        this.pb.SetProperty(ppT, form.isstart.checked?"care":"nocare");
	   	    ppT.SetTempLeaf("isend");
	        this.pb.SetProperty(ppT, form.isend.checked?"care":"nocare");
	}

}


//==========================================================
//Phrase object : stores data related to a complete simple or
//complex phrase node
//==========================================================

//constructor for the simple or complex phrase data object
//pbIn: property bag holding the up to date rules
//pp_str: path to the  phrase node: "match" if it is a simple, or "Near*" or "AndRule" if it is a complex one
//node: type of node, e.g "Match", "MatchPatterm", "AndRule" , "NotNear", "NearAny", "NearAll"
//
//the parameter "context" is a data structure with the following members:
//ppIn: path to the phrase node (simple match or complex container, includes enum)
//node : type of the phrase node (either a simple match or a complex container)
//logic : relationship with contextualwords
//lst   : list of contextual words (path and node type)
//distance : nb of characters to examine fr contextual words

function CSRPhrase(pbIn, ppIn, node)
{
    var ppT;
    this.node = node;
    this.phrase_pb = new PropertyBag();
    this.context=null;

    if ("string" == typeof(ppIn))
    {   this.pp_str = ppIn;
        ppT = new PropertyPath(this.pp_str);
    }
    else
    {   this.pp_str = ppIn.GetPath();
        ppT=ppIn;
		gPharseEnable = true;
    }

    if (CSRules_IsSimplePhrase(node))
    {       this.complex=false;
    }
    else
    {       this.complex=true;
    }



    //copy whole CFRule context.
    var pp_cfrule_str=this.pp_str.substr(0,this.pp_str.lastIndexOf("."))
    var ppCFRule = new PropertyPath(this.pp_cfrule_str);
    pbIn.GetElement(pp_cfrule_str, this.phrase_pb);

    //create a new phrase node if not there
	if( undefined == this.phrase_pb.GetProperty(ppT) )
    {
       this.phrase_pb.SetProperty(ppT);
       if (!CSRules_IsSimplePhrase(node))
       {  ppT.Append("Match")
           this.phrase_pb.SetProperty(ppT);
       }
       ppT.SetTempLeaf("case")
       this.phrase_pb.SetProperty(ppT, "nocare");
       ppT.SetTempLeaf("isstart")
       this.phrase_pb.SetProperty(ppT, "nocare");
       ppT.SetTempLeaf("isend")
       this.phrase_pb.SetProperty(ppT, "nocare");
       ppT.SetTempLeaf("text")
       this.phrase_pb.SetProperty(ppT, "");
    }

}


//create a new phrase pp from the existing pp_str and the node name
//does not replace existing pp though
CSRPhrase.prototype.CreateNewPP = function(node, chk_regex, chk_wildcard)
{
	var pp_str = "";

	// Find out whether it is first node or enumerated one.
	var enumValue = false;
	var dotCount = gPhrase.pp_str.lastIndexOf(".");
	var colonCount = gPhrase.pp_str.lastIndexOf(":");
	if (colonCount > dotCount)
	{
		enumValue = true;
	}

	if (chk_regex)
	{
		// RegEx path then modifiy it.
		pp_str=this.pp_str.substr(0,gPhrase.pp_str.lastIndexOf("."))
		pp_str=pp_str.substr(0, pp_str.lastIndexOf("."))
		pp_str+=".RERule";
	}
	else
	{
		//node is different: get a new path
		pp_str=this.pp_str.substr(0,gPhrase.pp_str.lastIndexOf("."))
		pp_str=pp_str.substr(0, pp_str.lastIndexOf("."))
		pp_str+=".CFRule";
	}

	if(node.length>0)
	{
		pp_str += "." + node;
	}

	if (this.node != node)
	{
		//Add the enum value. This is essential for multiple Rule Creation.Since this increments the Enumeration.
		//Followed the cue from the function CSRPhrase_CreateNewPP
		pp_str = this.phrase_pb.GetNextElementEnum(pp_str);
	}
	else if (enumValue)
	{
		pp_str += gPhrase.pp_str.substr(colonCount);
	}

	return pp_str;
}

//create a new context
CSRPhrase.prototype.InitContext = function(logic, distance, lst)
{
     if(logic!="")
     {   this.context=new Object();
	     this.context.logic=logic;
 	     this.context.distance=distance;
	     this.context.lst=lst;
         this.context.pp_str="";
         this.context.main_node="";

         for(var i=0;i< CSRules_PhraseStruct.length; i++)
         {
             if ( (CSRules_PhraseStruct[i].logic==logic) && (CSRules_PhraseStruct[i].dist==(distance>0)) )
             {   var path= CSRules_PhraseStruct[i].path;
                 this.context.lst_path=this.pp_str
                 if (path.length)
                 {   this.context.lst_path+= ".";
                     this.context.lst_path+=path;
                 }
             }
         }


     }
	 else
	 {   this.context=null;
	 }
}


//Find the type of the main node (either Match or MatchPattern) in a complex phrase
//This will be the first Match or MatchPatter node found
CSRPhrase.prototype.FindMainNode = function(resOut)
{
   var regexStr='^' + this.pp_str + ".(Match\\w*)(:\\d{8})*$";
   var pattern=new RegExp(regexStr);
   var lst= this.phrase_pb.GetMatchingPaths(pattern);
   var name = CSRules_GetPhraseTxt(this.phrase_pb, this.pp_str,  this.node );

   if(lst.length)
   {   resOut.pp_str=lst[0][0];
       resOut.node=lst[0][1];
   }
}

//returns the number of context words registered
CSRPhrase.prototype.GetNbComplex = function(chk)
{
    if(!chk) return 0;
    if (!this.context) return 0;
    if (!this.context.lst) return 0;
    return this.context.lst.length;
}

//Find sublist
//@pp_str and key give path to the parent node (not including match)
//@noTop is true if first item should be ignored
CSRPhrase.prototype.FindSubList = function(lst_pp, noTop)
{
    var regexStr='^' + lst_pp + ".(Match\\w*)(:\\d{8})*$";
    var pattern=new RegExp(regexStr);
    var lst=this.phrase_pb.GetMatchingPaths(pattern);

    if (noTop)
    {  var dup = [];
	   for(var i=1;i<lst.length;i++)
	   {   dup.push(lst[i]);
	   }
       lst=dup;
    }
	return lst;
}


//Get the logic  and list of phrases behind a complex node
//@pp_str: pp to a complex phrase node
CSRPhrase.prototype.Parse_AndRule= function()
{
    var res=new Object();
	res.distance=0;
	this.FindMainNode(res);

    //look for "OrRule"
    var key=".OrRule";
	var lst=this.FindSubList(this.pp_str+ key, false)
	if (lst.length>0)
	{   res.logic="ANY";
        res.lst_path=this.pp_str + key
	    res.lst=lst;
		return res;
    }

    //look for "NotRule"
    key=".NotRule.OrRule";
	lst=this.FindSubList(this.pp_str+ key, false)
 	if (lst.length>0)
	{   res.logic="NONE";
        res.lst_path=this.pp_str + key
	    res.lst=lst;
		return res;
	}
	lst=this.FindSubList(this.pp_str , true)     //we explicity send it as true (noTop) since we donot want the first element.(which is the main phrase.)
    res.logic="ALL";
    res.lst_path=this.pp_str;
	res.lst=lst;
	return res;
}

//get context from property bag
CSRPhrase.prototype.GetComplex = function()
{

var distance=0;
var main_node="Match";


   if (this.node != "AndRule")
   {
       var res=new Object();

       //get the distance
       var ppT = new PropertyPath(this.pp_str)
       ppT.SetTempLeaf("distance");
       res.distance=this.phrase_pb.GetPropertyDef(ppT, 0)-0;

       //find contextual phrases
	   res.lst=this.FindSubList(this.pp_str+".List", false)
       res.lst_path=this.pp_str+ ".List";

	   //get the logic selection
       if(this.node=="NotNear")
       {
           res.logic="NONE"
       }
       else if(this.node=="NearAll")
       {
           res.logic="ALL"
       }
       else if(this.node=="NearAny")
       {
           res.logic="ANY"
       }
	   this.FindMainNode(res);

	   this.context= res;

   }
   else
   {
       this.context=this.Parse_AndRule();
   }

}

//save the converted list from old pb
//phrases have to be different!
CSRPhrase.prototype.SaveConvertLst = function(oPhrase)
{
    var oPb = oPhrase.phrase_pb;
    var nPb = this.phrase_pb;
    var oPP = oPhrase.context.lst_path;
    var nPP = this.context.lst_path;     //this has been modified appropriately in SavePhraseNode function

    if(!oPP) return;
    if(!oPb) return;
    if(oPb == nPb) return;

    //cleanup the new phrase
    //nPb.DeleteElement(oPP);

    //create parent node
    var parent_ppT = new PropertyPath (nPP);
    nPb.SetProperty(parent_ppT);

    //save list
    for (var i=0;i<oPhrase.context.lst.length ; i++)
    {
        var oEltNode = oPhrase.context.lst[i][1];
        var oEltPP  = oPhrase.context.lst[i][0];

        var base_pp_str=nPP+"."+oEltNode;
        var base_ppT = new PropertyPath(base_pp_str);
        var nEltPP = nPb.GetNextElementEnum(base_ppT);
        var ppT =  new PropertyPath(nEltPP);
        nPb.SetProperty(ppT)

        for (var pp in oPb.propValues)
        {

            if (IsAncestorPathOf(oEltPP, pp))
            {
                var tail = pp.substr(1+oEltPP.length)
                ppT.SetTempLeaf(tail)
                nPb.SetProperty(ppT, oPb.propValues[pp])
                ppT.SetTempLeaf("");
            }

        }
    }
}

//Save the converted old phrase into a new phrase
CSRPhrase.prototype.SavePhraseNode = function(oldPhrase)
{
	//cleanup
	 this.phrase_pb.DeleteElementEx(oldPhrase.pp_str);
	//the deletion has moved the enumeration upwards. //so now the pp_str needs to be changed
	if( oldPhrase.pp_str == this.pp_str)
	{
		//check whether this the base path.
		var new_pp_str = this.pp_str.substr(this.pp_str.lastIndexOf(".")+1);      //string after the last period.

		if(-1 != new_pp_str.indexOf(":"))    //enumeration present //this is not the base path so find the substr.
			new_pp_str = this.pp_str.substr(0,this.pp_str.lastIndexOf(":")); //string without enumeration.
		else
		    new_pp_str = this.pp_str;       //since it is the base path //no enumeration present.

		new_pp_str = this.phrase_pb.GetNextElementEnum(new_pp_str);
		this.pp_str = new_pp_str;       //setting the property path of the phrase object.
		/**********************************************************************/
		//we also need to set context_path value for the current phrase.
		/**********************************************************************/
		if( null != this.context)          //complex node only.
		{
			var nPP=this.context.lst_path ;
			var tail_str= nPP.substr(nPP.lastIndexOf(".")+1);     //string after the last period.

			if("OrRule" == tail_str && "NONE" == this.context.logic)     //then the tail should become NotRule.OrRule //refer CSRules_PhraseStruct for further understanding.
				tail_str = "NotRule.OrRule" ;

			if((-1 != tail_str.indexOf(":") ) || ("AndRule" == tail_str))   //enumeration present //it can be of the type AndRule:0000x type only.//or if it is AndRule
				this.context.lst_path = this.pp_str;     //just set the contextpath to the latest pp.
			else
				this.context.lst_path = this.pp_str + "." + tail_str;   //just add the tail to the latest enumerated value.//period in between.
		}
	}
	this.phrase_pb.DeleteElementEx(this.pp_str);     //required //for wildcards. //so that Match Tag isn't present for MatchPattern Phrases.
    //save
    if (this.complex)
    {
        //get name of the node from name of main word or phrase
        var form= document.forms["main_form"];
        //save complex phrase node
	    var ppT = new PropertyPath(this.pp_str);
        this.phrase_pb.SetProperty(ppT);
        var dist=this.context.distance-0;
        if (dist>0)
        {
             ppT.SetTempLeaf("distance");
             this.phrase_pb.SetProperty(ppT, dist);
        }
        ppT.SetTempLeaf("name");
        this.phrase_pb.SetProperty(ppT, form.text.value);
        ppT.SetTempLeaf("");
        //save main word item
        var match=new CSMatchItem(this.phrase_pb, "main_form");
 	    match.Save(this.pp_str, true);

        //save list (from old list, with paths changed)
        this.SaveConvertLst(oldPhrase)
      }
	  else
	  {
           var match=new CSMatchItem(this.phrase_pb, "main_form");
		   var parent_pp_str =  this.pp_str.substr(0,this.pp_str.lastIndexOf("."))
		   match.Save(parent_pp_str,true,false);
	  }

}

//==========================================================
// Drawing functions
//==========================================================


function CSRPhrase_DrawContextLogic(logic)
{
    var sel=document.getElementById("context_sel");
    if (!sel)    return;
    for(var i=0;i<sel.options.length;i++)
    {  if ( sel.options[i].value==logic)
       {  sel.selectedIndex=i;
          return;
       }
    }
}


//Build table of all phrases in this condition
//@ppIn: pp to the phrase node
//@node: type of the main node
function  CSRPhrase_DrawContextList(res)
{

   var tbl_div=document.getElementById("context_lst_div")
   if (!tbl_div)
   {  return;
   }
   tbl_div.innerHTML="";

   var pbIn=gPhrase.phrase_pb;
   var tbl=document.createElement("table");
   tbl_div.appendChild(tbl);
   tbl.width="100%";
   tbl.id="tbl_phrases";

   var tbody=document.createElement("tbody");
   tbl.appendChild(tbody);

   for (var i=0;i<res.length ;i++ )
   {
      var row=document.createElement("tr");
  	  tbody.appendChild(row);

      //add first cell
      var cell=document.createElement("td");
      row.appendChild(cell);
      cell.vAlign="top";
      cell.noWrap=true;
      var txt=CSRules_GetPhraseTxt(pbIn, res[i][0], res[i][1])
      var content=document.createTextNode(txt+'\u00A0');
	  cell.appendChild(content);

      //add edit/delete cell
      var lnk1="javascript:CSRPhrase_ShowCtxPopup(\"" +res[i][0]+"\",\""+ res[i][1] + "\",false)"
	  var lnk2="javascript:CSRPhrase_Delete(\"" +res[i][0]+"\" )"
      cell=document.createElement("td");
  	  row.appendChild(cell);
      cell.className="rightAligned"
      cell.noWrap="true"
      cell.vAlign="top";
      var tmpValue = "__edit";
      var content="<a href='" + lnk1 + "' class='blueLink'>"+ resolveString(cse_pp_st, tmpValue)+" </a>"
      content+="&nbsp;|&nbsp;"
	  tmpValue = "__delete";
      content+="<a href='" + lnk2 + "' class='blueLink'>"+ resolveString(cse_pp_st, tmpValue)+" </a>"
      cell.innerHTML=content;

   }

//apply style
makeSDL(tbl.id, false);
}



//Draw context component, including logic selection and distance
//@ppIn: pp to the phrase node
//@node: type of the main node
function  CSRPhrase_DrawContext(complex_phrase)
{

    var distance=complex_phrase.distance;
    var form= document.forms["main_form"];

    var chk=(distance>0);
    if (chk)
    {
            form.distance_shadow.value=distance;
            form.distance_ctl.checked = true
    }
    else
    {       form.distance_shadow.value="";
            form.distance_ctl.checked = false
    }

    CSRPhrase_ToggleDistance(chk);
    CSRPhrase_DrawContextLogic(complex_phrase.logic);
    CSRPhrase_DrawContextList(complex_phrase.lst);


}


//Build table of all phrases in this condition
//@ppIn: pp to the phrase "Match" or "MatchPattern" node
//@node: type of the main node
function  CSRPhrase_DrawMain(pp_str, node, form_name)
{
    var match=new CSMatchItem(gPhrase.phrase_pb, form_name);
	match.draw(pp_str, node)
}


//Populate page with data from property bag
//@pp_str: pp to the actual phrase
function CSRPhrase_DrawData(phrase)
{
var pbIn=phrase.phrase_pb;
var pp = phrase.pp_str;
var node = phrase.node;

var chk=phrase.complex;

    var ctl=document.getElementById("complex_ctl");
    ctl.checked=chk;
    CSRPhrase_ToggleComplex(chk);

    //draw complex phrase data, if any
    if(chk)
    {
        phrase.GetComplex();
        pp=phrase.context.pp_str;
		node=phrase.context.node;

        //CSRPhrase_DrawContextList(complex_phrase.lst);
        CSRPhrase_DrawContext(phrase.context);
    }

    //draw
    CSRPhrase_DrawMain(pp, node, "main_form");
}


//Show popup
function CSRPhrase_ShowCtxPopup(pp_str, node, addNewCtxWordFlag)
{
	var pop_div=document.getElementById("ctx_div");
    var sel=document.getElementById("context_sel");

    var x= (mouseY - 140)
    //38
	
	pop_div.style.top = x + "px";
    pop_div.style.display="";
    sel.style.display="none";
    CSRPhrase_DrawMain(pp_str, node, "ctx_form")

	var form= document.forms["main_form"];
	var form_ctx= document.forms["ctx_form"];

	//form_ctx.exact_match.disabled=form.regexp.checked;
	form_ctx.wildcard.disabled=form.regexp.checked;
	form_ctx.isstart.disabled=form.regexp.checked;
	form_ctx.isend.disabled=form.regexp.checked;
	form_ctx.regexp.disabled=!form.regexp.checked;
	form_ctx.regexp.checked=form.regexp.checked;
	if(addNewCtxWordFlag != false)	//'Exact Match' radio button within Contextual word Popup should be selected only when Adding a NEW Contextual word and word text must be reset to blank
	{
		form_ctx._text.value = "";
		//form_ctx.exact_match.checked=!form.regexp.checked;
	}
}

//set the gPhrase Context list right in case of Trigger All option
//Checks whether the current rule belongs to the AndRule group.
function Check_AndRule(pp_str)
{
	var temp_pp = pp_str.substr(pp_str.lastIndexOf(".")+1);
	var pos = temp_pp.indexOf(":");
	if( pos != -1)
	temp_pp = temp_pp.substr(0,pos)

	if("AndRule"==temp_pp)
		return true;
	else
	    return false;
}


function CSRPhrase_HideCtxPopup(ok)
{

    if(ok)
    {
	     var valid = csw_vframeworks["ctx_form"].onsubmit()
		 if(!valid) return;

	     //get pp to parent path - create a .List if there was none.
         if(!gPhrase.complex)
         {    gPhrase.InitContext("ANY", 0, [])
         }
         var parent_pp = gPhrase.context.lst_path;
         //save the phrase
         var match=new CSMatchItem(gPhrase.phrase_pb, "ctx_form");
	     match.Save(parent_pp);

		 //Need to chopoff the top element the context.lst incase of Trigger ALL (no distance) since the main phrase too appears in the context_list.
		 var noTop = Check_AndRule(parent_pp); //check for AndRule

         gPhrase.context.lst= gPhrase.FindSubList(parent_pp, noTop)
         CSRPhrase_DrawContextList(gPhrase.context.lst)
    }

    var div=document.getElementById("ctx_div");
    var sel=document.getElementById("context_sel");
    div.style.display="none";
    sel.style.display="";

    var phraseT=gPhrase;
}

//deleting word or phrase
function CSRPhrase_Delete(pp_str)
{
     var parent_pp = gPhrase.context.lst_path;
     gPhrase.phrase_pb.DeleteElementEx(pp_str);

	 //Need to chopoff the top element the context.lst incase of Trigger ALL (no distance) since the main phrase too appears in the context list.
	 var noTop = Check_AndRule(parent_pp);//code change
     gPhrase.context.lst= gPhrase.FindSubList(parent_pp, noTop);

     CSRPhrase_DrawContextList(gPhrase.context.lst);
     top.gPageStack.Active().SetModified(true);
}


//==========================================================
// Reading form and saving Phrase
//==========================================================

//check if  path to context have changed
//
function CSRPhrase_Diff(phraseIn, phraseOut)
{
     if(phraseIn.pp_str != phraseOut.pp_str) return false;
	 if(phraseIn.node != phraseOut.node) return false;
	 if(phraseIn.complex != phraseOut.complex) return false;
     if(phraseIn.complex)
	 {  if(phraseIn.context.logic != phraseOut.context.logic) return false;
	 }
	 return true;
}



//get new pp_str from old and node
function CSRPhrase_CreateNewPP(node)
{
     if (gPhrase.node == node)
     {   return gPhrase.pp_str;
     }

     //node is different
     var pp_str=gPhrase.pp_str.substr(0,gPhrase.pp_str.lastIndexOf("."))

     if(node.length>0)
     {   pp_str+=".";
         pp_str+=node;
     }

      //add enum bit
      var new_pp_str = this.phrase_pb.GetNextElementEnum(pp_str);
      return new_pp_str;
}


//Read data from the form and guess what the new node is
//add complex data from old phrase, if any.
function CSRPhrase_CreatePhraseFromData(oldPhrase)
{
    var form= document.forms["main_form"];
    var logic="";
    var chk_complex=form.complex_ctl.checked;
    var chk_wildcard=form.wildcard.checked;
    var chk_regex=form.regexp.checked;
    var distance = "";

    if(chk_complex)
    {
         var sel=form.context_sel;
         if (sel)
         {   logic=sel.options[sel.selectedIndex].value
         }
         if (logic=="")
         {   chk_complex=false;
         }

         var nbContext = oldPhrase.GetNbComplex(chk_complex)
         if (!nbContext)
         {   chk_complex=false;
             logic="";
         }

         if(nbContext)
         {
             if(form.distance_ctl.checked)
             {    distance=form.distance.value;
             }
         }
    }

    //now create the phrase (without the list of complex nodes)
    var node = CSRPhrase_GetPhraseNode(chk_complex, chk_wildcard, distance, logic)
    var pp_str=oldPhrase.CreateNewPP(node, chk_regex, chk_wildcard);
	var phrase=new CSRPhrase(oldPhrase.phrase_pb, pp_str, node);
	if(chk_complex)
    {   phrase.InitContext(logic, distance, [])
	}

    phrase.SavePhraseNode(oldPhrase);

    return phrase;
}

// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function CSRP_Show(pbIn, ppIn, node)
{

CSRP_Validation_Init();

//display rule name, category and description, then the list of conditions
gPhrase=new CSRPhrase(pbIn, ppIn, node);
CSRPhrase_DrawData(gPhrase)
}

/**
 * Asynchronous data validation function
 */
function CSRP_Validate() {
    var ok = csw_vframeworks["main_form"].onsubmit()
	return ok
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function CSRP_Apply( pbOut)
{

    //convert phrase into a clean new one
	var phrase = CSRPhrase_CreatePhraseFromData(gPhrase);

    //now save in outgoing propertybag
    pbOut.DeleteElementEx(gPhrase.pp_str);
    phrase.phrase_pb.GetElement(phrase.pp_str, pbOut);

	return pbOut;
}

function UpdateRuleControls()
{
	var form= document.forms["main_form"];
	var val=form.regexp.checked;


	if(gIsScoreBased == true)
		val = true
	if(form.score != McUndefined)
	{
		if(form.score.value != "")
			val = true
	}

	form.complex_ctl.disabled = val;

	if (val == true  )
	{
		CSRPhrase_ToggleComplex(false);
		form.complex_ctl.checked = false;
	}
}

function CSRPhrase_ToggleRegXSimpStr(chk)
{
	
	var div=document.getElementById("regexp");
	

	if(div.checked)
	{
		var div1=document.getElementById("regexp");
		div1.checked = "checked"

		var div=document.getElementById("wildcard");
		if (div)
		{
			div.disabled="true"
		}

		/*div=document.getElementById("exact_match");
		if (div)
		{
			div.disabled="true"
		}*/
		
		div=document.getElementById("isstart");
		if (div)
		{
			div.disabled="true"
		}
		div=document.getElementById("isend");
		if (div)
		{
			div.disabled="true"
		}
	}
	else
	{
		var div1=document.getElementById("simplestring");
		div1.checked = "checked"
		
		var div=document.getElementById("wildcard");
		if (div)
		{
			
			div.disabled=""
		}

		/*div=document.getElementById("exact_match");
		if (div)
		{
			div.disabled=""
		}*/
		
		div=document.getElementById("isstart");
		if (div)
		{
			div.disabled=""
		}
		div=document.getElementById("isend");
		if (div)
		{
			div.disabled=""
		}

	}

	UpdateRuleControls();
}