// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Manage one CS rule
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================

var gCSRulePanel;
var csr_vframeworks = new Object();
var csr_dataBindings = new Array();
var ruleTypePath="";
var origName="";

// data structure to store info
// @this.pb local propertybag, cloned from pbIn
// @this.pp_str path to this rule

function CSRulePanel(pbIn, ppIn)
{
    this.pb=new PropertyBag();

    if ("string" == typeof(ppIn))
    {   this.pp_str = ppIn;
        ppT = new PropertyPath(this.pp_str);
    }
    else
    {   this.pp_str = ppIn.GetPath();
        ppT=ppIn;
    }

    if( pbIn==null || undefined == pbIn.GetProperty(ppT) )
    {//path does not exist: create a new node
         var id= MakeGuid("RNAI")
	     this.pb.SetProperty(ppT);
	     ppT.SetTempLeaf("ID");
         this.pb.SetProperty(ppT, id);
         ppT.SetTempLeaf("description");
         this.pb.SetProperty(ppT, "");
         ppT.SetTempLeaf("name");
         this.pb.SetProperty(ppT, "");
         ppT.SetTempLeaf("enabled");
         this.pb.SetProperty(ppT, "0");
         ppT.SetTempLeaf("root");
         this.pb.SetProperty(ppT, "0");
    }
    else
	{   //the path already exists - copy data locally
       pbIn.GetElement(this.pp_str, this.pb);
    }
}


//store data from this page
CSRulePanel.prototype.LocalStore = function()
{
     //nothing to store if there was no change
	 if( ! top.gPageStack.Active().Modified() )
	 return;

	 var ppT = new PropertyPath(this.pp_str);

     //make sure we don't store the top pb
	 var pbT = CSRules_GetTopPb();
     if (gCSRulePanel.pb==pbT)
     {   gCSRulePanel.pb= CSRules_MakePb(pbT)
     }

	 //save parameters from the page
     for(var i=0; i<csr_dataBindings.length; i++)
	 {   csr_dataBindings[i].get(ppT, this.pb);
	 }

	 //store pb
     CSRules_SetStorePb(this.pb, "rule")
}

//restore saved data - keep storeage if path does not exist yet in top pb.
CSRulePanel.prototype.LocalRestore = function()
{
   if(CSRules_IsStorePb("rule"))
   {
   var ppT = new PropertyPath (this.pp_str);
   var clear=true;

       this.pb=CSRules_GetStorePb("rule", true)
       top.gPageStack.Active().SetModified(true);
   }
}

//Delete condition
function CSRulePanel_DelCondition(pp_str)
{
   //make sure we don't delete in top propertybag
   var pbT = CSRules_GetTopPb();
   if (gCSRulePanel.pb==pbT)
   {   gCSRulePanel.pb= CSRules_MakePb(pbT)
   }
   gCSRulePanel.pb.DeleteElementEx(pp_str);
   CSRulePanel_DrawData(gCSRulePanel.pb, gCSRulePanel.pp_str)
   top.gPageStack.Active().SetModified(true);

}

//link to condition page
//@create=true if the condition is to be created, false=we are editing an existing condition
function CSRulePanel_EditCondition(create, pp_str)
{
    var title= resolveString(cse_pp_cs_st, "__condition" );
    var target= 'CSRCondition.html';

    if(create)
    {   target= 'CSNewCondition.html'
        pp_str=  gCSRulePanel.pb.GetNextElementEnum( gCSRulePanel.pp_str+".ConditionRule");
    }

    gCSRulePanel.LocalStore();
    var page = new DialogPage(target, title);
    top.gPageStack.Forward(page, pp_str);
}

function  CSRulePanel_GetPhraseSep(nb,  node )
{
   	var txt_tpl = "__any_complex_phrase";

	if (CSRules_IsSimplePhrase(node)  )
	{   txt_tpl = "__any_simple_phrase";
	}


    var txt= nb>0?resolveString(cse_pp_cs_st,"__or"):"";
    txt+=resolveString(cse_pp_cs_st,txt_tpl);

    return txt;
}

function  CSRulePanel_GetAllPhrases(pbIn, pp_str,  node, tbody, nb)
{

    var txt = "";
    var res=CSRules_GetAllSortedPhrases(pbIn, pp_str, node)

    for (var i=0;i<res.length ;i++ )
    {   if(i>0) txt +=", ";
        txt+= CSRules_GetPhraseTxt(pbIn, res[i][0], node, true)
    }

    //add row
    if(txt.length)
    {
        var row=document.createElement("tr");
        tbody.appendChild(row);
        var cell=document.createElement("td");
        row.appendChild(cell);
        cell.noWrap=true;
        cell.vAlign="top";
        var sep=CSRulePanel_GetPhraseSep(nb,  node);
        var content=document.createTextNode(sep+'\u00A0');
	    cell.appendChild(content);

        cell=document.createElement("td");
        row.appendChild(cell);
	    cell.className="noLeft";
        content=document.createTextNode(txt)
        cell.appendChild(content);
        return 1;
    }
	return 0;
}

//Retrieve "found in " infromation from the propertybag
//@pbIn = propertybag
//pp_str: pp to the condition node
function CSRulePanel_FoundIn(pbIn, pp_str)
{
   var lst=FCS_GetPropertyList(pbIn, pp_str, "Applies", "section" )
   var txt = FCS_ConvertValues(lst, 1)
   return txt;

}

//Build table of al phrases in a given condition
//@ppIn: pp to the condition node
function  CSRulePanel_Phrases(pbIn, pp_str, tbl_id, tbl_div, hdr_txt)
{
   var fileformat_str=CSRulePanel_FoundIn(pbIn, pp_str)

   var tbl=document.createElement("table");
   tbl_div.appendChild(tbl);
   tbl.width="90%";
   tbl.id=tbl_id;
   //alert(pp_str + " " + regexStr + " " + res.length);

   var tbody=document.createElement("tbody");
   tbl.appendChild(tbody);

   //add header
   var row=document.createElement("tr");
   tbody.appendChild(row);
   row.className="header";
   //add header first cell
   var cell=document.createElement("td");
   row.appendChild(cell);
   cell.style.fontWeight="bold";
   cell.noWrap="true";
   cell.appendChild (document.createTextNode(hdr_txt));

   //append header second cell
   cell=document.createElement("td");
   row.appendChild(cell);
   cell.noWrap=true;
   cell.className="noLeft rightAligned";
   var btn_html= '<a class="blueLink" href="javascript:CSRulePanel_EditCondition(false, \'' + pp_str + '\')" >';
   btn_html += resolveString(cse_pp_st, "__edit") + '</a>'
   btn_html += '&nbsp;|&nbsp;'
   btn_html += '<a class="blueLink" href="javascript:CSRulePanel_DelCondition( \'' + pp_str + '\')" >';
   btn_html += resolveString(cse_pp_st, "__delete") + '</a>'
   cell.innerHTML=btn_html;


   //add phrases rows
   var nb=0;
   for (var i=0; i<CSRules_PhraseTypes.length;i++ )
   {    for (var j=0; j<CSRules_PhraseTypes[i].length;j++ )
        {  nb+= CSRulePanel_GetAllPhrases(pbIn, pp_str, CSRules_PhraseTypes[i][j], tbody, nb);
        }
   }

   //add fileformat
   var row=document.createElement("tr");
   tbody.appendChild(row);

   var cell=document.createElement("td");
   row.appendChild(cell);
   cell.colSpan="2";
   var span=document.createElement("span");
   cell.appendChild(span);
   span.style.fontWeight = "bold";
   var label=document.createTextNode(resolveString(cse_pp_cs_st,"__found") +" : ");
   span.appendChild(label);
   cell.appendChild(document.createTextNode(fileformat_str));

   return nb;

}

//Draw the list of conditions
//pbIn: rules property bag
//ppIn: property path to condition node
//tbl_node :document node where to add the table row

function     CSRulePanel_DrawCondition(hdr_txt, pbIn, ppIn, tbl_node, ndx)
{
//find fileformat

//add header row
var tbl_id="phrases_"+ndx;

var row=document.createElement("tr");
tbl_node.appendChild(row);
var cell=document.createElement("td");
row.appendChild(cell);
cell.innerHTML="&nbsp;"

//add content row
row=document.createElement("tr");
tbl_node.appendChild(row);

//add first cell
cell=document.createElement("td");
row.appendChild(cell);

var nb= CSRulePanel_Phrases(pbIn, ppIn, tbl_id, cell, hdr_txt);

makeSDL(tbl_id, true);

}


//Populate page with data from property bag
function CSRulePanel_DrawData(pbIn, pp_str)
{
	//alert(pp_str)
	var ppT_Score =new PropertyPath(pp_str);

	ppT_Score.RemoveLeaf()
	 ppT_Score.SetTempLeaf("recommended_threshold");
    // ppT_Score.Append("recommended_threshold");
	//alert(ppT_Score)
	//alert(pbIn.GetProperty(ppT_Score))
	var div=document.getElementById("newcondition_btn");
   if(pbIn.GetProperty(ppT_Score) != McUndefined)
   {
       div.style.display = "none";
   }


     var ppT=new PropertyPath(pp_str);
     if(undefined === pbIn.GetProperty(ppT))
	 {
	      return;
	 }

     for(var i=0; i<csr_dataBindings.length; i++)
	 {   csr_dataBindings[i].set(ppT, pbIn);
	 }

     //now add all conditions in a table
	 var hdr=0;
	 var ndx=0;
	 var header_txt = [resolveString(cse_pp_cs_st, "__rule_triggered"), resolveString(cse_pp_cs_st, "__and_when")];
     var conditions_div=document.getElementById("conditions_div");
	 conditions_div.innerHTML="";

	 var table = document.createElement('table');
     conditions_div.appendChild(table);
     table.border = table.cellSpacing = 0;
	 table.width="100%"
     var tbody = document.createElement('tbody');
     table.appendChild(tbody);

     ppT.SetTempLeaf("");
     ppT.Append("ConditionRule");
     ppT.BeginEnum();

     while(pbIn.GetProperty(ppT) !== undefined)
     {
         CSRulePanel_DrawCondition(header_txt[hdr], pbIn, ppT.GetPath(), tbody, ndx);
	     ppT.IncrementEnum();
		 hdr=1;
		 ndx++;
     }

     ppT.EndEnum();
}


function CSRulePanel_Validation_Init()
{
   var forms = ["_rule_name","cs_rule"];

   for (var i = 0; i < forms.length; i++) {
        var form = forms[i];
        if (document.forms[form]) {
            csr_vframeworks[form] = new ValidationFramework(form);
            csr_vframeworks[form].formAction = std_val_form_action;
            csr_vframeworks[form].fieldAction = std_val_field_action;
        }
    }

   var reqV=new RequiredValidator();
   //var scriptV = new ScriptValidator();
   csr_vframeworks["_rule_name"].addValidator("name",reqV);
   // csr_vframeworks["_rule_name"].addValidator("name",scriptV);
   // csr_vframeworks["cs_rule"].addValidator("description",scriptV);
   var inputV = new InputTextValidator(true);
   csr_vframeworks["_rule_name"].addValidator("name",inputV);
   csr_vframeworks["cs_rule"].addValidator("description",inputV);

   var inputArray= new Array();
   inputArray["SECTION"]="DLP and Compliance Rules";
   inputArray["origName"]=origName;
   inputArray["basePP"]=ruleTypePath + ".Rule";
   csr_vframeworks["_rule_name"].addValidator("name",new DuplicatesValidator(CSRules_GetTopPb(),inputArray))
   csr_vframeworks["_rule_name"].addValidator("name",new LengthValidator())

   csr_vframeworks["_rule_name"].labelMap["name"] = resolveString(page_st, "lm_rule_name");
   csr_vframeworks["cs_rule"].labelMap["description"] = resolveString(cse_pp_st,"__description");

}

/**
 * Asynchronous data load function
 */
// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function CSRulePanel_Show(ppIn, qp_cat)
{

   var basePP="";
   //data init
   var rules_pb = CSRules_GetTopPb();

   if ("string" == typeof(ppIn))
    basePP=ppIn;
   else
    basePP=ppIn.GetPath();

   origName=rules_pb.GetPropertyDef( basePP + ".name", "");  //to be used for validation
   ruleTypePath=basePP.substr(0,basePP.lastIndexOf(".")); //get to the right property path string so as to iterate only in that particular RuleGroup.

   gCSRulePanel = new CSRulePanel(rules_pb, ppIn);

   var conditions_div=document.getElementById("conditions_div");
   conditions_div.innerHTML="";

   //Update page title with category
   var cat_div=document.getElementById("cat_div");
   cat_div.appendChild(document.createTextNode(" - "+resolveString(cse_pp_cs_st,"__category")+qp_cat));

   //display rule name, category and description, then the list of conditions
   CSRulePanel_DrawData(gCSRulePanel.pb, gCSRulePanel.pp_str)

 //validation framework
   CSRulePanel_Validation_Init();
}

/**
 * Asynchronous data validation function
 */
function CSRulePanel_Validate(/*check_condition*/) {

	var ok = csr_vframeworks["_rule_name"].onsubmit()

	if(!ok)
		return false;

	ok = csr_vframeworks["cs_rule"].onsubmit()

	/*if(!ok) return false;

    if(!check_condition)
    {
        return ok;
    }

  	var ppT = new PropertyPath(gCSRulePanel.pp_str);
	ppT.Append("ConditionRule");
	ppT.Append("Applies");
    ppT.SetTempLeaf("section");

    if(undefined === gCSRulePanel.pb.GetProperty(ppT))
	{     alert(resolveString(cse_pp_cs_st,"__create_condition"));
	      return false;
	}*/;

	return ok;
}

/**
 * Asynchronous data save function
 * @param pbOut the property bag to fill
 */
function CSRulePanel_Apply(pbOut)
{

	var ppT = new PropertyPath(gCSRulePanel.pp_str);
	var change=false;


	//save parameters
    for(var i=0; i<csr_dataBindings.length; i++)
	{
	     if ( csr_dataBindings[i].get(ppT, gCSRulePanel.pb))
	     {   change=true;
	     }
	}


    //update outgoing propertybag
	if (gCSRulePanel.pb != pbOut)
	{
         pbOut.DeleteList(gCSRulePanel.pp_str+".ConditionRule");
         gCSRulePanel.pb.GetElement(gCSRulePanel.pp_str, pbOut);
		 change=true;

	}

    if (change)
    {   top.gPageStack.Active().SetModified(true);
    }

    return change;
}
