// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Display list of content rules
// Assumes CSRules is included in the master page
//

//====================================================================================
// Const, globals and Flags
//====================================================================================

var csrListWidget = null;
var gCurrentCategoryId=null;

function CheckForDuplicates(displayName)
{
 var vRules= gContentRules.rules;
 var len= vRules.length;
 displayName = trim_string(displayName);
 for(var ndx=0;ndx<len;ndx++)
 {
	vRules[ndx].name = trim_string(vRules[ndx].name);
	if(displayName.toUpperCase() == vRules[ndx].name.toUpperCase())
		return true;
 }
 return false;
}

function CheckforMaxLength(displayName)
{
  //code to check for length
	displayName = trim_string(displayName);

	if(displayName.length <= 100)
     return false;
    else
     return true;
}

function CheckForSpecialChars(displayName)
{
	var splChars = "!@#$%^&*()+=-[]\\\';,./{}|\":<>?";
	for( var i = 0 ; i < displayName.length ; i++ )
	{
		if( splChars.indexOf( displayName.charAt(i) ) != -1 )
			return false;	
	}
		return true;
}
function CSRLists_createNewCategory()
{
	var str=prompt(resolveString(cse_pp_st, "__specify_category_name"));
	
      if(str)
        {
			var ret = false;
		    str = trim_string(str);

			ret=CheckforMaxLength(str);
			if(ret)
			{
			   alert(gsInvalidNameTooLong);
			   return;
			}
			ret=CheckForDuplicates(str);
			if(ret)
			{
				alert(gsDuplicateNotAllowed);
				return;
			}
			ret= ScriptInputValidation(str,false);
			if(!ret)
			{
				alert(gsScriptNotAllowed);
				return;
			}
			ret = CheckForSpecialChars(str);
			if(!ret)
			{
				alert(gsSpecialCharsNotAllowed);
				return;
			}
            // all the validations passed
			gContentRules.CreateGrpRules(str);
			csrListWidget = new SharedResourceManager("csr_lst_div", "csrListWidget", new CSRulesDriver(), {verticalSpace:"0px"});
			csrListWidget.setGWCtoZero();
			csrListWidget.setundefinedCounttoZero();
			csrListWidget.draw();
			csrListWidget.selLastCat();
			top.SetModified(true);
       }
}


function CSRLists_renameCategory() {

		var name = gContentRules.GetNameFromId("RefRuleGroup", gCurrentCategoryId);
		var str=prompt(resolveString(cse_pp_st, "__rename_category",[name]),"");
		if(str)
        {
			var ret = false;
		    str = trim_string(str);

			ret=CheckforMaxLength(str);
			 if(ret)
				{
					alert(gsInvalidNameTooLong);
					return;
				}
			ret = CheckForDuplicates(str);
			if(ret)
				{
					alert(gsDuplicateNotAllowed);
					return;
				}
			ret= ScriptInputValidation(str,false);
			if(!ret)
			{
				alert(gsScriptNotAllowed);
				return;
			}
			// all the validations passed
			gContentRules.RenameGrpRules(gCurrentCategoryId,str);
			csrListWidget = new SharedResourceManager("csr_lst_div", "csrListWidget", new CSRulesDriver(), {verticalSpace:"0px"});
			csrListWidget.draw();
			top.SetModified(true);
		}
}

function CSRLists_deleteCategory() {

        var name = gContentRules.GetNameFromId("RefRuleGroup", gCurrentCategoryId);
        var ok=confirm(resolveString(cse_pp_st, "__del_category_prompt",[name]));
        if(ok)
        {
            gContentRules.DeleteGrpRules(gCurrentCategoryId);
            csrListWidget = new SharedResourceManager("csr_lst_div", "csrListWidget", new CSRulesDriver(), {verticalSpace:"0px"});
            csrListWidget.draw();
            top.SetModified(true);
        }
}

// The resource management driver class for content rules
function CSRulesDriver() {
}

// Gets the header text: "Content Scanner Rules"
CSRulesDriver.prototype.getHeader = function() {
    return resolveString(cse_pp_cs_st, "__cs_rules");
}

// Gets the select directive: "Category:"
CSRulesDriver.prototype.getSelDirective = function() {
    return resolveString(cse_pp_st, "__cat_sel_directive");
}

// Gets the header text: "Select a Language"
CSRulesDriver.prototype.getLanguage = function() {
    return resolveString(cse_pp_st, "__MultiLangOpt");
}


// Gets category list for displaying in a dropdown list
CSRulesDriver.prototype.getCategoryList = function() {
    var ret = [];
    for (var i = 0; i < gContentRules.rules.length; i++) {
        var ruleGroup = gContentRules.rules[i];
		     ret.push({value:ruleGroup.id, text:ruleGroup.name, rtype:ruleGroup.rultype,lang:ruleGroup.lang,score:ruleGroup.score});
	
    }
    return ret;
}

// Creates a new content scanning rule
CSRulesDriver.prototype.newInstance = function(cat) {
    CSRLists_LoadCSRule(true, CSRLists_GetRGIndex(cat), 0);
}

CSRulesDriver.prototype.drawNoList = function(tbody) {
        var row = tbody.insertRow(0);
        var td = row.insertCell(0);
        td.colSpan = 3;
        td.style.textAlign = "center";
        td.appendChild(document.createTextNode(resolveString(cse_pp_st, "__nothing_to_display")));
        //dispalying the delete hyperlink
        var reflnk=document.getElementById("rg_del_lnk");
		reflnk.style.display=""
}

//parameters:
//cell= dom container for the controls
//id= category id, or value associated with item in getCategoryList
CSRulesDriver.prototype.otherTitleCtl = function(cell, id) {

        cell.appendChild(document.createTextNode("     "));
        var link = document.createElement("a");
        link.className = "blueLink";
        link.appendChild(document.createTextNode(resolveString(cse_pp_st, "__new_category")));
        link.href = "javascript:CSRLists_createNewCategory()";
        cell.appendChild(link);

        cell.appendChild(document.createTextNode("|"));
        var link = document.createElement("a");
        link.className = "blueLink";
        link.appendChild(document.createTextNode(resolveString(cse_pp_st, "__rename")));
        link.href = "javascript:CSRLists_renameCategory()";
        cell.appendChild(link);

        var span = document.createElement("span");
        cell.appendChild(span);
        span.id="rg_del_lnk";

        span.appendChild(document.createTextNode("|"));
        var link = document.createElement("a");
        link.className = "blueLink";
        link.appendChild(document.createTextNode(resolveString(cse_pp_st, "__delete")));
        link.href = "javascript:CSRLists_deleteCategory()";
        span.appendChild(link);

}


// Lists content scanning rules
CSRulesDriver.prototype.drawList = function(category, tbody, listWidget) {

    gCurrentCategoryId=category;
    var rgIdx = CSRLists_GetRGIndex(category);
    var ruleGroup = gContentRules.rules[rgIdx];
    if (null == ruleGroup) {
        gCurrentCategoryId=null;
        this.drawNoList(tbody);
        return;
    }

    // Display the name of the rule group in the list table header
    if (listWidget)
    {
        listWidget.setHeaderText(0, resolveString(cse_pp_st, ruleGroup.name));
    }

    //check if there are any rows
    if (ruleGroup.lst.length==0) {
        this.drawNoList(tbody);
        return;
    }

    var rgRefCount = RefCounter.getRefCount("CS", category, null,
        RefCounter.getRuleRefCount, RefCounter.ruleTypeToSettingsType);

    var overallRefCount=rgRefCount.refCount;


    var rowIdx = 0, cellIdx = 0;


    // Create group row
    var row = tbody.insertRow(rowIdx++);
    var cell = row.insertCell(cellIdx++);
	
	if( ruleGroup.score !="")
	  cell.appendChild(document.createTextNode(resolveString(cse_pp_cs_st, "__rulegroup_includes") + "  (" + gsScoreBasedDict + ") "));
	else
	cell.appendChild(document.createTextNode(resolveString(cse_pp_cs_st, "__rulegroup_includes")));
    var usedByStr = (1 == rgRefCount.refCount) ? resolveString(cse_pp_st,"__one_policy") :
        resolveString(cse_pp_st,"__n_policies",[rgRefCount.refCount]);
    cell = row.insertCell(cellIdx++);
    cell.appendChild(document.createTextNode(usedByStr));
    cell = row.insertCell(cellIdx++);
    cell.appendChild(document.createTextNode(String.fromCharCode(NBSP)));

    var links = ruleGroup.lst;
    var linkCount = links.length;
    var grp_size = 0;

    // Display all rules within a group
    for (var i = 0; i < linkCount; i++) {
        var link = links[i];
        var r_id = link.id;
        var chk = CSRLists_GrpMember(true, r_id, false);
        var refCounter = RefCounter.getRefCount("CS", r_id, null,
            RefCounter.getRuleRefCount, RefCounter.ruleTypeToSettingsType);

        link.refCount = refCounter.refCount;
        link.totalRefCount = refCounter.refCount;
        overallRefCount+=refCounter.refCount;

        if (chk-0==1) {
            ++grp_size;
            link.totalRefCount += rgRefCount.refCount
        }

        link.root = CSRLists_IsRoot(r_id);
        link.href = 'javascript:CSRLists_LoadCSRule(false,' + rgIdx + ',' + i +');';
        link.delLink = 'javascript:CSRLists_DeleteCSRule(\'' + r_id + '\');';

        // Draw the row of data
        cellIdx = 0;
        row = tbody.insertRow(rowIdx++);
        cell = row.insertCell(cellIdx++);

        var chkBox = document.createElement("input");
        chkBox.type = chkBox.className = "checkbox";
        cell.appendChild(chkBox);
        chkBox.style.marginRight = "5px";
        chkBox.checked = (chk-0==1);

        var fnStr = "top.SetModified(true);CSRLists_GrpMember(this.checked,'" + r_id + "',true);";
        chkBox.onclick = new Function(fnStr);

        cell.appendChild(document.createTextNode(link.name));

        cell = row.insertCell(cellIdx++);
        usedByStr = (1 == link.totalRefCount) ? resolveString(cse_pp_st,"__one_policy") :
            resolveString(cse_pp_st,"__n_policies",[link.totalRefCount]);
        cell.appendChild(document.createTextNode(usedByStr));

        cell = row.insertCell(cellIdx++);
        cell.appendChild(SharedResourceManager.createLink(link.href, resolveString(cse_pp_st, "__edit")));
        if (!link.root && 0 == link.totalRefCount) {
            cell.appendChild(document.createTextNode(" | "));
            cell.appendChild(SharedResourceManager.createLink(link.delLink, resolveString(cse_pp_st, "__delete")));
        }
    }

    //Hide group "delete" if rules are being referenced by a policy
    var reflnk=document.getElementById("rg_del_lnk");
	
	if( ruleGroup.rultype == "true" )
	{
		reflnk.style.display="none";
	}
    else
	{ 
		 if(overallRefCount>0) 
		 {
			 reflnk.style.display="none";
		 }
		 else
		 {
			 reflnk.style.display="";
		  }
	}

   

	
}

//initialise the CSRule object that sotres lists of rules in memory
function CSRLists_Init(pbIn)
{
    gContentRules = new CSRules();
    gContentRules.BuildGrpRulesList();
}

function CSRLists_GetRGIndex(ruleGroup) {
    var ret = 0;
    var ruleList = gContentRules.rules;
    for (var i = ruleList.length - 1; i >= 0; i--) {
        if (ruleList[i].id == ruleGroup) {
            ret = i;
            break;
        }
    }
    return ret;
}

//open CSRule configuration page
function CSRLists_LoadCSRule(create, gr_ndx, r_ndx )
{   var pp_str="";
    var gr_id = gContentRules.rules[gr_ndx].id;
    var title= resolveString(cse_pp_cs_st, "__cs_rule" );

	var cat=gContentRules.rules[gr_ndx].name;
    var target= ''

    if (create)
    {   target= 'CSNewRule.html?gr='+gr_id+'&cat='+cat;
		pp_str = gContentRules.GetNextRulePP(gr_id);
    }
    else
    {   target= 'CSRSettings.html?gr='+gr_id+'&cat='+cat;
        var r_id = gContentRules.rules[gr_ndx].lst[r_ndx].id;
        pp_str=gContentRules.GetPPFromId("RefRule", r_id);
	    target += '&id='+r_id;
    }

    var page = new DialogPage(target, title);
    top.gPageStack.Forward(page, pp_str);

}

function CSRLists_DeleteCSRule(r_id )
{

    var res= confirm( resolveString(cse_pp_st,"__del_rule_prompt"));
    if(!res) return;

    var pp_str=gContentRules.GetPPFromId("RefRule", r_id);
    top.SetModified(true);

    gContentRules.rules_pb.DeleteElementEx(pp_str);
    gContentRules.BuildGrpRulesList();

    csrListWidget.draw();
}

function CSRLists_IsRoot(r_id)
{
       var pp_str=gContentRules.GetPPFromId("RefRule", r_id);
       var ppT = new PropertyPath(pp_str);
       ppT.SetTempLeaf("root");
       var res = gContentRules.rules_pb.GetPropertyDef(ppT, 1);
       return (res==0)?false:true;
}



function CSRLists_GrpMember(is_member, r_id, save)
{
    var res=is_member?1:0;
    var pp_str=gContentRules.GetPPFromId("RefRule", r_id);
    var ppT = new PropertyPath(pp_str);

    ppT.SetTempLeaf("enabled");

    if(save)
    {
        gContentRules.rules_pb.SetProperty(ppT, is_member?1:0);
        csrListWidget.draw();
    }
    else
    { 
		
		res = gContentRules.rules_pb.GetPropertyDef(ppT, 1);
    }

	if(res == true || res ==1)
		res = 1
	else
		res = 0
    return res;
}

/**
 * Asynchronous data load function
 * //initialise and display list of rules
 */
function CSRLists_Show(pbIn)
{   CSRLists_Init(pbIn);
    csrListWidget = new SharedResourceManager("csr_lst_div", "csrListWidget", new CSRulesDriver(), {verticalSpace:"0px"});
    csrListWidget.draw();
}

