/**
 * JavaScript breadcrumb trail and page navigation functionality
 * Studio * provided code - see prototype pages for usage examples
 *
 * Copyright (C) 2009 McAfee, Inc. All Rights Reserved
 */

var DEBUG				= false;
var TOPNAV_DOCUMENT 	= null;
var LEFTNAV_DOCUMENT 	= null;
var CONTENT_FRAME		= null;
var CONFIG_FRAME = null;
var BUTTON_FRAME = null;

var BREADCRUMB_DELIMINATOR = "<img src=\"../../images/icons/carat.gif\" width=\"7\" height=\"4\" border=\"0\" style=\"padding-left:7px;vertical-align:middle\">";

// Global property bag for current property values. Defined here so
// It is always available.
var gPB = new PropertyBag();
var gSystemStatePB = new PropertyBag()
var gbSystemStateLoaded=false

// Container for custom property bags (for things like default alerts,
// engine.xml, etc. - all read-only)
var gPBContainer = new Object();
// Gets a custom property bag object
function getCustomPB(name) {
    if (null == gPBContainer[name]) {
        gPBContainer[name] = new PropertyBag();
    }
    return gPBContainer[name];
}

// PropertySource for transfering config to/from server
var gPS = new PropertySource()

// Page stack for embedded pages
var gPageStack = new PageStack()

// Whether data on current page has been modified
var gbPageModified = false

// Whether not frame set has loaded
var gbFramesetLoaded = false

// Whether or not config has loaded
var gbConfigLoaded = false

// Content page - To find the corresponding sections for this category in ePO
var gContentPage = ""

// ePO 3.5 flag
var gIsePO35 = gEPOMode && (typeof(window.external.policy_value_secure_string) == "undefined") && (!gIsEPO4);

// Temporary save object
var pageCtx = {};

/*
Page Class
*/
Page = function( k, d, u, p ,pp,ss,f)
{
    this.Key = k.toLowerCase();
    this.DisplayName = d
    this.URL = u
    this.ParentKey = p.toLowerCase();
    this.PropertyPath = (null == pp) ? "" : pp;
    this.showSave = (null == ss) ? "" : ss
    this.showFullCat = f
    this.init();
}
Page.Items = new Array();
Page.Order = new Array();
Page.prototype.init = function()
{
    Page.Items[ this.Key ] = this;
    if (this.ParentKey=="")
	 Page.Order[Page.Order.length]=this.Key;
}

/*
Page State Functions
*/

var page = null;
var page_init = false;
var frameset_init = false;


/////////////////////////////////////////////////////////////
//
// Build menu
//
function RenderSubCat(curr_sub,table)
{
	var row = table.insertRow(table.rows.length);
	var cell1 = row.insertCell(row.cells.length);
	cell1.className = "whiteline";
	var row = table.insertRow(table.rows.length);
	var cell1 = row.insertCell(row.cells.length);
	cell1.className = "subcat";
	cell1.id = "nav_" + curr_sub.Key;
	cell1.innerHTML = "<a href=\"javascript:top.SetContent('" + curr_sub.URL +"');\">" +
        ReplaceSpecialHTMLChars(curr_sub.DisplayName) +"</a>";
}
BuildMenu = function(page)
{
	// Do nothing if we already have a menu
	var table = LEFTNAV_DOCUMENT.getElementById("idMenu");
	if (table == null || table.rows.length >2)
		return

	// Choose cats to draw
	var oneSub;
	if (gEPOMode)
	{
		var parent=Page.Items[page];
		if (parent.ParentKey)
		{
			var child=parent;
			parent=Page.Items[parent.ParentKey];
			if (parent.showFullCat != "yes")
				oneSub=child;
		}
		keys=[parent.Key];
	}
	else
		keys=Page.Order;

	// Draw each cat and associated sub cats
	for (var i=0;i<keys.length;i++)
	{
		// get active category and subcatory
		key=keys[i];
		curr_sub=null
		curr_cat=Page.Items[key];
		if (!curr_cat)
			continue;

		// Render cat
		var row = table.insertRow(table.rows.length-1);
		var cell1 = row.insertCell(row.cells.length);
		cell1.className = "cat";
		cell1.id = "nav_" + curr_cat.Key;
		cell1.innerHTML = "<a href=\"javascript:top.SetContent('" + (oneSub? oneSub.URL : curr_cat.URL) +"');\">" +
        	ReplaceSpecialHTMLChars(curr_cat.DisplayName) +"</a>";

		// Render subcat(s)
		var row = table.insertRow(table.rows.length-1);
		row.className=(i==0)?"subcat":"hide";
		row.id="nav_sub_"+curr_cat.Key;
		var subTable =LEFTNAV_DOCUMENT.createElement("table");
		subTable.style.width= gIsEPO4 ? "185px":"175px"
		subTable.cellPadding=0;
		subTable.cellSpacing=0;
		var cell=row.insertCell(0);
		cell.appendChild(subTable);
		var row = subTable.insertRow(0);
		var cell1 = row.insertCell(row.cells.length);
		cell1.className = "blackline";
		if (oneSub)
		{
			RenderSubCat(oneSub,subTable);
		}
		else
			for (var key in Page.Items)
			{
				var curr_sub=Page.Items[key]
				if (curr_sub && curr_sub.ParentKey == curr_cat.Key)
					RenderSubCat(curr_sub,subTable);
			}

		// Render bottom line
		var row = table.insertRow(table.rows.length-1);
		row.id="nav_line_"+curr_cat.Key;
		var cell1 = row.insertCell(row.cells.length);
		cell1.className = "whiteline";
	}
}

Initialize = function()
{

 // Apply any missing cookie settings to default
    if (typeof(gEPOMode) == "undefined")
    	ApplyDefaultCookieSettings(true);

    // Check for valid config and show error page
    gbFramesetLoaded = true
    if(gIsEPO4)
    {
    	if (gPB.IsEmpty()) {
			gPS.Get(gPB);
    	}

		// Initialize global variables
    	TOPNAV_DOCUMENT		= top.iframeID_NAP.frames["frame_topnav"].document;
    	LEFTNAV_DOCUMENT	= top.iframeID_NAP.frames["frame_leftnav"].document;
    	CONTENT_FRAME		= top.iframeID_NAP.frames["frame_content"];
    	CONFIG_FRAME = top.iframeID_NAP.frames["config"];
		BUTTON_FRAME = top.iframeID_NAP.window.frames["frame_buttons"];

		top.OnInitialize();
	}
	else
	{
		if (gPB.IsEmpty())
		{
	        // This may be due to a pathological condition or it may be the result
	        // of the user hitting the refresh button
	        var configQ = top.frames["config"].document.location.search;
	        if ("" == configQ || -1 != configQ.indexOf("%2526source%253D")
							  || -1 != configQ.indexOf("%2526res%253D"))
			{
	            // Any JavaScript in the config frame will not be loading
	            // the main config file
	            location.href = "index.html";
	            return;
	        }
	        location.href = "NoConfig.html"
		}

	    // Initialize global variables
	    TOPNAV_DOCUMENT		= top.frames["frame_topnav"].document;
	    LEFTNAV_DOCUMENT	= top.frames["frame_leftnav"].document;
	    CONTENT_FRAME		= top.frames["frame_content"];
	    CONFIG_FRAME = top.frames["config"];
		BUTTON_FRAME = top.window.frames["frame_buttons"];
	}
    // Hide spam related pages if spam not installed
    if (!pp_componentInstalled("AS"))
    {
        if (Page.Items["quarantined"])
            Page.Items["quarantined"].URL="ResultsTable.html?Virus";
        if (Page.Items["spam"])
            Page.Items["spam"]=null;
        if (Page.Items["phish"])
            Page.Items["phish"]=null;
	if (Page.Items["ip"])
            Page.Items["ip"]=null;
	if (Page.Items["spoof"])
            Page.Items["spoof"]=null;			
    }

    // Show page
    frameset_init = true;
    if( !page_init )
    {
     	SetPage();
        SetModified(false);
    }
	if(!gIsEPO4)
	{
		LEFTNAV_DOCUMENT.getElementById("apply_nochanges").style.display = "block";
	}
    if ( gIsePO35 ) {
		LEFTNAV_DOCUMENT.getElementById("inherit").checked = window.external.policy_value_bool(gePOCategorySectionsMap[gContentPage][0], "Inherit" )
	}

   return true;
}

SetPage = function()
{
     // Store new page
    if( arguments[0] ) page = arguments[0];
    if (null == page) {
		try	{
			// This is likely due to the refresh button being hit
			location.href = "index.html";
		}
		catch(e) {
		}
        return;
    }
    page = page.toLowerCase();
    if( !frameset_init || page == null ) return;
    page_init = true;

    // Make sure navigation menu exists
    BuildMenu(page);

    // If we're returning to a page from a second-level page, we don't need
    // to create the page stack
    if (!top.gPageStack.popped) {
        // Reset page stack with base page
        var newPage = Page.Items[page];
        var pb = gPB;
        if (newPage.PropertyPath)
        {
            try {
                pb = new PropertyBag;
                var pps = newPage.PropertyPath.split(",");
                var nPPs = pps.length;
                for (var i = 0; i < nPPs; i++) {
                    gPB.GetElement(pps[i], pb);

		}
            }
            catch(e) {
                alert(e);
            }
        }
        top.gPageStack.Reset(new EmbeddedPage(newPage.URL, newPage.DisplayName),
            pb, new PropertyPath(newPage.PropertyPath));





        // Update navigation controls

        _setPageTitle(page);
        _setNavigation(page);
    }
    ShowPage();
    // Delete the popped page so that left-menu navigation works correctly
    top.gPageStack.popped = undefined;
}


//make sure the page will not reload by mistake on "enter"
//does not override existing onsubmit method
_nullOnsubmit = function() {
    return false;
}

PageFormsSubmit = function( page_frame) {

    try{
       var docFormsList=page_frame.document.getElementsByTagName("form");
       for (i=0;i<docFormsList.length ; i++)
       {   if( null == docFormsList[i].onsubmit )
          {   docFormsList[i].onsubmit=_nullOnsubmit;
          }
       }
    }
    catch(e){
          alert(e);
    }

}

/**
 * Shows the current page, but waits on additional config to be loaded, if necessary
 */
ShowPage = function() {

    // Check to see whether the page requires additional config
    var configSources = [];
    if (CONTENT_FRAME.GetCustomConfigReq) {
        configSources = CONTENT_FRAME.GetCustomConfigReq();
    }
    if (configSources.length > 0) {

        // Get unloaded data
        QueueCustomConfig(configSources);
    }

    // Initialize page itself
    if( CONTENT_FRAME.Show )
    {
            CONTENT_FRAME.Show(top.gPageStack.Active().pb,top.gPageStack.Active().pp);
    }

    //Init forms onsubmit
    PageFormsSubmit(CONTENT_FRAME);
}

SetPageTitle = function( title )
{
    try
    {
        o = TOPNAV_DOCUMENT.getElementById("title");
        o.innerHTML = title;
    } catch(e){ if( DEBUG ) alert( e.message ); }
}

SetContent = function( url )
{
    try
    {
        // Check for unsaved modifications
        if (gbModified || top.gPageStack.Active().Modified())
        {
            if (!confirm(strModified))
                return
            SetModified(false)
        }
        // Reset page stack
        top.gPageStack = new PageStack();
        CONTENT_FRAME.location.href = url;
    } catch(e){ if( DEBUG ) alert( e.message ); }
}

_setPageTitle = function( key )
{
    o = TOPNAV_DOCUMENT.getElementById("title");

    if( o )
    {
        var a = Page.Items[key];
        var b = null;

        while( a.ParentKey )
        {
            b = a;
            a = Page.Items[ b.ParentKey ];
        }

        o.innerHTML = a.DisplayName;
        if(b!=null) o.innerHTML += ": " + b.DisplayName;
    }
}

var curr_cat = null;
var curr_sub = null;

_setNavigation = function( key )
{
    // reset navigation
    if( curr_cat != null )
    {
        try
        {
            LEFTNAV_DOCUMENT.getElementById( "nav_" + curr_cat.Key ).className = "cat";
            LEFTNAV_DOCUMENT.getElementById( "nav_sub_" + curr_cat.Key ).className = "hide";
            LEFTNAV_DOCUMENT.getElementById( "nav_line_" + curr_cat.Key ).className = "show";
        }
        catch( e )
        {
            if( DEBUG ) alert(e.message)
            curr_cat = null;
        }
    }
    if( curr_sub != null )
    {
        try
        {
            LEFTNAV_DOCUMENT.getElementById( "nav_" + curr_sub.Key ).className = "subcat";
        }
        catch( e )
        {
            if( DEBUG ) alert(e.message)
            curr_sub = null;
        }
    }

    // get active category and subcatory
    var a = Page.Items[key];
    if( a == null ) return;
    var b = null;

    while( a.ParentKey )
    {
        b = a;
        a = Page.Items[ b.ParentKey ];
    }

    // set navigation
    if( a != null )
    {
        try
        {
            LEFTNAV_DOCUMENT.getElementById( "nav_" + a.Key ).className = "cat_select";
            LEFTNAV_DOCUMENT.getElementById( "nav_sub_" + a.Key ).className = "show";
            LEFTNAV_DOCUMENT.getElementById( "nav_line_" + a.Key ).className = "hide";
            curr_cat = a;
        }
        catch( e )
        {
            if( DEBUG ) alert(e.message);
            curr_cat = null;
        }
    }
    if( b != null )
    {
        try
        {
            LEFTNAV_DOCUMENT.getElementById( "nav_" + b.Key ).className = "subcat_select";
            curr_sub = b;
        }
        catch( e )
        {
            if( DEBUG ) alert(e.message);
            curr_sub = null;
        }
    }
}

/////////////////////////////////////////////////////////////
//
// Set modified state of page
//
var gbModified = false;
function SetModified(bModified)
{
    // Cache state
    gbModified = bModified;

    // Update page
    var aac_div = LEFTNAV_DOCUMENT.getElementById("apply_nochanges");
    if (aac_div) {
        var className = bModified ? "apply" : "apply_nochanges";
        aac_div.className = className;
    }
    var aac_directive = LEFTNAV_DOCUMENT.getElementById("aac_directive");
    if (aac_directive) {
        var key = bModified ? gsPendingChanges : gsNoChanges;
        aac_directive.innerHTML = key;
    }
    var applyBtn = LEFTNAV_DOCUMENT.getElementById("idApply");
    var cancelBtn = LEFTNAV_DOCUMENT.getElementById("idCancel");
    if (applyBtn && cancelBtn) {
        applyBtn.disabled = !gbModified;
        cancelBtn.disabled = !gbModified;
        applyBtn.style.cursor = gbModified ? "pointer" : "default";
        cancelBtn.style.cursor = gbModified ? "pointer" : "default";
		if(bModified && gIsEPO4 )
		{
			top.epoEnableApplyButton();
		}
    }
}
function SetPageModified(bModified)
{
	top.gPageStack.Active().SetModified(bModified);
}
////////////////////////////////////////////////////////////
//
//ePO 4.0 specific
//
function epoApplyPolicySettings()
{
	return Apply();
}

function epoCancelPolicySettings()
{
	Cancel();
}
/////////////////////////////////////////////////////////////
//
// Apply and Cancel
//
function Apply()
{
    // Check we had a modification
    if (!gbModified)
        return true;

    // If active page has a local pb and is modified then save to it ...
    var pbOut=pbOut=top.gPageStack.pages[0].pb;
    var page = top.gPageStack.Active();
    if (page.pb != gPB)
	{
		// Prevent applying the changes if the sub page is modified.
		// Otherwise cancelling the sub page after apply, may cause invalid config state.
		if( top.gPageStack.Active().Save && top.gPageStack.Active().Modified() )
		{
			alert(gsSaveChanges);
			return false;
		}
		if( top.gPageStack.Active().DoSave() == false )
			return false;
	}
    else
    {
		// Check if content frame has a validation function, if so call it.
		if(gIsEPO4)
		{
			if( top.iframeID_NAP.frames["frame_content"].Validate )
			{
				if( top.iframeID_NAP.frames["frame_content"].Validate() == false )
					return false;
			}
		}
		else
		{
			if( top.frames["frame_content"].Validate )
			{
				if( top.frames["frame_content"].Validate() == false )
					return false;
			}
		}

		// ... otherwise retrieve settings direct from Apply method
       	pbOut= new PropertyBag;
		CONTENT_FRAME.Apply(pbOut);
    }

    // Add any lazyloaded xml that has changed
    var parser = new XMLParser
    for (var name in gPBContainer)
    {
		var llpb = gPBContainer[name];
		if (llpb.modified)
		{
	
			pbOut.SetProperty(name, parser.Save(llpb, new Array));
			llpb.modified=false;
		}
    }

    var bInherit = gIsePO35 ? LEFTNAV_DOCUMENT.getElementById("inherit").checked : false
    gPS.Put(pbOut,bInherit);
    gPB.SetProperties(pbOut);
    SetModified(false);
    SetPageModified(false);

    if (CONTENT_FRAME.OnApplied != McUndefined)
	DoOnFramesetLoad("CallOnApplied()");
	if(gIsEPO4)
	{
		top.epoDisableApplyButton();
	}

	return true;
}

function CallOnApplied()
{
    if (CONTENT_FRAME.OnApplied != McUndefined)
	CONTENT_FRAME.OnApplied()
}

function Cancel()
{
    // Make sure
    if (!gbModified)
        return
	//In Mercury, the required action is that we do not prompt the user if he clicks on the CANCEL button
	if(!gIsEPO4)
	{
		if (!confirm(gsSubPagesModified))
			return
	}

    // Reset any lazyloaded xml that has changed.
    for (var name in gPBContainer)
    {
	var llpb = gPBContainer[name];
	if (llpb.modified)
	{
		llpb.Empty();
		LoadSource(name);
	}
    }

    // Reset page
    var url=top.gPageStack.pages[0].name;
    top.gPageStack = new PageStack();

    if(!gIsEPO4)
         CONTENT_FRAME.location.href = url;

    SetModified(false);
}

function Reset()
{
    if (CONTENT_FRAME.Reset) {
        CONTENT_FRAME.Reset();
    }
}

/**
 * Searches the property bag for an entry matching a specific property and
 * returns the base path
 */
function GetBasePath(pb, basePP, propName, targetValue) {
    var ret = null;

    // Search for the settings blob to use
    var s = ("string" == typeof(basePP)) ? basePP : basePP.GetPath();
    var ppT = new PropertyPath(s);
    ppT.BeginEnum();
    var found = false;
    while (undefined !== pb.GetProperty(ppT)) {
        ppT.SetTempLeaf(propName);
        if (targetValue == pb.GetProperty(ppT)) {
            found = true;
            ppT.SetTempLeaf("");
            break;
        }
        ppT.SetTempLeaf("");
        ppT.IncrementEnum();
    }
    if (found) {
        ret = ppT.GetPath();
    }

    return ret;
}

/**
 * Wrapper around the PageStack page loading mechanism
 * @param url the page to load
 * @param title the title of the page (for the breadcrumb)
 * @param pb the PropertyBag from which to read settings (may be null in
 * which case the global property bag will be used)
 * @param pp the property path to use to copy settings from (may be
 * null in which case the target page needs to have its own mechanism
 * to locate its setting information in the property bag)
 * @returnPage the page to go back to when the target page is dismissed;
 * must not be null
 */
function LoadPage(url, title, pb, pp, returnPage) {
    var pbToUse = pb;
    if (null == pb) {
        // Work on the global property bag
        pb = top.gPB;
    }
    if (null != pp) {
        // Initialize a property bag with just the data required for the new page
        pbToUse = new PropertyBag();
        pb.GetElement(pp, pbToUse);
    }
    var page = new EmbeddedPage(url, title);
    top.gPageStack.Forward(page, pbToUse, pp, returnPage);
}

function RenderMainPage(contentPage)
{
	// Store the content page, to identify the sections for this category in ePO
	gContentPage = contentPage


    //In ePO4, the property bag is enumerated later due to timing issues.
    //In addition, we dont require the hidden frames.
    if(gIsEPO4)
    {
	    var contents = ("" != contentPage) ? Page.Items[contentPage].URL : "Dashboard.html";
	    document.write( "<frameset rows=\"0,*\" border=\"0\" frameborder=\"no\">" );

	    document.write( "<frame id=\"frame_topnav\" name=\"frame_topnav\" src=\"TopNav.html\" " +
	        "frameborder=\"no\" scrolling=\"no\" marginwidth=\"0\" marginheight=\"0\" framespacing=\"0\" noresize>" );
		if(contentPage=="policy_manager")
		{
			document.write( "<frameset cols=\"200,*\" framespacing=\"0\" border=\"0\">");
		}
		else
		{
			document.write( "<frameset cols=\"0,*\" framespacing=\"0\" border=\"0\">");
		}
	    document.write( "<frame id=\"frame_leftnav\" name=\"frame_leftnav\" src=\"LeftNav.html\" " +
	        "frameborder=\"no\" scrolling=\"no\" marginwidth=\"0\" marginheight=\"0\" framespacing=\"0\" noresize>" );
	    document.write( "<frameset id=\"fsButtons\" rows=\"*,0\" border =\"0\"><frame id=\"frame_content\" name=\"frame_content\" src=\"" + contents +
						"\" frameborder=\"no\" scrolling=\"auto\" marginwidth=\"5\" marginheight=\"0\" framespacing=\"0\" noresize>");
	    document.write("<frame name=\"frame_buttons\" id =\"frame_buttons\" src=\"ButtonBar.html\" noresize scrolling=\"no\" >  </frameset>" );
	    document.write( "</frameset></frameset>");
	}
	else
	{
		// Get configuration
		gPS.Get(gPB)
	    var contents = ("" != contentPage) ? Page.Items[contentPage].URL : "Dashboard.html";
	    document.write( "<frameset rows=\"0,0,0,94,*\" border=\"0\" frameborder=\"no\">" );
	    document.write( "<frame name=\"config\" src=\"" + GetDynamicPageUrl('uiconfig&act=getuser') + "\" noresize>");
	    document.write( "<frame name=\"hiddenFrame\" src=\"../../blank.html\" noresize>");
	    document.write( "<frame name=\"systemStateFrame\" src=\"" +GetDynamicPageUrl('uiconfig&act=getstate')+"\" noresize>");
	    document.write( "<frame id=\"frame_topnav\" name=\"frame_topnav\" src=\"TopNav.html\" " +
	        "frameborder=\"no\" scrolling=\"no\" marginwidth=\"0\" marginheight=\"0\" framespacing=\"0\" noresize>" );
	    document.write( "<frameset cols=\"195,*\" border=\"0\">" );
	    document.write( "<frame id=\"frame_leftnav\" name=\"frame_leftnav\" src=\"LeftNav.html\" " +
	        "frameborder=\"no\" scrolling=\"no\" marginwidth=\"0\" marginheight=\"0\" framespacing=\"0\" noresize>" );
	    document.write( "<frameset id=\"fsButtons\" rows=\"*,0\" border =\"0\"><frame id=\"frame_content\" name=\"frame_content\" src=\"" + contents +
	        "\" frameborder=\"no\" scrolling=\"auto\" marginwidth=\"0\" marginheight=\"0\" framespacing=\"0\" noresize>");
	    document.write("<frame name=\"frame_buttons\" id =\"frame_buttons\" src=\"ButtonBar.html\" noresize scrolling=\"no\" >  </frameset>" );
	    document.write( "<frame name=\"hiddenFrame2\" src=\"../../blank.html\" noresize>" );
	    document.write( "</frameset></frameset>");
	}
    window.onload = Initialize;
}
