/**
 * JavaScript for the DISCSettings page.
 * Defines disc_init() for page initialization along with Show(), Validate()
 * and Apply() functions
 * Note: include it last.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

/*includeJS("../js/Locale.js");
includeJS("../js/PolicyRes.js");
includeJS("../js/VFrameworkStrings.js");
includeJS("../../js/PropertySource.js");
includeJS("../../js/PropertyPath.js");
includeJS("../../js/PropertyBag.js");
includeJS("../../js/PointProductSpecific.js");
includeJS("../../js/OnlineHelp.js");
includeJS("../../js/ValidationFramework.js");
includeJS("../../js/StdValidationActions.js");
includeJS("../../js/DefaultValues.js");
includeJS("../../js/RefCounter.js");
includeJS("../../js/SharedSettings.js");*/

var vframeworks = new Object();
var dataBindings = new Array();
var qparams = queryParameters();
var newInstance = false;
var newId = null;

var basePP = "Settings.DISCSettings";
var disc_pb = null;
var origName="";
var settingsId = qparams["id"];
var discOptsForm = "disc_options";
var browserInfo = IdentifyBrowser();

//var g_changeNotifyFn = "top.gPageStack.Active().SetModified(true);";

var discContainer = "_de";
var discEditor = null;
var deProps = {readOnly:false, resetBtn:false, width:788};

// Initializes the page's forms
function disc_forms_init() {
    shs_affectedPolicyReport(newInstance, "DISC", settingsId, disc_pb);

    vframeworks["InstanceSettings"]= new ValidationFramework("InstanceSettings");
	vframeworks["InstanceSettings"].formAction = std_val_form_action;
    vframeworks["InstanceSettings"].fieldAction = std_val_field_action;
    vframeworks["InstanceSettings"].addValidator("displayName", new RequiredValidator());
    //vframeworks["InstanceSettings"].addValidator("displayName", new ScriptValidator());
	vframeworks["InstanceSettings"].addValidator("displayName", new InputTextValidator());
	vframeworks["InstanceSettings"].labelMap["displayName"] =  resolveString(cse_pp_field_st, "__instancename");

    var inputArray= new Array();
	inputArray["SECTION"]="Scanners";
	inputArray["origName"]=origName;
	inputArray["basePP"]="Settings.DISCSettings";
	vframeworks["InstanceSettings"].addValidator("displayName",new DuplicatesValidator(disc_pb,inputArray));
	vframeworks["InstanceSettings"].addValidator("displayName",new LengthValidator());

    var form = discOptsForm;
    if (document.forms[form]) {
        var e = document.forms[form].elements["DisclaimerText"];
        /*if (e && browserInfo.isIE) {
            // Fix margins
            e.style.marginTop = "-1px";
            e.style.marginBottom = "-1px";
        }*/
		discEditor = new DiscEditor( "de1", "discEditor", deProps);
        dataBindings.push(new DiscTDataBinding(discEditor));
    }
    addChangeNotification(g_changeNotifyFn);
}

// Sets form data and enables / disables controls as appropriate
function disc_init() {
    disc_forms_init();
    Reset();
}

/**
 * Asynchronous reset function
 */
function Reset() {
    var defValues = top.defValues["DISC"];
    var disc_pp = new PropertyPath(basePP);
    for (var i = 0; i < dataBindings.length; i++) {
        dataBindings[i].set(disc_pp, disc_pb);
    }
	//Fix for BZ 660357
	if(newInstance) // For a new instance, radio button is not selected until Show() is called where radio_1 (i.e. Plaintext) is selected. Hence after reset, radio_1 selection should be retained.
	{
		var radio = document.getElementById("radio_1");
		radio.checked = 1;
		discEditor.setPT();
	}
	else
	{
		if(document.getElementById("radio_1").checked)
			Disc_changeFormat(false);
		else if(document.getElementById("radio_0").checked)
			Disc_changeFormat(true);
	}
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {
    if (null == pbIn) {
        pbIn = top.gPB;
    }
    newInstance = shs_initPB(pbIn, pp, "DISC");
    disc_pb = pbIn;
    if (settingsId) {
        // Search for the settings blob to use
        basePP = top.GetBasePath(pbIn, basePP, "id", settingsId);
        if (null == basePP) {
            top.gPageStack.Active().Cancel();
            return;
        }
    }
    else {
        // Assume that we've been set up with the correct property path
        // and property bag
        basePP = pp.GetPath();
        settingsId = pbIn.GetPropertyDef(basePP + ".id", "");
        origName=pbIn.GetPropertyDef(basePP + ".displayName", "");
    }
    disc_init();
	
	if( pp )
	{
		pp.SetTempLeaf("UseHTML");
		var html = pbIn.GetPropertyDef(pp, "");
		pp.SetTempLeaf("");
		
		if( html == "0") {
			discEditor.setPT();
		}
		else{
			discEditor.setWYSIWYG();
		}
	}
	if(newInstance)
	{
		var radio = document.getElementById("radio_1");
		radio.checked = 1;
		discEditor.setPT();
	}
}

/**
 * Asynchronous data validation function
 */
function Validate() {
	if(document.getElementById("radio_1").checked) // Plain text radio button selected
	{
		var text = discEditor.getText()
		
		if(!ValidateLimitedHtmlInput(text))
		{
			alert(gsScriptNotAllowed)
			var radio = document.getElementById("radio_1");
			radio.checked = 1;
			discEditor.setPT();
			return false
		}

		if(!ValidateTextInput(text))
		{
			alert(gsScriptNotAllowed)
			var radio = document.getElementById("radio_1");
			radio.checked = 1;
			discEditor.setPT();
			return false
		}	

		if(!ValidateAlertTextInput(text))
		{
			alert(gsScriptNotAllowed);
			return false;
		}		
		
	}
	
	if(document.getElementById("radio_0").checked) // HTML radio button selected
	{
		var Value = discEditor.getValue()
		
		if(!ValidateAlertTextInput(Value))
		{
			alert(gsScriptNotAllowed);
			return false;
		}
		
		if(!ValidateLimitedHtmlInput(Value))
		{
			alert(gsScriptNotAllowed)
			var radio = document.getElementById("radio_0");
			radio.checked = 1;
			discEditor.setWYSIWYG();
			return false
		}

		if(!ValidateTextInput(Value))
		{
			alert(gsScriptNotAllowed)
			var radio = document.getElementById("radio_0");
			radio.checked = 1;
			discEditor.setWYSIWYG();
			return false
		}		
		
		
	}
    return shs_Validate();
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    if (null == pb) {
        pb = disc_pb;
    }
    shs_Apply(pb, basePP, dataBindings, newInstance);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    if (newInstance) {
        // Remove the new instance from the property bag
        disc_pb.DeleteElement(basePP);
    }
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
    return [];
}

function Disc_changeFormat(html) {
	if(html)	{
		discEditor.setWYSIWYG();
	}
	else {
		discEditor.setPT();
	}
}
