// Copyright (C) 2009 McAfee, Inc.  All rights reserved.

var gDBMaxAge = McUndefined;

// Validators
var vfLocal				= new ValidationFramework("localForm");
var vfMQM				= new ValidationFramework("mqmForm");
var localLabelMap		= new Object();
var MQMLabelMap			= new Object();

////////////////////////////////////////////////
//
// Writes current config settings into controls
//
var gBytesPerMegabyte=1048576

//Characters which are not allowed in a hostname include ` ~ ! @ # $  ^ & * ( ) = + [ ] { } \ | ;  ' " , < > / and ?  character ":" is not included as it is meaningful for IPv6
var gKeysNotAllowed=[126,33,37,64,35,36,94,32,38,42,40,41,61,43,91,93,123,125,92,124,59,39,34,44,60,62,47,63];

function  AddNumericOnlyValidation()
{
	var fn =   cb_numOnlyNN ;

	document.getElementById("mqmport").onkeypress = fn;
	document.getElementById("callbackport").onkeypress = fn;
	document.getElementById("maxitemsize").onkeypress =  fn ;
	document.getElementById("maxquerysize").onkeypress = fn;
	document.getElementById("maxitemage").onkeypress = fn;
	document.getElementById("diskchecktime").onkeypress = fn;
	document.getElementById("disksize").onkeypress = fn;
}


function Show(pbIn)
{
	if( typeof(gEPOMode) != "undefined" && typeof(gHasLocalRepositoryTask)!= "undefined" )
	{
		if (this.gEPOMode && this.gHasLocalRepositoryTask)
		{
			document.getElementById("rowId_purgefrequency").style.display="none";
			document.getElementById("rowId_optfrequency").style.display="none";
			document.getElementById("rowId_maxitemage").className = "lastrow shaded";
		}
	}
	// Get other elements if we are not returning from edit
	if (top.gPageStack.ReturnedFrom() == McUndefined)
	{
		top.gPB.GetElement("Scheduler",pbIn)
		top.gPB.GetElement("MQM",pbIn)
		top.gPB.GetElement("AsyncReporting",pbIn)
 	}

	AddNumericOnlyValidation();

	// Local database
  var pp = new PropertyPath("Repository");

  localLabelMap["maxitemsize"]   = gsErrMaxItemSize;
  localLabelMap["maxquerysize"]  = gsErrMaxQuerySize;
  localLabelMap["maxitemage"]    = gsErrMaxItemAge;
  localLabelMap["diskchecktime"]    = gsErrDiskIntervalCheck;
  localLabelMap["disksize"]    = gsErrDiskSpaceWarn;
  localLabelMap["idDatabaseLocation"] = gsErrDbLocationType;
  MQMLabelMap["mqmport"]         = gsErrMQMPort;
  MQMLabelMap["callbackport"]    = gsErrCallbackPort;
  MQMLabelMap["bwlistupdateinterval"]    = gsErrMQMBWListUpdateInterval;
  vfLocal.labelMap = localLabelMap;
  vfMQM.labelMap = MQMLabelMap;

  //Fetch the values from DBMacroDispTable Array
 	var gDBMacroDispTableSize = gDBMacroDispTable.length;
	if( typeof(gEPOMode) != "undefined" && typeof(gLinux) != "undefined" )
	{
		if ( this.gEPOMode && this.gLinux )
		{
			gDBMacroDispTableSize--;
		}
	}
   	for(var i =0; i < gDBMacroDispTableSize; i++ )
   	{
 	  	 document.getElementById("idDatabaseLocationType").options[i]=new Option(gDBMacroDispTable[i])
   	}

	// Database location
	pp.SetTempLeaf("Path")
	value = pbIn.GetProperty(pp.GetPath());
	if(value != McUndefined && value != "")
	{
		document.getElementById("idSpecifyDbLocation").checked = true;

		var macroIndex = GetFilePathMacro(value)
		if (macroIndex != -1)
		{
			if( typeof(gLinux) != "undefined" )
			{
				if ( this.gLinux )
				{
					document.getElementById("idDatabaseLocationType").selectedIndex = macroIndex;
					value = value.substr(gMacroTable[macroIndex].length+1)
				}
				else
				{
					document.getElementById("idDatabaseLocationType").selectedIndex = macroIndex - 1;
					value = value.substr(gMacroTable[macroIndex].length+1)
				}
			}
			else
			{
				document.getElementById("idDatabaseLocationType").selectedIndex = macroIndex - 1;
				value = value.substr(gMacroTable[macroIndex].length+1)
			}
		}
		else
		{
			document.getElementById("idDatabaseLocationType").selectedIndex = document.getElementById("idDatabaseLocationType").length - 1;
		}
		document.getElementById("idDatabaseLocation").value = value
	}
	else
		document.getElementById("idSpecifyDbLocation").checked = false;
	
	if( typeof(gEPOMode) == "undefined" || this.gEPOMode == false)
	{		
		document.getElementById("rowId_AutoUpd").style.display = "none";	
	}
	
	pp.SetTempLeaf("MaxItemSize");
	var value = pbIn.GetProperty(pp);
	document.getElementById("maxitemsize").value  =  value == McUndefined ? 100 : (value/gBytesPerMegabyte);
	pp.SetTempLeaf("MaxQuerySize");
	var value = pbIn.GetProperty(pp);
	document.getElementById("maxquerysize").value  =  value == McUndefined ? 1000 : value;
	pp.SetTempLeaf("MaxDays");
	var value = pbIn.GetProperty(pp);
	gDBMaxAge = value == McUndefined ? 30 : value;
	document.getElementById("maxitemage").value  =  gDBMaxAge;
	pp.SetTempLeaf("DiskSizeWaitTime");
	var value = pbIn.GetProperty(pp);
	document.getElementById("diskchecktime").value  =  value == McUndefined ? 6 : value;
	pp.SetTempLeaf("DiskSizeWarnAT");
	var value = pbIn.GetProperty(pp);
	document.getElementById("disksize").value  =  value == McUndefined ? 2048 : value;
	var pp = new PropertyPath("Scheduler.Task")
	pp.SetTempLeaf("When.Interval")
	var interval = pbIn.GetProperty(pp)
	document.getElementById("local_optAtUpd").innerHTML = (interval == McUndefined) ? gsNotScheduled : gsUpdateFreqs[interval];
	pp.BeginEnum()
	pp.IncrementEnum()
	var interval = pbIn.GetProperty(pp)
	document.getElementById("local_optFreq").innerHTML = (interval == McUndefined) ? gsNotScheduled : gsUpdateFreqs[interval];
	pp.IncrementEnum()
	var interval = pbIn.GetProperty(pp)
	document.getElementById("local_purgeFreq").innerHTML = (interval == McUndefined) ? gsNotScheduled : gsUpdateFreqs[interval];

	// Create validators
    var cvport = new CrossValidator("value.length > 0 && value >=0 && value <=65535", formatString(strRange, new Array(0,65535)));
	vfMQM.addValidator("mqmport", cvport);
	
	vfLocal.addValidator("maxitemsize", new CrossValidator("value.length > 0 && value >=1 && value <=100", formatString(strRange, new Array(1,100))));
 	vfLocal.addValidator("maxquerysize", new CrossValidator("value.length > 0 && value >=1 && value <=20000", formatString(strRange, new Array(1,20000))));
 	vfLocal.addValidator("maxitemage", new CrossValidator("value.length > 0 && value >=1 && value <=365", formatString(strRange, new Array(1,365))));
	vfLocal.addValidator("diskchecktime", new CrossValidator("value.length > 0 && value >=6 && value <=2880", formatString(strRange, new Array(6,2880))));
 	vfLocal.addValidator("disksize", new CrossValidator("value.length > 0 && value >=1 && value <=512000", formatString(strRange, new Array(1,512000))));
	var inputVtor = new InputTextValidator(true);
	vfLocal.addValidator("idDatabaseLocation",inputVtor);
	vfLocal.formAction = std_val_form_action;
	vfLocal.fieldAction = std_val_field_action;
	
	// MQM
   	var pp = new PropertyPath("MQM");
	pp.SetTempLeaf("Enabled");
	var value = pbIn.GetProperty(pp);
	document.getElementById("mqmenabled").checked = value == 1;
	pp.SetTempLeaf("IPAddress");
	var value = pbIn.GetProperty(pp);
	if (value != McUndefined)
	{
		document.getElementById("mqmipaddress").value = value;
	}
	pp.SetTempLeaf("Port");
	document.getElementById("mqmport").value  =   pbIn.GetProperty(pp);
	pp.SetTempLeaf("CallbackPort");
	document.getElementById("callbackport").value  =   pbIn.GetProperty(pp);
		
	// Get CommunicationMode
	pp.SetTempLeaf("CommunicationMode");
	var commMode = pbIn.GetProperty(pp);
	document.getElementById("mqmradiorpc").checked = commMode == 0;
	document.getElementById("mqmradiohttp").checked = commMode == 1;
	document.getElementById("mqmradiohttps").checked = commMode == 2;
	
	// Get BW List Update Interval
	pp.SetTempLeaf("BWListUpdateInterval");
	var bwListInterval = pbIn.GetProperty(pp);
	document.getElementById("bwlistupdateinterval").value = (bwListInterval == McUndefined) ? 4 : bwListInterval;
	
	//setting a new size for database location for solving the localization issue.
	document.getElementById("idDatabaseLocationType").style['width'] = '150px';

	// Async Reporting
	pp = new PropertyPath("AsyncReporting")
	pp.SetTempLeaf("ASYNCReportingLevel")
	document.getElementById("asynclevel").value = pbIn.GetProperty(pp);

	EnableMQMControls();
	OnSpecifyDbLocationCheck();
	SetDbLocationControls();
}

function SetDbLocationControls()
{
	var bIsClustered = top.gSystemStatePB.GetProperty("systemstate.clustered");
	if ( parseInt(bIsClustered) == 1 )
	{
		document.getElementById("idSpecifyDbLocation").disabled = true;
		// List of controls to enable / disable
		var ctrlArray	= new Array();
		ctrlArray[0] = "idDatabaseLocationType";    
		ctrlArray[1] = "idDatabaseLocation";
		EnableDisableCtrl(true, ctrlArray);
	}
}

function EnableMQMControls()
{
	var bEnable = document.getElementById("mqmenabled").checked;
	EnableControl("mqmport",bEnable );
	EnableControl("callbackport",bEnable );
	EnableControl("mqmipaddress",bEnable );
	EnableControl("mqmradiorpc", bEnable);
	EnableControl("mqmradiohttp", bEnable);
	EnableControl("mqmradiohttps", bEnable);
	EnableControl("bwlistupdateinterval", bEnable);
	
	// Enable or disable Callback port
	EnableDisablePort();
}
function EnableDisablePort()
{
	// Set Default as HTTP when MQM is Enabled, in case RPC, HTTP or HTTPs is not selected.
	if (document.getElementById("mqmenabled").checked && 
		(document.getElementById("mqmradiorpc").checked == false && 
		 document.getElementById("mqmradiohttp").checked == false && document.getElementById("mqmradiohttps").checked == false))
	{
		// Check HTTP
		document.getElementById("mqmradiohttp").checked = true;
	}
	
	var commMode = (1 * document.getElementById("mqmradiohttp").checked) + (2 * document.getElementById("mqmradiohttps").checked);
	
	if (0 != commMode)
	{
		// If HTTP/HTTPs mode, disable Callback Port and display BW List Update Interval
		document.getElementById("callbackport_tbl_div").style.display = "none";
		document.getElementById("bwlistupdateinterval_tbl_div").style.display = "";
		
		// Create validators and set for BW List Update Interval and remove Callback Port validator
		var cvBWLUInterval = new CrossValidator("value.length > 0 && value >= 1 && value <= 23", formatString(strRange, new Array(1, 23)));
		vfMQM.addValidator("bwlistupdateinterval", cvBWLUInterval);
		if (null != vfMQM.getValidators("callbackport"))
		{
			vfMQM.clearValidators("callbackport");
		}
	}
	else
	{
		// The mode is RPC, display Callback Port and disable BW List Update Interval
		document.getElementById("callbackport_tbl_div").style.display = "";
		document.getElementById("bwlistupdateinterval_tbl_div").style.display = "none";
		
		// Create validators and set for Callback Port and remove  BW List Update Interval
		var cvport = new CrossValidator("value.length > 0 && value >= 0 && value <= 65535", formatString(strRange, new Array(0, 65535)));
		vfMQM.addValidator("callbackport", cvport);
		if (null != vfMQM.getValidators("bwlistupdateinterval"))
		{
			vfMQM.clearValidators("bwlistupdateinterval");
		}
	}
}
//changes MQM port values based on mode
function ChangeQuarantineMode(mode)
{
	switch(mode)
	{
		case 0: //RPC mode
			document.getElementById("mqmport").value = 49500;
			break;
		case 1: //http mode
			document.getElementById("mqmport").value = 80;
			break;
		case 2://https mode
			document.getElementById("mqmport").value = 443;
			break;
		default:
	}
	EnableDisablePort();
}
//Validates the ip Address enetered
function validateIPAddress()
{
	var ipAddrSegments = [];
	var ipAddress = "";
	var errmsg = vfr_st["bad_form_one_error"]+ "\n" + "- " + gsErrMQMIpAddress + ": " + gsInvalidIPAddress + "\n" + vfr_st["one_error_resubmit"];

	ipAddress = document.getElementById("mqmipaddress").value;

	//check for empty string
	if( IsEmpty(ipAddress))
	{
		alert ( errmsg ) ;
		return false;//ipaddress invalid
	}

	//check if the address is an IPv4 address. If it is do ipv4 based processing e.g: 172.16.228.12
	if(ipAddress.match(/^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})$/))
	{
		return Checkv4Address(ipAddress);
	}
	//check if the address is a pure IPv6 address. If it is do ipv6 based processing e.g: 2001:0db8:0000:0000:0000:0000:1428:57ab
	else if (ipAddress.match(/^((([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}:[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){5}:([0-9A-Fa-f]{1,4}:)?[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){4}:([0-9A-Fa-f]{1,4}:){0,2}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){3}:([0-9A-Fa-f]{1,4}:){0,3}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){2}:([0-9A-Fa-f]{1,4}:){0,4}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(([0-9A-Fa-f]{1,4}:){0,5}:((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(::([0-9A-Fa-f]{1,4}:){0,5}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|([0-9A-Fa-f]{1,4}::([0-9A-Fa-f]{1,4}:){0,5}[0-9A-Fa-f]{1,4})|(::([0-9A-Fa-f]{1,4}:){0,6}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){1,7}:))$/))
	{
		return Checkv6Address(ipAddress);
		return true;
	}
	//check if the address is an IPv4 mapped IPv6 address. If it is do ipv6 based processing e.g: ::FFFE:192.168.1.2
	else if(ipAddress.match(/^((([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}:[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){5}:([0-9A-Fa-f]{1,4}:)?[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){4}:([0-9A-Fa-f]{1,4}:){0,2}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){3}:([0-9A-Fa-f]{1,4}:){0,3}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){2}:([0-9A-Fa-f]{1,4}:){0,4}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(([0-9A-Fa-f]{1,4}:){0,5}:((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(::([0-9A-Fa-f]{1,4}:){0,5}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|([0-9A-Fa-f]{1,4}::([0-9A-Fa-f]{1,4}:){0,5}[0-9A-Fa-f]{1,4})|(::([0-9A-Fa-f]{1,4}:){0,6}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){1,7}:))$((1[0-1][0-9]|12[0-8]|[2-9][0-9]|1[6-9]))?/))
	{
		return true;
	}
	else if(ipAddress.match(/^[a-zA-Z0-9-_]([a-zA-Z0-9-_]*[\.]?[a-zA-Z0-9-_])+$/)) //validate for host name
	{
		return true;
	}
	else // not matching any of the conditions
	{
		alert ( errmsg ) ;
		return false;//ipaddress invalid
	}

	return true ; //valid ip address
}
////////////////////////////////////////////////
//
// Validates values in controls before applying
//
function Validate()
{
	if (document.getElementById("idSpecifyDbLocation").checked)
	{
		vfLocal.clearValidators ("idDatabaseLocation");
		if ( this.gEPOMode && this.gLinux )
		{
			// Don't add any validator
		}
		else
		{
			var bRelative = true;
			if ( document.getElementById("idDatabaseLocationType").length-1 == document.getElementById("idDatabaseLocationType").selectedIndex )
				bRelative = false;
			vfLocal.addValidator("idDatabaseLocation", new FilePathValidator(bRelative));
		}

	}
	else
	{
		vfLocal.clearValidators ("idDatabaseLocation");
	}


	var bOK = vfLocal.onsubmit()
	if( document.getElementById("mqmenabled").checked )
	   {
			bOK = bOK && validateIPAddress();
			bOK = bOK && vfMQM.onsubmit();
	   }

	return bOK
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function Apply(pb)
{

	// Local database
	var pp = new PropertyPath("Repository")
	pb.SetProperty(pp)

	// Path
	pp.SetTempLeaf("Path");
	if( document.getElementById("idSpecifyDbLocation").checked )
	{
		var path = document.getElementById("idDatabaseLocation").value;
		var nSelectedIndexType = document.getElementById("idDatabaseLocationType").selectedIndex;

		var nMacroAllowedIndex = gMacroTable.length - 2;
		if( typeof(gLinux) != "undefined" )
		{
			if ( this.gLinux )
			{
				nMacroAllowedIndex = 1;
			}
		}
		if( typeof(gEPOMode) != "undefined" && typeof(gLinux) != "undefined" )
		{
			if ( this.gEPOMode && this.gLinux )
			{
				nMacroAllowedIndex = 1;
			}
		}

		if( nSelectedIndexType <= nMacroAllowedIndex )
		{
			if( typeof(gLinux) != "undefined" )
			{
				if ( this.gLinux )
				{
					path = PSGetDatabaseLocationPath(gMacroTable[nSelectedIndexType] , path);
				}
				else
				{
					path = PSGetDatabaseLocationPath(gMacroTable[nSelectedIndexType+1] , path);
				}
			}
			else
			{
				path = PSGetDatabaseLocationPath(gMacroTable[nSelectedIndexType+1] , path);
			}
		}

		pb.SetProperty(pp.GetPath(), path);
	}
	else
			pb.SetProperty(pp.GetPath(), "");

	pp.SetTempLeaf("MaxItemSize")
	pb.SetProperty(pp,document.getElementById("maxitemsize").value*gBytesPerMegabyte)
	pp.SetTempLeaf("MaxQuerySize")
	pb.SetProperty(pp,document.getElementById("maxquerysize").value)
	pp.SetTempLeaf("MaxDays")
	pb.SetProperty(pp,document.getElementById("maxitemage").value)
	pp.SetTempLeaf("DiskSizeWaitTime")
	pb.SetProperty(pp,document.getElementById("diskchecktime").value)
	pp.SetTempLeaf("DiskSizeWarnAT")
	pb.SetProperty(pp,document.getElementById("disksize").value)

	// MQM
	var pp = new PropertyPath("MQM")
	pb.SetProperty(pp)
	pp.SetTempLeaf("Enabled")
	pb.SetProperty(pp,document.getElementById("mqmenabled").checked)
	if (document.getElementById("mqmenabled").checked)
	{
		var value = ""

		value = document.getElementById("mqmipaddress").value;

		pp.SetTempLeaf("IPAddress")
		pb.SetProperty(pp,value)
		pp.SetTempLeaf("Port")
		pb.SetProperty(pp,document.getElementById("mqmport").value)
		pp.SetTempLeaf("CallbackPort")
		pb.SetProperty(pp,document.getElementById("callbackport").value)
			
		// Set Communication Mode
		// RPC 			: 0
		// HTTP			: 1
		// HTTPs		: 2
		var commMode = (1 * document.getElementById("mqmradiohttp").checked) + (2 * document.getElementById("mqmradiohttps").checked)
		pp.SetTempLeaf("CommunicationMode")
		pb.SetProperty(pp, commMode)
		
		pp.SetTempLeaf("BWListUpdateInterval")
		pb.SetProperty(pp, document.getElementById("bwlistupdateinterval").value)
	}
	
	// Fix for BZ:643059
	var valMaxAge = document.getElementById("maxitemage").value
	if(valMaxAge != gDBMaxAge && valMaxAge != McUndefined)
	{
		alert(gstrMaxAgeInfo);
		gDBMaxAge = valMaxAge;
	}

	// Async Reporting
	pp = new PropertyPath("AsyncReporting")
	pb.SetProperty(pp)
	pp.SetTempLeaf("ASYNCReportingLevel")
	pb.SetProperty(pp, document.getElementById("asynclevel").value)
}


////////////////////////////////////////////////////////////
//
// Edit Purge Schedule
//
function EditPurgeSchedule()
{
	var pp = new PropertyPath("Scheduler.Task")
	pp.BeginEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	top.gPageStack.Forward(new DialogPage("EditTaskSchedule.html",gsEditPurgeSchedule), pp.GetPath())
}

////////////////////////////////////////////////////////////
//
// Edit Optimimization Schedule
//
function EditOptSchedule()
{
	var pp = new PropertyPath("Scheduler.Task")
	pp.BeginEnum()
	pp.IncrementEnum()
	top.gPageStack.Forward(new DialogPage("EditTaskSchedule.html",gsEditOptSchedule), pp.GetPath())
}

////////////////////////////////////////////////////////////
//
// Naviages to page to edit update schedule
//
function EditSchedule()
{
	var pp = new PropertyPath("Scheduler.Task")
	pp.BeginEnum()
	pp.IncrementEnum()
	top.gPageStack.Forward(new DialogPage("EditTaskSchedule.html",gsEditTaskSchedule), "Scheduler.Task")
}

////////////////////////////////////////////////////////////
//
// key Validation for MQM IP address field (IPv4, IPv6, host name)
// Characters which are not allowed in a hostname include ` ~ ! @ # $  ^ & * ( ) = + [ ] { } \ | ; ' " , < > / and ?
//
function FilterKeysForMQM(event)
{
	var charCode = (event.which) ? event.which : event.keyCode;

	// Is it one of the filtered keys
	for( var n = 0; n < gKeysNotAllowed.length; n++ )
		if( gKeysNotAllowed[n] == charCode )
			return false;

	// Is it one of the allowed keys
	for( var n = 0; n < gAllowedKeyCodes.length; n++ )
		if( gAllowedKeyCodes[n] == charCode )
			return true;

	return true
}

////////////////////////////////////////////////////////////
//
// IPv4 address Validation for MQM IP address field
// return values: -1  = Proceed to next validation
//						0  = invalid IPv4 address ( e.g 0.0.0.0 )
//						1  = valid IPv4 address
//
function Checkv4Address(sMQMIPAddress)
{
	var errmsg = vfr_st["bad_form_one_error"]+ "\n" + "- " + gsErrMQMIpAddress + ": " + gsInvalidIPAddress + "\n" + vfr_st["one_error_resubmit"];

	var ipAddrSegments = sMQMIPAddress.split(".");

	if(ipAddrSegments.length > 4)
	{
		return false;
	}

	//handling the case where the first octet is zero // this also handles "0.0.0.0" case
	if ( ipAddrSegments[0] == 0)
	{
		alert ( errmsg ) ;
		return false;//ipaddress invalid
	}

	//handling the special case "255.255.255.255"
	if ( ipAddrSegments[0] == 255 && ipAddrSegments[1] == 255 && ipAddrSegments[2] == 255 && ipAddrSegments[3] == 255 )
	{
		alert ( errmsg ) ;
		return false; //ipaddress invalid
	}

	//check all the individual segments
	for (var i = 0; i < 4; i++)
		{
			// non empty field and in the range of 0-255
			if( ipAddrSegments[i].length > 0 && ipAddrSegments[i] >=0 && ipAddrSegments[i] <=255 )
				continue; //segment is correct
			else
		     {
				alert ( errmsg );
				return false; //ipaddress invalid.
	         }
		}
	return true ; //valid ip address
}

////////////////////////////////////////////////////////////
//
// IPv6 address Validation for MQM IP address field
//
function Checkv6Address(sMQMIPAddress)
{
	var errmsg = vfr_st["bad_form_one_error"]+ "\n" + "- " + gsErrMQMIpAddress + ": " + gsInvalidIPAddress + "\n" + vfr_st["one_error_resubmit"];

	//check for zero based IPv6 address
	if ( sMQMIPAddress == 0 ||  sMQMIPAddress == "::")
	{
		alert ( errmsg ) ;
		return false;//ipaddress invalid
	}
	//add addditional check a required below

	return true ; //valid ip address
}
