/*
 * DefaultValues.js
 * Specifies default values for various fields.
 *
 * Point products may customize these values
 *
 * Copyright (C) 2016 McAfee, Inc. All rights reserved.
 */

// Indexing of the defValues object is [topic][field], e.g. ["AV"]["ScanLevel"];
if (!top.defValues) {
    top.defValues = new Object();
    top.defValues["AV"] = new Object();
    top.defValues["AV"]["ScanLevel"] = "Custom";
    top.defValues["AV"]["AVP_SCANWHAT"] = "ALL";
    top.defValues["AV"]["AVP_DECOMPARCHIVES"] = 1;
    top.defValues["AV"]["AVP_HEURISTICANALYSIS"] = 1;
    top.defValues["AV"]["AVP_MACROANALYSIS"] = 1;
    top.defValues["AV"]["ArtemisSensitivityLevel"] = 0;
    top.defValues["AV"]["CMBSENSLEVEL"] = 2;
    top.defValues["AV"]["AVP_SCANALLMACROS"] = 1;
    top.defValues["AV"]["AVP_FINDALLMACROS"] = 0;
    top.defValues["AV"]["AVP_DELETEALLMACROS"] = 0;
    top.defValues["AV"]["AVP_SERVER"] = 1;
    top.defValues["AV"]["AVP_SHOWCOMPRESSED"] = 1;
    top.defValues["AV"]["PackerExclusions"] = 1;
    top.defValues["AV"]["AVP_PROGRAM"] = 1;
    top.defValues["AV"]["PupExclusions"] = 1;
    top.defValues["AV"]["PupTypes"] = 0xffff;
    top.defValues["AV"]["RemoveDetectedCookies"] = 1;
    top.defValues["AV"]["CleanToZeroIsNotClean"] = "Remove";
    top.defValues["AV"]["BackdoorProtection"] = 0;
    top.defValues["AV"]["DropperProtection"] = 0;
    top.defValues["AV"]["DownloaderProtection"] = 0;
    top.defValues["AV"]["HtmlProtection"] = 0;
    top.defValues["AV"]["IrcProtection"] = 0;
    top.defValues["AV"]["JscriptProtection"] = 0;
    top.defValues["AV"]["MassMailerProtection"] = 0;
    top.defValues["AV"]["PasswordStealerProtection"] = 0;
    top.defValues["AV"]["ProxyProtection"] = 0;
    top.defValues["AV"]["ReplayMailerProtection"] = 0;
    top.defValues["AV"]["TrojanProtection"] = 0;
    top.defValues["AV"]["WormProtection"] = 0;
    top.defValues["AV"]["SpecificVirusProtection"] = 0;
    top.defValues["AV"]["MalwareCleaningAllowed"] = 1;

    top.defValues["AS"] = new Object();
    top.defValues["AS"]["ScoreLevel"] = "Custom";
    top.defValues["AS"]["SpamThreshold"] = 10.0;
    top.defValues["AS"]["PrefixSubject"] = 1;
    top.defValues["AS"]["PrefixSubjectText"] = resolveString(cse_pp_st, "__def_spam_pfx");
    top.defValues["AS"]["SpamIndicator"] = "Never";
    top.defValues["AS"]["SpamIndicatorText"] = "*";
    top.defValues["AS"]["AttachReport"] = "SpamOnly";
    top.defValues["AS"]["VerboseLogging"] = 0;
    top.defValues["AS"]["MaxMailScanSize"] = 250;
    top.defValues["AS"]["MaxHeaderWidth"] = 76;
    top.defValues["AS"]["MaxReportedRules"] = 180;
    top.defValues["AS"]["AddCheckedToNonSpam"] = 0;
    top.defValues["AS"]["MsgHeaderIndicator"] = "Never";
    top.defValues["AS"]["UseDefaultBayesConfig"] = 1;
    top.defValues["AS"]["UseBayesLearning"] = 1;
    top.defValues["AS"]["NonSpamBayesThreshold"] = "";
    top.defValues["AS"]["SpamBayesThreshold"] = "";
    top.defValues["AS"]["EnableNetworkTests"] = 1;
    top.defValues["AS"]["EnableRBLTests"] = 1;
    top.defValues["AS"]["TimeoutRBLTests"] = 15000;
    top.defValues["AS"]["ScoreBasedActionLevel1"]="High";
    top.defValues["AS"]["ScoreBasedActionValue1"]=15.0;
    top.defValues["AS"]["ScoreBasedActionLevel2"]="Med";
    top.defValues["AS"]["ScoreBasedActionValue2"]=10.0;
    top.defValues["AS"]["ScoreBasedActionLevel3"]="Low";
    top.defValues["AS"]["ScoreBasedActionValue3"]=5.0;

    top.defValues["AF"] = new Object();
    top.defValues["AF"]["PrefixSubject"] = 1;
    top.defValues["AF"]["PrefixSubjectText"] = resolveString(cse_pp_st, "__def_phish_pfx");
    top.defValues["AF"]["PhishIndicator"] = 0;
    top.defValues["AF"]["AttachReport"] = 0;
    top.defValues["AF"]["VerboseLogging"] = 0;

    top.defValues["FF"] = new Object();
    top.defValues["FF"]["FilenameCheck"] = 0;
    top.defValues["FF"]["SizeCheck"] = 0;
    top.defValues["FF"]["SizeType"] = "greater";
    top.defValues["FF"]["SizeLimit"] = 10485760;
    top.defValues["FF"]["FormatCheck"] = 0;
	top.defValues["FF"]["EvalChildRulesOnTrigger"] = 0;
    top.defValues["FF"]["Unrecognised"] = 0;

    top.defValues["SS"] = new Object();
    top.defValues["SS"]["maxwidth"] = 500;
    top.defValues["SS"]["maxdepth"] = 100;
    top.defValues["SS"]["ScannerTimeout"] = 900000;

    top.defValues["ALERT"] = new Object();
    top.defValues["ALERT"]["PlainText"] = 0;
    top.defValues["ALERT"]["Charset"] = "NCR";
    top.defValues["ALERT"]["HeaderEnabled"] = 0;
    top.defValues["ALERT"]["FooterEnabled"] = 1;

    top.defValues["DISC"] = new Object();
    top.defValues["DISC"]["DisclaimerType"] = 2;

    top.defValues["MF"] = new Object();
    top.defValues["MF"]["MaxSize"] = 100000;
    top.defValues["MF"]["BiggerThanVal"] = 32000;
    top.defValues["MF"]["MoreThanVal"] = 500;

    top.defValues["MIME"] = new Object();
    top.defValues["MIME"]["HdrCorruptionCheck"] = 0;
    top.defValues["MIME"]["HdrNULLCheck"] = 0;
    top.defValues["MIME"]["QPCorruptionDetection"] = 0;
    top.defValues["MIME"]["InconsistentEOLAction"] = 0;
    top.defValues["MIME"]["MaxBoundaries"] = 10000;
    top.defValues["MIME"]["MaxBoundariesExceededAsDoS"] = 0;
    top.defValues["MIME"]["InlineReplacementText"] = 0;
    top.defValues["MIME"]["ReEncodingScheme"] = 3;
    top.defValues["MIME"]["ReEncodingName"] = "utf-8";
    top.defValues["MIME"]["Continuations"] = ["boundary", "name", "charset", "filename"];
    top.defValues["MIME"]["AsciiContentTypes"] = "text/plain;text/html;text/javascript;text/css";
    top.defValues["MIME"]["BinContentTypes"] = "";
    top.defValues["MIME"]["PreferredContentTransferEncoding"] = 10;
    top.defValues["MIME"]["AlternateCharset"] = "us-ascii";
    top.defValues["MIME"]["PreAttStrip"] = 1;
    top.defValues["MIME"]["HeaderEncodingScheme"] = 0;
    top.defValues["MIME"]["HeaderEncodingCharset"] = "utf-7";
    top.defValues["MIME"]["HeaderEncodingFallback"] = 0;
    top.defValues["MIME"]["BadCharsetConversionBehaviour"] = 3;

    top.defValues["HTML"] = new Object();
    top.defValues["HTML"]["ScanComments"] = "1";
    top.defValues["HTML"]["ScanLinkURLs"] = "1";
    top.defValues["HTML"]["ScanSourceURLs"] = "1";
    top.defValues["HTML"]["ScanMetaData"] = "1";
    top.defValues["HTML"]["ScanScript"] = "1";
    top.defValues["HTML"]["StripScript"] = "0";
    top.defValues["HTML"]["StripApplets"] = "0";
    top.defValues["HTML"]["StripActiveX"] = "0";
    top.defValues["HTML"]["StripFlash"] = "0";
	
	top.defValues["MailURL"] = new Object();
	top.defValues["MailURL"]["HighThresholdValue"] = 80;
	top.defValues["MailURL"]["LowThresholdValue"] = 50;
	top.defValues["MailURL"]["MaxNetworkURLLookup"] = 100;
	top.defValues["MailURL"]["MaxOverallURLLookup"] = 1000;
	top.defValues["MailURL"]["URLThresholdType"] = 0;
	top.defValues["MailURL"]["LURLThresholdType"] = 1;

    top.defValues["PX"] = new Object();
    top.defValues["PX"]["ScanType"] = 1;
    top.defValues["PX"]["ThresholdHIPAA"] = 60;
    top.defValues["PX"]["ThresholdPrivacy"] = 80;
    top.defValues["PX"]["GruntScan"] = 0;

    // Default action lists
    top.defValues["Actions"] = new Object();
    top.defValues["Actions"]["AV"] = new Object();
    top.defValues["Actions"]["AV"]["Action"] = "ESERVICES:CLEAN,(QUARANTINE)";
    top.defValues["Actions"]["AF"] = new Object();
    top.defValues["Actions"]["AF"]["Action"] = "(ESERVICES:ALLOWTHRU)";
    top.defValues["Actions"]["FF"] = new Object();
    top.defValues["Actions"]["FF"]["Action"] = "(ESERVICES:ALLOWTHRU)";
    top.defValues["Actions"]["SS"] = new Object();
    top.defValues["Actions"]["SS"]["MaxWidthAction"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["SS"]["MaxDepthAction"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["SS"]["TimeoutAction"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["SM"] = new Object();
    top.defValues["Actions"]["SM"]["Action"] = "(ESERVICES:BREAKSIG)";
    top.defValues["Actions"]["EM"] = new Object();
    top.defValues["Actions"]["EM"]["Action"] = "(ESERVICES:ALLOWTHRU)";
    top.defValues["Actions"]["PM"] = new Object();
    top.defValues["Actions"]["PM"]["Action"] = "(ESERVICES:ALLOWTHRU)";
    top.defValues["Actions"]["CM"] = new Object();
    top.defValues["Actions"]["CM"]["Action"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["PPF"] = new Object();
    top.defValues["Actions"]["PPF"]["Action"] = "(ESERVICES:ALLOWTHRU)";
    top.defValues["Actions"]["MF"] = new Object();
    top.defValues["Actions"]["MF"]["MaxSizeAction"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["MF"]["BiggerThanAction"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["MF"]["MoreThanAction"] = "(ESERVICES:REPLACE)";
	top.defValues["Actions"]["MailURL"] = new Object();
    top.defValues["Actions"]["MailURL"]["HighThresholdAction"] = "(ESERVICES:REPLACE)";
    top.defValues["Actions"]["MailURL"]["LowThresholdAction"] = "(ESERVICES:ALLOWTHRU)";
    top.defValues["Actions"]["MailURL"]["MAXURLExceededAction"] = "(ESERVICES:REPLACE)";
}
