// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
var gDiagMaxAge = McUndefined;
var vfInput = new ValidationFramework("diagnosticsForm");

function Validate()
{
	var vf = new ValidationFramework("diagnosticsForm");
	vf.labelMap = gDiagnosticLabels;

	// Debug tracing
	if (document.getElementById("idDebugLimitLogSize").checked)
	{
		if (document.getElementById("idDebugLogMaxSizeMB").checked)
			vf.addValidator("idDebugLogMaxSize", new CrossValidator("value >=1 && value <=2000", formatString(strRange, new Array("1 "+strKB, "2000 "+strMB))));
		else
			vf.addValidator("idDebugLogMaxSize", new CrossValidator("value >=1 && value <=2048000", formatString(strRange, new Array("1 "+strKB, "2000 "+strMB))));
	}
	if (document.getElementById("idDebugSpecifyLocation").checked && document.getElementById("idDebugLevel").selectedIndex != 0)
	{
		if ( this.gEPOMode && this.gLinux )
		{
			// Don't add any validator
		}
		else
		{
			var bRelative = true;
			if ( document.getElementById("idDebugLogLocationType").length-1 == document.getElementById("idDebugLogLocationType").selectedIndex )
				bRelative = false;

			vf.addValidator("idDebugLogLocation", new FilePathValidator(bRelative));
		}
	}

	// Product log
	if (document.getElementById("idPLLimitDbSize").checked)
	{
		if (document.getElementById("idPLMaxDbSizeTypeInMB").checked)
			vf.addValidator("idPLMaxDbSize", new CrossValidator("value >=1 && value <=2000", formatString(strRange, new Array("1 "+strKB, "2000 "+strMB))));
		else
			vf.addValidator("idPLMaxDbSize", new CrossValidator("value >=1 && value <=2048000", formatString(strRange, new Array("1 "+strKB, "2000 "+strMB))));
	}
	if (document.getElementById("idPLSpecifyLocation").checked)
	{
		if ( this.gEPOMode && this.gLinux )
		{
			// Don't add any validator
		}
		else
		{
			var bRelative = true;
			if ( document.getElementById("idPLDatabaseLocationType").length-1 == document.getElementById("idPLDatabaseLocationType").selectedIndex )
				bRelative = false;

			vf.addValidator("idPLDatabaseLocation", new FilePathValidator(bRelative));
		}
	}
	if (document.getElementById("idPLSpecifyFilename").checked)
	{
		vf.addValidator("idPLDbFilename", new FileNameValidator());
	}
	if (document.getElementById("idPLLimitAgeOfEntries").checked)
		vf.addValidator("idPLMaxAgeOfEntries", new CrossValidator("value >=1 && value <=365", formatString(strRange, new Array(1, 365))));


	// Advanced
	if (document.getElementById("idPLEnableQueryTimeout").checked)
		vf.addValidator("idPLQueryTimeout", new CrossValidator("value >=1 && value <=3600", formatString(strRange, new Array(1, 3600))));

	return vf.onsubmit();
}

function AddNumericOnlyValidation()
{
   	var fn =   cb_numOnlyNN ;
	document.getElementById("idPLMaxAgeOfEntries").onkeypress =  fn ;
	document.getElementById("idPLQueryTimeout").onkeypress = fn;
	document.getElementById("idDebugLogMaxSize").onkeypress = fn;
	document.getElementById("idPLMaxDbSize").onkeypress = fn;
}

function Show(pbIn)
{
	// Hide the row that shows the AM reporting option.
	if( typeof(gbSupportsAM) != "undefined" && gbSupportsAM == false ){
		document.getElementById("idAMRow").style.display="none";
		document.getElementById("idLastRow").className = "lastrow";
	}

	if ( gLinux )
	{
		document.getElementById("ERS_div").style.display="none";
	}

	AddNumericOnlyValidation();

	var pp = new PropertyPath("Diagnostics");
	var ppPLDatabase = new PropertyPath("ProductLog")

	// Load settings from property bag into controls
	LoadSettings(pbIn, pp);
	LoadProductLogSettings(ppPLDatabase, pbIn);
	
	vfInput.addValidator("idDebugLogLocation", new InputTextValidator(true));
	vfInput.addValidator("idPLDatabaseLocation", new InputTextValidator(true));
	vfInput.addValidator("idPLDbFilename", new InputTextValidator(true));
	vfInput.formAction = std_val_form_action;
	vfInput.fieldAction = std_val_field_action;

	// Make sure all the controls are in the correct state
	OnDebugLogLimitSizeCheck();
	OnDebugSpecifyLocationCheck();
	OnCheckLimitDbSizePL();
	OnCheckLimitAgePL();
	OnCheckLocationPL();
	OnCheckFilenamePL();
	OnCheckQueryTimeoutPL();
	EnableDisableCheck();

    	// Initialize the tab handler
	diagnostics_tabs.ValidateCallback = Validate;
	//setting a new size for database location for solving the localization issue.
	document.getElementById("idDebugLogLocationType").style['width'] = '150px';
	document.getElementById("idPLDatabaseLocationType").style['width'] = '150px';
}

function Apply(pb)
{
	var pp = new PropertyPath("Diagnostics");
	var ppPLDatabase = new PropertyPath("ProductLog")

	// Load settings from property bag into controls
	ApplySettings(pb, pp);
	ApplyProductLogSettings(ppPLDatabase, pb);

	// Fix for BZ:643059
	var valMaxAge = parseInt(document.getElementById("idPLMaxAgeOfEntries").value, 10)
	if(valMaxAge != gDiagMaxAge && !isNaN(valMaxAge))
	{
		alert(gstrMaxAgeInfo)
		gDiagMaxAge = valMaxAge
	}
}

function ApplyProductLogSettings(pp, pb)
{
	var sCtrlIDPrefix = "idPL";
	// Delete all current settings
	pb.DeleteElement(pp);
	pb.SetProperty(pp);
	var pp2 = new PropertyPath(pp.GetPath());

	var ctrlArray = GetCtrlArray(sCtrlIDPrefix);


	var sCtrlIDInfoInfo		= sCtrlIDPrefix + "WriteInfoEvents";
	var sCtrlIDInfoWarning	= sCtrlIDPrefix + "WriteWarningEvents";
	var sCtrlIDInfoError	= sCtrlIDPrefix + "WriteErrorEvents";

	pp2.SetTempLeaf("LogInfo_toProduct");
	if( document.getElementById( sCtrlIDInfoInfo ).checked )
		pb.SetProperty(pp2.GetPath(), "1");
	else
		pb.SetProperty(pp2.GetPath(), "0");

	pp2.SetTempLeaf("LogWarn_toProduct");
	if( document.getElementById( sCtrlIDInfoWarning ).checked )
		pb.SetProperty(pp2.GetPath(), "1");
	else
		pb.SetProperty(pp2.GetPath(), "0");

	pp2.SetTempLeaf("LogErr_toProduct");
	if( document.getElementById( sCtrlIDInfoError ).checked )
		pb.SetProperty(pp2.GetPath(), "1");
	else
		pb.SetProperty(pp2.GetPath(), "0");

	var sCtrlIDPrefix2 = "idEL";
	sCtrlIDInfoInfo		= sCtrlIDPrefix2 + "WriteInfoEvents";
	sCtrlIDInfoWarning	= sCtrlIDPrefix2 + "WriteWarningEvents";
	sCtrlIDInfoError	= sCtrlIDPrefix2 + "WriteErrorEvents";

	pp2.SetTempLeaf("LogInfo_toEvent");
	if( document.getElementById( sCtrlIDInfoInfo ).checked )
		pb.SetProperty(pp2.GetPath(), "1");
	else
		pb.SetProperty(pp2.GetPath(), "0");

	pp2.SetTempLeaf("LogWarn_toEvent");
	if( document.getElementById( sCtrlIDInfoWarning ).checked )
		pb.SetProperty(pp2.GetPath(), "1");
	else
		pb.SetProperty(pp2.GetPath(), "0");

	pp2.SetTempLeaf("LogErr_toEvent");
	if( document.getElementById( sCtrlIDInfoError ).checked )
		pb.SetProperty(pp2.GetPath(), "1");
	else
		pb.SetProperty(pp2.GetPath(), "0");

	pp2.SetTempLeaf("");

	// Step into repository settings
	pp2.Append("Repository");
	
	pb.SetProperty(pp2);
	// Max database size
	pp2.SetTempLeaf("MaxDBSize");
	if( document.getElementById(ctrlArray[0]).checked )
	{
		var value = document.getElementById(ctrlArray[1]).value;

		if( document.getElementById(ctrlArray[2]).checked )
			value = value * 1024;

		pb.SetProperty(pp2.GetPath(), parseInt(value, 10));
	}

	// Maximum item age
	pp2.SetTempLeaf("MaxAge");
	if( document.getElementById(ctrlArray[4]).checked )
		pb.SetProperty(pp2.GetPath(), parseInt(document.getElementById(ctrlArray[5]).value, 10));

	// Path
	pp2.SetTempLeaf("Path");
	if( document.getElementById(ctrlArray[10]).checked )
	{
		var path = document.getElementById(ctrlArray[12]).value;
		var nSelectedIndexType = document.getElementById(ctrlArray[11]).selectedIndex;

		var nMacroAllowedIndex = 4;
		if( typeof(gLinux) != "undefined" )
		{
			if ( this.gLinux )
			{
				nMacroAllowedIndex = 1;
			}
		}

		if( typeof(gEPOMode) != "undefined" && typeof(gLinux) != "undefined" )
		{
			if ( this.gEPOMode && this.gLinux )
			{
				nMacroAllowedIndex = 1;
			}
		}
		if( nSelectedIndexType <= nMacroAllowedIndex )
		{
			path = PSGetPLPath(gMacroTable[nSelectedIndexType] , path);
		}

		pb.SetProperty(pp2.GetPath(), path);
	}
	else
	{
		pb.SetProperty("ProductLog.Repository");
	}

	// Filename
	pp2.SetTempLeaf("Filename");
	if( document.getElementById(ctrlArray[13]).checked )
	{
		pb.SetProperty(pp2.GetPath(), document.getElementById(ctrlArray[14]).value);
	}
	else
	{
		pb.SetProperty("ProductLog.Repository");
	}

	// Query timeout
	pp2.SetTempLeaf("Timeout");
	if( document.getElementById(ctrlArray[15]).checked )
		pb.SetProperty(pp2.GetPath(), parseInt(document.getElementById(ctrlArray[16]).value, 10) );

}

function ApplySettings(pb, pp)
{
	pb.SetProperty(pp);

	var pp2 = new PropertyPath(pp.GetPath());

	// level
	pp2.SetTempLeaf("TraceLevel");
	pb.SetProperty(pp2.GetPath(), parseInt(document.getElementById("idDebugLevel").selectedIndex,10));

	// maxfilesize
	pp2.SetTempLeaf("TraceMaxSize");
	if(document.getElementById("idDebugLimitLogSize").checked)
	{
		var maxSize = document.getElementById("idDebugLogMaxSizeMB").checked ? document.getElementById("idDebugLogMaxSize").value * 1024 : document.getElementById("idDebugLogMaxSize").value;
		pb.SetProperty(pp2.GetPath(), parseInt(maxSize,10));
	}
	else
		pb.SetProperty(pp2.GetPath(),"0");

	// path
	pp2.SetTempLeaf("TracePath");
	if(document.getElementById("idDebugSpecifyLocation").checked)
	{
		var path = document.getElementById("idDebugLogLocation").value;
		var nMacroAllowedIndex = 4;
		if( typeof(gLinux) != "undefined" )
		{
			if ( this.gLinux )
			{
				nMacroAllowedIndex = 2;
			}
		}
		if( typeof(gEPOMode) != "undefined" && typeof(gLinux) != "undefined" )
		{
			if ( this.gEPOMode && this.gLinux )
			{
				nMacroAllowedIndex = 2;
			}
		}

		if (document.getElementById("idDebugLogLocationType").selectedIndex <= nMacroAllowedIndex)
			path = PSGetDebugLogLocationPath(gMacroTable[document.getElementById("idDebugLogLocationType").selectedIndex] , path);

		pb.SetProperty(pp2.GetPath(),path);
	}
	else
		pb.SetProperty(pp2.GetPath(), "");

	// Talkback
	pp2.SetTempLeaf("TBEnable")
	pb.SetProperty(pp2.GetPath(),document.getElementById("idERSEnable").checked ? 1 : 0)
	pp2.SetTempLeaf("TBHandle")
	pb.SetProperty(pp2.GetPath(),document.getElementById("idERSCatchExceptions").checked ? 1 : 0)
	pp2.SetTempLeaf("TBReportToAM")
	pb.SetProperty(pp2.GetPath(),document.getElementById("idERSReportToAM").checked ? 1 : 0)
	pp2.SetTempLeaf("TBReport")
	pb.SetProperty(pp2.GetPath(),document.getElementById("idERSReportToUser").checked ? 1 : 0)

	pp2.SetTempLeaf("");
}

function LoadProductLogSettings(pp, pb)
{
	var sCtrlIDPrefix = "idPL";
	var pp2 = new PropertyPath(pp.GetPath());

	var ctrlArray = GetCtrlArray(sCtrlIDPrefix);


	var sCtrlIDInfoInfo		= sCtrlIDPrefix + "WriteInfoEvents";
	var sCtrlIDInfoWarning	= sCtrlIDPrefix + "WriteWarningEvents";
	var sCtrlIDInfoError	= sCtrlIDPrefix + "WriteErrorEvents";

	pp2.SetTempLeaf("LogInfo_toProduct");
	document.getElementById( sCtrlIDInfoInfo ).checked = pb.GetProperty(pp2.GetPath()) != 0;

	pp2.SetTempLeaf("LogWarn_toProduct");
	document.getElementById( sCtrlIDInfoWarning ).checked = pb.GetProperty(pp2.GetPath()) != 0;

	pp2.SetTempLeaf("LogErr_toProduct");
	document.getElementById( sCtrlIDInfoError ).checked = pb.GetProperty(pp2.GetPath()) != 0;

	var sCtrlIDPrefix2 = "idEL";
	sCtrlIDInfoInfo		= sCtrlIDPrefix2 + "WriteInfoEvents";
	sCtrlIDInfoWarning	= sCtrlIDPrefix2 + "WriteWarningEvents";
	sCtrlIDInfoError	= sCtrlIDPrefix2 + "WriteErrorEvents";

	pp2.SetTempLeaf("LogInfo_toEvent");
	document.getElementById( sCtrlIDInfoInfo ).checked = pb.GetProperty(pp2.GetPath()) != 0;

	pp2.SetTempLeaf("LogWarn_toEvent");
	document.getElementById( sCtrlIDInfoWarning ).checked = pb.GetProperty(pp2.GetPath()) != 0;

	pp2.SetTempLeaf("LogErr_toEvent");
	document.getElementById( sCtrlIDInfoError ).checked = pb.GetProperty(pp2.GetPath()) != 0;

	pp2.SetTempLeaf("");
	// Step into repository settings
	pp2.Append("Repository");


	// Database Size Limits

	// Limit Database Size
	pp2.SetTempLeaf("MaxDBSize");
	var value = pb.GetProperty(pp2.GetPath());
	if( value != McUndefined )
	{
		if(value != 0 )
		{
			if( value % 1024 == 0 )
			{
				value = (value / 1024);
				document.getElementById(ctrlArray[2]).checked = true;
			}

			document.getElementById(ctrlArray[1]).value = value;
		}

		document.getElementById(ctrlArray[0]).checked = true;
	}
	else
	{
		document.getElementById(ctrlArray[0]).checked = false;
	}

	//Maximum record age
	pp2.SetTempLeaf("MaxAge");
	value = pb.GetProperty(pp2.GetPath());
	if( value != McUndefined )
	{
		document.getElementById(ctrlArray[5]).value = value;
		document.getElementById(ctrlArray[4]).checked = true;
		gDiagMaxAge = value;
	}
	else
		document.getElementById(ctrlArray[4]).checked = false;

	//Fetch the values from gDebugLocationMacroDispTable Array
 	var gPLMacroDispTableSize = gPLMacroDispTable.length;
	if( typeof(gEPOMode) != "undefined" && typeof(gLinux) != "undefined" )
	{
		if ( this.gEPOMode && this.gLinux )
		{
			gPLMacroDispTableSize--;
		}
	}

   	for(var i = 0; i < gPLMacroDispTableSize; i++)
   	{
 	  	 document.getElementById("idPLDatabaseLocationType").options[i]=new Option(gPLMacroDispTable[i])
   	}

	// Database location
	pp2.SetTempLeaf("Path")
	value = pb.GetProperty(pp2.GetPath());
	if(value != McUndefined)
	{
		document.getElementById(ctrlArray[10]).checked = true;

		var macroIndex = GetFilePathMacro(value)
		if (macroIndex != -1)
		{
			document.getElementById(ctrlArray[11]).selectedIndex = macroIndex;
			value = value.substr(gMacroTable[macroIndex].length+1)
		}
		else
		{
			document.getElementById(ctrlArray[11]).selectedIndex = 	document.getElementById(ctrlArray[11]).length - 1;
		}

		document.getElementById(ctrlArray[12]).value = value
	}
	else
		document.getElementById(ctrlArray[10]).checked = false;

	// Database filename
	pp2.SetTempLeaf("Filename")
	value = pb.GetProperty(pp2.GetPath());
	if( value != McUndefined )
	{
		document.getElementById(ctrlArray[14]).value = value;
		document.getElementById(ctrlArray[13]).checked = true;
	}
	else
		document.getElementById(ctrlArray[13]).checked = false;

	// Database filename
	pp2.SetTempLeaf("Timeout")
	value = pb.GetProperty(pp2.GetPath());
	if( value != McUndefined )
	{
		document.getElementById(ctrlArray[16]).value = value;
		document.getElementById(ctrlArray[15]).checked = true;
	}
	else
		document.getElementById(ctrlArray[15]).checked = false;


	pp2.SetTempLeaf("");
}

function LoadSettings( pb, pp )
{
	var pp2 = new PropertyPath(pp.GetPath());

	// Trace Level
	pp2.SetTempLeaf("TraceLevel");
	var traceLevelIndex = pb.GetProperty( pp2.GetPath() );
	if( traceLevelIndex != McUndefined )
		document.getElementById("idDebugLevel").selectedIndex = traceLevelIndex;

	// Limit size of debug files
	pp2.SetTempLeaf("TraceMaxSize")
	var value = pb.GetProperty(pp2.GetPath());
	if( value != McUndefined )
	{
		if (value != 0)
		{
			if(value % 1024 == 0)
			{
				value = (value / 1024);
				document.getElementById("idDebugLogMaxSizeMB").checked = true;
			}

			document.getElementById("idDebugLogMaxSize").value = value;
			document.getElementById("idDebugLimitLogSize").checked  =  true;
		}
	}
	else
		document.getElementById("idDebugLimitLogSize").checked  =  false;

	//Fetch the values from gDebugLocationMacroDispTable Array
 	var gDebugLogLocationMacroDispTableSize = gDebugLogLocationMacroDispTable.length;
	if( typeof(gEPOMode) != "undefined" && typeof(gLinux) != "undefined" )
	{
		if ( this.gEPOMode && this.gLinux )
		{
			gDebugLogLocationMacroDispTableSize--;
		}
	}

   	for(var i = 0; i < gDebugLogLocationMacroDispTableSize; i++)
   	{
 	  	 document.getElementById("idDebugLogLocationType").options[i]=new Option(gDebugLogLocationMacroDispTable[i])
   	}

	// Specifiy debug file location
	pp2.SetTempLeaf("TracePath")
	value = pb.GetProperty(pp2.GetPath());

	if(value != McUndefined)
	{
		document.getElementById("idDebugSpecifyLocation").checked  =  value != ""

		if (value != "")
		{
			var macroIndex = GetFilePathMacro(value)
			if (macroIndex != -1)
			{
				document.getElementById("idDebugLogLocationType").selectedIndex = macroIndex;
				value = value.substr(gMacroTable[macroIndex].length+1)
			}
			else
			{
				document.getElementById("idDebugLogLocationType").selectedIndex = document.getElementById("idDebugLogLocationType").length - 1;
			}
			document.getElementById("idDebugLogLocation").value = value
		}
	}
	else
		document.getElementById("idDebugSpecifyLocation").checked  =  false

	// Error Reporting Service
	pp2.SetTempLeaf("TBEnable")
	document.getElementById("idERSEnable").checked = pb.GetProperty(pp2.GetPath()) != 0;

	pp2.SetTempLeaf("TBHandle")
	document.getElementById("idERSCatchExceptions").checked = pb.GetProperty(pp2.GetPath()) != 0

	pp2.SetTempLeaf("TBReportToAM")
	document.getElementById("idERSReportToAM").checked = pb.GetProperty(pp2.GetPath()) != 0

	pp2.SetTempLeaf("TBReport")
	document.getElementById("idERSReportToUser").checked = pb.GetProperty(pp2.GetPath()) != 0

	pp2.SetTempLeaf("");
}

function GetCtrlArray( sCtrlIDPrefix )
{
	var ctrlArray = new Array;

	ctrlArray[0]	= sCtrlIDPrefix + "LimitDbSize"; // Limit database size (boolean)
	ctrlArray[1]	= sCtrlIDPrefix + "MaxDbSize";
	ctrlArray[2]	= sCtrlIDPrefix + "MaxDbSizeTypeInMB";
	ctrlArray[3]	= sCtrlIDPrefix + "MaxDbSizeInKB";
	ctrlArray[4]	= sCtrlIDPrefix + "LimitAgeOfEntries";
	ctrlArray[5]	= sCtrlIDPrefix + "MaxAgeOfEntries";
	ctrlArray[6]	= sCtrlIDPrefix + "LimitedItemSize";
	ctrlArray[7]	= sCtrlIDPrefix + "MaxItemSize";
	ctrlArray[8]	= sCtrlIDPrefix + "MaxItemSizeMB";
	ctrlArray[9]	= sCtrlIDPrefix + "MaxItemSizeKB";
	ctrlArray[10]	= sCtrlIDPrefix + "SpecifyLocation";
	ctrlArray[11]	= sCtrlIDPrefix + "DatabaseLocationType";
	ctrlArray[12]	= sCtrlIDPrefix + "DatabaseLocation";
	ctrlArray[13]	= sCtrlIDPrefix + "SpecifyFilename";
	ctrlArray[14]	= sCtrlIDPrefix + "DbFilename";
	ctrlArray[15]	= sCtrlIDPrefix + "EnableQueryTimeout";
	ctrlArray[16]	= sCtrlIDPrefix + "QueryTimeout";

	return(ctrlArray);
}

function EnableDisableCheck()
{

	//To disable the DebugSpecifyLocation Checkbox, when DebugLevel is none
	if(document.getElementById("idDebugLevel").selectedIndex == 0)
	{
		 document.getElementById( "idDebugSpecifyLocation" ).disabled = true;
		document.getElementById( "idDebugLogLocationType" ).disabled = true;
		document.getElementById( "idDebugLogLocation" ).disabled = true;
	}
	else
	{
		document.getElementById( "idDebugSpecifyLocation" ).disabled = false;
		OnDebugSpecifyLocationCheck();
	}
}
