/**
 * JavaScript for handling filter rules in the settings page
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var fr_pb = null;
var fr_ruleTypes = [];
var rLists = new Object();
var rListWidgets = new Object();

function DeleteRule(pp, type) {
    if (confirm(resolveString(cse_pp_st, "__del_rule_prompt"))) {
        fr_pb.DeleteElement(pp);
        top.SetModified(true);
        fr_showList(type);
    }
}

function LoadRule(url, title, pp) {
    var page = new DialogPage(url, title);
    top.gPageStack.Forward(page, pp);
}

function NewRule(type) {
    var basePP = type + "Rules.Rule";
    // Get the next enumeration
    var newPP = fr_pb.GetNextElementEnum(basePP);
    var target = type + "Rule.html";
    var title = resolveString(cse_pp_st, type);
    top.gPageStack.Forward(new DialogPage(target, title), newPP);
}

/**
 * Show helper function to render filter rules
 */
function fr_Show(pbIn) {
    fr_pb = pbIn;
    fr_ruleTypes = fr_getRuleTypes();
    var nTypes = fr_ruleTypes.length;
    // Create the panels to hold the rule lists before creating the
    // lists themselves
    var html = "";
    var currRollupCount = this.form_rollups ? form_rollups.getCount() : 0;
    for (var i = 0; i < nTypes; i++) {
        var type = fr_ruleTypes[i];
        var ruIdx = i + currRollupCount;
        var ruName = "fr_ru" + ruIdx;
        var tableId = "tbl_" + type;
        if (this.form_rollups) {
            // Create a rollup control for the table
            form_rollups.addTableRollup(ruName, tableId, true);
        }

        // Create the table
        html += '<table border="0" cellpadding="0" cellspacing="0" id="' +
             tableId + '" class="shadedTable" style="width:100%;';
        if (0 != i) {
            html += 'margin-top:10px;';
        }
        html += '">';

        // Create the title row
        html += '<tr class="noBottom"><td class="st bold" nowrap>' +
            resolveString(cse_pp_st, type + "_Hdr") + '</td>';
        html += '<td class="st rightAligned">';
        if (this.form_rollups) {
            html += form_rollups.makeControlHTML(ruIdx);
        }
        else {
            html += '&nbsp;'
        }
        html += '</td></tr>';

        // Create the content panel
        html += '<tr><td nowrap class="bordered noLeft" width="88%">';
        html += '<div id="' + type + 'RuleListDiv" style="padding:5px 10px;"></div>';
        html += '</td>';
        // Create a new instance button
        html += '<td class="bordered noLeft rightAligned" style="padding:10px;" valign="top">';
        html += '<input type="button" class="btnSmall" value="' +
            resolveString(cse_pp_st, "__new_rule") +
            '" onclick="NewRule(\'' + type + '\');" />';
        html += '</td></tr>';
        html += '</table>';
    }

    var rListsDiv = document.getElementById("rListsDiv");
    if (rListsDiv) {
        rListsDiv.innerHTML = html;
    }

    for (var i = 0; i < nTypes; i++) {
        var sType = fr_ruleTypes[i];
        fr_showList(sType);
    }
}

/**
 * Gets the rule types defined in the global property bag
 */
function fr_getRuleTypes() {
    var tmp = new Object();
    var ret = [];

    var pattern = /^(\w+)Rules$/;
    var matches = top.gPB.GetMatchingPaths(pattern);

    for (var i = 0; i < matches.length; i++) {
        var type = matches[i][1];
        if (undefined === tmp[type]) {
            tmp[type] = 1;
        }
    }

    for (var type in tmp) {
        ret.push(type);
    }
    return ret;
}

function fr_showList(type) {
    var settingsPage = type + "Rule.html";
    rLists[type] = new Array();
    var pp = new PropertyPath(type + "Rules.Rule");
    for (pp.BeginEnum(); fr_pb.GetProperty(pp) !== undefined; pp.IncrementEnum()) {
        pp.SetTempLeaf("id");
        var id = fr_pb.GetProperty(pp);
        pp.SetTempLeaf("name");
        var text = ReplaceSpecialHTMLChars(resolveString(cse_pp_st, fr_pb.GetProperty(pp)));
        if (!text) {
            text = id;
        }
        pp.SetTempLeaf("");
        var href = "javascript:LoadRule('" + settingsPage +
            "','" +	resolveString(cse_pp_st, type) + "','" + pp.GetPath() + "');";
        var delLink = "javascript:DeleteRule('" + pp.GetPath() + "', '" + type + "');";
        var refCounter = RefCounter.getRefCount(type, id, null,
            RefCounter.getRuleRefCount, RefCounter.ruleTypeToSettingsType);
        rLists[type].push({"href":href, "text":text, "refCount":refCounter.refCount,
            "delLink":delLink, "root":0});
    }
    if (!rListWidgets[type]) {
        rListWidgets[type] = new SettingsList(type + "RuleListDiv", "rListWidgets['" + type + "']",
            {scrollAfter:10});
    }
    rListWidgets[type].draw(rLists[type], resolveString(cse_pp_st, "__rule_name"));
}
