// Copyright (C) 2009 McAfee, Inc.  All rights reserved.

// Initialize data
var pb			= new PropertyBag()
var	bEnabled	= true
var pTableRules;	// Table to display rules

function Show(pbIn)
{
	pTableRules = document.getElementById("idTableContent");
	pbIn.GetElement("Firewall", pb);

	// Display current rules
	DisplayRules();
}

function Validate()
{
	return(true);
}

function Apply(pbOut)
{
	pbOut.Copy(pb)
}

function OnEnableDisableRule(nIndex)
{
	var pp = GetRulePath(nIndex);

	if( pp != McUndefined  )
	{
		pp.SetTempLeaf("Enabled");

		var sValue = pb.GetProperty(pp.GetPath());
		var sImage = "../../images/icons/checkbox_unchecked.gif";

		if( sValue == "0" )
		{
			sValue = "1";
			sImage = "../../images/icons/checkbox.gif";
		}
		else
			sValue = "0";

		// Update the icon and property bag
		var theImage = document.getElementById("idRuleEnabledIco"+nIndex);
		if( theImage )
		{
			// Set the property
			pb.SetProperty( pp.GetPath(), sValue );

			// Set the image file
			theImage.src = sImage;

			// Set as modified
			top.SetModified(true);
		}
	}
}

function OnDeleteRule(nIndex)
{
	var pp = GetRulePath(nIndex);

	if( pp != McUndefined  )
	{
		pp.SetTempLeaf("Name");

		var sName			= pb.GetProperty(pp.GetPath());
		var sConfirmMessage = formatString(gsFWConfirmDelete, new Array(sName));

		if( confirm(sConfirmMessage) )
		{
			pp.SetTempLeaf("");
			pb.DeleteElement(pp);

			// Set as modified
			top.SetModified(true);

			DisplayRules();
		}
	}

}

function OnModifyRule(nIndex)
{
	// TEMP CODE, REMOVE IT
	document.location.href = "FirewallWizard.html"
}

function GetRulePath(nRuleIndex)
{
	// Enumerate rules in given property bag
	var nIndex = 0;
	var pp = new PropertyPath("Firewall");
	var pp2 = new PropertyPath(pp.GetPath());
	pp2.Append("Range");
	pp2.BeginEnum();

	while( pb.GetProperty(pp2.GetPath()) != McUndefined )
	{
		nIndex++;

		if( nIndex == nRuleIndex )
			return(pp2);

		// Move to next element
		pp2.IncrementEnum();
	}
}

function DisplayRules()
{
	if( pTableRules )
	{
		var	sHtml = "";
		var nIndex = 0;

		// Get the rules table header
		sHtml += GetTableRulesHeader(true);

		// Enumerate rules in given property bag
		var pp = new PropertyPath("Firewall");
		var pp2 = new PropertyPath(pp.GetPath());
		pp2.Append("Range");
		pp2.BeginEnum();

		while( pb.GetProperty(pp2.GetPath()) != McUndefined )
		{
			var	sName;
			var bEnabled = false;
			var	sSourcePortsDescription = gsFirewallAllPorts;
			var sDestPortsDescription	= gsFirewallAllPorts;
			var sAddressesDescription	= gsFirewallAllAddresses;
			var sFullDescription		= "";

			// Increment the index count
			nIndex++;

			// Get the name of the rule
			pp2.SetTempLeaf("Name");
			sName = pb.GetProperty(pp2.GetPath());
			pp2.SetTempLeaf("");

			// Is it enabled
			pp2.SetTempLeaf("Enabled");
			var sTemp;
			if( (sTemp = pb.GetProperty(pp2.GetPath())) != McUndefined )
				if( sTemp == "1" ) bEnabled = true;
			pp2.SetTempLeaf("");

			// Build up the description text

			// Source ports
			var sFrom;
			pp2.SetTempLeaf("SourcePortFrom");
			sForm = pb.GetProperty(pp2.GetPath());
			if( (sFrom = pb.GetProperty(pp2.GetPath())) != McUndefined )
			{
				pp2.SetTempLeaf("SourcePortTo");
				var sTo		= pb.GetProperty(pp2.GetPath());

				sSourcePortsDescription = formatString(gsFirewallPortRange, new Array(sFrom,sTo)) ;
			}
			pp2.SetTempLeaf("");

			// Destination ports
			pp2.SetTempLeaf("DestPortFrom");
			if( (sFrom = pb.GetProperty(pp2.GetPath())) != McUndefined )
			{
				pp2.SetTempLeaf("DestPortTo");
				var sTo = pb.GetProperty(pp2);

				sDestPortsDescription = formatString(gsFirewallPortRange, new Array(sFrom,sTo)) ;
			}
			pp2.SetTempLeaf("");

			// IP Address Ranges
			pp2.SetTempLeaf("IPFrom")
			if( (sFrom = pb.GetProperty(pp2.GetPath())) != McUndefined )
			{
				pp2.SetTempLeaf("IPTo")
				var sTo = pb.GetProperty(pp2.GetPath())

				sAddressesDescription = formatString(gsFirewallAddressRange,new Array(sFrom,sTo))
			}
			pp2.SetTempLeaf("");

			var protocols =""
			pp2.SetTempLeaf("TCP")
			if( pb.GetProperty(pp2.GetPath()) != McUndefined )
				protocols = "TCP"

			pp2.SetTempLeaf("UDP")
			if( pb.GetProperty(pp2.GetPath()) != McUndefined )
				protocols = (protocols == "") ? "UDP" : gsFirewallAllProtocols

			pp2.SetTempLeaf("");

			// Build the full description
			sFullDescription = formatString(gsFirewallRuleDesc, new Array(sSourcePortsDescription,sAddressesDescription,sDestPortsDescription,protocols));
			sFullDescription += "<br><br>";

			// Description of process names
			pp2.SetTempLeaf("ProcessOption")
			switch(pb.GetProperty(pp2.GetPath()))
			{
				case "Only":
					sFullDescription += gsFirewallOnlyProcess
				break

				case "AllExcept":
					sFullDescription += gsFirewallExceptProcess
				break

				default:
					sFullDescription += gsFirewallAllProcess
				break
			}
			pp2.SetTempLeaf("");

			var ppProcess = new PropertyPath(pp2.GetPath());
			var sLocalProcess;
			ppProcess.Append("LocalProcess");
			ppProcess.BeginEnum()

			while( (sLocalProcess = pb.GetProperty(ppProcess.GetPath())) != McUndefined )
			{
				sFullDescription += sLocalProcess + " ";
				ppProcess.IncrementEnum();
			}
			ppProcess.EndEnum();


			// Build the HTML to display this entries row in the table
			sHtml += GetTableEntryHTML( nIndex, sName, sFullDescription, bEnabled );

			// Move to next element
			pp2.SetTempLeaf("");
			pp2.IncrementEnum();
		}
		pp2.EndEnum();
		pp.RemoveLeaf()
		pp.EndEnum()

		if( nIndex == 0 )
		{
			sHtml += GetTableRulesNoRules(true);
			nIndex = -1;
		}

		// Close the table
		sHtml += GetTableRulesCloseTable(nIndex);

		// Set the HTML
		pTableRules.innerHTML = sHtml;
	}
}

function OnNewFirewallRule()
{
	alert("Would be creating a new rule!");
}

function GetTableRulesHeader(bIncludeColumnTitles)
{
	var sHtml = "";

	sHtml += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dataSubTable\" style=\"WIDTH:775px\" id=\"idTableRules\" name=\"idTableRules\">";

	// Header bar description and buttons
	sHtml += "<tr class=\"row1\">";
	sHtml += "<td class=\"dst\" colspan=\"3\"><span class='bold'>"+gsFWConfiguredRules+"</span></td>";
	sHtml += "<td class=\"dst noleft eor\" align=\"right\"><input type=\"button\" class=\"btnStd\" value=\""+gsFWNewRule+"\" ID=\"idNewRule\" NAME=\"idNewRule\" onclick=\"javascript:OnNewFirewallRule()\"></td>";
	sHtml += "</tr>";

	// Column titles
	if( bIncludeColumnTitles )
	{
		sHtml += "<tr class=\"row0\">";
		sHtml += "<td class=\"dst\" width=\"25%\"><span class='bold'>"+gsFWRuleName+"</span></td>";
		sHtml += "<td class=\"dst\" width=\"60%\"><span class='bold'>"+gsFWDescription+"</span></td>";
		sHtml += "<td class=\"dst\" width=\"5%\" align=\"center\"><span class='bold'>"+gsFWEnabled+"</span></td>";
		sHtml += "<td class=\"dst eor\" align=\"center\" width=\"10%\"><span class='bold'>"+gsFWAction+"</span></td>";
		sHtml += "</tr>";
	}

	return(sHtml);
}

function GetTableRulesNoRules()
{
	var sHtml = "";

	sHtml += "<tr class=\"row0 lastrow\">";
	sHtml += "<td align=\"center\" class=\"dst eor\" colspan=\"4\">";
	sHtml += "There are currently no rules defined. To add a rule ";
	sHtml += "<a class=\"blueLink\" href=\"javascript:OnNewFirewallRule()\">click here</a>, or click the button 'New Rule'.";
	sHtml += "</td></tr>";

	return(sHtml);
}

function GetTableRulesCloseTable(nIndex)
{
	var sHtml = "";
	var sRowClass = "row0";

	if( nIndex >= 0 )
	{
		if( (nIndex%2) == 1 )
			sRowClass = "row0";

		sRowClass += " lastrow";

		sHtml += "<tr class=\""+sRowClass+"\">";
		sHtml += "<td class=\"dst eor\" colspan=\"4\">&nbsp;</td>";
	}


	sHtml += "</table>";

	return(sHtml);
}

function GetTableEntryHTML( nIndex, sName, sDescriptionText, bEnabled )
{
	var sHtml = "";
	var sRowClass = "row1";

	if( (nIndex%2) == 1 )
		sRowClass = "row0";

	sHtml += "<tr class=\""+sRowClass+"\">";
	sHtml += "<td class=\"dst\" width=\"25%\"><a href=\"javascript:OnModifyRule("+nIndex+")\" class=\"bluelink\">"+sName+"</a></td>";
	sHtml += "<td class=\"dst\" width=\"60%\">"+sDescriptionText+"</td>";
	if( bEnabled )
	{
		sHtml += "<td class=\"dst\" width=\"5%\" align=\"center\"><a href=\"javascript:OnEnableDisableRule("+nIndex+")\"><img id=\"idRuleEnabledIco"+nIndex+"\" border=\"0\" src=\"../../images/icons/checkbox.gif\" /></a></td>";
	}
	else
	{
		sHtml += "<td class=\"dst\" width=\"5%\" align=\"center\"><a href=\"javascript:OnEnableDisableRule("+nIndex+")\"><img id=\"idRuleEnabledIco"+nIndex+"\" border=\"0\" src=\"../../images/icons/checkbox_unchecked.gif\"/></a></td>";
	}

	sHtml += "<td class=\"dst eor\" align=\"center\" width=\"10%\"><a href=\"javascript:OnModifyRule("+nIndex+")\" class=\"bluelink\">Modify</a><br><br>";
	sHtml += "<a href=\"javascript:OnDeleteRule("+nIndex+")\" class=\"bluelink\">Delete</a></td>";
	sHtml += "</tr>";

	return(sHtml);
}

