/**
 * GenActions.js
 *
 * JavaScript support for the generic actions page
 * Copyright (C) 2009 McAfee, Inc. All rights reserved.
 */

// A reference to any tabset on the page
var g_ActionsTabs = null;

/**
 * Callback to save context temporarily
 */
function TempSave(pb, pp) {
    ga_TempSave(pb, pp);
}

function Reset(onShow) {
    ga_Reset(onShow);
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {
    alh_onShow();
    ga_init(pbIn, pp);
    Reset(true);
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    return true;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    ga_clearTabSelection();
    if (null == pb || !ga_usePB())
        pb = actionsPB;
    return ga_Apply(pb);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    ga_clearTabSelection();
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
	return ["DefaultAlerts"];
}

/**
 * Clears the tab selection, if any
 */
function ga_clearTabSelection() {
    if (null != g_ActionsTabs)
        g_ActionsTabs.clearSelection();
}


