/**
 * JavaScript for the HTMLSettings page.
 * Defines html_init() for page initialization along with Show(), Validate()
 * and Apply() functions
 * Note: include it last.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var vframeworks = new Object();
var dataBindings = new Array();
var qparams = queryParameters();
var newInstance = false;
var newId = null;

var basePP = "Settings.HTMLSettings";
var html_pb = null;
var origName="";
var settingsId = qparams["id"];
var htmlOptsForm = "html_options";

var g_changeNotifyFn = "top.gPageStack.Active().SetModified(true);";

// Handles the user clicking on the strip ActiveX control, which is linked
// to the strip Flash control
function handleActiveX(checked) {
    var e = document.forms[htmlOptsForm].elements["StripFlash"];
    if (e) {
        e.checked = checked;
        e.disabled = !checked;
    }
    e = document.getElementById("flash_cell");
    if (e) {
        e.className = checked ? removeClass(e.className, "disabled") :
            addClass(e.className, "disabled");
    }
}

// Initializes the page's forms
function html_forms_init() {
    shs_affectedPolicyReport(newInstance, "HTML", settingsId, html_pb);
    vframeworks["InstanceSettings"] = new ValidationFramework("InstanceSettings");
    vframeworks["InstanceSettings"].formAction = std_val_form_action;
    vframeworks["InstanceSettings"].fieldAction = std_val_field_action;
    vframeworks["InstanceSettings"].addValidator("displayName", new RequiredValidator());
    //vframeworks["InstanceSettings"].addValidator("displayName", new ScriptValidator());
	vframeworks["InstanceSettings"].addValidator("displayName", new InputTextValidator());
    vframeworks["InstanceSettings"].labelMap["displayName"] =  resolveString(cse_pp_field_st, "__instancename");

    var inputArray= new Array();
	inputArray["SECTION"]="Scanners";
	inputArray["origName"]=origName;
	inputArray["basePP"]="Settings.HTMLSettings";
	vframeworks["InstanceSettings"].addValidator("displayName",new DuplicatesValidator(html_pb,inputArray));
	vframeworks["InstanceSettings"].addValidator("displayName",new LengthValidator());

    var form = htmlOptsForm;
    if (document.forms[form]) {
    }
    addChangeNotification(g_changeNotifyFn);
}

// Sets form data and enables / disables controls as appropriate
function html_init() {
    html_forms_init();
    Reset();
}

/**
 * Asynchronous reset function
 */
function Reset() {
    var html_pp = new PropertyPath(basePP);
    for (var i = 0; i < dataBindings.length; i++) {
        dataBindings[i].set(html_pp, html_pb);
    }
    handleActiveX("1" == html_pb.GetPropertyDef(
        html_pp.toString() + ".StripActiveX", "0"));
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {
    if (null == pbIn) {
        pbIn = top.gPB;
    }
    newInstance = shs_initPB(pbIn, pp, "HTML");
    html_pb = pbIn;
    if (settingsId) {
        // Search for the settings blob to use
        basePP = top.GetBasePath(pbIn, basePP, "id", settingsId);
        if (null == basePP) {
            top.gPageStack.Active().Cancel();
            return;
        }
    }
    else {
        // Assume that we've been set up with the correct property path
        // and property bag
        basePP = pp.GetPath();
        settingsId = pbIn.GetPropertyDef(basePP + ".id", "");
        origName=pbIn.GetPropertyDef(basePP + ".displayName", "");
    }
    html_init();
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    return shs_Validate();
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    if (null == pb) {
        pb = html_pb;
    }
    shs_Apply(pb, basePP, dataBindings, newInstance);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    if (newInstance) {
        // Remove the new instance from the property bag
        html_pb.DeleteElement(basePP);
    }
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
    return [];
}
