// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
// Manage reading and writing identities
// also displays components data on screen
//
var gIdentities;
var K_PPBase="Identities";
var K_PPFirst="Identities.Identity"

var K_I_FRM="I_FRM"
var K_TPK_DIV="TPK_DIV"
var K_TPK_SEL="TPK_SEL"
var K_IPK_DIV="IPK_DIV"
var K_IPK_CTL="IPK_CTL"
var K_LST_SEL="LST_SEL"
var K_I_EVERYONE="I:EVERYONE"


//==================================================================
//Readable strings and strings formats are defined in ppstrings.js
// and ppspecific.js
//==================================================================================

//===========================================================
//mouse track to display popup in the right location
//==========================================================
var t_mouseX = 0;
var t_mouseY = 0;

function t_mouseTrack(e) {
		if (e) {
			t_mouseX = e.pageX;
			t_mouseY = e.pageY;
		} else {
			if (event) {
				t_mouseX = event.x;
				t_mouseY = event.y;
			}
		}
}
document.onmousemove=t_mouseTrack;


//======================================================

//extract data from local property bag if they are there,
//or use global otherwise
//parameters: pb of the page
//id : id of the relevant identity
//name: name of the policy (used for naming identities too)
//logic: either "One", ... or....
//members:
//ident_pb = property bag that includes identities
//i_table = structure storing identity rules

function Identities(objName, pbIn, refId, name, create)
{
   this.i_table=[];
   this.pb = new PropertyBag();

   if (undefined === pbIn.GetProperty(K_PPBase))
   {
         top.gPB.GetElement(K_PPBase, this.pb);
   }
   else
   {
         pbIn.GetElement(K_PPBase, this.pb);
   }

   this.objName=objName;
   this.pp=undefined;
   this.id=refId;
   this.name=name;
   this.logic="One";

   if(undefined==this.id)
   {   this.id=MakeGuid("");
   }
   else
   {   this.GetValFromPb();
   }

}



//Helper functions:
Identities.GetTplType = function(ndx)
{
    var tk= FindNextToken(gIdCfgTemplates[ndx])
    return tk[1];
}

//render a rule in natural language
//parameter: ndx=index in gIdUITemplates, val= array of values
Identities.GetCfgTpl = function(ndx, val)
{
    var rule = new EnvelopeRule(McUndefined,gIdCfgTemplates[ndx],val)
    return rule.RenderDescription();
}

//render a rule in natural language
//parameter: ndx=index in gIdUITemplates
Identities.GetUITpl = function(ndx, val)
{
    var rule = new EnvelopeRule(gIdUITemplates[ndx],McUndefined,val)
    return rule.RenderDescription();
}

//Populate a combo box with a list of choice
Identities.prototype.PopulateTplPicker = function(pskey)
{

    if(!pskey)
    {   pskey="__default";
    }
    else if(gIdTplSubset[pskey]==undefined)
    {    pskey="__default";
    }

    var div = document.getElementById(K_TPK_DIV);
	if(!div)
	{   return;
	}

    var sel=document.createElement("select");
    sel.id=K_TPK_SEL;


    sel.onchange=Identities.DrawInputPicker;

    var opt=document.createElement("option");
    opt.value=-1;
	opt.appendChild(document.createTextNode(gsRuleTemplateValue));
	sel.appendChild(opt);


    for (var i=0; i<gIdTplSubset[pskey].length ; i++)
	{

		var opt=document.createElement("option");

        var tag=Identities.GetUITpl(gIdTplSubset[pskey][i],[]);
        opt.value=gIdTplSubset[pskey][i];
		opt.appendChild(document.createTextNode(tag));
		sel.appendChild(opt);

	}


    div.appendChild(sel);

}


//Populate a combo box with a list of choice
var gCurrentPicker
Identities.DrawInputPicker = function()
{
    sel=this;
    var div = document.getElementById(K_IPK_DIV);
	if(!div)
	{   return;
	}

    //get type of selection
    var opt= sel.options[sel.selectedIndex].value;
	if ( opt != -1)
	{
	    var t=Identities.GetTplType(opt)
		if (typeof(eval(t + "Picker")) == "function")
			gCurrentPicker = eval("new " + t + "Picker");
		else
			gCurrentPicker = new DefaultPicker()
	}
	else
	{
		gCurrentPicker = new DefaultPicker();
	}
    div.innerHTML = "";
    div.appendChild(gCurrentPicker.Draw());
}

Identities.prototype.DrawPoliciesCombo= function(pp,pbIn)
{
    //initialise location
	var div = document.getElementById("IDLST_DIV");
    if (!div) return;
    div.innerHTML = "";

    //create select element
    var sel=document.createElement("select");
    div.appendChild(sel);
    sel.id="IDLST_SEL";
    sel.style.width="200px"

	//read items from propertybag
	var pbT = new PropertyBag();
	// Just the commited and uncommited data except for the entity under creation
	top.gPageStack.CachedDataPage().pb.GetElement("Policies", pbT);
	//Need to remove the current policy from the pbT
	var ppIn = new PropertyPath(pp);
	if(pbT.GetProperty(ppIn) !== undefined) //delete only if present
		pbT.DeleteElement(ppIn);


	var ppT = new PropertyPath("Policies.PolicySet");
    ppT.BeginEnum();
    while(pbT.GetProperty(ppT) !== undefined)
	{
       var sppT = new PropertyPath(ppT.GetPath());
	   sppT.Append("Policy")
	   sppT.BeginEnum();
       while(pbT.GetProperty(sppT) !== undefined)
	   {
           sppT.SetTempLeaf("name")
		   var name = pbT.GetProperty(sppT);
		   sppT.SetTempLeaf("IdentityRef");
           var idref = pbT.GetProperty(sppT);
		   if(idref!=K_I_EVERYONE)
		   {
                 var opt=document.createElement("option");
                 sel.appendChild(opt);
                 opt.value=idref;
                 opt.appendChild(document.createTextNode(name))
		   }
		   sppT.IncrementEnum();
       }
       sppT.EndEnum();
	   ppT.IncrementEnum();
    }
    ppT.EndEnum();

    var opt=document.createElement("option");
    sel.appendChild(opt);
    opt.value="";
	opt.selected="true";
    opt.appendChild(document.createTextNode(""))
}


//Select radio buttonand populate selection From object members
Identities.prototype.PopulateForm = function()
{
     this.WriteLogic();

     var lst = document.getElementById(K_LST_SEL);
     if(!lst)
     {   return;
     }

	 while(lst.firstChild)
     {  lst.removeChild(lst.firstChild);
	 }


     for(var i=0;i<this.i_table.length;i++)
	 {
	        var ndx=this.i_table[i].ndx;
			if(ndx>=0)
			{   var opt=document.createElement("option");
	            var values=this.i_table[i].val;
	            var rule = new EnvelopeRule(gIdUITemplates[ndx], gIdCfgTemplates[ndx],values)
                var str=rule.RenderDescription();
				opt.value=i;
                opt.appendChild(document.createTextNode(str));
                lst.appendChild(opt);
             }
	 }

}


//Function called when the "add button is pressed
Identities.prototype.AddRule = function()
{


   //get selection in tpl picker and user input
   var sel=document.getElementById(K_TPK_SEL);
   var ndx= sel.options[sel.selectedIndex].value;
   if (sel.selectedIndex<=0)
   {  return true;
   }

   // Validate and retrieve data value
   if (!gCurrentPicker.Validate())
	return false;
   var values=gCurrentPicker.Selection();

   top.gPageStack.Active().SetModified(true);

   var pos=0;

   //build new rule
   var rule = new EnvelopeRule(gIdUITemplates[ndx], gIdCfgTemplates[ndx],values)
   var str=rule.RenderDescription();

   //add to the list
   var lst = document.getElementById(K_LST_SEL);
   if(!lst)
   {   return true;
   }
   var opt=document.createElement("option");
   opt.value=pos;

   //Check whether this rule is already added for this Policy
   for(var i=0;i<this.i_table.length;i++)
   {
	   if(this.i_table[i].ndx == ndx && this.i_table[i].val == rule.values[0])
	   {
		   alert(gsDuplicateRule);
		   return false;
	   }
   }
   if(i == this.i_table.length)
   {
		this.i_table.push({"ndx":ndx, "val":rule.values});
	    opt.appendChild(document.createTextNode(str));
	    lst.appendChild(opt);
	    pos++;
   }

   return true;
}

//Copy (duplicate) rules from another policy
//@IdRef: refence to a identity
Identities.prototype.CopyRules = function()
{
    var IdRef="";
	var sel = document.getElementById("IDLST_SEL");
    if (!sel) return true;

	var IdRef = sel.options[sel.selectedIndex].value;
	if(IdRef=="") return true;

    //blah
    var pp_str = this.FindPP(IdRef);
	if(!pp_str) return;
    var ppT= new PropertyPath(pp_str);
	if(this.pb.GetProperty(ppT) == undefined)
	{   return true;
	}

	var bCopyRules = true;
    this.GetRules(ppT,bCopyRules);
    this.PopulateForm();
    top.gPageStack.Active().SetModified(true);
    return true;
}


//Find property Path to proper Identity blob
Identities.prototype.MakePPRoot = function()
{
    if(this.pb.GetProperty(K_PPBase) == undefined)
	{
	   var ppT=new PropertyPath(K_PPBase)
	   this.pb.SetProperty(ppT);
	}
}


//Find property Path to proper Identity blob
Identities.prototype.FindPP = function(refId)
{
   var pp_str=undefined;
   var identity_pp = new PropertyPath(K_PPFirst);
    identity_pp.BeginEnum();
    while(this.pb.GetProperty(identity_pp) !== undefined) {
       identity_pp.SetTempLeaf("id");
       var id = this.pb.GetProperty(identity_pp);
	   identity_pp.SetTempLeaf("");
       if (id == refId) {
           pp_str = identity_pp.GetPath();
           break;
       }

       identity_pp.IncrementEnum();
    }

    identity_pp.EndEnum();

    return pp_str;

}//FindPP


//Add rules from a given identity node
//@ppT is the path to that node

Identities.prototype.GetRules = function(ppIn,bCopyRules)
{
    ppIn.Append("Rule");
    ppIn.BeginEnum();
    while(this.pb.GetProperty(ppIn) !== undefined) {

       var rule_str = this.pb.GetProperty(ppIn);
	   var rule = new EnvelopeRule(McUndefined,McUndefined,McUndefined);
	   var ndx=rule.FromLiteral(rule_str, gIdCfgTemplates,gIdUITemplates);

	   //Check whether this rule is already added for this Policy
	   for(var i=0;i<this.i_table.length;i++)
	   {
		   if(this.i_table[i].ndx == ndx && this.i_table[i].val == rule.values[0])
		   {
			   //Pop-up message first time only ...
			   if(bCopyRules)
			   {
			   		alert(gsCopyDuplicateRule);
			   		bCopyRules = false;
			   }
			   break;
		   }
	   }
	   if(i == this.i_table.length)
	   {
	   		this.i_table.push({"ndx":ndx, "val":rule.values});
	   }
       ppIn.IncrementEnum();
    }

    ppIn.EndEnum();
}


//Populate object with logic and list of rules from the property bag
Identities.prototype.GetValFromPb = function()
{
    this.i_table=[];
    var pp_str = this.FindPP(this.id);
	if(!pp_str) return;
    var ppT= new PropertyPath(pp_str);
	if(this.pb.GetProperty(ppT) == undefined)
	{   return;
	}

    ppT.SetTempLeaf("Logic");
	this.logic=this.pb.GetProperty(ppT);
	ppT.SetTempLeaf("");

    this.GetRules(ppT)

}

//Delete rules from the list
Identities.prototype.DeleteRules = function()
{
     var lst = document.getElementById(K_LST_SEL);
     if(!lst)
     {   return;
     }

    top.gPageStack.Active().SetModified(true);

    for(var i=0;i<lst.options.length;++i)
	{
	    if(lst.options[i].selected)
		{    var pos=lst.options[i].value;
			 for(var j=0;j<this.i_table.length;j++)
			 {
					var ndx=this.i_table[j].ndx;
					if(ndx>=0)
					{
						var values=this.i_table[j].val;
						var rule = new EnvelopeRule(gIdUITemplates[ndx], gIdCfgTemplates[ndx],values)
						var str=rule.RenderDescription();
						if(str == lst.options[i].text)
						{
							this.i_table[j].ndx=-1;
							break;
						}
					 }
			 }
             lst.removeChild(lst.options[i]);
             i--;
		}
	}
}



//Write values from to page
Identities.prototype.WriteLogic = function()
{
	var f = document.forms[K_I_FRM];
	if(!f) return;
	for(var i=0;i<f.logic.length;i++)
	{   if (f.logic[i].value==this.logic)
	    f.logic[i].checked=true;
    }

}

//Read values from the page
Identities.prototype.ReadLogic = function()
{
	var f = document.forms[K_I_FRM];
	if(!f) return;
	for(var i=0;i<f.logic.length;i++)
	{   if (f.logic[i].checked)
	    this.logic=f.logic[i].value;
    }
}

Identities.prototype.Validate = function()
{

	var lst = document.getElementById(K_LST_SEL);
	    if( lst.options.length > 0 )
	    {
			return true;
		}
		else
		{
		   alert(gsIdentityPageError)
	       return false;
		}
}


//Create a new identity group, delete any existing one with the same id (if any)
Identities.prototype.CreateGroup = function(pbOut)
{
    if(this.i_table.length<=0)
    {  return undefined;
    }

    var pp_str = this.FindPP(this.id);
    if (undefined == pp_str)
    {   this.MakePPRoot();
	    pp_str=this.pb.GetNextElementEnum(K_PPFirst);
    }
	else
    {  pp_old = pp_str+".Rule";
       this.pb.DeleteList(pp_old);
    }

	this.ReadLogic();

	var ppT = new PropertyPath(pp_str);
	this.pb.SetProperty(ppT);
	ppT.SetTempLeaf("id");
	this.pb.SetProperty(ppT, this.id);
	ppT.SetTempLeaf("name");
	this.pb.SetProperty(ppT, this.name);
	ppT.SetTempLeaf("Logic");
	this.pb.SetProperty(ppT, this.logic);
	ppT.SetTempLeaf("");

    ppT.Append("Rule");
    for(var i=0;i<this.i_table.length;i++)
    {
	   if(this.i_table[i].ndx>=0)
	   {   pp_str=this.pb.GetNextElementEnum(ppT.GetPath())
           var rule=Identities.GetCfgTpl(this.i_table[i].ndx, this.i_table[i].val);
           this.pb.SetProperty(pp_str, rule);
       }

    }

    //remove any identity from the existing bag and add this one.
    pbOut.DeleteElement(K_PPBase);
    this.pb.GetElement(K_PPBase, pbOut);

	return this.id;
}


//Show or Hide popup
Identities.prototype.ShowPopup = function()
{
    var pop_div=document.getElementById("POP_DIV");

	//var y= (t_mouseY)+50
    var y= (t_mouseY)+0

    pop_div.style.top = y + "px";
    pop_div.style.display="";

	var sel = document.getElementById(K_TPK_SEL);
	sel.selectedIndex = 0;
	var div = document.getElementById(K_IPK_DIV);
	var a = document.getElementById(K_IPK_CTL);
	if(a)
		div.removeChild(a);
	var list1 = document.getElementById("IPK_CTL_LIST");
	if(list1)
		div.removeChild(list1);

    var lst = document.getElementById(K_LST_SEL);
    lst.style.display="none";
}

Identities.prototype.HidePopup = function(ok)
{

    if(ok)
    {


	var f = document.forms[K_I_FRM];
	var id_src="new";

	if(f){
	      for(var i=0;i<f.id_src.length;i++)
	      {   if (f.id_src[i].checked)
	          id_src=f.id_src[i].value;
              }
        }

	var bClose;
	if(id_src=="new")
      		bClose =this.AddRule();
	else
		bClose = this.CopyRules()
        if (!bClose)
		return;

    }

    var div=document.getElementById("POP_DIV");
    div.style.display="none";
   var lst = document.getElementById(K_LST_SEL);
   lst.style.display="";

}

Identities.prototype.PopulateAll = function(pskey,pp,pbIn)
{
   this.PopulateTplPicker(pskey);
   this.DrawPoliciesCombo(pp,pbIn);
   this.HidePopup();
   this.PopulateForm();
}
