/**
 * Deferred loading logic for pages that need to wait on custom configuration data.
 * If the source for custom config is other than the ConfigUI plugin, the
 * QueueCustomConfig function in this file needs to be overridden
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

/////////////////////////////////////////////////////
//
// Getts http object for browser
//
function getHTTPObject()
{
    var xmlhttp;
    if (typeof XMLHttpRequest != 'undefined')
    {
        xmlhttp = new XMLHttpRequest();
    }
    else
    {
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
    return xmlhttp;
}

function LoadSource(source)
{
    // Get XML
    var xml
    if (gEPOMode)
    {
        xml = top.gPB.GetProperty(source);
		if(xml == McUndefined || xml == null) 
			xml = "";
    }
    else
    {
        var url = GetDynamicPageUrl("uiconfig&act=getuser&source=" + source);
        var http = getHTTPObject();
        http.open("GET",url, false);
        http.send(null);
        xml = http.responseText;
    }

    var pb = getCustomPB(source);
    var processingComplete = false;
    if (top.CONTENT_FRAME.ProcessCustomConfig)
        processingComplete = top.CONTENT_FRAME.ProcessCustomConfig(xml, source, pb);

    if (!processingComplete) {
        // Do standard processing
        (new XMLParser()).Load(xml, pb);
    }

    pb.modified = false;
}

// Queues custom configuration files for lazy-loading
// sources is an array of source names
// Returns the list of queued data sources
function QueueCustomConfig(sources)
{
    //alert(window.status);
    var sourcesToLoad = []
    if (sources)
    {
        for (var i = 0; i < sources.length; i++)
        {
            if (null == gPBContainer[sources[i]] || gPBContainer[sources[i]].IsEmpty()) {
                sourcesToLoad.push(sources[i]);
                ret = true;
            }
        }
        if (sourcesToLoad.length > 0) {
            disablePage(top.CONTENT_FRAME.document, true);
            for (var i= 0; i < sourcesToLoad.length; i++) {
                // Transform the data source name to a stringtable key
                // The name format is <SOURCE>_xx_XX
                var source = sourcesToLoad[i];
                var p = /_\w\w$/;
                while (p.test(source)) {
                    source = source.substring(0, source.length - 3);
                }
                var sourceName = resolveString(pm_st, source);
                window.status = resolveString(pm_st, "__default_loading_msg", [sourceName]);
                LoadSource(sourcesToLoad[i]);
            }
            window.status = "";
            disablePage(top.CONTENT_FRAME.document, false);
        }
    }
    return sourcesToLoad;
}


/**
 * Disables or enables all the fields in all the forms in a page
 * @param doc the target page's document object
 * @param disabled true if the page is to be disabled, false otherwise
 */
function disablePage(doc, disabled) {
    var forms = doc.forms;
    if (forms) {
        for (var i = 0; i < forms.length; i++) {
            var elems = forms[i].elements;
            for (j = 0; j < elems.length; j++) {
                elems[j].disabled = disabled;
            }
        }
    }
}
