/**
 * JavaScript for the MIMESettings page; this file needs to be included
 * if the MIMEOptionsDlg component is used.
 * Defines mime_init() for page initialization along with Show(), Validate()
 * and Apply() functions
 * Note: include it last.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var vframeworks = new Object();
var dataBindings = new Array();
var qparams = queryParameters();
var newInstance = false;
var newId = null;

var basePP = "Settings.MIMESettings";
var mime_pb = null;
var origName="";
var settingsId = qparams["id"];
var mimeOptsForm = "mime_options";
var advancedOptsForm = "amime_options";
var mimeTypesForm = "mimet_options";
var charSetsForm = "chars_options";

var g_changeNotifyFn = new Function("top.gPageStack.Active().SetModified(true);");

var browserInfo = IdentifyBrowser();
var inputLists = {};

var RE_CUST = 1;
var HE_UTF8 = 0;
var HE_CUST = 2;
var ENC_QP = 1;
var ENC_B64 = 2;
var ENC_8BIT = 4;
var SEVEN_BIT_NO = 8;

// Data binding class to handle preferred encoding of text parts
function PreferredEncodingDataBinding(formName) {
    this.formName = formName;
    this.initialValue = null;
    this.propName = "PreferredContentTransferEncoding";
    this.def = top.defValues["MIME"][this.propName];
}
PreferredEncodingDataBinding.prototype = new DataBinding("", "", "");

PreferredEncodingDataBinding.prototype.set = function(pp, pbIn) {
    var f = document.forms[this.formName];
    if (!f)
        return;
    // This control makes use of a dropdown list and a checkbox
    var selCtl = f.elements["_encoding"];
    var cbCtl = f.elements["_7bitno"];
    var peOpts = pbIn.GetPropertyDef(pp.toString() + "." + this.propName,
        this.def);
    var selIdx = 0;
    if (selCtl) {
        var opts = selCtl.options;
        for (var i = 0; i < opts.length; i++) {
            if (0 != (peOpts & opts[i].value)) {
                selIdx = i;
                break;
            }
        }
        selCtl.selectedIndex = selIdx;
    }
    if (cbCtl) {
        var checked = (0 != (peOpts & SEVEN_BIT_NO));
        cbCtl.checked = checked;
    }
    this.initialValue = peOpts;
}

PreferredEncodingDataBinding.prototype.get = function(pp, pbOut) {
    var changed = false;
    var peOpts = 0;

    var f = document.forms[this.formName];
    if (!f)
        return false;

    var selCtl = f.elements["_encoding"];
    var cbCtl = f.elements["_7bitno"];
    if (selCtl)
        peOpts |= selCtl.value;
    if (cbCtl && cbCtl.checked)
        peOpts |= SEVEN_BIT_NO;
    pbOut.SetProperty(pp.toString() + "." + this.propName, peOpts);

    if (peOpts != this.initialValue)
        changed = true;
    return changed;
}


// Fields that come under general mail settings rather than MIME settings
var fieldOverrides = {"ModSubjPrefix":"GM"};

// Initializes the page's forms
function mime_forms_init() {
    var useTabs = (undefined !== this.mime_tabs);
    shs_affectedPolicyReport(newInstance, "MIME", settingsId, mime_pb);

    vframeworks["InstanceSettings"]= new ValidationFramework("InstanceSettings");
	vframeworks["InstanceSettings"].formAction = std_val_form_action;
    vframeworks["InstanceSettings"].fieldAction = std_val_field_action;
    vframeworks["InstanceSettings"].addValidator("displayName", new RequiredValidator());
    vframeworks["InstanceSettings"].addValidator("displayName", new InputTextValidator());
	//vframeworks["InstanceSettings"].addValidator("displayName", new ScriptValidator());
	vframeworks["InstanceSettings"].labelMap["displayName"] = resolveString(cse_pp_field_st, "__instancename");

    var inputArray= new Array();
	inputArray["SECTION"]="Scanners";
	inputArray["origName"]=origName;
	inputArray["basePP"]="Settings.MIMESettings";
	vframeworks["InstanceSettings"].addValidator("displayName",new DuplicatesValidator(mime_pb,inputArray));
	vframeworks["InstanceSettings"].addValidator("displayName",new LengthValidator());

    var reqV = new RequiredValidator();

    var tabIdx = 0;
    var validatedForms = [mimeOptsForm, advancedOptsForm, mimeTypesForm];
    for (var i = 0; i < validatedForms.length; i++) {
        var form = validatedForms[i];
        vframeworks[form] = new ValidationFramework(form);
        var vf = vframeworks[form];
        vf.formAction = std_val_form_action;
        vf.fieldAction = std_val_field_action;

        if (useTabs) {
            mime_tabs.addValidation(tabIdx++, vframeworks[form]);
        }
    }

    var form = mimeOptsForm;
    if (document.forms[form]) {
        var propName = "Continuations";
        inputLists[propName] = new HiddenInputList([], "continuations_div",
            'inputLists["Continuations"]', {});
        dataBindings.push(new InputListDataBinding(inputLists[propName], propName,
            false, "", top.defValues["MIME"]["Continuations"]));

		 var vf = vframeworks[form];
         //vf.addValidator("ModSubjPrefix",new ScriptValidator());
		 vf.addValidator("ModSubjPrefix",new InputTextValidator());
         vf.labelMap["ModSubjPrefix"]=resolveString(page_st,"lm_MailPrefixSubjectText");
     }

    form = advancedOptsForm;
    if (document.forms[form]) {
        var f = document.forms[form];
        var vf = vframeworks[form];
        var propName = "MaxBoundaries";
        vf.labelMap[propName] = resolveString(page_st, "lm_MaxBoundaries");
        vf.addValidator(propName, reqV);
        var rangeV = new RangeValidator(10, 999999);
        vf.addValidator(propName, rangeV);
        setNumeric(advancedOptsForm, [propName], false, false);

        dataBindings.push(new PreferredEncodingDataBinding(form));
    }

    form = mimeTypesForm;
    if (document.forms[form]) {
        inputLists["amt"] = new InputList([], "ascii_types_div", "inputLists['amt']",
            { baseFieldName:"amtype", directive:"",
            vframework:vframeworks[form], compulsory:false,
            displayName:resolveString(page_st, "atl_displayName"),
            inputNamePattern:resolveString(page_st, "atl_inputNamePattern"),
            inputFilter:mimeTypeCheckInput, changeNotify:g_changeNotifyFn});
        dataBindings.push(new InputListDataBinding(inputLists["amt"], "AsciiContentTypes", true,
            ";", top.defValues["MIME"]["AsciiContentTypes"]));

        inputLists["bmt"] = new InputList([], "bin_types_div", "inputLists['bmt']",
            { baseFieldName:"bmtype", directive:"",
            vframework:vframeworks[form], compulsory:false,
            displayName:resolveString(page_st, "btl_displayName"),
            inputNamePattern:resolveString(page_st, "btl_inputNamePattern"),
            inputFilter:mimeTypeCheckInput, changeNotify:g_changeNotifyFn});
        dataBindings.push(new InputListDataBinding(inputLists["bmt"], "BinContentTypes", true,
            ";", top.defValues["MIME"]["BinContentTypes"]));
    }

    form = charSetsForm;
    if (document.forms[form]) {
        inputLists["csm"] = new CharsetMapper("csm_div", "inputLists['csm']",
            pp_cse_encodings, g_changeNotifyFn);
        dataBindings.push(new CSMDataBinding(inputLists["csm"]));
    }

    // Stick standard encoding options in various select controls
    var encSelectCtls = {mime_options:["HeaderEncodingCharset","ReEncodingName"],
        amime_options:["AlternateCharset"]};
    var exclusions = {"HeaderEncodingCharset":{"utf-8":1}};
    for (form in encSelectCtls) {
        var f = document.forms[form];
        if (!f)
            continue;
        var ctlList = encSelectCtls[form];
        for (var j = 0; j < ctlList.length; j++) {
            var ctlName = ctlList[j];
            var ex = exclusions[ctlName];
            if (!ex)
                ex = {};
            var selCtl = f.elements[ctlName];
            if (selCtl) {
                var opts = pp_cse_encodings;
                var nOpts = opts.length;
                for (var i = 0; i < nOpts; i++) {
                    var encoding = opts[i];
                    if (ex[encoding])
                        continue;
                    var option = document.createElement("option");
                    option.value = encoding;
                    option.text = resolveString(cse_pp_st, encoding);
                    if (browserInfo.isIE) {
                        selCtl.add(option);
                    }
                    else {
                        selCtl.add(option, null);
                    }
                }
            }
        }
    }
    fixCSSelectors();
    addChangeNotification(g_changeNotifyFn);
}

// Restricts input for a mime type
function mimeTypeCheckInput(evt) {
    // Mime-type names are made up of a subset of ASCII
    // Forbidden characters are control characters, space and
    // the following: ()<>@,;:\"[]?=
    return cb_restrictInput(evt, ["AZ", "az", "09", "!'", "*+", "-.",
        "/", "^`", "{~"]);
}

// Handles the user clicking on the preferred re-encoding radio buttons
function handlePreferredReEncoding(encVal) {
    var f = document.forms[mimeOptsForm];
    if (!f)
        return;
    var selCtl = f.elements["ReEncodingName"];
    if (selCtl)
        selCtl.disabled = (RE_CUST != encVal);
}

// Handles the user clicking on the preferred  header encoding radio buttons
function handlePreferredHeaderEncoding(encVal) {
    var f = document.forms[mimeOptsForm];
    if (!f)
        return;
    var selCtl = f.elements["HeaderEncodingCharset"];
    if (selCtl)
        selCtl.disabled = (HE_CUST != encVal);
    var propName = "HeaderEncodingFallback";
    var fbError = null, fbUTF8 = null;
    for (var i = f.elements.length - 1; i >= 0; i--) {
        var e = f.elements[i];
        if (propName == e.name) {
            if (0 == e.value)
                fbError = e;
            else
                fbUTF8 = e;
        }
        if (fbError && fbUTF8)
            break;
    }

    fbError.disabled = fbUTF8.disabled = (HE_UTF8 == encVal);

    if (HE_UTF8 == encVal) {
        fbError.checked = true;
    }
    else {
        dataBindings[mimeOptsForm + "_" + propName].set(new PropertyPath(basePP), mime_pb);
    }

    var elemIds = ["hefb_lbl", "hefb_opts"];
    for (var i = 0; i < elemIds.length; i++) {
        var e = document.getElementById(elemIds[i]);
        if (e) {
            e.className = (HE_UTF8 == encVal) ? addClass(e.className, "disabled") :
                removeClass(e.className, "disabled");
        }
    }
}

// Sets form data and enables / disables controls as appropriate
function mime_init() {
    mime_forms_init();
    Reset();
}

/**
 * Asynchronous reset function
 */
function Reset() {
    var defValues = top.defValues["MIME"];
    var mime_pp = new PropertyPath(basePP);
    for (var i = 0; i < dataBindings.length; i++) {
        var ppToUse = mime_pp;
        var db = dataBindings[i];
        ppToUse = getPPToUse("MIME", db, fieldOverrides, mime_pp);
        db.set(ppToUse, mime_pb);
    }
    for (var iListName in inputLists)
        inputLists[iListName].draw(true);
    handlePreferredReEncoding(mime_pb.GetPropertyDef(basePP + ".ReEncodingScheme",
        top.defValues["MIME"]["ReEncodingScheme"]));
    handlePreferredHeaderEncoding(mime_pb.GetPropertyDef(basePP + ".HeaderEncodingScheme",
        top.defValues["MIME"]["HeaderEncodingScheme"]));
}

/**
 * Fixes choices and selections in character list controls, adding obsolete
 * character sets that have been imported from old config files
 */
function fixCSSelectors() {
    var encSelectCtls = {mime_options:["HeaderEncodingCharset","ReEncodingName"],
        amime_options:["AlternateCharset"]};
    var exclusions = {"HeaderEncodingCharset":{"utf-8":1}};
    for (form in encSelectCtls) {
        var f = document.forms[form];
        if (!f)
            continue;
        var ctlList = encSelectCtls[form];
        for (var j = 0; j < ctlList.length; j++) {
            var ctlName = ctlList[j];
            var ex = exclusions[ctlName];
            if (!ex)
                ex = {};
            var selCtl = f.elements[ctlName];
            if (selCtl) {
                var opts = selCtl.options;
                var nOpts = opts.length;
                var encoding = mime_pb.GetPropertyDef(basePP + "." + ctlName,
                    top.defValues["MIME"][ctlName]);
                var found = false;
                for (var i = 0; i < nOpts; i++) {
                    if (encoding == opts[i].value) {
                        found = true;
                        break;
                    }
                }
                if (found || ex[encoding])
                    continue;
                var option = document.createElement("option");
                option.value = encoding;
                option.text = encoding;
                if (browserInfo.isIE) {
                    selCtl.add(option);
                }
                else {
                    selCtl.add(option, null);
                }
            }
        }
    }
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {
    if (null == pbIn) {
        pbIn = top.gPB;
    }
    newInstance = shs_initPB(pbIn, pp, "MIME");
    mime_pb = pbIn;
    if (settingsId) {
        // Search for the settings blob to use
        basePP = top.GetBasePath(pbIn, basePP, "id", settingsId);
        if (null == basePP) {
            top.gPageStack.Active().Cancel();
            return;
        }
    }
    else {
        // Assume that we've been set up with the correct property path
        // and property bag
        basePP = pp.GetPath();
        settingsId = pbIn.GetPropertyDef(basePP + ".id", "");
        origName=pbIn.GetPropertyDef(basePP + ".displayName", "");
    }
    mime_init();
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    return shs_Validate(this.mime_tabs);
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    if (null == pb) {
        pb = mime_pb;
    }
    shs_Apply(pb, basePP, dataBindings, newInstance, false, "MIME", fieldOverrides);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    shs_cancel(newInstance, mime_pb, basePP, "MIME");
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
    return [];
}
