//
// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//

var timeOutPP = null;
var vfSS = new ValidationFramework("odscansettings_form");
var labelMap = new Object();
var bIsEPO = (typeof(gEPOMode) != "undefined" && gEPOMode)

function Show(pb, pp)
{
	ShowSettings(pb, pp)
}

function Apply(pb, pp)
{
	ApplySettings(pb, pp)
}

////////////////////////////////////////////////
//
// Writes current config settings into controls 
// and then reset modified flag
//
function ShowSettings(pb,pp)
{
	if( !bIsEPO ) {
		// Make sure there is an active wizard
		if( top.gPageStack.Active() == McUndefined )
			return
	} else {
		labelMap["Timeout"] = "Scan Timeout";
		// Initialize validator
		var rangeVtor = new RangeValidator(1, 6000);
		vfSS.addValidator("Timeout", rangeVtor);						
		vfSS.labelMap = labelMap;			
	}
	
	var inputVtor = new InputTextValidator(true);
	vfSS.addValidator("searchField1", inputVtor);		
	vfSS.addValidator("searchField2", inputVtor);
	vfSS.addValidator("searchField3", inputVtor);
	vfSS.addValidator("searchField4", inputVtor);
	vfSS.addValidator("searchField5", inputVtor);
	
	vfSS.formAction = std_val_form_action;
	vfSS.fieldAction = std_val_field_action;
	setNumeric("odscansettings_form", ["Timeout"], true, false);
	
	//Only for E15
	var exVersion = top.gSystemStatePB.GetProperty("systemstate.exversion");
	if(( exVersion == 3) || (exVersion == 2))
		document.getElementById("advFilter").style.display = "inline"
	
	var path = new PropertyPath(pp.GetPath())
	path.Append("What.OnDemand")

	// Get 'PolicyName' value
	path.SetTempLeaf("PolicyName")
	var strSelected = pb.GetProperty(path.GetPath())
	//build up options
	var select = document.getElementById("PolicyList")
	for(var i = 0; i < gODPolicyNames.length; i++)
	{
		select.options[i] = new Option(gODPolicyNames[i], i)
		if(strSelected == gODPolicyRegNames[i])
			select.options[i].selected = true
	}
	if(select.options.selectedIndex == -1)
		select.options[0].selected = true

	// Get 'ResumeEnabled' value
	path.SetTempLeaf("ResumeEnabled")
	document.getElementById("Enabled").checked = pb.GetProperty(path.GetPath()) == 1
	
	//set 'RestartFromLast' value
	if(document.getElementById("Enabled").checked)
	{
		path.SetTempLeaf("RestartFromLastItem")
		document.getElementById("RestartFromLast").checked = pb.GetProperty(path.GetPath())
		document.getElementById("RestartFromLast").disabled = false
		path.SetTempLeaf("")
	}
	
	path.SetTempLeaf("AdvFiler");
	if((pb.GetProperty(path.GetPath()) == "") || (pb.GetProperty(path.GetPath()) == McUndefined)){
	IntialiseDateControl();
	}else{
		FillControl(pb.GetProperty(path.GetPath()));
	}
}

////////////////////////////////////////////////
// 
// Validates values in controls before applying
//
function Validate()
{
	// Return success
	if(!OnGenResult()) return false;
	
	var searchField1 = document.getElementById("searchField1").value
	var searchField2 = document.getElementById("searchField2").value
	var searchField3 = document.getElementById("searchField3").value
	var searchField4 = document.getElementById("searchField4").value
	var searchField5 = document.getElementById("searchField5").value
	
	
	if(!ValidateHtmlInput(searchField1))
		return false
	if(!ValidateHtmlInput(searchField2))
		return false
	if(!ValidateHtmlInput(searchField3))
		return false
	if(!ValidateHtmlInput(searchField4))
		return false
	if(!ValidateHtmlInput(searchField5))
		return false

	if(!ValidateTextInput(searchField1))
		return false
	if(!ValidateTextInput(searchField2))
		return false
	if(!ValidateTextInput(searchField3))
		return false
	if(!ValidateTextInput(searchField4))
		return false
	if(!ValidateTextInput(searchField5))
		return false

	return true;
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function ApplySettings(pb,pp)
{
	//Transfer data from controls into properties and add to given bag
	var path = new PropertyPath(pp.GetPath())
	path.Append("What.OnDemand")
	path.SetTempLeaf("PolicyName")
	var select = document.getElementById("PolicyList")
	if( !bIsEPO ) {
		var selected = select.options[select.selectedIndex].value
		pb.SetProperty(path.GetPath(), gODPolicyRegNames[selected])
	} else {
		pb.SetProperty(path.GetPath(), "od_custom");
	}

	// Set "ResumeEnabled" flag if enabling resumable scanning
	path.SetTempLeaf("ResumeEnabled")
	var bResumeEnabled = document.getElementById("Enabled").checked
	pb.SetProperty(path.GetPath(), bResumeEnabled)

	path.SetTempLeaf("RestartFromLastItem")
	pb.SetProperty(path.GetPath(), document.getElementById("RestartFromLast").checked)
//	pb.SetProperty(path.GetPath(), bResumeEnabled)

	//OnGenResult();
	if(document.getElementById("result").value != "")
	{
		path.SetTempLeaf("AdvFiler")
		pb.SetProperty(path.GetPath(), document.getElementById("result").value)
	}

	if( bIsEPO ) {
		//timeout is is the "When" section
		var timeOut = document.getElementById("Timeout").value
		if( !IsEmpty(timeOut) && timeOut > 0 )
			pb.SetProperty(timeOutPP.GetPath(), timeOut)
	}
}

function FillControl(advFiler)
{

	var strItem, lastPos, strVal, strOpr , iCount=1;
	
	
	var strArrayFilters = "";
	strArrayFilters = advFiler.split(";");
	for( var i = 0; i < strArrayFilters.length ; i++)
	{
		var strFilterType = strArrayFilters[i].substring( 0, strArrayFilters[i].indexOf("(") );
		strVal = strArrayFilters[i].substring( strArrayFilters[i].indexOf("(")+1, strArrayFilters[i].indexOf(")") );
		var filterId = 0;
		
		if( strFilterType == "subject" )
		{
			filterId = 1;
		}
		else if(strFilterType == "from" )
		{
			filterId = 2;
		}
		else if(strFilterType == "to" )
		{
			filterId = 3;
		}
		else if(strFilterType == "cc" )
		{
			filterId = 4;
		}
		else if(strFilterType == "messageid" )
		{
			filterId = 5;
		}
		else if(strFilterType == "participants" )
		{
			filterId = 6;
		}
		else if(strFilterType == "")
			continue;
			
		if( filterId != 0 )
		{
			document.getElementById("fieldList"+(i+1)).selectedIndex = filterId-1;
			document.getElementById("searchField" + iCount).value = strVal;
			iCount++;
		}
	}

	//(Attachment:(a))
	strItem = advFiler.split("attachment(")
	if(strItem.length > 1)
	{
		lastPos = FindInArray(strItem[1], ")");
		strVal = strItem[1].substr(0,lastPos)
		
		var theFilter = document.getElementById("fieldList"+iCount);
		theFilter.selectedIndex = 7;
		
		document.getElementById("searchField"+iCount).value = strVal;
	}
			
	//(Sent:(2012-08-15..2012-08-16))
	strItem = advFiler.split("sent(")
	if(strItem.length > 1)
	{
		lastPos = FindInArray(strItem[1], ")");
		strVal = strItem[1].substr(0,lastPos)
		
		strItem1 = strVal.split("..")

		InitDTControls("fr", XMLToDateUTC(strItem1[0]+"T00:00:00"))
		InitDTControls("to", XMLToDateUTC(strItem1[1]+"T00:00:00"))
		document.getElementById("chksent").checked = true
	}
	else
	{
		IntialiseDateControl();
	}
	
	//(Size:(1KB..9KB))
	strItem = advFiler.split("size(")
	if(strItem.length > 1)
	{
		lastPos = FindInArray(strItem[1], ")");
		strVal = strItem[1].substr(0,lastPos)
		
		strItemColon = strVal.split("..")
		var strFirstVal="",strSecVal="",strByteVal = "";

		strFirstVal = strItemColon[0].substr(0,strItemColon[0].length-2);
		if(strItemColon.length == 2)
			strSecVal = strItemColon[1].substr(0,strItemColon[1].length-2);
		strByteVal = strItemColon[0].substr(strItemColon[0].length-2);
		
		if(strFirstVal != "")
			document.getElementById("fsize").value = strFirstVal;
		
		if(strSecVal != "")		
			document.getElementById("tsize").value = strSecVal;
			
		document.getElementById("chkMSize").checked = true
	}
	//(HasAttachments:(true))
	strItem = advFiler.split("HasAttachments(")
	if(strItem.length > 1)
	{
		document.getElementById("chkAttach").checked = true	
	}
	//(unread:(false))
	strItem = advFiler.split("unread(")
	if(strItem.length > 1)
	{
		lastPos = FindInArray(strItem[1], ")");
		strVal = strItem[1].substr(0,lastPos)

		if(strVal == "true")
			document.getElementById("chkUnread").checked = false	;
		else
			document.getElementById("chkUnread").checked = true;	
	}
	document.getElementById("result").value = advFiler;
}

function OnGenResult()
{

	var searchValue1 = document.getElementById("searchField1").value
	var searchValue2 = document.getElementById("searchField2").value
	var searchValue3 = document.getElementById("searchField3").value
	var searchValue4 = document.getElementById("searchField4").value
	var searchValue5 = document.getElementById("searchField5").value
	var filter="";
	
	searchValue1 = searchValue1;
	
	if (searchValue1 != "" || searchValue2 != "" ||searchValue3 != "" || searchValue4 != "" || searchValue5 != "")
	{
		if(searchValue1 !="")
		{
			filter = document.getElementById("fieldList1").options[document.getElementById("fieldList1").selectedIndex].id
			filter += "("+searchValue1+");";
		}
		
		for (var i=2; i <=5 ; i++)
		{
			fieldValue = document.getElementById("fieldList" + i).options[document.getElementById("fieldList"+i).selectedIndex].id;
			searchValue1 = document.getElementById("searchField" + i).value
			var endOR = document.getElementById("andORField" + i).value;
			searchValue1 = searchValue1;

			if (searchValue1 != "")
			{
				filter += fieldValue;	
				filter +=  "("+searchValue1+");";
			}
		}
		
		
	}
	// In case of Sent ...
	// ... validate date time fields ...
	if(document.getElementById("chksent").checked)
	{
		if (DateToXMLUTC(FromControls("fr")) >= DateToXMLUTC(FromControls("to")))
		{
			alert (strStartLaterThanEnd)
			return false;
		}
		
		var FromDate, ToDate;
		FromDate = DateToXMLUTC(FromControls("fr"));
		ToDate = DateToXMLUTC(FromControls("to"));
		if((FromDate != "") && (ToDate != ""))
		{
			filter += "sent(";
			filter += FromDate + ".." + ToDate + ");";
		}
	}
	
	// In case of Mail Size ...
	if(document.getElementById("chkMSize").checked)
	{
		if ((document.getElementById("fsize").value == "") && (document.getElementById("tsize").value == ""))
		{
			alert (gsMailSizeCheck);
			document.getElementById("fsize").focus();
			return false;
		}
		
		if (document.getElementById("fsize").value > document.getElementById("tsize").value)
		{
			alert (gsMailSizeFromMoreThanTo);
			document.getElementById("fsize").focus();
			return false;
		}
		
		var selectbyte = document.getElementById("byte")
		var byteName = selectbyte.options[selectbyte.selectedIndex].id;

		filter += "size(";
			
		var FromSize, ToSize;
		if (document.getElementById("fsize").value)
		{
			filter += document.getElementById("fsize").value + byteName;
		}
		if (document.getElementById("tsize").value)
		{
			if(filter == "")
				filter += "size(";
				
			filter += ".."+document.getElementById("tsize").value + byteName +");";
		}
		else
			filter += "..);";
	}
	
	// In case of Items with attachment ...
	if(document.getElementById("chkAttach").checked)
	{
		filter += "HasAttachments(true);";
	}
	// In case of Items with attachment ...
	if(document.getElementById("chkUnread").checked)
	{
		filter += "unread(false);";
	}

	document.getElementById("result").value = filter;
	return true;
}

function EnableControls(bEnable)
{	
	document.getElementById("Enabled").disabled = !bEnable
	document.getElementById("PolicyList").disabled = !bEnable
	EnableResumableScan()
}

function EnableResumableScan()
{
	document.getElementById("RestartFromLast").disabled = !document.getElementById("RestartFromLast").disabled
}

function IntialiseDateControl()
{
	// Search times
	var now = new Date()
	now.setMinutes(now.getMinutes()+1)
	var yesterday = new Date()
	yesterday.setTime(yesterday.getTime() - 86400000)
	InitDTControls("fr", yesterday)
	InitDTControls("to", now)
}