////////////////////////////////////////////////
//
// Constructor for OnaccessPage class
// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
function OndemandPage()
{
	// Initialize member functions
	this.Show = Show
	this.Validate = Validate
	this.Apply = Apply
	this.EnableDisable = EnableDisable
	this.InheritUninherit = InheritUninherit

	// Initialize member data
	this.bEnabled = true
}

////////////////////////////////////////////////
//
// Enables or disables all controls on the page
//
function EnableDisable(bEnable)
{
        document.getElementById("RestartFromLast").disabled = !bEnable
	EnableControl("McIDPolSelect", bEnable)
}

function InheritUninherit()
{
	EnableDisable(!document.getElementById("inherit").checked)
}

////////////////////////////////////////////////
//
// Writes current config settings into controls 
//
function Show()
{
	// Load current settings
	var ps = new PropertySource(true)
	this.pb = new PropertyBag()
	ps.Get(this.pb, new Array("ePOTask"))
	var pp = new PropertyPath("ePOTask")	
	pp.Append("What.OnDemand")
	
	//set 'RestartFromLast' value
	pp.SetTempLeaf("RestartFromLastItem")
	document.getElementById("RestartFromLast").checked = this.pb.GetProperty(pp.GetPath())
	pp.SetTempLeaf("")

	// Get 'PolicyName' value
	var strSelected = ""
	pp.SetTempLeaf("PolicyName")
	if(this.pb.GetPropertyDef(pp.GetPath(),-1) != -1)
	{	
		strSelected = this.pb.GetProperty(pp.GetPath())
	}
	
	//build up options
	var select = document.getElementById("McIDPolSelect")

	if( typeof(gODPolicyNames) != 'undefined' )
	{
		for(var i = 0; i < gODPolicyNames.length; i++)
		{
			select.options[i] = new Option(gODPolicyNames[i], i)
			if(strSelected == gODPolicyRegNames[i])
				select.options[i].selected = true
		}
	}
	if(select.options.selectedIndex == -1)
		select.options[0].selected = true
	
	// Apply inherit state
	var bInherit = window.external.schedule_value_bool("ePOTask", "Inherit")
	document.getElementById("inherit").checked = bInherit 
	EnableDisable(!bInherit)
}

////////////////////////////////////////////////
// 
// Validates values in controls before applying
//
function Validate()
{	
	if (document.getElementById("Enabled").checked && document.getElementById("Timeout").value == "")
	{
		alert(gsScanNoTimeout)
		document.getElementById("Timeout").focus
		return false
	}
	// Return success
	return true
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function Apply()
{
	var pp = new PropertyPath("ePOTask")
	pp.Append("What.OnDemand")
	
	pp.SetTempLeaf("ResumeEnabled")
	this.pb.SetProperty(pp.GetPath(), document.getElementById("RestartFromLast").checked)
	pp.SetTempLeaf("")
	pp.SetTempLeaf("RestartFromLastItem")
	this.pb.SetProperty(pp.GetPath(), document.getElementById("RestartFromLast").checked)
	pp.SetTempLeaf("")

	pp.SetTempLeaf("PolicyName")
	var select = document.getElementById("McIDPolSelect")
	var selected = select.options[select.selectedIndex].value
	this.pb.SetProperty(pp.GetPath(), gODPolicyRegNames[selected])

	var ps = new PropertySource(true)
	ps.Put(this.pb,document.getElementById("inherit").checked)
}
