/**
 * JavaScript for the PXSettings page.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var vframeworks = new Object();
var dataBindings = new Array();
var qparams = queryParameters();
var newInstance = false;
var newId = null;

var basePP = "Settings.PXSettings";
var px_pb = null;
var origName="";
var settingsId = qparams["id"];
var pxOptsForm = "px_options";

var g_changeNotifyFn = "top.gPageStack.Active().SetModified(true);";

// Initializes the page's forms
function px_forms_init() {
    shs_affectedPolicyReport(newInstance, "PX", settingsId, px_pb);

    var form = pxOptsForm;
    vframeworks["InstanceSettings"]= new ValidationFramework("InstanceSettings");
	vframeworks["InstanceSettings"].formAction = std_val_form_action;
    vframeworks["InstanceSettings"].fieldAction = std_val_field_action;
    vframeworks["InstanceSettings"].addValidator("displayName", new RequiredValidator());
    vframeworks["InstanceSettings"].addValidator("displayName", new ScriptValidator());
	vframeworks["InstanceSettings"].labelMap["displayName"] =resolveString(cse_pp_field_st, "__instancename");

    var inputArray= new Array();
	inputArray["SECTION"]="Scanners";
	inputArray["origName"]=origName;
	inputArray["basePP"]="Settings.PXSettings";
	vframeworks["InstanceSettings"].addValidator("displayName",new DuplicatesValidator(px_pb,inputArray));
	vframeworks["InstanceSettings"].addValidator("displayName",new LengthValidator());

    if (document.forms[form]) {
        vframeworks[form] = new ValidationFramework(form);
        var vf = vframeworks[form];
        vf.formAction = std_val_form_action;
        vf.fieldAction = std_val_field_action;
        var reqV = new RequiredValidator();
        var iList = [];
        var validatedFields = ["ThresholdHIPAA", "ThresholdPrivacy"];
        for (var i = 0; i < validatedFields.length; i++) {
            var eName = validatedFields[i];
            vf.labelMap[eName] = resolveString(page_st, "lm_" + eName);
            vf.addValidator(eName, reqV);
            iList.push(eName);
        }
        // Restrict input to non-negative integer values only
        setNumeric(pxOptsForm, iList, false, false);
    }
    addChangeNotification(g_changeNotifyFn);
}

// Sets form data and enables / disables controls as appropriate
function px_init() {
    px_forms_init();
    Reset();
}

/**
 * Asynchronous reset function
 */
function Reset() {
    var defValues = top.defValues["PX"];
    var px_pp = new PropertyPath(basePP);
    for (var i = 0; i < dataBindings.length; i++) {
        dataBindings[i].set(px_pp, px_pb);
    }
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {
    if (null == pbIn) {
        pbIn = top.gPB;
    }
    newInstance = shs_initPB(pbIn, pp, "PX");
    px_pb = pbIn;
    if (settingsId) {
        // Search for the settings blob to use
        basePP = top.GetBasePath(pbIn, basePP, "id", settingsId);
        if (null == basePP) {
            top.gPageStack.Active().Cancel();
            return;
        }
    }
    else {
        // Assume that we've been set up with the correct property path
        // and property bag
        basePP = pp.GetPath();
        settingsId = pbIn.GetPropertyDef(basePP + ".id", "");
        origName=pbIn.GetPropertyDef(basePP + ".displayName", "");
    }
    px_init();
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    return shs_Validate();
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    if (null == pb) {
        pb = px_pb;
    }
    shs_Apply(pb, basePP, dataBindings, newInstance);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    if (newInstance) {
        // Remove the new instance from the property bag
        px_pb.DeleteElement(basePP);
    }
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
    return [];
}
