var gTabs				= new TabSet("gTabs", true);	// Tab set for the page

// Validators
var vfDashboard		= new ValidationFramework("dashboardForm");
var vfGrapReports	= new ValidationFramework("graphicalReportingForm");

// Label map to support validation
var labelMap = new Object();
labelMap["idRefreshRate"] = gsPPRefreshRate;
labelMap["idSysMetricsScale"] = gsPPGraphScale;
labelMap["idSysMetricsHours"] = gsPPHours;
labelMap["idPieAngle"] = gsPPAngle;
labelMap["idMaxRecentlyScanned"] = gsPPMaxScannedItems;

function AddNumericOnlyValidation()
{
	var fn =   cb_numOnlyNN ;
	document.getElementById("idRefreshRate").onkeypress =  fn ;
	document.getElementById("idMaxRecentlyScanned").onkeypress = fn;
	document.getElementById("idSysMetricsScale").onkeypress = fn;
	document.getElementById("idSysMetricsHours").onkeypress = fn;
	document.getElementById("idPieAngle").onkeypress = fn;
}

function Show(pbIn)
{
	AddNumericOnlyValidation();
	// Add the tabs
	gTabs.add("Dashboard", "tabDashboardPage");
	gTabs.addValidation(0, vfDashboard);
	gTabs.add("Graphical Reports", "tabGraphicalReporting");
	gTabs.addValidation(1, vfGrapReports);
	
	// Initialize the tab handler
	gTabs.handler();
	
	// Initialise validators
	InitializeValidators();
	
	// Load settings
	LoadSettings(pbIn);
	
	//EnableDisableReportCtrls();
	on3DClicked();
}

function Validate()
{
    var bValidated = false;
    
    bValidated = vfDashboard.onsubmit();
    if( bValidated )
        bValidated = vfGrapReports.onsubmit();
    
	return(bValidated);
}

function Apply(pb)
{
	var pbOut = SaveSettings(pb);
	top.SetModified(false);
	
	return(pbOut);
}

function InitializeValidators()
{
	// Validators
	var rv = new RequiredValidator();
    var nv = new NumericValidator();
    var cvRefresh	= new CrossValidator("value >= 30 && value <= 3600", gsPPRefreshInputVal); 
    var cvScale		= new CrossValidator("value >= 100 && value <= 500", gsPPScaleInputVal); 
	var cvHours		= new CrossValidator("value >= 1 && value <= 24", gsPPHoursInputVal);     
	var cvAngle		= new CrossValidator("value >= 1 && value <= 360", gsPPAngleInputVal); 
	var cvMaxRecentItems = new CrossValidator("value >= 10 && value <= 100", gsPPMaxScannedItemsInputVal);    
    
    // Dashboard
    vfDashboard.addValidator("idRefreshRate", rv);
    vfDashboard.addValidator("idRefreshRate", nv);
    vfDashboard.addValidator("idRefreshRate", cvRefresh);
    vfDashboard.addValidator("idSysMetricsScale", rv);
    vfDashboard.addValidator("idSysMetricsScale", nv);
    vfDashboard.addValidator("idSysMetricsScale", cvScale);
    vfDashboard.addValidator("idSysMetricsHours", rv);
    vfDashboard.addValidator("idSysMetricsHours", nv);
    vfDashboard.addValidator("idSysMetricsHours", cvHours);
    vfDashboard.addValidator("idMaxRecentlyScanned", cvMaxRecentItems);
    
    vfDashboard.labelMap = labelMap;
    vfDashboard.formAction = std_val_form_action;
    
    // Graphical Reports
    vfGrapReports.addValidator("idPieAngle", rv);
    vfGrapReports.addValidator("idPieAngle", nv);
    vfGrapReports.addValidator("idPieAngle", cvAngle);
    
    vfGrapReports.labelMap = labelMap;
    vfGrapReports.formAction = std_val_form_action;
    
}

function LoadSettings(pb)
{
	var pp = new PropertyPath("UIPreferences");
	
	pp.SetTempLeaf("DashboardAutoRefresh");
	var value = pb.GetProperty(pp);
	
	//
	// Dashboard Refresh
	//
	if( value && value == "1" )
		document.getElementById("idAutoRefresh").checked = true;
	else
		document.getElementById("idAutoRefresh").checked = false;
	
	// Refresh rate	
	pp.SetTempLeaf("DashboardRefreshRate");
	var value = pb.GetProperty(pp);
	
	if( value == McUndefined )
		value = "30";
		
	document.getElementById("idRefreshRate").value = value;
	
	//
	// Reports
	//
	/*pp.SetTempLeaf("AVERTReports");
	var value = pb.GetProperty(pp);
	
	if( value == McUndefined )
		value = "1";
	
	if( value == "1" )
		document.getElementById("idEnableAVERTReports").checked = true;
	else
		document.getElementById("idEnableAVERTReports").checked = false;
	
	pp.SetTempLeaf("ShowRecentlyScannedItems");
	value = pb.GetProperty(pp);
	
	if( value == McUndefined  )
		value = "0";
	
	if( value == "1" )
		document.getElementById("idShowRecentlyScanned").checked = true;
	else
		document.getElementById("idShowRecentlyScanned").checked = false;
	*/	
	
	pp.SetTempLeaf("MaxRecentlyScannedItems");
	value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "100";
	
	document.getElementById("idMaxRecentlyScanned").value = value;
		
	//
	// System Metrics Graph
	//
	pp.SetTempLeaf("SysMetricsGraphScale");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "100";
		
	document.getElementById("idSysMetricsScale").value = value;
	
	pp.SetTempLeaf("SysMetricsReportFor");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "7";
	
	document.getElementById("idSysMetricsHours").value = value;
	
	//
	// Graphical Reports
	//
	pp.SetTempLeaf("GraphReport3D");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "1";
		
	if( value == "1" )
		document.getElementById("id3D").checked = true;
	else
		document.getElementById("id3D").checked = false;
		
	pp.SetTempLeaf("GraphReportTransparent");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "1";
		
	if( value == "1" )
		document.getElementById("idTransparent").checked = true;
	else
		document.getElementById("idTransparent").checked = false;
		
	pp.SetTempLeaf("GraphReportAntiAlias");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "1";
		
	if( value == "1" )
		document.getElementById("idAntiAlias").checked = true;
	else
		document.getElementById("idAntiAlias").checked = false;
		
	pp.SetTempLeaf("GraphReportExplodePie");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "0";
		
	if( value == "1" )
		document.getElementById("idExplodePie").checked = true;
	else
		document.getElementById("idExplodePie").checked = false;
			
	pp.SetTempLeaf("GraphReportPieAngle");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "45";
	
	document.getElementById("idPieAngle").value = value;		
}

function SaveSettings(pb)
{
	var pp = new PropertyPath("UIPreferences");
	
	pb.SetProperty(pp);
	pp.SetTempLeaf("DashboardAutoRefresh");
	pb.SetProperty(pp,document.getElementById("idAutoRefresh").checked);
	pp.SetTempLeaf("DashboardRefreshRate");
	pb.SetProperty(pp,document.getElementById("idRefreshRate").value);
	
	/*pp.SetTempLeaf("AVERTReports");
	pb.SetProperty(pp,document.getElementById("idEnableAVERTReports").checked);
	
	pp.SetTempLeaf("ShowRecentlyScannedItems");
	pb.SetProperty(pp,document.getElementById("idShowRecentlyScanned").checked);
	
	if( document.getElementById("idShowRecentlyScanned").checked )
	{*/
	pp.SetTempLeaf("MaxRecentlyScannedItems");
	pb.SetProperty(pp,document.getElementById("idMaxRecentlyScanned").value);
	/*}*/
	
	pp.SetTempLeaf("SysMetricsGraphScale");
	pb.SetProperty(pp,document.getElementById("idSysMetricsScale").value);
	
	pp.SetTempLeaf("SysMetricsReportFor");
	pb.SetProperty(pp,document.getElementById("idSysMetricsHours").value);

	pp.SetTempLeaf("GraphReport3D");
	pb.SetProperty(pp,document.getElementById("id3D").checked);
	pp.SetTempLeaf("GraphReportTransparent");
	pb.SetProperty(pp,document.getElementById("idTransparent").checked);
	pp.SetTempLeaf("GraphReportAntiAlias");
	pb.SetProperty(pp,document.getElementById("idAntiAlias").checked);
	pp.SetTempLeaf("GraphReportExplodePie");
	pb.SetProperty(pp,document.getElementById("idExplodePie").checked);	
	
	pp.SetTempLeaf("GraphReportPieAngle");
	pb.SetProperty(pp,document.getElementById("idPieAngle").value);

	return(pb);
}


