// Copyright (C) 2005 McAfee, Inc. All rights reserved.
// Example Simple graph filers

// Set gbDisableMasterPolEnable to true to cause the default policy Enable check to become disabled.
var gbDisableMasterPolEnable = true;
var gbSupportsAM = false;
var gEPOMode;//=false;
var gsProductTitle;
var gbShowPerfObjInstances = false;
var gsAntiSpamAddOn;
var gsPolicyMgmt;
includeJS("../../js/ePO.js");
includeJS("../../js/Validator.js");


//
// License registry keys
//
var gbEnableViewMail =false;

var gsLicenseTypes = new Array()
gsLicenseTypes[0] = "msme"
gsLicenseTypes[1] = "antispam"
//gsLicenseTypes[2] = "policymanagement"

// System Metrics Counters
var gSystemMetricCounters = new Array();
try {
    gSystemMetricCounters[0] = new SystemMetricsCounter( "1", gsCounter1, "0xADD4EE", true );
    gSystemMetricCounters[1] = new SystemMetricsCounter( "2", gsCounter2, "0xFFE581", true );
    gSystemMetricCounters[2] = new SystemMetricsCounter( "3", gsCounter3, "0xD69EFE", true );
    gSystemMetricCounters[3] = new SystemMetricsCounter( "4", gsCounter4, "0xFBC5A1", true );
    gSystemMetricCounters[4] = new SystemMetricsCounter( "5", gsCounter5, "0xA1FBD4", true );
    gSystemMetricCounters[5] = new SystemMetricsCounter( "6", gsCounter6, "0x268CFE", true );
    gSystemMetricCounters[6] = new SystemMetricsCounter( "7", gsCounter7, "0xAA55A5", true );
    gSystemMetricCounters[7] = new SystemMetricsCounter( "8", gsCounter8, "0xE0FBA5", true );
    gSystemMetricCounters[8] = new SystemMetricsCounter( "9", gsCounter9, "0x2FD1C7", true );
}
catch(e) {
}

var gbAntiSpamInstalled = pp_componentInstalled("AS");

// Function to determine whether a given software component is installed
// settingsType is the mnemonic for a given type ("AV", "AS", etc.)
function pp_componentInstalled(settingsType) {
    var ret = true;
	try {
		if(gEPOMode) return true;
		if ("AS" == settingsType || "AF" == settingsType) {
			var licenseType;
			var ppLicense = "systemstate.license." + gsLicenseTypes[1] + ".licensetype";
			if( parent.gSystemStatePB != McUndefined )
				licenseType = parent.gSystemStatePB.GetProperty(ppLicense);
			else // Sub-Policy wizard page is grand-child of the parent
				licenseType = parent.parent.gSystemStatePB.GetProperty(ppLicense);
			ret = ( licenseType != McUndefined && licenseType > 0 && licenseType < 7 );
			if( false == ret ) {
				disableAntiSpamSpecificItems();
			}
		}
	} catch(e){}
    return ret;
}

function disableAntiSpamSpecificItems() {
	if( McUndefined != gSearchableCols ) {
		delete gSearchableCols;
		gSearchableCols = new Array("sbj","rpt","rsn","tik","vrs"); 
	}

	if( McUndefined != gQueryCols ) {
		delete gQueryCols;
		gQueryCols = new Array("rpt","sdr","fln","vrs","sbj","rsn","rul","idy");
	}
}

var gGraphFilterRules = new Array();
try {
	var i = 0;
    gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription0, "pie", "rsn=\"av\"", "vrs", 10 );
	if( gbAntiSpamInstalled) {
		gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription5, "pie", "rsn=\"spam\"", "rul", 10 );
		gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription9, "pie", "rsn=\"spam\"", "rpt", 10 );
		gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription6, "pie", "rsn=\"phish\"", "rul", 10 );		
		gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription17, "pie", "rsn=\"spfhf\" OR rsn=\"spfsf\"", "rsn", 10);
		gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription14, "pie", "rsn=\"ip\"", "tsip", 10 );
	}
    gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription7, "pie", "rsn=\"pup\"", "vrs", 10 );
    gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription8, "pie", "rsn=\"content\"", "rul", 10 );
    gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription1, "pie", "rsn=\"av\"", "fln", 10 );
	gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription15, "pie", "rsn=\"url\"", "ctp", 10 );
	gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription16, "pie", "rsn=\"tie\"", "tiescr", 10);
    gGraphFilterRules[i++] = new GraphFilterRule( i+1, gsRuleDescription4, "bar", "", "", -1 );
}
catch(e) {
} 

//
// ApplyDefaultCookieSettings should set all required cookie settings to defaults
//
function ApplyDefaultCookieSettings(bOnlyIfNotSet)
{
	// BEGIN: AVERT SETTINGS	
	setCookieBooleanIfBlank("avertEnabled", true, true );
	// END: AVERT SETTINGS
	
	// BEGIN: DASHBOARD SETTINGS
	setCookieBooleanIfBlank("dashboardAutoRefresh", true, true );
	setCookieValueIfBlank("dashboardRefreshRate", "30", true);
	// END: DASHBOARD SETTINGS
	
	// BEGIN: GRAPHICAL REPORT SETTINGS
	setCookieBooleanIfBlank("graphs3D", true, true );
	setCookieBooleanIfBlank("graphsTransparent", false, true );
	setCookieBooleanIfBlank("graphsAntiAlias", true, true );
	setCookieBooleanIfBlank("graphsExplodePie", false, true );
	setCookieValueIfBlank("graphPieAngle", "45", true);
	// END: GRPAHICAL REPORT SETTINGS
	
	// BEGIN: SYSTEM METRICS
	setCookieValueIfBlank("dashboardSysMetricsScale", "100", true);
	setCookieValueIfBlank("dashboardSysMetricsHours", "7", true);
	// END: SYSTEM METRICS
}

// Display order for settings listing
pp_cse_settingsOrder = ["AV", "AS", "AF", "MIME", "SS"];

// Dependent settings blobs that should not be displayed in the settings lists
pp_cse_settingsExclusions = ["GM", "SM", "EM", "CM", "PM", "PPF", "HTTP", "URL"];
// Some settings are linked to others; each MIME settings instance, for example,
// has a linked GM settings blob
pp_cse_settingsDependencies = {};
pp_cse_settingsDependencies["MIME"] = ["GM"];

// AV settings option: show or hide the protection level dialog
pp_cse_ShowProtectionLevel = false;

// Maximum time to download custom configuration data
pp_maxConfigDownloadTime = 300000; // five minutes

// Protocol (policy-set) specific values that affect the operation of the UI
var pp_ui_flags = new Object();
pp_ui_flags["__default"] = new Object();
pp_ui_flags["__default"]["NoClean"] = 0;
pp_ui_flags["__default"]["PupTypesHidden"] = 0x40; // Hide the Cookies
pp_ui_flags["__default"]["PreFileFilter"] = 1;
pp_ui_flags["__default"]["canCreate"]=[];

pp_ui_flags["on_access"] = new Object();
pp_ui_flags["on_access"]["NoClean"] = 0;
pp_ui_flags["on_access"]["PupTypesHidden"] = 0x40;  // Hide the Cookies
pp_ui_flags["on_access"]["PreFileFilter"] = 1;
pp_ui_flags["on_access"]["canCreate"]=["AV","FF","CS","SS","MIME","SM","PM","EM","CM","PPF","MAILURL","MF","ALERT"];

pp_ui_flags["gateway"] = new Object();
pp_ui_flags["gateway"]["NoClean"] = 0;
pp_ui_flags["gateway"]["PupTypesHidden"] = 0x40; // Hide the Cookies
pp_ui_flags["gateway"]["PreFileFilter"] = 1;
//pp_ui_flags["gateway"]["canCreate"]=["AV","AS","URL"];
pp_ui_flags["gateway"]["canCreate"]=["AS","AF","MF","SS","MIME"];

// Entries in the default alerts file that are to be excluded from the alerts lists
pp_cse_alertExclusions = ["FILE_FILTER_ALLOWDESC", "POSTX_MSG", "URL_MSG", "URL_MSG_COACH", "URL_MSG_DENY", "SPAM_MSG"];

// Display order for alerts listing
pp_cse_alertsOrder = ["AV_REPLACEMENT", "SPAM_MSG", "FILE_FILTER_BLOCK", "CONTENT_RULE_REPLACEMENT", "MAILURL_MSG"];

// Action names per settings type; default is one item called "Action"
pp_cse_actionNames = {};
pp_cse_actionNames["STD"] = ["Action"];
pp_cse_actionNames["AS"] = ["Action1", "Action2", "Action3"];
pp_cse_actionNames["AV"] = ["Action", "MaliciousAction", "PackerAction", "PupAction"];
pp_cse_actionNames["CM"] = ["CorruptedObjAction"];
pp_cse_actionNames["EM"] = ["EncryptedObjAction"];
pp_cse_actionNames["PM"] = ["ProtectedObjAction"];
pp_cse_actionNames["PPF"] = ["PwdProtectedObjAction"];
pp_cse_actionNames["SM"] = ["SignedMailAction"];
pp_cse_actionNames["SS"] = ["MaxDepthAction", "MaxWidthAction", "TimeoutAction"];
pp_cse_actionNames["MF"] = ["MaxSizeAction", "BiggerThanAction", "MoreThanAction"];
pp_cse_actionNames["MAILURL"] = ["HighThresholdAction", "LowThresholdAction", "MAXURLExceededAction"];
pp_cse_actionNames["MIME"] = ["BlockPartial", "BlockExternal"];
pp_cse_actionNames["PX"] = ["ActionHIPAA", "ActionPrivacy"];

// This map is used in counting the number of policies that use the Default alert (of any category)
var pp_cse_alertTypeMatch = {};
pp_cse_alertTypeMatch["AV_REPLACEMENT"] = "Message";
pp_cse_alertTypeMatch["AV_PACKER_REPLACEMENT"] = "PackerAlert";
pp_cse_alertTypeMatch["AV_PUP_REPLACEMENT"] = "PupAlert";
pp_cse_alertTypeMatch["AV_MALWARE_REPLACEMENT"] = "MaliciousAlert";
pp_cse_alertTypeMatch["MAXMSGSIZEMSG"] = "MaxSizeAlert";
pp_cse_alertTypeMatch["MAXATTSIZEMSG"] = "BiggerThanAlert";
pp_cse_alertTypeMatch["ATTSTRIPMSG"] = "MoreThanAlert";

pp_cse_alertTypeMatch["MAILURL_MSG"] = "ThresholdAlert";
pp_cse_alertTypeMatch["MAILURL_MSG_MAXURL"] = "MaxUrlAlert";

pp_cse_alertTypeMatch["PHISH_MSG"] = pp_cse_alertTypeMatch["FILE_FILTER_BLOCK"] = pp_cse_alertTypeMatch["DOS_PROTECTION_MSG"] = 
									 pp_cse_alertTypeMatch["ENCRYPTED_DESC"] = pp_cse_alertTypeMatch["SIGNED_DESC"] = 
									 pp_cse_alertTypeMatch["CORRUPT_DESC"] = pp_cse_alertTypeMatch["PROTECTED_DESC"] = 
									 pp_cse_alertTypeMatch["PWDPROTECTED_DESC"] = pp_cse_alertTypeMatch["CONTENT_RULE_REPLACEMENT"] = 
									 pp_cse_alertTypeMatch["BLOCKEDMSGTYPE_DESC"] = pp_cse_alertTypeMatch["MAIL_NOTIFICATION"] = "Alert";

// Mapping between alert categories and settings types
var pp_cse_alertTypeMap = {};
pp_cse_alertTypeMap["AV_REPLACEMENT"] = "AV";
pp_cse_alertTypeMap["AV_PACKER_REPLACEMENT"] = "AV";
pp_cse_alertTypeMap["AV_PUP_REPLACEMENT"] = "AV";
pp_cse_alertTypeMap["AV_MALWARE_REPLACEMENT"] = "AV";
pp_cse_alertTypeMap["SPAM_MSG"] = "AS";
//pp_cse_alertTypeMap["PHISH_MSG"] = "AF";
pp_cse_alertTypeMap["FILE_FILTER_BLOCK"] = "FF";
pp_cse_alertTypeMap["DOS_PROTECTION_MSG"] = "SS";
pp_cse_alertTypeMap["ENCRYPTED_DESC"] = "EM";
pp_cse_alertTypeMap["SIGNED_DESC"] = "SM";
pp_cse_alertTypeMap["CORRUPT_DESC"] = "CM";
pp_cse_alertTypeMap["PROTECTED_DESC"] = "PM";
pp_cse_alertTypeMap["PWDPROTECTED_DESC"] = "PPF";
pp_cse_alertTypeMap["CONTENT_RULE_REPLACEMENT"] = "CS";
pp_cse_alertTypeMap["BLOCKEDMSGTYPE_DESC"] = "MIME";
pp_cse_alertTypeMap["MAXMSGSIZEMSG"] = "MF";
pp_cse_alertTypeMap["MAXATTSIZEMSG"] = "MF";
pp_cse_alertTypeMap["ATTSTRIPMSG"] = "MF";
pp_cse_alertTypeMap["URL_MSG"] = "URL";
pp_cse_alertTypeMap["URL_MSG_COACH"] = "URL";
pp_cse_alertTypeMap["URL_MSG_DENY"] = "URL";
pp_cse_alertTypeMap["MAILURL_MSG"] = "MAILURL";
pp_cse_alertTypeMap["MAILURL_MSG_MAXURL"] = "MAILURL";
pp_cse_alertTypeMap["POSTX_MSG"] = "PX";
// Inverse mapping
pp_cse_alertTypeMap["AV"] = "AV_REPLACEMENT";
pp_cse_alertTypeMap["AS"] = "SPAM_MSG";
//pp_cse_alertTypeMap["AF"] = "PHISH_MSG";
pp_cse_alertTypeMap["FF"] = "FILE_FILTER_BLOCK";
pp_cse_alertTypeMap["SS"] = "DOS_PROTECTION_MSG";
pp_cse_alertTypeMap["EM"] = "ENCRYPTED_DESC";
pp_cse_alertTypeMap["SM"] = "SIGNED_DESC";
pp_cse_alertTypeMap["CM"] = "CORRUPT_DESC";
pp_cse_alertTypeMap["PM"] = "PROTECTED_DESC";
pp_cse_alertTypeMap["PPF"] = "PWDPROTECTED_DESC";
pp_cse_alertTypeMap["CS"] = "CONTENT_RULE_REPLACEMENT";
pp_cse_alertTypeMap["MIME"] = "BLOCKEDMSGTYPE_DESC";
pp_cse_alertTypeMap["PX"] = "POSTX_MSG";
pp_cse_alertTypeMap["URL"] = "URL_MSG";
pp_cse_alertTypeMap["MAILURL"] = "MAILURL_MSG";

// Mapping between alert categories and token contexts
var pp_cse_categoryContextMap = {};
pp_cse_categoryContextMap["AV_REPLACEMENT"] = "AV";
pp_cse_categoryContextMap["DOS_PROTECTION_MSG"] = "DOS";
pp_cse_categoryContextMap["CONTENT_RULE_REPLACEMENT"] = "CF";
pp_cse_categoryContextMap["ENCRYPTED_DESC"] = "EM";
pp_cse_categoryContextMap["CORRUPT_DESC"] = "CM";
pp_cse_categoryContextMap["FILE_FILTER_BLOCK"] = "FF";
pp_cse_categoryContextMap["URL_MSG"] = "URL";
pp_cse_categoryContextMap["URL_MSG_COACH"] = "URL";
pp_cse_categoryContextMap["URL_MSG_DENY"] = "URL";
pp_cse_categoryContextMap["MAILURL_MSG"] = "MAILURL";
pp_cse_categoryContextMap["BLOCKEDMSGTYPE_DESC"] = "MIME";
pp_cse_categoryContextMap["POSTX_MSG"] = "PX";

// Mapping between action properties and corresponding alerts;
// Key is settings type + action name; value is the corresponding
// alert property together with its alert category
// Note that that if there are multiple actions but only one alert
// no mapping is defined
var pp_cse_actionAlertMap = {};
pp_cse_actionAlertMap["AV_Action"] = ["Message", "AV_REPLACEMENT"];
pp_cse_actionAlertMap["AV_MaliciousActions"] = ["MaliciousAlert", "AV_REPLACEMENT"];
pp_cse_actionAlertMap["AV_PackerActions"] = ["PackerAlert", "AV_REPLACEMENT"];
pp_cse_actionAlertMap["AV_PupActions"] = ["PupAlert", "AV_REPLACEMENT"];
//pp_cse_actionAlertMap["AF_Action"] = ["Alert", "PHISH_MSG"];
pp_cse_actionAlertMap["SM_SignedMailAction"] = ["Alert", "SIGNED_DESC"];
pp_cse_actionAlertMap["EM_EncryptedObjAction"] = ["Alert", "ENCRYPTED_DESC"];
pp_cse_actionAlertMap["PM_ProtectedObjAction"] = ["Alert", "PROTECTED_DESC"];
pp_cse_actionAlertMap["CM_CorruptedObjAction"] = ["Alert", "CORRUPT_DESC"];
pp_cse_actionAlertMap["PPF_PwdProtectedObjAction"] = ["Alert", "PWDPROTECTED_DESC"];
pp_cse_actionAlertMap["MF_MaxSizeAction"] = ["MaxSizeAlert", "MAXMSGSIZEMSG"];
pp_cse_actionAlertMap["MF_BiggerThanAction"] = ["BiggerThanAlert", "MAXATTSIZEMSG"];
pp_cse_actionAlertMap["MF_MoreThanAction"] = ["MoreThanAlert", "ATTSTRIPMSG"];
pp_cse_actionAlertMap["MAILURL_HighThresholdAction"] = ["ThresholdAlert", "MAILURL_MSG"];
pp_cse_actionAlertMap["MAILURL_LowThresholdAction"] = ["ThresholdAlert", "MAILURL_MSG"];
pp_cse_actionAlertMap["MAILURL_MAXURLExceededAction"] = ["MaxUrlAlert", "MAILURL_MSG_MAXURL"];
//pp_cse_actionAlertMap["FF_Action"] = ["Alert", "FILE_FILTER_BLOCK"];

// Settings types that use generic action pages
var pp_cse_genActionMap = {"AF":1, "SM":1, "EM":1, "PM":1, "CM":1, "PPF":1};

// Actions that involve replacement with an alert
var pp_cse_alertActions = {"ESERVICES:REPLACE":1,
						   "ESERVICES:REPLACE[SAFE:CORRUPTED]":1,
						   "ESERVICES:REPLACE[SAFE:ENCRYPTED]":1,
						   "ESERVICES:REPLACE[SAFE:PWDPROTECTED]":1,
						   "ESERVICES:REPLACE[SAFE:PROTECTEDCNT]":1};

// File category exclusion lists for file filtering and content scanning
var pp_cse_fcExclusionLists = {};
pp_cse_fcExclusionLists["C"] = [];
pp_cse_fcExclusionLists["F"] = ["ALL"];
// Sample customization: exclude Samsung office suite
//pp_cse_fcExclusionLists["F"].push("OI:DOC:GUL");

// A number of file formats are not displayed but are automatically selected when the user
// selects another format
var pp_cse_fcDependencies = {};
pp_cse_fcDependencies["OI:DOC:1082"] = ["OI:DOC:1102"];         // Word 6 or 7 -> Word 7
pp_cse_fcDependencies["OI:DOC:1054"] = ["OI:DOC:1055"];         // Word for Windows 1.0 -> WfW 1.0 (Complex)
pp_cse_fcDependencies["OI:DOC:1065"] = ["OI:DOC:1096"];         // Word for Windows 2.0 -> WfW 2.0 Object
pp_cse_fcDependencies["OI:DOC:1129"] = ["OI:DOC:1135"];         // MIFF 3.0 -> MIFF 3.0 Japan
pp_cse_fcDependencies["OI:DOC:1130"] = ["OI:DOC:1136"];         // MIFF 4.0 -> MIFF 4.0 Japan
pp_cse_fcDependencies["OI:DOC:1131"] = ["OI:DOC:1137"];         // MIFF 5.0 -> MIFF 5.0 Japan
pp_cse_fcDependencies["OI:DOC:1166"] = ["OI:DOC:1167"];         // MIFF 6.0 -> MIFF 6.0 Japan
pp_cse_fcDependencies["OI:DOC:1028"] = ["OI:DOC:1091"];         // Rich Text Format -> RTF Japan
pp_cse_fcDependencies["OI:DOC:1038"] = ["OI:DOC:1083"];         // WordPerfect 5.x -> WP 5.1 Far East
pp_cse_fcDependencies["OI:DOC:1107"] = ["OI:DOC:1139"];         // WordPerfect 7/8/10 -> WP 8/10
pp_cse_fcDependencies["OI:SPREAD:1415"] = ["OI:SPREAD:1439",
    "OI:IMAGE:1530"];                                           // Excel 3.0 -> Excel 3.0 workbook, Excel 3 chart
pp_cse_fcDependencies["OI:SPREAD:1419"] = ["OI:SPREAD:1436",
    "OI:SPREAD:1440", "OI:SPREAD:1441", "OI:SPREAD:1442",
    "OI:IMAGE:1531"];                                           // Excel 4.0 -> Excel 4 (alt code), Excel 4.0 workbook (x3), chart
pp_cse_fcDependencies["OI:SPREAD:1433"] = ["OI:SPREAD:1444",
    "OI:SPREAD:1434"];                                          // Quattro Pro 7/8 -> QP 8, QP 7/8 Graph
pp_cse_fcDependencies["OI:SPREAD:1430"] = ["OI:SPREAD:1431"];   // 123 for OS/2 -> 123 for OS/2 Chart
pp_cse_fcDependencies["OI:SPREAD:1424"] = ["OI:SPREAD:1437",
    "OI:IMAGE:1536"];                                           // Excel 5/7 -> Excel 5, chart
pp_cse_fcDependencies["OI:SPREAD:1420"] = ["OI:SPREAD:1422"];   // Quattro Pro for Windows -> QP Win Japan
pp_cse_fcDependencies["OI:SPREAD:1405"] = ["OI:IMAGE:1529"];    // Excel 2.x -> Excel 2.x chart
pp_cse_fcDependencies["OI:IMAGE:1538"] = ["OI:IMAGE:1563",
    "OI:IMAGE:1567", "OI:IMAGE:1549", "OI:IMAGE:1562"];         // Powerpoint 4.0 -> Macintosh and other variants
pp_cse_fcDependencies["OI:IMAGE:1540"] = ["OI:IMAGE:1548",
    "OI:IMAGE:1566"];                                           // Powerpoint 3.0 -> Macintosh and other variants
pp_cse_fcDependencies["OI:IMAGE:1500"] = ["OI:IMAGE:1602",
    "OI:IMAGE:5002", "OI:IMAGE:5003", "OI:IMAGE:5011",
    "OI:IMAGE:5012", "OI:IMAGE:5013", "OI:IMAGE:5014"];         // Various Windows bitmap formats, including embedded
pp_cse_fcDependencies["OI:IMAGE:1514"] = ["OI:IMAGE:1551"];     // OS/2 bitmaps
pp_cse_fcDependencies["OI:IMAGE:1508"] = ["OI:IMAGE:1564",
    "OI:IMAGE:5000", "OI:IMAGE:5005", "OI:IMAGE:5006"];         // Windows metafile formats, including embedded
pp_cse_fcDependencies["OI:IMAGE:1552"] = ["OI:IMAGE:1585"];     // Autocad 12 drawing -> Autocad drawing, unknown version
pp_cse_fcDependencies["OI:IMAGE:1553"] = ["OI:IMAGE:1585"];     // Autocad 13 drawing -> Autocad drawing, unknown version
pp_cse_fcDependencies["OI:IMAGE:1587"] = ["OI:IMAGE:1585"];     // Autocad 14 drawing -> Autocad drawing, unknown version
pp_cse_fcDependencies["OI:IMAGE:1581"] = ["OI:IMAGE:1600"];     // Powerpoint 97 - 2002 -> Powerpoint 2000 - 2002
pp_cse_fcDependencies["OI:IMAGE:1592"] = ["OI:IMAGE:1543"];     // Powerpoint 95/97 -> Powerpoint 7.0
pp_cse_fcDependencies["OI:IMAGE:1501"] = ["OI:IMAGE:1504"];     // TIFF -> EPS (TIFF header)
pp_cse_fcDependencies["OI:IMAGE:1535"] = ["OI:IMAGE:1599"];     // JPEG -> Progressive JPEG
pp_cse_fcDependencies["OI:IMAGE:1506"] = ["OI:IMAGE:5004"];     // MAC PICT 2 -> MAC PICT 2 Binary
pp_cse_fcDependencies["OI:IMAGE:1507"] = ["OI:IMAGE:5001",
    "OI:IMAGE:5010"];                                           // WordPerfect Graphic v1
pp_cse_fcDependencies["OI:IMAGE:1527"] = ["OI:IMAGE:5008"];     // WordPerfect Graphic v2

// File filtering uses "/" as the category delimiter rather than ":"
for (var prop in pp_cse_fcDependencies) {
    var pat = /:/g;
    var dList = pp_cse_fcDependencies[prop];
    var tProp = prop.replace(pat, "/");
    pp_cse_fcDependencies[tProp] = [];
    var dCatMap = {};
    for (var i = dList.length - 1; i>= 0; i--) {
        var dCat = dList[i];
        if (null == dCatMap[dCat]) {
            // Add the category to the exclusion lists
            pp_cse_fcExclusionLists["C"].push(dCat);
            pp_cse_fcExclusionLists["F"].push(dCat);
            dCatMap[dCat] = 1;
        }
        pp_cse_fcDependencies[tProp].push(dCat.replace(pat, "/"));
    }
}

// The default filenames for MIME-encoded alerts
var pp_cse_defAlertFN = "warning.htm";
var pp_cse_defAlertFNP = "warning.txt";

if (undefined !== this.gEPOMode)
    this.gEPOMode = false;

// Character encoding list
var pp_cse_encodings = ["big5", "cp850", "cp851", "cp856", "cp857",
    "cp858", "cp860", "cp861", "cp862", "cp863", "cp864", "cp865",
    "cp866", "cp868", "cp869", "cp922", "euc-jp", "euc-kr", "gb18030", "gb2312",
    "hz-gb-2312", "ksc_5601", "iso-2022-cn", "iso-2022-cn-ext",
    "iso-2022-jp", "iso-2022-jp-2", "iso-2022-kr",
    "iso-8859-1", "iso-8859-2", "iso-8859-3", "iso-8859-4", "iso-8859-5",
    "iso-8859-6", "iso-8859-7", "iso-8859-8", "iso-8859-9", "iso-8859-13", "iso-8859-15",
    "koi8-r", "macintosh", "x-mac-centraleurroman", "x-mac-cyrillic", "x-mac-greek", "x-mac-turkish",
    "shift_jis", "us-ascii", "utf-7", "utf-8"];

// On-Demand Scan
var gOnDemandScanSeperator = "\\"
if (typeof Wizard != "undefined")
{
    try {
        var gTaskWizards = new Array
        var pages = new Array
        pages[pages.length] = new WizardPage("ScheduleWizardPage.html", gsODWizPage1, "ODWizardHelp", "timeforthescan")
        pages[pages.length] = new WizardPage("ODWizardPage.html", gsODWizPage2, "ODWizardHelp", "inclusions")
//        pages[pages.length] = new WizardPage("ODWizardPage.html", gsODWizPage3)
        pages[pages.length] = new WizardPage("ODScanSettings.html", gsODWizPage4, "ODWizardHelp", "scansettings")
        pages[pages.length] = new WizardPage("TaskNameWizardPage.html", gsODWizPage5, "ODWizardHelp", "nameforthescan")
        gTaskWizards["ScanTask"] = new Wizard(pages, gsODWizTitle)
		
		pages = new Array
        pages[pages.length] = new WizardPage("ScheduleWizardPage.html", gsWhenToReport, "StatusWizardHelp", "when_to_report")
        pages[pages.length] = new WizardPage("Statusreportpage.htm", gsStatusReportSettings, "StatusWizardHelp", "report_settings")
        pages[pages.length] = new WizardPage("TaskNameWizardPage.html", gsNoTaskName, "StatusWizardHelp", "nameforthetask")
        gTaskWizards["StatusReportTask"] = new Wizard(pages, gsReport)
		
		pages = new Array
        pages[pages.length] = new WizardPage("ScheduleWizardPage.html", gsWhenToReport, "ConfigWizardHelp", "when_to_report")
        pages[pages.length] = new WizardPage("reportpage.htm", gsReportSettings, "ConfigWizardHelp", "who_to_report")
        pages[pages.length] = new WizardPage("TaskNameWizardPage.html", gsNoTaskName, "ConfigWizardHelp", "nameforthetask")
        gTaskWizards["ReportTask"] = new Wizard(pages, gsReport)
    }
    catch(e){}
}

try
{
       // Results table cols - names,visible,allowed,searchable,hidden
    var gResultsTableCols = new Array
    gResultsTableCols["spam"]  = [gStoreCols,["dts","sdr","rul","act","tsscr","tsip"],["dts","sdr","act","tik","ssc","idy","psn","svr","rul","ase","asr","rpt","sbj","tsscr","tsip"],["sdr","act","tik","ssc","idy","psn","svr","rul","ase","asr","rpt","sbj","tsscr","tsip"],["qtn"]]
	gResultsTableCols["ip"]  = [gStoreCols,["dts","tsip","ipscr","act"],["dts","tsip","ipscr","act"],["tsip","ipscr","act"],["qtn"]]
    gResultsTableCols["phish"] = [gStoreCols,["dts","sdr","rul","act","tsscr","tsip"],["dts","sdr","act","tik","ssc","idy","psn","svr","rul","ase","asr","rpt","sbj","tsscr","tsip"],["sdr","act","tik","ssc","idy","psn","svr","rul","ase","asr","rpt","sbj","tsscr","tsip"],["qtn"]]

	gResultsTableCols["virus"] = [gStoreCols,["dts","sdr","fln","vrs","act"],["dts","sdr","fln","vrs","act","fdr","tik","idy","psn","svr","avd","ave","rpt","sbj"],["sdr","fln","vrs","act","fdr","tik","idy","psn","svr","avd","ave","rpt","sbj"],["qtn","rsn","sav"]]
	gResultsTableCols["tie_atd"]  = [gStoreCols,["dts","tsip","tiescr","act"],["dts","sdr","fln","fdr","vrs","trs","tik","ssc","idy","psn","svr","ftr","rul","avd","ave","ase","asr","act","rpt","rsn","sbj","ctp","tn","tsscr","tsip","tiescr"],["tiescr"],["qtn"]]
	gResultsTableCols["spoof"]  = [gStoreCols,
	["dts", "sdr", "ftr", "rsn", "tsip", "fln"], //visible		
	["dts","sdr","fln","fdr","vrs","trs","tik","ssc","idy","psn","svr","ftr","rul","avd","ave","ase","asr","act","rpt","rsn","sbj","ctp","tn","tsscr","tsip","tiescr"], //allowed
	["sdr", "rsn", "ftr", "tsip"], //searchable
	["qtn", "sav"] ]; //hidden
    gResultsTableCols["pup"]   = [gStoreCols,["dts","sdr","fln","vrs","act"],["dts","sdr","fln","vrs","act","fdr","tik","idy","psn","svr","rul","avd","ave","rpt","sbj"],["sdr","fln","vrs","act","fdr","tik","idy","psn","svr","rul","avd","ave","rpt","sbj"],["qtn","sav"]]

    gResultsTableCols["unwantedcontent"] = [gStoreCols,["dts","sdr","rul","fln","act"],["sdr","act","dts","fln","fdr","tik","idy","psn","svr","rul","rpt","rsn","sbj","ctp"],["sdr","act","fln","fdr","tik","idy","psn","svr","rul","rpt","sbj","ctp"],["qtn"]]

	gResultsTableCols["bannedfile"] = [gStoreCols,["dts","sdr","rul","fln","act"],["sdr","act","dts","fln","fdr","tik","idy","psn","svr","rul","rpt","rsn","sbj"],["sdr","act","fln","fdr","tik","idy","psn","svr","rul","rpt","sbj"],["qtn"]]
	if( gbAntiSpamInstalled )
	{
		gResultsTableCols["allitems"] = [gStoreCols,["dts","sdr","ftr","rsn","fln","rul","act","tn","tsip","tsscr"],["dts","sdr","fln","fdr","vrs","trs","tik","ssc","idy","psn","svr","ftr","rul","avd","ave","ase","asr","act","rpt","rsn","sbj","ctp","tn","tsscr","tsip","tiescr"],["fln","fdr","vrs","trs","tik","ssc","idy","psn","svr","ftr","rul","avd","ave","ase","asr","act","rpt","rsn","sbj","ctp","tn","tsscr","sdr","tsip"],["qtn", "sav"]]
	}
	else
	{
		gResultsTableCols["allitems"] = [gStoreCols,["dts","sdr","ftr","fln","rul","act","tn"],["dts","sdr","fln","fdr","vrs","trs","tik","idy","psn","svr","ftr","rul","avd","ave","act","rpt","rsn","sbj","ctp","tn"],["sdr","fln","fdr","vrs","trs","tik","idy","psn","svr","ftr","rul","avd","ave","act","rpt","rsn","sbj","ctp","tn"],["qtn", "rsn","sav"]]
	}

	gResultsTableCols["productlog"] = [gProductLogCols,["dts","id","dsc","lvl"],["dts","id","lvl","dsc"],["id","lvl","dsc"],["lvl"]]

	gResultsTableColIntTypes = ["ssc","tsscr","ipscr", "tiescr"]
	
	gResultsTableCols["content"] = [gStoreCols,["dts","sdr","rul","fln","act"],["sdr","act","dts","fln","fdr","tik","idy","psn","svr","rul","rpt","rsn","sbj","ctp"],["sdr","act","fln","fdr","tik","idy","psn","svr","rul","rpt","sbj","ctp"],["qtn"]]
	gResultsTableCols["url"] = [gStoreCols,["dts","sdr","rul","fln","act"],["sdr","act","dts","fln","fdr","tik","idy","psn","svr","rul","rpt","rsn","sbj","ctp"],["sdr","act","fln","fdr","tik","idy","psn","svr","rul","rpt","sbj","ctp"],["qtn"]]
}
catch(e){}

try
{
    var gRecentlyScannedTableCols = new Array;
    if( gbAntiSpamInstalled )
	{
		gRecentlyScannedTableCols = [gStoreCols, [ "dts", "ipscr", "sdr","rpt","sbj", "act", "fln", "vrs", "tn", "ftr", "psn", "idy","tsscr","rsn"], ["rsn"]];
	}
	else
	{
		gRecentlyScannedTableCols = [gStoreCols, [ "dts", "sdr","rpt", "sbj", "act", "fln", "vrs", "tn", "ftr", "psn", "idy","rsn"], ["rsn"]];
	}
}
catch(e){}


//==========================================================
// those strings are related to the gIdCfgTemplates array defined
// in PPString.js.
//Both arrays must stay in sync.
//============================================================
var gIdTplSubset= new Object();
var gIdCfgTemplates = new Array(
/* 0*/	"sma IS %1e",
/* 1*/	"NOT (sma IS %1e)",
/* 2*/	"ato IS %1e",
/* 3*/	"NOT (ato IS %1e)",
/* 4*/	"sma IN %1g",
/* 5*/	"NOT (sma IN %1g)",
/* 6*/	"ato IN %1g",
/* 7*/	"NOT (ato IN %1g)"
)

SetNewArrayVal();


function SetNewArrayVal()
{
	var testvar; 
	if ((parent != McUndefined) && (parent.gSystemStatePB != McUndefined) )
	{
		testvar = parent.gSystemStatePB.GetProperty("systemstate.exsvrrole") 
	}
	else if( parent.parent.gSystemStatePB != McUndefined) 
	{
		testvar = parent.parent.gSystemStatePB.GetProperty("systemstate.exsvrrole") 
	}

	if (testvar == 4 )
	{
		gIdTplSubset["__default"]=[0,1,2,3];
	}
	else
	{
		gIdTplSubset["__default"]=[0,1,2,3,4,5,6,7];
	}
}

function fPicker(){}
fPicker.prototype = new DefaultPicker
fPicker.prototype.Validate=function()
{
	var s= top.IsValidFilename(this.Selection()[0]);
	if (s!=null)
	{
		alert(s);
		return false;
	}
	return true;
}
function hPicker(){}
hPicker.prototype = new DefaultPicker
hPicker.prototype.Validate=function()
{
	var s = top.IsValidFilePath(this.Selection()[0]);
	if (s!=null)
	{
		alert(s);
		return false;
	}
	return true;
}

// Picker
var gPickerEntries = null;

function OnChangeOfPickerList()
{
	document.getElementById(K_IPK_CTL).value = document.getElementById("IPK_CTL_LIST").value
}

function DrawPickerList(tplType)
{
   // Create select object
   var ctl= document.createElement("select");
   ctl.className = "textField"; 
   ctl.size=10;
   ctl.id = "IPK_CTL_LIST";
   ctl.style.verticalAlign="text-top";

   ctl.onchange = OnChangeOfPickerList;
   
   var div = document.getElementById(K_IPK_DIV);
   if(div){
     div.innerHTML = "";
	 div.appendChild(DrawPickerInput())
	 if("g" == tplType)     //i.e, it is related to Active Directory Listing.
		div.appendChild(document.createElement("br"));
   }

   if( gPickerEntries == null ) {
	 gPickerEntries = new Array()
	 top.hiddenFrame.location.href = GetDynamicPageUrl( "grouppicker&p=1&u=1&g=1&l=1");
   } else {
	   for( var i = 0; i < gPickerEntries.length; ++i ) {
			var adGroupList = document.createElement("option")
			if( !IsEmpty( gPickerEntries[i] ) ) {
				adGroupList.value = gPickerEntries[i];
				adGroupList.appendChild(document.createTextNode(gPickerEntries[i]));
				ctl.appendChild(adGroupList)
			}
	   }
   }
   return ctl;
}

function DrawPickerInput()
{
	var ctl= document.createElement("input");
	ctl.type = "text";
	ctl.className = "textField";
	ctl.disabled = true;
	ctl.id = K_IPK_CTL;
	return ctl;
}

// Group picker
function gPicker(){}
gPicker.prototype = new DefaultPicker
gPicker.prototype.constructor = gPicker
gPicker.prototype.Draw=function(){
	return DrawPickerList("g")
}

gPicker.prototype.Validate=function(){
	if( IsEmpty(this.Selection()[0]) ) {
		alert(gsInvalidADGroup)
		return false
	}
	return true
}
gPicker.prototype.AddPickerEntries=function( tplType, list ){
	for( var i = 0; i < list.length; ++i )
		gPickerEntries[i] = list[i]

    var div = document.getElementById(K_IPK_DIV);
	if(div)	{
		div.appendChild(this.Draw())
	}
}

// On-Demand Scan policy names mapped to the PolicyId in the registry
gODPolicyRegNames = new Array(
				"od_default",
				"od_findviruses", 
				"od_removeviruses", 
			    "od_find_bannedcontent",
			    "od_remove_bannedcontent",
			    "od_fullscan" )
	

// Avert report names supported
var gAVERTReports=["AntiVirusNews", "SecurityNews"];


// 
// Description of License types (based on above array)
//
var gsLicenseDescriptionLanguage = new Array;
gsLicenseDescriptionLanguage[gsLicenseTypes[0] ] = gsProductTitle ;
gsLicenseDescriptionLanguage[gsLicenseTypes[1]] = gsAntiSpamAddOn;
//gsLicenseDescriptionLanguage[gsLicenseTypes[2]] = gsPolicyMgmt;



// Constants for Exchange Server Version
var const_exVersion2003 = 0
var const_exVersion2007 = 1
var const_exVersion2010 = 2
var const_exVersion2013 = 3

// Constants for Exchange 2003 Roles
var const_ex2k3RoleMBOnly = 0
var const_ex2k3RoleGatewayOnly = 1
var const_ex2k3RoleMBAndGateway = 2

// Constants for Exchange 2007/2010 Roles
var const_exSvrRoleMBOnly = 1
var const_exSvrRoleHubOnly = 2
var const_exSvrRoleMBAndHub = 3
var const_exSvrRoleEdgeOnly = 4

function GetExVersion() {
	return parent.gSystemStatePB.GetProperty("systemstate.exversion")
}

function IsBHInstalled() {
	if(gEPOMode)
		return true;
	if(GetExVersion() == const_exVersion2003) {
		var role = parent.gSystemStatePB.GetProperty("systemstate.ex2k3svrrole")
		return (role == const_ex2k3RoleGatewayOnly) || (role == const_ex2k3RoleMBAndGateway)
	}

	var role = parent.gSystemStatePB.GetProperty("systemstate.exsvrrole")
	return (role == const_exSvrRoleHubOnly) || (role == const_exSvrRoleMBAndHub)
}

function IsMBInstalled() {
	if(gEPOMode)
		return true;
	if(GetExVersion() == const_exVersion2003) {
		var role = parent.gSystemStatePB.GetProperty("systemstate.ex2k3svrrole")
		return (role == const_ex2k3RoleMBOnly) || (role == const_ex2k3RoleMBAndGateway)
	}

	var role = parent.gSystemStatePB.GetProperty("systemstate.exsvrrole")
	return (role == const_exSvrRoleMBOnly) || (role == const_exSvrRoleMBAndHub)
}

function IsGWInstalled() {
	if(gEPOMode)
		return true;
	if(GetExVersion() == const_exVersion2003) {
		return false
	}
	
	var role = parent.gSystemStatePB.GetProperty("systemstate.exsvrrole")
	return (role == const_exSvrRoleEdgeOnly)
}

function IsMBOnlyInstalled()
{
	if(gEPOMode)
		return false; //BZ: 683863 returning false incase of ePO because Disc settings should be always shown in ePO, as ePO cant determine the exchange role
	if(GetExVersion() == const_exVersion2003) {
		var role = parent.gSystemStatePB.GetProperty("systemstate.ex2k3svrrole")
		return (role == const_ex2k3RoleMBOnly)
	}

	var role = parent.gSystemStatePB.GetProperty("systemstate.exsvrrole")
	return (role == const_exSvrRoleMBOnly)
}

function DisableFormControls(elem) {
	if(elem.type == "text" ||
			elem.type == "checkbox" ||
			elem.type == "button" ||
			elem.type == "textarea" ||
			elem.type == "select-multiple" ||
			elem.type == "select-one") {
		elem.disabled = true
	}
	
	for(var child in elem.childNodes) {
		DisableFormControls(elem.childNodes[child])
	}
}

function IsODEnable() {
	if(gEPOMode)
		return true;
	return IsMBInstalled();
}

//Function implemented in PointProductSpecific.js to override the default
//locales supported by SAFe. MSME 7.6 does not have translations for Traditinal Chinese and Korean
//and hence in these languages the UI will default to En.
function pp_GetLocale() {
	var cp = "0409";
	var lang = GetBrowserLanguage();

	if(LanguageSupported(lang))
	{
		if (lang == "zh-cn" || lang=="zh-CN") cp = "0804";
		if (lang == "de") cp = "0407";
		if (lang == "fr") cp = "040C";
		if (lang == "es") cp = "040A";
		if (lang == "ja") cp = "0411";
	}

	return cp;
}
