// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//====================================================================================
// Const, globals and Flags
//====================================================================================
var K_NP=0;
var K_GR=1;
var K_RL=2;
var K_GRP_DIV="grp_div";
var K_R_DIV = "r_div"
var K_GRP_SEL = "grp_sel"
var K_LANG_DIV="lang_div"
var K_R_SEL = "r_sel"
var K_FORM = "rule_form"
var GenericWCount=0;

var pageProperties=[];
var settingsType = "CS";
var vframeworks=[];
var qparams = queryParameters();
var create_flag=false
var policy_pb;
var setting_pp;
function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}


//rules combo related utilities
PolActions_CS_ShowRules = function(hide)
{
var div = document.getElementById(K_R_DIV);
    div.style.display=hide?"none":"";
}

//returns a list of rule type + id
PolActions_CS_GetSelect = function()
{
    var ret = [];

    var f = document.forms[K_FORM];
    var grp_ndx=f.grp_sel.value;

	f.r_src.checked = true;

	if (f.r_src.checked)
	{
        ret.push({type:"RefRuleGroup", id:gContentRules.rules[grp_ndx].id});
	}
	else
	{
	     for(var i=0; i<gContentRules.rules[grp_ndx].lst.length;i++)
		 {
		     if (f.r_sel.options[i].selected)
		     {  ret.push({type:"RefRule", id:gContentRules.rules[grp_ndx].lst[i].id});
		     }
		 }
	}

	return ret;
}



//populate list of rules depending on  rule group selection
//check/uncheck checkbox as needed
function PolActions_CS_SelectGrp(OnChange)
{
	

	if(gContentRules.GetScoreFromId("RefRuleGroup", gContentRules.rules[document.forms[K_FORM].grp_sel.value].id) == McUndefined)
	{
		var div = document.getElementById("tscr");
		if (div)
		{   
			div.style.display = "none";
			
		}
		div = document.getElementById("mcnt");
		if (div)
		{   
			div.style.display = "none";
			
		}
	}
	else
	{
		var div = document.getElementById("tscr");
		if (div)
		{   
			div.style.display = "";
			
		}	
		div = document.getElementById("mcnt");
		if (div)
		{   
			div.style.display = "";
			
		}
	}

	if(OnChange)
		top.gPageStack.Active().SetModified(true);
    //populate rules list
    var ndx= PolActions_CS_PopulateRules();
    var gr_id = gContentRules.rules[ndx].id;
    var id_lst=gContentRules.GetGrpRules(ndx);
    var status=K_NP;

    //check if any of the rules is selected already
    for (var i=0;i<gContentRules.rulesTable.GetLength();i++ )
    {
        var t_id=gContentRules.rulesTable.GetId(i)
        if(t_id == gr_id)
        {   status=K_GR;
            break;
        }

        for (var j=0;j<id_lst.length;j++ )
        {    if(t_id==id_lst[j])
             {    status=K_RL;
                  break;
             }
        }
    }

	status=K_RL;

    var ctl = document.getElementById("r_src");
	 if(!ctl) return;
    ctl.disabled=false;
	
	
    //rule group aleady selected
    if(status==K_GR)
    {   ctl.checked=true;
        ctl.disabled=true;
        PolActions_CS_ShowRules(true);
    }

    //rule group aleady selected
    if(status==K_RL)
    {    ctl.checked=false;
         ctl.disabled=true;
         PolActions_CS_ShowRules(false);
    }


   //rule group not selected
    if(status==K_NP)
    {    ctl.checked=false;
         ctl.disabled=false;
         PolActions_CS_ShowRules(false);
    }
}


//Populate rules combo box
//returns the selected rule group id
PolActions_CS_PopulateRules = function()
{
    var sel = document.getElementById(K_GRP_SEL);
	if(!sel)
	{   return;
	}
	var ndx = sel.options[sel.selectedIndex].value-0

    var div = document.getElementById(K_R_DIV);
    if (!div)
        return;

    while(div.firstChild)
        div.removeChild(div.firstChild);

    var sel=document.createElement("select");
	sel.id=K_R_SEL;
	sel.multiple = true;
    sel.size = gContentRules.rules[ndx].lst.length;

	for(var i=0;i<gContentRules.rules[ndx].lst.length;i++)
	{   var tag=gContentRules.rules[ndx].lst[i].name;
	    var opt=document.createElement("option");
		opt.appendChild(document.createTextNode(gContentRules.rules[ndx].lst[i].name));
		sel.appendChild(opt);
	}

    div.appendChild(sel);

    return ndx;
}


//Populate rules group combo box
PolActions_CS_PopulateGrpRules = function()
{

	//to populate languages
	var lang_div=document.getElementById(K_LANG_DIV);
	if (!lang_div)
        return;
    while(lang_div.firstChild)
        lang_div.removeChild(lang_div.firstChild);
		var selLang = document.createElement("select");
        selLang.id = this.uniquifier + "_langSel";
        selLang.style.marginLeft = "5px";
        selLang.style.width = "150px";
		selLang.onchange= function(){PolActions_CS_LanguageGrp(true);}
		
		//LangList is defined in Strings.js
		for(index in LangList) 
		{
			selLang.options[selLang.options.length] = new Option(LangList[index], index);
		}
		//setting default language here
		selLang.value=GetLang();
	    lang_div.appendChild(selLang);
		
		
	    //to populate corresponding dictionary words
    	var div = document.getElementById(K_GRP_DIV);

    if (!div)
        return;
    while(div.firstChild)
        div.removeChild(div.firstChild);

    if(gContentRules.rules.length>0)
	{
       var sel=document.createElement("select");
	   sel.id=K_GRP_SEL;
	   sel.onchange= function()
			{PolActions_CS_SelectGrp(true);}

	   var lang = GetLang();
	   
	//this for loop is to generate all generic words that is where lang=neutral so that they don't have to be populated everytime a new language is selected
	for(var i=0;i<gContentRules.rules.length;i++)
	   {
		   if(gContentRules.rules[i].lang == "neutral")
		   {
		   	   GenericWCount=GenericWCount+1;
			   var opt=document.createElement("option");
			   opt.value=i;
			   opt.appendChild(document.createTextNode(gContentRules.rules[i].name));
			   sel.appendChild(opt);
		   }
	   }
	   
	//This for loop is to generate all language specific words
	for(var i=0;i<gContentRules.rules.length;i++)
	   {
		   if(gContentRules.rules[i].lang == lang)
		   {
			   var opt=document.createElement("option");
			   opt.value=i;
			   opt.appendChild(document.createTextNode(gContentRules.rules[i].name));
			   sel.appendChild(opt);
		   }
	   }

       div.appendChild(sel);
       PolActions_CS_PopulateRules();
       PolActions_CS_SelectGrp();
    }



}

//returns selected rule group
PolActions_CS_GetSelectGrp = function()
{
    return document.forms[K_FORM].grp_sel.value;
}


//adding function which populates dictionary words based on language change
function PolActions_CS_LanguageGrp(onChange)
{
 var div = document.getElementById(K_GRP_DIV);
 var selLang = document.getElementById(this.uniquifier + "_langSel");
 
    if (!div)
        return;
    	
	if(gContentRules.rules.length>0)
	{
       	var sel=document.getElementById(K_GRP_SEL);
		sel.length=GenericWCount;
	   
	   for(var i=0;i<gContentRules.rules.length;i++)
	    {
		   if(gContentRules.rules[i].lang == selLang.value)
		   {
			   var opt=document.createElement("option");
			   opt.value=i;
			   opt.appendChild(document.createTextNode(gContentRules.rules[i].name));
			   sel.appendChild(opt);
		   }
	    }

       div.appendChild(sel);
       PolActions_CS_PopulateRules();
       PolActions_CS_SelectGrp();
    }

}


//add html text only (in a safe way) in a placeholder - adds &nbsp in the end so that td are not left empty
function PolActions_CS_SetContent(div_id, txt)
{
    var div = document.getElementById(div_id);
    if (div)
	{   div.innerHTML = ""
        if(!txt)
        {  div.style.display = "none";
        }
        else
        {  div.appendChild(document.createTextNode(txt+'\u00A0'));
        }
    }
}

//build the action table
function PolActions_CS_BuildTable(pb)
{
   var ppT = new PropertyPath(setting_pp);
   gContentRules.rulesTable= new PolicyAction (pb, ppT, false);
   var len=0;

   ppT.Append("RuleRef");
   ppT.BeginEnum();
   while(pb.GetProperty(ppT) !== undefined) {
       ppT.SetTempLeaf("id");
       var id = pb.GetProperty(ppT);
       ppT.SetTempLeaf("type");
       var type = pb.GetProperty(ppT);
	   ppT.SetTempLeaf("");

       var str = gContentRules.GetNameFromId(type, id)
       gContentRules.rulesTable.BuildRulesTable(str, type, len, id, ppT.GetPath());
       ppT.IncrementEnum();
       len++;
   }

   ppT.EndEnum();

}//fn


//populate both combo box with rule group and list
function PolActions_CS_SetLists(pb)
{
    gContentRules = new CSRules();
    PolActions_CS_BuildTable(pb);
	gContentRules.BuildGrpRulesList();
    PolActions_CS_PopulateGrpRules();
}




//returns the path to a rulereference  in a policy
//assumes rulesTable is set.
PolActions_CS_FindRuleRefPP = function(id)
{
var pp_str="";
    for (var i=0;i<gContentRules.rulesTable.GetLength();i++ )
    {
        if(gContentRules.rulesTable.GetId(i) == id)
        {   pp_str=gContentRules.rulesTable.GetPath(i);
        }
    }
    if(!pp_str) pp_str="";

    return pp_str;
}

//Add a number of rules
function PolActions_CS_AddRules()
{
	var ret=  PolActions_CS_GetSelect();

	for(var i=0;i<ret.length;i++)
	{

        var pp_str = PolActions_CS_FindRuleRefPP(ret[i].id);

        if( pp_str =="" )
    	{  pp_str= policy_pb.GetNextElementEnum(setting_pp+".RuleRef");

        }

        var ppT=new PropertyPath(pp_str);
        policy_pb.SetProperty(ppT);
	    ppT.SetTempLeaf("type");
		policy_pb.SetProperty(ppT, ret[i].type);
	    ppT.SetTempLeaf("id");
		policy_pb.SetProperty(ppT, ret[i].id);
        ppT.SetTempLeaf("Actions");
		policy_pb.SetProperty(ppT);
 	    ppT.SetTempLeaf("");

		gPolAction = new PolicyAction (policy_pb, ppT, false);
		gPolAction.Apply();
		//get next path;
    	ppT.SetTempLeaf("");

	}
}

//
// Asynchronous data load function
// ppIn is the path to the rule object in create mode,
// or a path to a new rule in update mode
///
function Show(pbIn, ppIn)
{

    policy_pb=pbIn;
	if(top.polctx.polSetting["tmp_pb"])
    {
	      policy_pb=PropertyBag.Recreate(top.polctx.polSetting["tmp_pb"]);
	      top.polctx.polSetting["tmp_pb"]=policy_pb;
    }

     if ("string" == typeof(ppIn))
     {   setting_pp=ppIn;
     }
     else
     {   setting_pp=ppIn.GetPath();
     }


	//initialise page specific components here
	var temp;
	var str;
	var rule_name_p = "";

	if(qparams["name"])
	{
		temp = qparams["name"].toString();;
	
		str = temp.split(',');

		if(str[0])
			 rule_name_p = str[0];//qparams["name"];
	}
		

	if(rule_name_p)
	{  create_flag=false;
       var div = document.getElementById("body_update");
       if(div) div.style.display="";
       gPolAction = new PolicyAction (policy_pb, ppIn, false);
	   gPolAction.Show();
       PolActions_CS_SetContent("rule_act_txt", rule_name_p? rule_name_p:null);

	   if(str[1] == "0")
		{
		   
			var div = document.getElementById("tscr");
			if (div)
			{   
				div.style.display = "none";
				
			}
			div = document.getElementById("mcnt");
			if (div)
			{   
				div.style.display = "none";
				
			}
		}
		else
		{
			
			var div = document.getElementById("tscr");
			if (div)
			{   
				
				div.style.display = "";
				
			}	
			div = document.getElementById("mcnt");
			if (div)
			{   
				div.style.display = "";
				
			}
		} 
    }
	else
	{  create_flag=true;
       var div = document.getElementById("body_create");
       if(div) div.style.display="";
	   PolActions_CS_SetLists(policy_pb);
	}


}
//
// Asynchronous data validation function
function Validate() {

	if(create_flag)
	{
        var ret=PolActions_CS_GetSelect();
        if(ret.length==0)
        {
             alert( resolveString(cse_pp_st, "__select_rule_prompt"))
             return false;
        }

	}

    return true;
}

//
// Asynchronous data save function
// @param pb the property bag to fill
//
function Apply(pb_null,pp_null,save)
{
var change = false;

	if(create_flag)
	{
	   PolActions_CS_AddRules();
	   change = true;
	}
	else
	{
  	   if (gPolAction.Apply())
       {  change = true;
       }
	}

	if (change)
	{  	top.gPageStack.Active().SetModified(true);
	}
	else
	{   top.gPageStack.Active().SetModified(false);
	}

	top.polctx.polSetting["tmp_pb"]=policy_pb;

   	if (!save) return top.gPageStack.Active().pb
}
