// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================
var K_ROOT = 1
var K_NOROOT  = 0

var myItemList = [];
var policySet_pb;
var  page_vf;

//Draw the list of settings combo
function PolNewSetting_DrawSettingsCombo()
{
   var lst=[];
    try {
        var tag = top.polctx.myPolicySet.pp_key;
        if (tag == undefined || pp_ui_flags[tag] == undefined)
        {  tag = "__default"
        }
        lst = pp_ui_flags[tag]["canCreate"];
    }
    catch(e) {}

    if ( !lst || lst.length<=0)
    {    return;
    }

   var combo_div;
   var data_html="<select style='width:240px' id='SETTINGS_SEL'>";

   for (var i=0;i<lst.length ;i++ )
   {  data_html+= ' <option value=' + lst[i] + '> '
      data_html+= resolveString(cse_pp_st,lst[i]);
   }

   data_html+="</select>";

   //dhtml output
   var div = document.getElementById("SETTINGS_DIV");
   if (div) {
   div.innerHTML = data_html;
   }
}

//Get whether time is selected from combo or a new time slot
function PolNewSetting_CheckTimeSrc( elt )
{
      var div = document.getElementById("NEW_TIME_DIV");
	  var sel = document.getElementById("TIME_SEL");
      if (elt.value == "t_new")
      {   div.style.display="";
	      sel.disabled = true;
      }
	  else
	  { div.style.display="none";
	    sel.disabled = false;
	  }
}

//Get whether time is selected from combo or a new time slot
function PolNewSetting_GetTimeSrc( f )
{
var ret;

    if (!f)
        return ret;
    var elems = f.elements;
    for (var i = 0; i < elems.length; i++) {
        var e = elems[i];
        if (e.name == "time_src" && e.checked) {
            ret = e.value;
            break;
        }
    }
    return ret;
}

//return the highest rank in pb
function PolNewSetting_maxRank(typeval, policy_pp)
{
	var regexStr='^' + policy_pp + "\\."+ typeval+"PolicySettings(:\\d{8})*$";
    var pattern=new RegExp(regexStr);
    var res=policySet_pb.GetMatchingPaths(pattern);
	return res.length;
}

//check if an instance with the same id already exist
function PolNewSetting_InstanceClash( typeval, t_id )
{
   if (t_id == "T:ALLTHETIME") t_id="";

   var current_pp_str = top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].pp_path;
   var node_str = "."+ typeval+"PolicySettings"
   current_pp_str+=node_str;

   var ppT=new PropertyPath(current_pp_str);
   ppT.BeginEnum();
   while(policySet_pb.GetProperty(ppT) !== undefined) {
       ppT.SetTempLeaf("RefTimeRestriction");
       var ref_id = policySet_pb.GetPropertyDef(ppT, "");

       if (ref_id == t_id) {
		   return true;
       }
       ppT.IncrementEnum();
   }
   return false;
}

//Create new time restriction
function PolNewSetting_Create(typeval, time_id)
{
     //setup propertypath
     var node_str = "."+ typeval+"PolicySettings"
	 var current_pp_str = top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].pp_path;
	 var root_pp_str = RemoveLeafEnum( current_pp_str ) + node_str;
     var rank=PolNewSetting_maxRank(typeval, current_pp_str);
	 current_pp_str+=node_str;
 	 if (rank>0)
	 {  current_pp_str+= ":" + GetPaddedEnum(rank+1);
	 }

     //copy over
	 var ppT= new PropertyPath(current_pp_str);

	 policySet_pb.SetProperty(ppT);

	 for (var pp in policySet_pb.propValues)
     {
		    if (IsAncestorPathOf(root_pp_str, pp))
		    {
               var c_ppT= new PropertyPath(current_pp_str);
			   var tail=pp.substr(1+root_pp_str.length)
			   c_ppT.Append(tail);
			   policySet_pb.SetProperty(c_ppT, policySet_pb.propValues[pp])
		    }
     }

	 ppT.SetTempLeaf("root");
	 policySet_pb.SetProperty(ppT, K_NOROOT)
 	 ppT.SetTempLeaf("RefTimeRestriction");
	 policySet_pb.SetProperty(ppT, time_id)

	 ppT.SetTempLeaf("");



}

function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp)
{
    var f = document.forms["TIME_FORM"];

	policySet_pb=pbIn;

	PolNewSetting_DrawSettingsCombo();

	page_vf = new ValidationFramework("TIME_FORM");
	page_vf.formAction = std_val_form_action;

	gTimeRestriction = new TimeRestriction(pbIn);
	gTimeRestriction.DrawTimeCombo( "", "", "TIME_DIV", false, ["T:ALLTHETIME"])
	gTimeRestriction.Init(f, page_vf, 1);

    top.gPageStack.Active().SetModified(true);

}

/**
 * Asynchronous data validation function
 */
function Validate() {

   	//get selected Time
    var f = document.forms["TIME_FORM"];
    var t_src=PolNewSetting_GetTimeSrc( f );
	var t_id ="";

	if(t_src=="t_new")
    {
		gTimeRestriction.BuildTimeStrings(f);

		if ( page_vf.onsubmit() )
	    {
           var pp_str= 	gTimeRestriction.TimeClash()
		   if (pp_str != "")
           {
 	           if ( confirm ( resolveString(cse_pp_vf_st,"__existing_time") ) )
			   {    pp_str="";
			   }
           }

		   if(pp_str=="")
		   {  t_id = gTimeRestriction.SaveTimeSlot(policySet_pb, "" );
		   }

        }
    }
	else
    {
        t_id = gTimeRestriction.GetSelProperty("id");
	}

    if (t_id == "")
    {  return false
    }

    //save t_id in hidden form CF
    var uid_ctl=f.time_uid;
	if(uid_ctl)
    {		uid_ctl.value=t_id;
	        return true;
    }

	return false;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb_null,pp_null,save)
{
    var uid_ctl =  document.getElementById("time_uid");
	var t_id = uid_ctl.value;

    var typesel=document.getElementById("SETTINGS_SEL");
	if (typesel)
	{
	    typeval=typesel.options[typesel.selectedIndex].value;
	    if (typeval=="")
	    {   return top.gPageStack.Active().pb
	    }
    }

    if (t_id !="")
	{
        if ( !PolNewSetting_InstanceClash( typeval, t_id ) )
        {   PolNewSetting_Create(typeval, t_id);
	    }
	}

	return top.gPageStack.Active().pb
}

