// Copyright (C) 2017 McAfee, Inc.  All rights reserved.
//
// Description:
// Included in any PolSettingView_*.html page
//====================================================================================
// Consts
//====================================================================================
var K_DELETED = 2
var K_ROOT = 1
var K_NOROOT  = 0

//====================================================================================
// globals and flags for this page
//====================================================================================
//policy_pb is the master ptoperty bag
//polsetting_pb is a local pb if newly created setting

var myPbIn;
var options_pb;
var policy_pp = top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].pp_path;
var policy_pb = null;
var polSetting_pp = null;
var polSetting_pb = null;
var pageProp=[];
var g_activatable = true;

//====================================================================================
// Draw and data management
//=====================================================================================

//Hide some html element
function PolSetting_DhtmlHide(div_id)
{
    var div = document.getElementById(div_id);
    if (div) div.style.display = "none";
}

//update dhtml - adds &nbsp in the end so that td are not empty
function PolSetting_DhtmlWrite(div_id, dhtml)
{
    var div = document.getElementById(div_id);
    if (div)
	{    div.innerHTML = dhtml + " &nbsp;"
    }

}

//add html text only (in a safe way) - adds &nbsp in the end so that td are not left empty
function PolSetting_TxtWrite(div_id, txt)
{
    var div = document.getElementById(div_id);
    if (div)
	{   div.innerHTML = ""
        div.appendChild(document.createTextNode(txt+'\u00A0'));
    }
}

//enable/disable controls and links depending on the status of inherit checkbox
function PolSetting_CheckInherit()
{
   var inherit = document.getElementById("INHERITS_CTL");
   var i;

   var inherited = inherit.checked;
   pageProp["inherit"]=inherited;

   var enabledState={"ACTIVE_CTL":inherited || !g_activatable, "TIME_SEL":inherited, "OPTIONS_SEL":inherited};
   for (var id in enabledState)
   {  var ctl= document.getElementById(id);
	     if (!ctl) continue;
         ctl.disabled=enabledState[id];
   }

   var lnk_ids= ["OPTIONS_LNK", "ACTIONS_LNK"];
   for (i=0;i<lnk_ids.length ; i++ )
   {   var lnk= document.getElementById(lnk_ids[i]);
	    if(!lnk) continue;

		if (inherit.checked) lnk.style.display="none";
		else lnk.style.display="";
   }


   return inherit.checked;

}

//utility function to enable apply and cancel button
//except when inherit is true
function PolSetting_SetModify()
{
   var inherit_ctl = document.getElementById("INHERITS_CTL");
   top.gPageStack.Active().SetModified(true);

   if (inherit_ctl.checked)
   {   var ndx = pageProp["ndx"];
	   if ( myPolicySettingsList.settings[ndx].pp_local=="" )
       {   top.gPageStack.Active().SetModified(false);
	   }
   }
}


//update local property bag and store it in top frame if relevant
//refopt_typeval: type of settings, if there is a settings id to store
//topStore: should be true if we store before going to a child page
// false when called from Apply
function PolSetting_StoreLocalCopy( topstore, refopt_typeval )
{
	var ndx = pageProp["ndx"];

  var inherit_ctl = document.getElementById("INHERITS_CTL");
  var active_ctl  = document.getElementById("ACTIVE_CTL");

  var inherit;
  var enabled;

  if (inherit_ctl.checked) inherit=1
  else inherit=0;
  if (active_ctl.checked) enabled=1
  else enabled=0;

  var ppT = new PropertyPath(polSetting_pp);
  ppT.SetTempLeaf("enabled");
  polSetting_pb.SetProperty(ppT.GetPath(), enabled);
  
  if ( myPolicySettingsList.settings[ndx].name=="File Filtering")
  {
	var scan_embedded = document.getElementById("Scan_For_Embedded");
	var scan_enabled;

	if (scan_embedded.checked) scan_enabled=1
	else scan_enabled=0;
  
    var pp_ScanEmbedded = new PropertyPath(polSetting_pp);
    pp_ScanEmbedded.Append("CSESettings");
    polSetting_pb.SetProperty(pp_ScanEmbedded);
    pp_ScanEmbedded.SetTempLeaf("ScanForEmbedded");
    polSetting_pb.SetProperty(pp_ScanEmbedded.GetPath(), scan_enabled);
  }
  //if 2nd param exists,
  //retrieve options id from the selection in options combo
  if(refopt_typeval)
  {
     ppT.SetTempLeaf("RefSettings");

     var opt_ppT = PolSetting_GetOptionsPath(refopt_typeval);
     var settingsRef = "";
     if(opt_ppT)
     {   opt_ppT.SetTempLeaf("id");
         settingsRef = options_pb.GetProperty(opt_ppT);
         polSetting_pb.SetProperty(ppT.GetPath(), settingsRef);
     }

     if (settingsRef && this.pp_cse_settingsDependencies &&
        this.pp_cse_settingsDependencies[refopt_typeval]) {
         // This category has dependent settings
         var dependencyList = pp_cse_settingsDependencies[refopt_typeval];
         for (var i = 0; i < dependencyList.length; i++) {
             var depSettingsType = dependencyList[i];
             var ppDep = ppT.toString().replace(refopt_typeval, depSettingsType);
             var depSRef = settingsRef.replace(refopt_typeval, depSettingsType);
             polSetting_pb.SetProperty(ppDep, depSRef);
         }
     }
  }

  var reftime = gTimeRestriction.GetSelProperty("id");
  ppT.SetTempLeaf("RefTimeRestriction");
  polSetting_pb.SetProperty(ppT.GetPath(), reftime);


  top.polctx.polSetting["pb"] = undefined;
  if (topstore)
  {
	  if (top.gPageStack.Active().modified)
      {    top.polctx.polSetting["pb"] = polSetting_pb;
           top.polctx.polSetting["inherit"] = inherit;
      }
  }
  return inherit;
}

//retrieve property bag from top frame
function PolSetting_RestoreLocalCopy()
{
	if (top.polctx.polSetting["pb"] != undefined)
	{
	      for (var prop in top.polctx.polSetting["pb"].propValues)
	      {    polSetting_pb.propValues[prop] = top.polctx.polSetting["pb"].propValues[prop];
	      }
		  pageProp["inherit"] = top.polctx.polSetting["inherit"];
	}

   	if (top.polctx.polSetting["newInst"] != undefined)
    {
          if( top.polctx.newInstance)
          {
               var ppT = new PropertyPath(polSetting_pp);
               ppT.SetTempLeaf("RefSettings");
               polSetting_pb.SetProperty(ppT.GetPath(), top.polctx.newInstance);
               top.polctx.newInstance=undefined;
               top.gPageStack.Active().SetModified(true);
          }

          top.polctx.polSetting["newInst"]=undefined;

    }

    top.polctx.polSetting["pb"]=undefined;
	top.polctx.polSetting["inherit"]=undefined;
}

//create local copy of property bag for custom values.
//and update with any data saved with StoreLocalCopy
function PolSetting_CreateLocalCopy()
{

    polSetting_pb=new PropertyBag();

	var ndx = pageProp["ndx"];
	var typeVal =  myPolicySettingsList.settings[ndx].typeval;

	var localPP_str=myPolicySettingsList.settings[ndx].pp_local;

	if (localPP_str=="")
	{   var regexStr='^' + policy_pp + "\\."+ typeVal+"PolicySettings(:\\d{8})*$";
	    var pattern=new RegExp(regexStr);
        var res=policy_pb.GetMatchingPaths(pattern);

		localPP_str= policy_pp + "."+ typeVal+"PolicySettings"
		if (res.length>0)
		{  localPP_str+= ":" + GetPaddedEnum(res.length+1);
		}

		//now copy ancestor across

		var anc_pp=myPolicySettingsList.settings[ndx].pp_ancestor;
		var ppT= new PropertyPath(localPP_str);
		polSetting_pb.SetProperty(ppT, policy_pb.propValues[anc_pp])

		for (var pp in policy_pb.propValues)
	    {
		    if (IsAncestorPathOf(anc_pp, pp))
		    {
               var c_ppT= new PropertyPath(localPP_str);
			   var tail=pp.substr(1+anc_pp.length)
			   c_ppT.Append(tail);
			   polSetting_pb.SetProperty(c_ppT, policy_pb.propValues[pp])
		    }
        }

		ppT.SetTempLeaf("root");
		polSetting_pb.SetProperty(ppT, K_NOROOT)
		ppT.SetTempLeaf("");

	    pageProp["inherit"] = true;

	}
	else
	{   policy_pb.GetElement( new PropertyPath(localPP_str), polSetting_pb);
		pageProp["inherit"] = false;
	}

    polSetting_pp=localPP_str;
    PolSetting_RestoreLocalCopy();

}

//get pb, either the policySet or the local pb
function PolSetting_GetPb()
{
    var ctl= document.getElementById("INHERITS_CTL");
	var ndx = pageProp["ndx"];

	if (ctl.checked)
	{    return policy_pb;
	}
	else
	{   return polSetting_pb;
	}
}

//get pp_str, either the ancestor or custom
function PolSetting_GetPPStr()
{
    var ctl= document.getElementById("INHERITS_CTL");
	var ndx = pageProp["ndx"];

	if (ctl.checked)
	{    return myPolicySettingsList.settings[ndx].pp_ancestor;
	}
	else
	{    return polSetting_pp;
	}
}

//return polsetting property, either from local property bag, or from ancestor in policyset pb
function PolSetting_GetPPNode( node )
{
	var ppT = new PropertyPath (PolSetting_GetPPStr());
	if (node!="")
	{  ppT.Append(node);
	}

	return ppT

}


//return polsetting property, either from local property bag, or from ancestor in policyset pb
function PolSetting_GetProp(key)
{
   var ndx = pageProp["ndx"];
   var ctl= document.getElementById("INHERITS_CTL");

   //if inheritance selection has not changed
   var ppT = new PropertyPath (PolSetting_GetPPStr())

   if (ctl.checked==true)
   {
	   ppT.SetTempLeaf(key);
	   return myPbIn.GetProperty(ppT);
   }
   else
   {
	   ppT.SetTempLeaf(key);
	   return polSetting_pb.GetProperty(ppT);
   }
}

//check if local time is same as existing time for another instance
function PolSetting_FindTimeClash( time, pp_str , typeval)
{
    if (time == "T:ALLTHETIME") time = "";
	var ndx = pageProp["ndx"];


	for (var i=0;i< myPolicySettingsList.settings.length; i++ )
	{ 	if ( (myPolicySettingsList.settings[i].typeval == typeval) &&
		     ( myPolicySettingsList.settings[i].time == time )&&
	         ( myPolicySettingsList.settings[i].pp_local !=  pp_str ) )
		{
  			 //if (myPolicySettingsList.settings[i].pp_local =="") return false;

			 if (i!=pageProp["ndx"])
				   return true;


		}
	}

	return false;
}

//extract data from local property bag if they are there,
// or use global otherwise
function PolSetting_GetSettingsOptions(pbIn)
{
var pbT = new PropertyBag();

        if (undefined === pbIn.GetProperty("Settings"))
		{
            // Copy the Settings node locally
            top.gPB.GetElement("Settings", pbT);
        }
		else
	    {
			pbIn.GetElement("Settings", pbT);
	    }

		return pbT;
}

//Draw the activation info
function PolSetting_DrawActivate()
{
	var ndx = pageProp["ndx"];

	var div_id= document.getElementById("INHERITS_DIV");
	var ctl_inherit= document.getElementById("INHERITS_CTL");
    var ctl= document.getElementById("ACTIVE_CTL");
    var div_time= document.getElementById("TIME_DIV");

	if ( myPolicySettingsList.settings[ndx].pp_ancestor=="") div_id.style.display = "none";
    else div_id.style.display = "block";
    ctl_inherit.checked = pageProp["inherit"];

	var ppT = new PropertyPath (PolSetting_GetPPStr());
    var pb=PolSetting_GetPb();

    ppT.SetTempLeaf("enabled");
    ctl.checked = pb.GetProperty(ppT);
    g_activatable = myPolicySettingsList.settings[ndx].activatable;
	
	if ( myPolicySettingsList.settings[ndx].name=="File Filtering")
	{
		var scan_embedded= document.getElementById("Scan_For_Embedded");

		var pp_ScanEmbedded = new PropertyPath(PolSetting_GetPPStr());
		pp_ScanEmbedded.Append("CSESettings");
		//var scnEmbedded_pb=PolSetting_GetPb();
		
		pp_ScanEmbedded.SetTempLeaf("ScanForEmbedded");
		scan_embedded.checked = pb.GetProperty(pp_ScanEmbedded);
		g_activatable = myPolicySettingsList.settings[ndx].activatable;
	}

	//hide time if there is an ancestor of same value or if it is root
	div_time.style.display = "block";
    ppT.SetTempLeaf("root");
	if (pb.GetProperty(ppT)==1)  div_time.style.display = "none";
	if ( myPolicySettingsList.settings[ndx].pp_ancestor!="") div_time.style.display = "none";

}


//convert time key into a string for the time combo
function PolSetting_TimeStr(key)
{
var res=""
   if (key!="")
   {   res=' (' + ReplaceSpecialHTMLChars(gTimeRestriction.GetDisplayName(key)) +') ';
   }
   return res;
}


//Draw the list of settings combo
function PolSetting_DrawSettingsCombo(settingsList, sel)
{
var len= settingsList.index.length;
var combo_div;

 var data_html=' <b>' + resolveString(cse_pp_st, "__select_settings") + ': </b> ';

   //select element
   data_html +=  '&nbsp <select id="SETTING_SEL" onChange="javascript:PolSetting_SelectFromCombo(this)" >'

   //draw the tables
   for (var i=0;i<len ;i++ )
   {  var ndx = settingsList.index[i];
      if (ndx==sel) data_html+= '<option selected> '
      else data_html+= '<option> '

      data_html+= settingsList.settings[ndx].name
      data_html += PolSetting_TimeStr(settingsList.settings[ndx].time);
   }
   data_html +="</select>"

  //dhtml output
  var div = document.getElementById("SETTINGSLST_DIV");
  if (div) {
  div.innerHTML = data_html;
  }
}

//Select appropriate option depending on inherit/local value
function PolSetting_SetOptionsSel(typeval)
{
   var the_combo= document.getElementById("OPTIONS_SEL");
   if (!the_combo) return;
   var sel=0;

    var refid = PolSetting_GetProp("RefSettings");

    var options_pp = new PropertyPath("Settings");
	options_pp.Append(typeval + "Settings");

    options_pp.BeginEnum();

    while(options_pb.GetProperty(options_pp) !== undefined)
	{
	   options_pp.SetTempLeaf("id");
	   var id= options_pb.GetProperty(options_pp);

	   if (id==refid)
	   {	   the_combo.selectedIndex=sel;
	   }
       options_pp.IncrementEnum();
	   sel++;
    }
    options_pp.EndEnum();
}


//Draw the combo for settings options
function PolSetting_DrawOptionsCombo( typeval, div_id)
{
	var sel = PolSetting_GetProp("RefSettings");
	var dhtml = ' <b>'+ resolveString(cse_pp_st, "__select_options") + ': </b> ' ;
	dhtml += '&nbsp <select onChange=javascript:PolSetting_' + typeval + '_SelectFromOptions(this) '
	dhtml += ' id=\"OPTIONS_SEL\" '
	dhtml += ' name= "' + typeval + 'Settings" >'


    var options_pp = new PropertyPath("Settings");
	options_pp.Append(typeval + "Settings");

    options_pp.BeginEnum();
    while(options_pb.GetProperty(options_pp) !== undefined) {
       options_pp.SetTempLeaf("displayName");
       var name = options_pb.GetProperty(options_pp);
	   options_pp.SetTempLeaf("id");
	   var id= options_pb.GetProperty(options_pp);

       dhtml += "<option value=\"" + id + "\"";
	   if (id==sel) dhtml += " selected"
	   dhtml += "> "

       dhtml += resolveString(cse_pp_st, name);

       options_pp.IncrementEnum();
    }
    options_pp.EndEnum();
    dhtml += "<option> " + '&lt; ' + resolveString(cse_pp_st, "__create_instance") + ' &gt;';
    dhtml += "</select>"
    //dhtml output
    var div = document.getElementById(div_id);
    if (div) {
    div.innerHTML = dhtml;
    }
}


//=========================================================
// Common parts for Mandatory Functions
//=========================================================

function PolSetting_Draw() {

	//draw the activate information
    PolSetting_CreateLocalCopy();
	PolSetting_DrawActivate();

	var ndx = pageProp["ndx"];
    var ppT = new PropertyPath(PolSetting_GetPPStr());
	var pbT = PolSetting_GetPb();
    ppT.SetTempLeaf("RefTimeRestriction");
	var time_id = pbT.GetPropertyDef(ppT, "");

	var time_label = resolveString(cse_pp_st, "__what_time") + ' :  &nbsp' ;
	var allow_create=false;
	gTimeRestriction.DrawTimeCombo(time_label, time_id, "TIME_DIV", allow_create, []);

	PolSetting_DrawSettingsCombo(myPolicySettingsList, ndx);

	return polSetting_pp;

}

function PolSetting_Show(pbIn) {
    myPbIn = pbIn;
	policy_pb=pbIn;
    policy_pp = top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].pp_path;
	options_pb = PolSetting_GetSettingsOptions(pbIn);
    gTimeRestriction = new TimeRestriction(pbIn);
	myPolicySettingsList.populate(policy_pb, policy_pp)

    var lst=myPolicySettingsList.settings;
	pageProp["ndx"]=0;
	for (var i=0; i<lst.length;i++)
	{  if (lst[i].typeval==top.polctx.polSetting["typeval"])
	   {
		    if (lst[i].time==top.polctx.polSetting["time"])
	        {   pageProp["ndx"]=i;
			    break;
            }

	        if (lst[i].time=="" || lst.time=="T:ALLTHETIME")
	        {  pageProp["ndx"]=i;
			}
	   }

	}

   return PolSetting_Draw();
}

//Saves parameters for this page
//parameters
//typeval = identify settings type
//merge = remove settings elements first
function PolSetting_Apply( typeval, safe_merge) {

  inherit = PolSetting_StoreLocalCopy( false, typeval );

  var ndx = pageProp["ndx"];
  //update policy property bag
  if (inherit==1)
  {    var prev_inherit=0;

	   if ( myPolicySettingsList.settings[ndx].pp_local == "")
	   {   //nothing changed
		   return;
	   }
	   else
	   {  //we need to delete the current setting
	      policy_pb.DeleteElement(myPolicySettingsList.settings[ndx].pp_local);
 	   }
  }
  else
  {    //check clash of time restriction
       var reftime = gTimeRestriction.GetSelProperty("id");
       if (  PolSetting_FindTimeClash( reftime, polSetting_pp, typeval ) )
	   {    alert(resolveString(cse_pp_st,"__time_clash"));
	   }
       else
	   {
          //remove properties from master property bag
          //Just delete the element without altering the enumeration count.
	      if(safe_merge) policy_pb.DeleteSingleElement(myPolicySettingsList.settings[ndx].pp_local);

          //just merge property bags, exclude reftime if it is all the time
	      for (var prop in polSetting_pb.propValues)
	      {    policy_pb.propValues[prop] = polSetting_pb.propValues[prop];

			   //delete time restriction if it is all the time
		       if (policy_pb.propValues[prop] == "T:ALLTHETIME" &&
				   prop.substr(prop.lastIndexOf(".")+1) == "RefTimeRestriction")
		       {     policy_pb.DeleteElement(prop);
		       }
	      }
       }

  }
  return policy_pb;

}

//====================================================================================
// Links to other pages
//====================================================================================

/*
 * Navigate to another Settings page
 */
function PolSetting_SelectFromCombo(the_combo)
{
    var sel = the_combo.selectedIndex;
	var ndx=myPolicySettingsList.index[sel];

	Policy_GotoSettingView(myPolicySettingsList.settings, ndx );
}

/*
 * build the path from the rank of the options in the select (or any other list)
 * typeval: type of the settings
 * sel_id:  options combo
 */
function PolSetting_GetOptionsPath(typeval)
{
    //get selection from the combo
	var the_combo=document.getElementById("OPTIONS_SEL");
	var sel=0;
	var level_name=typeval+"Settings";

    if (the_combo)
    {   sel = the_combo.selectedIndex
    }
	else
	{
		return undefined;
	}

    var options_pp = new PropertyPath("Settings");

	var str_enum = ""
	if (sel>0)
	{   str_enum = GetPaddedEnum(sel+1);
        level_name += ":" + str_enum;
    }

	options_pp.Append(level_name);

    return options_pp;

}


// Opens the options edit page depending onthe selectionin combo box
// url: file name of the relevant html page
function PolSetting_EditOptions(typeval)
{

    var ctl= document.getElementById("INHERITS_CTL");
	if (ctl.checked)
    {     alert("_Options are inherited from parent policy");
	      return;
	}

    //save current changes first
    PolSetting_StoreLocalCopy( true, typeval );

    //goto option page
	var id;

	var url=typeval+"Settings.html"
	var title = typeval;

	var ppT=PolSetting_GetOptionsPath(typeval);

    //ppT.SetTempLeaf("id");
	//var idT = options_pb.GetProperty(ppT);
	//ppT.SetTempLeaf("");
	//var target= uriAppend(url, "id", idT);

    var target= url;
    var page = new DialogPage(target, resolveString(cse_pp_st, title));
    top.gPageStack.Forward(page, ppT.GetPath());

}

// Opens the options edit page depending onthe selectionin combo box
// url: file name of the relevant html page
function PolSetting_EditOptionsTab(typeval, query)
{

    var ctl= document.getElementById("INHERITS_CTL");
	if (ctl.checked)
    {     alert("_Options are inherited from parent policy");
	      return;
	}

    //save current changes first
    PolSetting_StoreLocalCopy( true, typeval );

    //goto option page
	var id;

	var url=typeval+"Settings.html" + query;
	var title = typeval;

	var ppT=PolSetting_GetOptionsPath(typeval);

    //ppT.SetTempLeaf("id");
	//var idT = options_pb.GetProperty(ppT);
	//ppT.SetTempLeaf("");
	//var target= uriAppend(url, "id", idT);

    var target= url;
    var page = new DialogPage(target, resolveString(cse_pp_st, title));
    top.gPageStack.Forward(page, ppT.GetPath());

}

//called when selection in the option combo box changes
function PolSetting_OnOptionsSel(the_combo, typeval)
{

    var sel = the_combo.selectedIndex;

    //create a new instance?
	if (sel==the_combo.length-1)
	{   top.polctx.polSetting["newInst"]=typeval;
		PolSetting_StoreLocalCopy( true, typeval);
		var ppT = PolSetting_GetOptionsPath(typeval)
		var page = new DialogPage( typeval+"Settings.html", resolveString(cse_pp_st, typeval));
		top.gPageStack.Forward(page, ppT.GetPath());
		return false;
	}

    PolSetting_SetModify();
    return true;
}

//link to action page
//typeval=type of the page
// generic: true if the page is generic and we can't use typeval
function PolSettings_Actions(typeval, generic)
{

	var pg=top.gPageStack.Active();
    var ctl= document.getElementById("INHERITS_CTL");
	if (ctl.checked)
    {     alert("_Actions are inherited from parent policy");
	      return;
	}

	PolSetting_StoreLocalCopy( true, typeval);

    // Lookup the title
    var title = "";
    var key = typeval + "_ACT_PAGE_TITLE";
    if (null != cse_pp_st[key]) {
        title = resolveString(cse_pp_st, key);
    }
    else {
        var inserts = [resolveString(cse_pp_st, typeval)];
        title = resolveString(cse_pp_st, "ACT_PAGE_TITLE", inserts);
    }

	var target = generic ? ("GenActions.html?type=" + typeval) : "PolActions_" + typeval+".html";
    var page = new DialogPage( target , title );
	top.gPageStack.Forward(page, polSetting_pp);

}
