// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//

//====================
//Globals and constant
//====================
var AVPageProp=new Object;

//====================================================================================
// Draw and data management
//=====================================================================================
function PolSetting_AV_DrawOpt_SCANWHAT (pp, div)
{   var prop;
    var key= "AVP_SCANWHAT"
	var dhtml="";

	var pb=options_pb; //use global options pb.

	pp.SetTempLeaf(key);
	prop = pb.GetPropertyDef(pp, "");

	if (prop!="")  dhtml = resolveString(cse_pp_st, "OPT_" + key + "_" + prop);

    //dhtml output
	dhtml+=" &nbsp;"
    var div = document.getElementById(div);
    if (div) div.innerHTML = dhtml;
}

function PolSetting_AV_DrawOpt_AVP (pp, div)
{   var prop;
    var dhtml="";
    var keys = [ "AVP_DECOMPARCHIVES",
		         "AVP_HEURISTICANALYSIS",
		         "AVP_MACROANALYSIS",
		         "ArtemisSensitivityLevel",	
		         "AVP_SCANALLMACROS",
		         "AVP_FINDALLMACROS",
		         "AVP_DELETEALLMACROS"
	           ];

	var pb=options_pb; //use global options pb.

    for (var i=0;i<keys.length ; i++ )
    {  	pp.SetTempLeaf(keys[i]);
	    prop = pb.GetPropertyDef(pp, keys[i],0);
		//Check dropdown prop value incase of ArtemisSensitivityLevel option it will return 0 to 4 incase of enabled
		prop = (keys[i] == "ArtemisSensitivityLevel" && prop >= 0 ) ? 1 : prop;
		if (prop == 1)
		{  if(dhtml!="") dhtml+=", "
		   dhtml+= resolveString(cse_pp_st, "OPT_" + keys[i])
		}
    }

    //dhtml output
	dhtml+=" &nbsp;"
    var div = document.getElementById(div);
    if (div) div.innerHTML = dhtml;

}

//Displays special cases malware
function PolSetting_AV_AdvMAL (pb, pp_str)
{
    var txt="";
    var ppT = new PropertyPath(pp_str);
    ppT.Append("SpecificVirusName");

    ppT.BeginEnum();

    while(pb.GetProperty(ppT) !== undefined)
    {
       if(txt!="") txt+=", ";
       txt  += pb.GetPropertyDef(ppT,"");
       ppT.IncrementEnum();
    }

    return txt;
}


//Displays special cases malware
function PolSetting_AV_DrawOpt_MAL (pp, div)
{   var prop;
    var dhtml="";
    var keys = [ "BackdoorProtection",
		         "DropperProtection",
		         "DownloaderProtection",
		         "HtmlProtection",
		         "IrcProtection",
		         "JscriptProtection",
	             "MassMailerProtection",
				 "PasswordStealerProtection",
				 "ProxyProtection",
				 "ReplyMailerProtection",
				 "TrojanProtection",
				 "WormProtection"
	           ];


	var pb=options_pb; //use global options pb.

    for (var i=0;i<keys.length ; i++ )
    {  	pp.SetTempLeaf(keys[i]);
	    prop = pb.GetPropertyDef(pp, 0);
		if (prop==1)
		{  if(dhtml!="") dhtml+=", "
		   dhtml+= resolveString(cse_pp_st, "OPT_" + keys[i])
		}
    }

    pp.SetTempLeaf("SpecificVirusProtection");
	prop = pb.GetPropertyDef(pp, 0);
	if (prop==1)
	{
          pp.SetTempLeaf("");
          var txt = PolSetting_AV_AdvMAL (pb, pp.GetPath())
          if(dhtml!="") dhtml+=", "
          dhtml += txt;
	}

    //dhtml output
    AVPageProp["MAL"]=dhtml;
	dhtml+=" &nbsp;"
    var div = document.getElementById(div);
    if (div) div.innerHTML = dhtml;

}


//Displays packers to be detected
function PolSetting_AV_DrawOpt_PCK (pp, div)
{
	var dhtml="";
	var pb=options_pb;

    pp.SetTempLeaf("AVP_SHOWCOMPRESSED");
	var flag_enable=pb.GetPropertyDef(pp, 0) - 0;

	if(flag_enable==1)
    {

        pp.SetTempLeaf("PackerNamePattern");
	    var prop = pb.GetPropertyDef(pp, "");

        if (prop =="")
        {   prop = resolveString(cse_pp_st,"__none_specified");
		}

		pp.SetTempLeaf("PackerExclusion");
	    var flag = pb.GetPropertyDef(pp, 0) - 0;

	    if (flag == 0) dhtml = resolveString(cse_pp_st, "OPT_PCK_EXCLUDE") + " : ";
	    else dhtml = resolveString(cse_pp_st, "OPT_PCK_DETECT") + " : ";
		dhtml += prop;

    }
	else
	{   dhtml += resolveString(cse_pp_st,"__no_detection");
	}


    //dhtml output
	dhtml+=" &nbsp;"
    var div = document.getElementById(div);
    if (div) div.innerHTML = dhtml;

}


//Displays pup to be detected
function PolSetting_AV_DrawOpt_PupTypes (pp, div)
{
	var dhtml="";

    pp.SetTempLeaf("AVP_PROGRAM");
	var flag_enable=options_pb.GetPropertyDef(pp, 0) - 0;



    if(flag_enable==1)
	{   var pTypes = ["PUP_SPYWARE", "PUP_ADWARE", "PUP_REMOTE_ADMIN", "PUP_DIALERS",
        "PUP_PWD_CRACKERS", "PUP_JOKE_PROGRAMS", "PUP_COOKIES", "PUP_OTHER"];
 	    pp.SetTempLeaf("PupTypes");
	    var prop = options_pb.GetPropertyDef(pp, "0") - 0;

	    var inputs = new Array();
        for (var i=0; i < pTypes.length; i++)
	    {
           var mask = 1 << i;
           if (0 != (prop & mask))
           {  if(dhtml!="") dhtml+=", ";
              dhtml+= resolveString(cse_pp_st, "OPT_" + pTypes[i])
           }
        }
     }
     else
     {  dhtml = resolveString(cse_pp_st,"__no_detection");
     }

    //dhtml output
	dhtml+=" &nbsp;"
    var div = document.getElementById(div);
    if (div) div.innerHTML = dhtml;

}

//param is the path to the settings
function PolSetting_AV_DrawOptions()
{
  var pp_str="";
  var ppT = PolSetting_GetOptionsPath("AV", "OPTIONSLST_DIV")

  PolSetting_AV_DrawOpt_SCANWHAT (ppT, "opt_div_SCANWHAT");
  PolSetting_AV_DrawOpt_AVP (ppT, "opt_div_AVP");
  PolSetting_AV_DrawOpt_MAL (ppT, "opt_div_MAL")
  PolSetting_AV_DrawOpt_PCK (ppT, "opt_div_PCK");
  PolSetting_AV_DrawOpt_PupTypes (ppT, "opt_div_PUP");
}

function PolSetting_AV_Actions()
{
    top.polctx.polSetting["MAL"] = AVPageProp["MAL"];
    PolSettings_Actions('AV');
}

//draw the actions in place in the page _ assumes the div are present
// pb:property bag to read from
// pp:path to the actual setting
function PolSetting_AV_DrawActions()
{

  var pb=PolSetting_GetPb();
  var pp = PolSetting_GetPPNode("");

  var act_obj= new PolicyAction (pb, pp, false);
  var len=0;

  len=act_obj.BuildTableAV("Action", 0, "AV");
  act_obj.BuildTable("MaliciousActions", len, "AV");
  act_obj.BuildTable("PackerActions", len+1, "AV");
  act_obj.BuildTable("PupActions", len+2, "AV");
  len= act_obj.GetLength();

  //build dhtml
  var dhtml="";

  dhtml= '<table border="0" cellpadding="0" cellspacing="0"  class="dataSubTable" width="100%">'
  dhtml += '<tr class="header">'
  dhtml += '<td class="dst"><span class="bold">' + resolveString(cse_pp_st , "ACTTITLE_AV") + '</span></td>'
  dhtml += '<td class="dst eor noLeft" align=right> <A href="javascript:PolSetting_AV_Actions()" class=BlueLink id="ACTIONS_LNK">'+resolveString(cse_pp_st , "__edit")+'</a> </td>'
  dhtml += '</tr>'

  for (var i=0;i<len; i++ )
  {
	  var sk="ACT_AV_" + act_obj.GetKey(i)
	  var cl="";
	  if (i<len-1) cl='class="row1"'
      else cl='class="row1 lastRow"'

	  dhtml += '<tr ' + cl + ' > <td  class="dst">'
	  dhtml += resolveString(cse_pp_st, sk)
	  dhtml +='</td><td class="dst eor ">'
	  dhtml += act_obj.GetVal(i)
	  dhtml +='</td></tr>'
  }

  dhtml += '</table><BR>'

  //dhtml output
  var div = document.getElementById("act_div");
  if (div) {
  div.innerHTML = dhtml;
  }
}


//=========================================================
// Functions called when user interact with controls
//=========================================================

//on selection in the options combo box,
//call create option page or refresh current page
function PolSetting_AV_SelectFromOptions(the_combo)
{
    if (PolSetting_OnOptionsSel(the_combo, "AV"))
	{    PolSetting_AV_DrawOptions();
	}
}

//inherit checkbox onclick
function OnclickInherit(val)
{   PolSetting_SetModify();
    PolSetting_SetOptionsSel("AV")
    PolSetting_AV_DrawActions();
    PolSetting_AV_DrawOptions();
    PolSetting_CheckInherit();
}

//=========================================================
// Mandatory Functions
//=========================================================

/**
 * Asynchronous data load function
 * enumerate all policyset until the one with the right name is found
 */
function Show(pbIn, null_pp)
{
    PolSetting_Show(pbIn);
	PolSetting_AV_DrawActions();
	PolSetting_DrawOptionsCombo("AV", "OPTIONSLST_DIV");
    PolSetting_AV_DrawOptions();
	PolSetting_CheckInherit();

    //clean up any temporary string
    if (top.polctx.polSetting["MAL"])
    {  top.polctx.polSetting["MAL"]=null;
    }
}


function Cancel()
{
    PolSetting_Draw();


	PolSetting_AV_DrawActions();
	PolSetting_DrawOptionsCombo("AV", "OPTIONSLST_DIV");
    PolSetting_AV_DrawOptions();
	PolSetting_CheckInherit();
    top.gPageStack.Active().SetModified(false);
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    return true;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb,pp,save) {

    PolSetting_Apply("AV", false);
   	if (!save) return top.gPageStack.Active().pb
}




