// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
// Generic functions to handle the Alert Editor in the policy Action pages
// Global plain-text flag
var g_pt = null;

//Ctr
//members are :
//@policy_pb : pb to get information from for this policy
//@alert_pb : pb where alerts resources are stored (not necessariy the same as policy_pb)
//@pp : property path to the policy settings alerts blob
//@AlertEditors : array of initialised Alert Editors objects
//@alert_pp : base pp to the alert blob
//@lst: list of available alerts
function PolicyAlerts(name)
{
   this.policy_pb="";
   this.alert_pb="";
   this.pp="";
   this.alert_editors=[];
   this.resource_managers;
   this.base_alert_pp = "Alerts.Alert";
   this.databindings=gAlertsDataBindings;
   this.name=name;
}

//Register an alert global object
//Params:
//@the_category: Alert category (eg, "AV_REPLACEMENT")
//@the_leave:property leave in PolicySetting blob
//@the_ae_id=unique id for the list element, used to prefix related html components
//other items registered (created at init time):
//name: name of the AlertEditor global variable
//ref_id=alert reference id, as used in the config file

PolicyAlerts.prototype.Register = function(the_ae_id, the_category, the_leave, the_width, the_height)
{


    this.alert_editors.push( { obj:null,
                           width:the_width,
		                   height:the_height,
                           cat:the_category,
                           leave:the_leave,
                           ae_id:the_ae_id,
                           name:"",
                           ref_id:"",
                           lst:[]}
                                  );
}

//Utility function that returns the form corresonding to an index
PolicyAlerts.prototype.GetForm = function(ndx)
{
    var ae_id=this.alert_editors[ndx].ae_id;
	var f = document.forms[ae_id+"_fld_form"];
	return f;

}

//Utility function that returns the id correspondig to an index
PolicyAlerts.prototype.GetId = function(ndx)
{
    return this.alert_editors[ndx].ae_id;
}



//Utility function that get the alert id from the policy setting blob
//param: @leave=alert leave property
PolicyAlerts.prototype.GetPolAlertId = function(leave)
{
	var ppT = new PropertyPath(this.pp);
	ppT.SetTempLeaf(leave);
    return this.policy_pb.GetPropertyDef(ppT, "")
}

//Store alert id in policy setting
PolicyAlerts.prototype.SavePolAlertId = function(leave, ref_id)
{

	var ppT = new PropertyPath(this.pp);
	ppT.SetTempLeaf(leave);
    this.policy_pb.SetProperty(ppT, ref_id);
	return true;
}

//Update alert header
PolicyAlerts.prototype.UpdateHeader = function(txt, ndx)
{
    /*var cat = resolveString( cse_pp_alerts_st, this.alert_editors[ndx].cat + "_S");

    if (txt=="")
    {  txt=resolveString(cse_pp_st, "__defalert", [cat]);
    }
    var header_txt = resolveString(cse_pp_st, "__alert_header_text_read_only2", [cat, txt] );*/
    var header_txt = resolveString(cse_pp_st, "__preview");
    this.alert_editors[ndx].obj.setHeaderText(header_txt);
}

//Initialise an alert editor object
//params:
//@parent_pb : property bag containing the alerts
///@pol_pb; pb where policy settings are stored
//ppIn : property path of the policy setting
PolicyAlerts.prototype.InitAll = function(parent_pb, pol_pb, ppIn)
{
    g_pt = PolicyAlerts.ShowPlainTextAlerts(parent_pb, pol_pb, ppIn);
    var pp_str;
    if ("string" == typeof(ppIn)) {
         pp_str=ppIn
    }
    else
    {    pp_str=ppIn.GetPath()
    }

   //setting up property bag and property path
   this.alert_pb=AlertEditor.makePB(parent_pb);
   this.policy_pb=pol_pb;
   var ppT = new PropertyPath (pp_str);
   ppT.Append("Alerts");
   this.pp= ppT.GetPath();
   this.resource_manager = new ResourceManager("DefaultAlerts");

   //initialising registered AlertEditor objects and create databindings
   //page_alert_width may be initialised in the page
   for (var i=0; i<this.alert_editors.length; i++)
   {
       var props={width:this.alert_editors[i].width, height:this.alert_editors[i].height, selector:false}
	   var ae=this.alert_editors[i];
	   var div_id = "box_" + ae.ae_id;
       var ctl_id = "ctl_"   + ae.ae_id;
	   var ae_name= this.name +".alert_editors[" + i + "].obj";

	   this.alert_editors[i].obj = new AlertPreview( ae.cat,
	                              ctl_id,
	                              ae_name,
	                              props);

	   ae.ref_id = this.GetPolAlertId(ae.leave);
	   ae.name=ae_name;

       var aeDB = ae.obj.makeDataBinding(div_id, g_pt);
       this.databindings.push(aeDB);
       this.databindings[ae_name] = aeDB;
   }
}

//call InitAll, policypb being either parent pb or locally stored pb
//@parent_pb : property bag containing the alerts
//@ppIn : property path of the policy setting
//@setLocal : boolean stating if temporary pb should be used for policy settings
// typically, false when call is from a settings page, true if this is from an action page)
PolicyAlerts.prototype.Init = function(parent_pb, ppIn, setlocal)
{
   var pbT = parent_pb;

  //setting page may have stored a temporary copy if the setting before opening
  //an action page. Use it if it existe.
   if (setlocal)
   {
	    var savpb= top.polctx.polSetting["pb"];
	    if (savpb != undefined)
	    {   pbT=PropertyBag.Recreate(savpb)
        }
   }

   this.InitAll(parent_pb, pbT,  ppIn)
}



//populate alert editor and other fields depending on selectionin combo box
PolicyAlerts.prototype.SelAlert = function(the_combo)
{

	var f= the_combo.form;
	var rank = the_combo.options[the_combo.selectedIndex].value-0;
	var category=f.type.value;
	var lst= this.alert_editors[f.ndx.value].lst;

	var ae_name= this.alert_editors[f.ndx.value].name;
    var ae_id = this.alert_editors[f.ndx.value].ae_id;
	var pp_str = AlertEditor.lookupPath(lst[rank].id, this.alert_pb);
	var ppT=new PropertyPath(pp_str);

	this.databindings[ae_name].set(ppT, this.alert_pb);

    f.name.value=lst[rank].displayName;
    f.id.value=lst[rank].id;

	this.UpdateHeader(f.name.value, f.ndx.value);

    // Hide or show the edit link according to whether or not the default alert
    // is selected
    var span = document.getElementById("edLink_" + ae_id);
    if (span)
        span.style.display = (0 == the_combo.selectedIndex) ? "none" : "inline";
}

// Utility function to get relevant alert list
PolicyAlerts.prototype.getAlertList = function(cat) {
    return AlertEditor.getList(cat, this.alert_pb);
}

//utility function to populate name selection combo
PolicyAlerts.prototype.PopulateNameSel = function(ndx, ref_id)
{
    var alert_id=this.alert_editors[ndx].ae_id;
    var div=document.getElementById(alert_id + "_name_div");
	var dhtml=""

	var lst= AlertEditor.getList(this.alert_editors[ndx].cat, this.alert_pb);
	this.alert_editors[ndx].lst=lst;

    var selIdx = -1;
	if(div)
	{
	   dhtml+="<select name='alert_sel' onchange='top.gPageStack.Active().SetModified(true);"  + this.name + ".SelAlert(this)'>"

	   for(var i=0;i<lst.length;i++)
	   {

		   if(lst[i].id==ref_id)
           {  dhtml+= "<option selected value=" + i + " >";
              selIdx = i;
		   }
		   else
           {  dhtml+= "<option value=" + i + " >";
		   }
		   dhtml +=  ReplaceSpecialHTMLChars(lst[i].displayName);

	   }

	   dhtml +="</select>"
	   div.innerHTML=dhtml;
	}

    // Hide or show the edit link according to whether or not the default alert
    // is selected
    var span = document.getElementById("edLink_" + alert_id);
    if (span)
        span.style.display = (0 == selIdx) ? "none" : "inline";
}

PolicyAlerts.prototype.ToggleRO = function(the_ae_id, ro)
{
	var ndx=-1;

	//find ndx
	for(i=0;i<this.alert_editors.length;i++)
    {   if (this.alert_editors[i].ae_id == the_ae_id)
        { ndx=i;
        }
	}

	if(ndx>=0)
	{  //this.alert_editors[ndx].obj.toggleReadOnly(!this.alert_editors[ndx].obj.readOnly);
	   this.alert_editors[ndx].obj.toggleReadOnly(ro);
	   var ro_div=document.getElementById(the_ae_id + "_ro_div");
	   var rw_div=document.getElementById(the_ae_id + "_rw_div");
	   var src=   document.getElementById(the_ae_id + "_src_1");
       var f = document.forms[the_ae_id + "_btn_form"];
	   if(ro_div && rw_div)
	   {
		   ro_div.style.display=ro?"":"none";
  		   rw_div.style.display=ro?"none":"";
	   }
	   if(src && !ro)
	   {
		    src.checked=true;
	   }

	}
}

//Initial display of content of one particular Alert Editor
PolicyAlerts.prototype.ShowOne = function(ndx)
{
    var ref_id=this.alert_editors[ndx].ref_id;

	var pp_str = AlertEditor.lookupPath(ref_id, this.alert_pb);
    var name=this.alert_editors[ndx].name;
	var ppT=new PropertyPath(pp_str);
	if (ref_id =="")
	{
		this.databindings[name].set("", this.alert_pb);
  	}
	else
    {
	   this.databindings[name].set(ppT, this.alert_pb);
    }

    //initialse hidden fields
	var f = this.GetForm(ndx);
	if(f)
    {  if(f.name) f.name.value=AlertEditor.getAlertAttribute(ref_id, "name", this.alert_pb);
	   if(f.id)   f.id.value=ref_id;
	   if(f.type) f.type.value=this.alert_editors[ndx].cat;
	   if(f.ndx)  f.ndx.value=ndx;
	}

	//update header
	this.UpdateHeader(f.name.value, ndx);

    //initialise combo box
	this.PopulateNameSel(ndx, ref_id);


}

//enable/disable the alert selector and associated links
PolicyAlerts.prototype.DisableAlertSel = function(disable)
{
    for (var i=0; i<this.alert_editors.length; i++)
    {
	        var alert_id=this.alert_editors[i].ae_id;
			var span = document.getElementById(alert_id + "_links");
            if (span)
			{
                   span.style.display = (disable) ? "none" : "inline";
            }
			var f=this.GetForm(i);
			f.alert_sel.disabled=disable;
    }
}

//Show the alerts elements
//(don't need to call this if databinding set is called globally)
PolicyAlerts.prototype.ShowAll = function()
{
    for (var i=0; i<this.alert_editors.length; i++)
    {
		  this.ShowOne(i);
    }
}



//local store and restore
PolicyAlerts.prototype.LocalStore = function(store_place)
{
   for (var i=0; i<this.alert_editors.length; i++)
   {    var f= this.GetForm(i);
        store_place[i]=f.id.value;
   }
}

//Refresh screen with stored data if any
PolicyAlerts.prototype.LocalRestore = function(store_place)
{
   for (var i=0; i<this.alert_editors.length; i++)
   {    var f= this.GetForm(i);
        f.id.value=store_place[i];
        if ( top.polctx.newAlert)
        {
		    if (top.polctx.polSetting["current_alert"] == i)
			{  f.id.value=top.polctx.newAlert;
               top.gPageStack.Active().SetModified(true);
			}
        }

        f.name.value=AlertEditor.getAlertAttribute(f.id.value, "name", this.alert_pb)

		var ae_name =  this.alert_editors[i].name;
		var ppT = new PropertyPath(AlertEditor.lookupPath(f.id.value, this.alert_pb));
        this.databindings[ae_name].set(ppT, this.alert_pb);
		this.UpdateHeader(f.name.value, i);
   	    this.PopulateNameSel(i, f.id.value);
   }

   top.polctx.polSetting["current_alert"]=undefined;
   top.polctx.newAlert = undefined;

}

//Call this function to make invisible containers RO
PolicyAlerts.prototype.ResetRO = function(ndx)
{
	for (var i=0; i<this.alert_editors.length; i++ )
	{
	     if (ndx!=i)
	     {
               if (!this.alert_editors[i].obj.readOnly)
               { this.alert_editors[i].obj.toggleReadOnly(true);
			     this.ToggleRO(this.alert_editors[i].ae_id, true);
               }
	     }
	}
}

//Save current alert (not used)
PolicyAlerts.prototype.SaveOne = function(ndx)
{  return false;
}


//global apply of the alerts (save current selection)
PolicyAlerts.prototype.Apply = function(pbOut)
{
	var changed=false;
	if(pbOut)
	{    this.policy_pb=pbOut;
	}

    for (var i = 0; i < this.alert_editors.length; i++)
	{
	    var f=this.GetForm(i);
		var leave = this.alert_editors[i].leave;

        if ( f.id.value != this.GetPolAlertId( leave ) )
		{
		    this.SavePolAlertId(leave, f.id.value)
            changed = true;
        }
    }
    return changed;
}

//Call the edit alert page
PolicyAlerts.prototype.EditAlert = function(the_ae_id, create_alert)
{
var ndx=-1;

//find the form from the ae_id
	for(i=0;i<this.alert_editors.length;i++)
    {   if (this.alert_editors[i].ae_id == the_ae_id)
        { ndx=i;
        }
	}

    if(ndx <0)
    {
	   return;
    }
//store this id for LocalRestore to use
    top.polctx.polSetting["current_alert"]=ndx;

//initialise pp
    var pp_str=this.base_alert_pp;
    var f=this.GetForm(ndx);


//create url and title
    var target = uriAppend("EditAlert.html", "type", f.type.value);
    if (g_pt)
        target = uriAppend(target, "pt", "1");
    if (create_alert || f.id.value =="" )
    {
	   pp_str=this.alert_pb.GetNextElementEnum(this.base_alert_pp);
    }
    else
    {	target = uriAppend (target, "id", f.id.value);
    }
    var title= resolveString(cse_pp_st, "__alert");

//call page

    var page = new DialogPage( target , title );
	top.gPageStack.Forward(page, pp_str, null, true);

}

// Determines whether plain text alerts are currently in force; changes how alert
// previews are displayed
PolicyAlerts.ShowPlainTextAlerts = function(parentPB, pb, pp) {
    var ret = false;
    var ppStr = pp.toString();
    var basePP = "";
    var testPattern = /(Policies\.PolicySet.*\.Policy.*\.).*/;
    var match = testPattern.exec(ppStr);
    if (!match)
        return false;
    basePP = match[1];
    var apsPP = basePP + "ALERTPolicySettings";
    if (null == pb.GetProperty(apsPP)) {
        pb = (null == parentPB.GetProperty(apsPP)) ? top.gPB : parentPB;
    }
    if (null == pb.GetProperty(apsPP)) {
        // Look up the parent policy and check its ALERTPolicySettings
        var parentPolicyId = pb.GetPropertyDef(basePP + "parent", "");
        if (parentPolicyId) {
            // Clear any trailing number from the property path
            basePP = basePP.replace(/:\d+\.$/, "");
            var ppT = new PropertyPath(basePP);
            for (ppT.BeginEnum(); null != pb.GetProperty(ppT); ppT.IncrementEnum()) {
                var pathToSearch = null;
                ppT.SetTempLeaf("id");
                if (parentPolicyId == pb.GetProperty(ppT)) {
                    pathToSearch = ppT.toString();
                }
                ppT.SetTempLeaf("");
                if (pathToSearch) {
                    return this.ShowPlainTextAlerts(parentPB, pb, pathToSearch);
                }
            }
        }
        return false;
    }
    var lookupPP = apsPP + ".RefSettings";
    var settingsRef = pb.GetPropertyDef(lookupPP, "ALERTS:1");
    // Bring the settings blobs into the property bag, if required
    var targetProp = "Settings";
    if (null == pb.GetProperty(targetProp)) {
        if (null == parentPB.GetProperty(targetProp))
            top.gPB.GetElement(targetProp, pb);
        else
            parentPB.GetElement(targetProp, pb);
    }
    var ppT = new PropertyPath("Settings.ALERTSettings");
    for (ppT.BeginEnum(); null != pb.GetProperty(ppT); ppT.IncrementEnum()) {
        ppT.SetTempLeaf("id");
        if (settingsRef == pb.GetProperty(ppT)) {
            // Found the settings blob of interest
            ppT.SetTempLeaf("PlainText");
            ret = ("1" == pb.GetProperty(ppT));
            break;
        }
        ppT.SetTempLeaf("");
    }
    return ret;
}

//define the global here, before the page is displayed
var gAlertsDataBindings=[];
var gPolicyAlerts=new PolicyAlerts( "gPolicyAlerts");

//Callback function to list required configuration data
/*
function GetCustomConfigReq() {
    return ["DefaultAlerts_" + "en_US"]; //use t_locale_id in locale.js
}
*/


function PolAlert_NewTab(ndx)
{   if (gPolicyAlerts.alert_editors.length>0)
    { gPolicyAlerts.ResetRO(ndx);
    }
}


function AlertSummaryPop(layerKey) {
		dhtmlSummary = document.getElementById(layerKey);

		if(!dhtmlSummary)
	    {
		   return;
	    }
    	dhtmlSummary.style.display = (dhtmlSummary.style.display=="none") ? "block" : "none";

}

