// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
// Description:
// Functions used across several policy pages
//
// History:  (Author/Comment)
// Sept 2005 :IL : Created
// Oct 2005 : IL : moved draw functions into PolicySetPage.js
//=====================================================================================
//FUNCTIONS COMMON TO POLICY PAGES
//=====================================================================================
/*
 * Set the activate flag for selected policy statement
 */

function do_PolicyActivate(ctl_id)
{
   var ctl = document.getElementById(ctl_id);

   if (ctl) {
	top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].active=ctl.checked;
   }
}

/*
 * draw the description of the policy in the right place
 * div_id : relevant pop summary div id
 */
function draw_PolicyDescr(pstatement, div_id)
{
   //output on page
   var div = document.getElementById(div_id);
   if (div) {
   div.innerHTML = ReplaceSpecialHTMLChars(pstatement.description);
   }
}

/*
 * enable/disable policy check
 * ctl_id: relevant checkbox id
 */
function draw_PolicyEnable(pstatement, ctl_id)
{
   var ctl = document.getElementById(ctl_id);
   if (ctl) {
       if (pstatement.active==1)  ctl.checked = true;
       else ctl.checked=false;

   }
}

/*
 * draw the title of the policy
 * div_id : relevant pop summary div id
 */
function draw_PolicyTitle(pstatement, div_id)
{
var dhtml="";

    if (pstatement.root==1)
    {   dhtml+= '<span class="bold">' + resolveString(cse_pp_st, "__policy") + ' : ' + ReplaceSpecialHTMLChars(pstatement.name) + ' </span> '
    }
	else
    {   dhtml+= '<span class="bold">' + resolveString(cse_pp_st, "__sub_policy") + ' : ' + ReplaceSpecialHTMLChars(pstatement.name) + ' </span> '
	    dhtml+= ' [ ' +  resolveString(cse_pp_st, "__parent_policy") + ' : ' + ReplaceSpecialHTMLChars(pstatement.parent_name) + ' ] '
	}

   //output on page
   var div = document.getElementById(div_id);
   if (div) {
   div.innerHTML = dhtml;
   }
}//draw_PolicySetTitle



function draw_PolicySetCombo(pset, combo_div)
{
   var len=pset.treeNdx.length
   var i,j;
   var ndx;
   var pol_indent="";


   var div = document.getElementById(combo_div);
   if (! div) { return; }
   div.innerHTML="";

   //label
   var span=document.createElement("span");
   span.className="bold";
   div.appendChild(span);
   var label=resolveString(cse_pp_st, "__select_policy")+":";
   span.appendChild( document.createTextNode(label) )

   //select element
   span=document.createElement("span");
   div.appendChild(span);

   var data_html =  '&nbsp <select class="policyWidth" onChange="javascript: selectPolicyFromCombo(this)">'

   for (i=0; i<len; i++)
   {
       ndx=pset.treeNdx[i];
	   if (ndx==-1) continue;

	   pol_indent="";
	   for (j=0; j<pset.policies[ndx].indent; j++)
	   {   if (j<=7)
	            pol_indent+="&nbsp;&nbsp;"
       }

	   if (ndx == pset.selection)  data_html+= '<option selected value='+ndx+'> '
	   else data_html+= '<option value='+ndx+'> '

	   data_html+= pol_indent + ' ' +  ReplaceSpecialHTMLChars(pset.policies[ndx].name)
   }

   data_html +='</select></span>';
   span.innerHTML=data_html;

   // now write the parent policy

   var pstatement = pset.policies[pset.selection]
   if ( pstatement.root==0)
   {
       span=document.createElement("span");
       div.appendChild(span);
       label= '\u00A0 [ ' +  resolveString(cse_pp_st, "__parent_policy") + ' : ' + pstatement.parent_name + ' ]';
       span.appendChild( document.createTextNode(label) );
   }

   div.style.width="700px";
   div.style.overflow="hidden";


}


/*
 *  Navigates to the Policy Setting View tab
 *  parameters:
 *    settings=array member of a PolicySettingsList
 *    ndx=selection in that list
 */

function Policy_GotoTab(url)
{
   var ndx= top.polctx.myPolicySet.selection
   var name= ReplaceSpecialHTMLChars(top.polctx.myPolicySet.policies[ndx].name);
   var title=resolveString(cse_pp_st, "__policy") + "(" + name + ")"

   var pg=top.gPageStack.Active();
   if (pg)
   {
		top.gPageStack.Sideways(new EmbeddedPage(url, title), "");
   }

}//GotoTab

function Policy_GotoSettingView(settings, ndx )
{
   top.polctx.selectedSetting=ndx;
   top.polctx.polSetting=[];
   top.polctx.polSetting["typeval"]=settings[ndx].typeval;
   top.polctx.polSetting["time"]=settings[ndx].time;

   var url = settings[ndx].lnk_url;
   Policy_GotoTab(url);

}//Policy_GotoSettingView


/*
 *  Navigates to the Policy User tab
 */
function Policy_GotoUsers()
{
   var url = "PolicyUsers.html"
   Policy_GotoTab(url);

}//Policy_GotoUser

/*
 *  Navigates to the Policy Settings List tab
 * level: 0 =caller is PolicySetPage; 1=caller is another tab
 */
function Policy_GotoSettingsList()
{
   url = "PolicySettingsListPage.html"
   Policy_GotoTab(url);

}//PolicySet_SelectPolicy


// Policy combo in the policySettingsList, PolSettingView, or PolicyUsers pages
function selectPolicyFromCombo(the_combo)
{
    var pg=top.gPageStack.Active();
    if(!pg) return;

    if(pg.CanClose() == true)
    {
		var ndx = top.polctx.myPolicySet.treeNdx[the_combo.selectedIndex];
		top.polctx.myPolicySet.selection = ndx;
		location.reload();
		// This is just to ensure that we are updating the breadcrumb correctly
		Policy_GotoTab(pg.name);
	}
	else
	{
		the_combo.selectedIndex = top.polctx.myPolicySet.selection;//retain the old selection since the page cannot be closed.
	}
}


