// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
// Description:
// Included in PolicySettingsListPage.html
// Javascript functions to manage data for the policySettingsList page.
// Assumes the page also inserts PolicySettingsData.js
//====================================================================================
// Consts
//====================================================================================
var K_DELETED = 2
var K_ROOT = 1
var K_NOROOT  = 0
//====================================================================================
// globals and flags for this page
//====================================================================================

//copy of the property path and property bag,
//re-initialised to the right values in the Show function
var policyStatement_pp = null;
var policyStatement_pb = null;

//====================================================================================
// DHTML and Draw functions for this page
//====================================================================================

//   hide/show summary popup
var mouseX = 0;
var mouseY = 0;

function mouseTrack(e) {
		if (e) {
			mouseX = e.pageX;
			mouseY = e.pageY;
		} else {
			if (event) {
				mouseX = event.x;
				mouseY = event.y;
			}
		}
}

document.onmousemove=mouseTrack;

function dhtmlSummaryPop(layerKey, onState) {
		dhtmlSummary = document.getElementById(layerKey);
		dhtmlSummary.style.display = (onState) ? "block" : "none";
		if (onState) {
			dhtmlSummary.style.left = (mouseX+5) + "px";
			dhtmlSummary.style.top = (mouseY+5) + "px";
		}
}


//Displays one setting as a table row
PolicySettingsListItem.prototype.draw = function(div_id, lst_name, policy_root, ndx)
{
var html = "";
var item_activate = "";
var item_time = " &nbsp; ";
var item_root = " &nbsp; ";
var item_indent = "";
var item_inherits = " &nbsp; ";
var bActiveEnable=true;
var i;

	//check if the setting is enabled - hide time restrictionif it is not active
    if (this.enabled==1)
	{   item_activate = " checked ";

	    if (this.nb_alt>0)
        {
			item_time = resolveString(cse_pp_st, "__rest_of_time");
	    }
		else
		{   item_time= ReplaceSpecialHTMLChars( gTimeRestriction.GetDisplayName(this.time) );
		}
	}

    item_activate+=' onclick=javascript:' + lst_name + '.drawActivate("' + ndx + '") ';

    //check inheritance
	if(this.inherits>0)
	{  item_inherits = '<img src="../../images/icons/checkmark_yellow.gif" width="14" height="14" border="0" style="margin-right:8px;" >';
       bActiveEnable=false;
	}

	//add delete button if it is not fixed data and is not inherited

	if (this.root==K_NOROOT && this.pp_ancestor=="")
	{
	    item_root =  '<A class="blueLink" HREF= javascript:' + lst_name + '.drawDelete("' + ndx + '")>'
	    item_root +=  resolveString(cse_pp_st, "__delete")
	    item_root +=  '</A>'

    }

	//add indentation if there is a time restriction
	if (this.time!="")
	{
		item_indent = "<img src=\"../../images/void.gif\" width=\"8\" height=\"8\" border=\"0\" style=\"vertical-align:middle;margin-right:7px;\"> "
    }



	item_link= ' javascript:PolicySettingsList_GotoItem('  + ndx + ') '

	//build html for the row
    html+='<td class="rt label" width="250" nowrap>'

    //icon linking to the description popup, if needed
	//html+=    '<img src="../../images/icons/info_popup.gif" width="14" height="14" border="0" ';
    //html+=        'onmouseover=\" dhtmlSummaryPop(' +'\''+ div_id +'_' + ndx + '\'' + ', true)\" ' ;
    //html+=        'onmouseout =\" dhtmlSummaryPop(' +'\''+ div_id +'_' + ndx + '\'' + ', false)\" ' ;
	//html+=        'style="vertical-align:middle;margin-right:7px" > ';

	html+=     item_indent + '<a class="blueLink" href="' + item_link + '" > ' + this.name + '</a>';

	html+='</td> <td class="rt label"  nowrap>';
    var disabledStr = (bActiveEnable&&this.activatable) ? "" : " disabled";

	html+=     '<input type="checkbox" ' + item_activate + 'class="noPadCheck"' + disabledStr + '> ';
	html+=     item_time;

    if (policy_root==K_NOROOT)
	{   html+='</td> <td class="rt label" width="50">';
	    html+=    item_inherits;
    }
	html+='</td><td class="rt label eor" width="10"> ' ;
	html+=     item_root;
	html+='</td>';

	return html;
}

/*
 * Displays one table
 */
PolicySettingsList.prototype.tableDraw = function(sec)
{
var len_table=this.tables[sec].items.length;
var i, ndx;
var last_item;
var title=this.tables[sec].tbl_title;
var table_div="LST_DIV_" + sec;
var item_class="";
var data_html="";
var t_colspan=3;

   //if table length is null, just output space to the place holder
   if(len_table<1)
   {
      var div = document.getElementById(table_div);
      if (div) div.innerHTML = "";
	  return;
   }

   //look for last item (there will be at least the root items)
   for (i=0; i<len_table; i++)
   {
       ndx=this.tables[sec].items[i];
	   if (ndx==-1) continue;
	   else last_item=i;
   }

   if (this.policy_root==1) t_colspan=3
   else   t_colspan=4;

   //table header
   data_html += '<table border="0" cellpadding="0" cellspacing="0" class="reportTable" width="100%">';
   data_html +=	'<tr>';
   data_html += '<td colspan= "' + t_colspan + '" class="rt eor subhead2 label"><span class="bold">' + title + '</span></td>';
   data_html += '</tr>';
   data_html += '<tr class="header">';
   data_html += '<td width="250px" class="rt label" nowrap><span class="bold">'      + resolveString(cse_pp_st,"__name") + '</span></td>';
   data_html += '<td   class="rt label" nowrap><span class="bold">'      + resolveString(cse_pp_st,"__active") + '</span></td>';

   if (this.policy_root==0)
   {   data_html += '<td width="50px"  class="rt label" nowrap><span class="bold">'      + resolveString(cse_pp_st,"__inherits") + '</span></td>';
   }

   data_html += '<td width="10px"  class="rt eor label " nowrap><span class="bold white">'+ resolveString(cse_pp_st,"__delete") + '</span></td>';
   data_html += '</tr>';

   //table content
   for (i=0;i<len_table;i++)
   {     ndx= this.tables[sec].items[i];

	     if (ndx==-1) continue;
		 if (this.settings[ndx].deleted==1) continue
         if(!pp_componentInstalled(this.settings[ndx].typeval)) continue

     //toggle shade
         if (item_class=="")
         {    item_class = "shaded ";
         }
	     else
	     {   item_class="";
	     }
	     //add lastrow if relevant
	     if (i==last_item)
	     {  item_class +="lastrow "
	     }

	     if (item_class!="")
	     {   item_class="class=\""+item_class+"\" ";
	     }

	     //build row
	     data_html+= '<TR ' + item_class + ' height="22">'
         data_html+=this.settings[ndx].draw("POP_DIV", this.objectName, this.policy_root, ndx);
	     data_html+='</TR>'
   }

   //end of table
   data_html +='</table><BR>';

   //output on page
   var div = document.getElementById(table_div);
   if (div) {
   div.innerHTML = data_html;
   }

}//tableDraw

/*
 * Display the list of settings in the right place, with the right style
 */
PolicySettingsList.prototype.draw = function()
{
var i;
var dhtml ="";

var len=this.tables.length;
var table_div;

	for (i=0;i<len ;i++ )
    {
	   dhtml += '<div id= LST_DIV_'+ i + ' >';
	   dhtml +=  '</div>'

    }
    //output div sections on page
    var div = document.getElementById("LST_DIV");
    if (div)
	{
        div.innerHTML = dhtml;
	}
	else alert ("__missing div section LST_DIV");

	//draw the tables
    for (i=0;i<len ;i++ )
    {
	   this.tableDraw(i);
    }

    //draw summary popups
    this.drawSummaryPopups();
}

/*
 * output the summary popup windows for later use
 */
PolicySettingsList.prototype.drawSummaryPopups = function()
{
var ndx;
var len=this.settings.length;
var html="";
var div;

	for (ndx=0;ndx<len ;ndx++ )
	{
        html+='<div id=' + "POP_DIV_"+ ndx +' class="dhtmlSummary" > '
        html+='<table border="0" cellspacing="0" cellpadding="0" class="dhtmlSummary">'
        html+='<tr class="titleRow"><td>' + this.settings[ndx].name + '</td></tr>'
        html+='<tr class="dataRow firstRow lastrow">'
	    html+='<td class="eor">' + "&nbsp;" + '<BR>'
	    html+='</td>'
        html+='</tr>'
        html+='</table>';
		html+='</div>'
    }

	div = document.getElementById("POP_DIV");
	if (div)
	{   div.innerHTML = html;
	}

}//drawSummaryPopups

/*
 * redraw after delete is pressed
 */
PolicySettingsList.prototype.drawDelete= function(id)
{

	 var name=this.settings[id].name;
	 var ok = confirm( resolveString(cse_pp_st,"__delete_scanner_prompt",[name]) )

	 if (ok)
	 {
	   this.deleteSetting(id);
	 }

	 var pg=top.gPageStack.Active();
     if (pg)
     {   pg.SetModified();
     }

	 this.draw();
}//drawDelete

/*
 * redraw after activate is clicked
 */
PolicySettingsList.prototype.drawActivate= function(ndx)
{
var ok=0;
var len=this.settings.length;

    //find and change activation
	rank=this.settings[ndx].rank
	if (this.settings[ndx].enabled==0) ok=1;
    this.settings[ndx].enabled=ok;

	//decrease nb_alt in "all the time" node
    if (this.settings[ndx].time!= "")
    {
	   for(i=0;i<len;i++)
	   {
		   if (this.settings[i].time=="" && this.settings[i].rank == rank)
		   {
			   if(ok) this.settings[i].nb_alt++;
			   else this.settings[i].nb_alt--;
		   }
       }
    }

	var pg=top.gPageStack.Active();
    if (pg)
    {   pg.SetModified();
    }
    top.SetModified(true);


    //redraw
	this.draw();
}//drawActivate

//=========================================================
// Mandatory functions
//=========================================================

/**
 * Asynchronous data load function
 * enumerate all policyset until the one with the right name is found
 */
function Show(pbIn) {

    if (top.polctx==undefined)
    {   return;
    }

    gTimeRestriction = new TimeRestriction(pbIn);

    //set up globals for later use
    policyStatement_pp = top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].pp_path;
	policyStatement_pb=pbIn;

    //populate and draw.
    top.polctx.selectedSetting= 0;
	myPolicySettingsList.populate(pbIn, policyStatement_pp)
	myPolicySettingsList.draw();

    //maybe hide create new settings btn
    var lst=[];
    try {
        var tag = top.polctx.myPolicySet.pp_key;
        if (tag == undefined || pp_ui_flags[tag] == undefined)
        {  tag = "__default"
        }
        lst = pp_ui_flags[tag]["canCreate"];
    }
    catch(e) {}

    var btndiv=document.getElementById("cancreate_div");
    if ( !lst || lst.length<=0)
    {   if(btndiv) btndiv.style.display="none";
    }
    else
    {   if(btndiv) btndiv.style.display="";
    }


}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var ok = true;
    return ok;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pbOut) {

   var pList = top.polctx.myPolicySet.policies;
   var ndx= top.polctx.myPolicySet.selection;
   var ppT = new PropertyPath(policyStatement_pp);

   //apply modification of policy activate (if any)
   ppT.SetTempLeaf("active")
   pbOut.SetProperty(ppT.GetPath(), pList[ndx].active);
   ppT.SetTempLeaf("")

   //now save settings status
   var pSettings = myPolicySettingsList.settings;
   var i;
   var id_key;

   for (i=0; i<pSettings.length ; i++)
   {
	    if(pSettings[i].pp_local!="")
	    {
	       ppT.SetPath(pSettings[i].pp_local);

           ppT.SetTempLeaf("enabled");
           pbOut.SetProperty(ppT.GetPath(), pSettings[i].enabled);

           if (pSettings[i].deleted==1)
           {   ppT.SetTempLeaf("root");
               pbOut.SetProperty(ppT.GetPath(), K_DELETED);
           }
        }
   }

   //delete items that should be deleted, in enum reverse order
   var regexStr='^' + policyStatement_pp + "\\.(\\w+)PolicySettings(:\\d{8})*$";
   var pattern=new RegExp(regexStr);
   var res=pbOut.GetMatchingPaths(pattern);

   for (i=res.length;i>0; i-- )
   {
        ppT.SetPath(res[i-1][0]);
        ppT.SetTempLeaf("root");

		var the_root = policyStatement_pb.GetProperty(ppT);
        ppT.SetTempLeaf("");
        if (the_root == K_DELETED)
        {   pbOut.DeleteElement(ppT)
        }
    }
    return pbOut;
}

//cancel all changes
function Cancel() {
    myPolicySettingsList.populate(policyStatement_pb, policyStatement_pp)
	myPolicySettingsList.draw();
}

//====================================================================================
// Links to other pages
//====================================================================================

// Link to the Policy Setting view page when clicking on a link.
//
function PolicySettingsList_GotoItem( ndx )
{
   Policy_GotoSettingView(myPolicySettingsList.settings, ndx );

}//PolicySettingsList_GotoItem

// Link to creation of a new Policy Setting item
//
function PolicySettingsList_CreateItem()
{
   var ppT = new PropertyPath(policyStatement_pp);
   var title= resolveString(cse_pp_st, "__new_settings");
   var target="PolNewSetting.html";
   var page = new DialogPage( target , title );
   top.gPageStack.Forward(page, ppT);

}//PolicySettingsList_CreateItem



