// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//
// History:  (Author/Comment)
// Sept 2005 :IL : Created

/*
 * Constructor for the PolicySettingType class
 * members: 
 *   typeval = type id as recorded in the config, eg, "AV", "AS" etc...
 *   secndx  = table the id belongs to, effectively an index in the RefTypes.sections array.  
 *   url = page associated with this setting type
 */

function PolicySettingType(v,i,lnk)
{ 
	
   this.typeval=v; 
   this.secndx=i;  
   this.lnk_url=lnk;
}

/*
 * Constructor for the PolicySettingRefTypes class
 * members: 
 *   typeArray = Array of all type associations  (typeval, secndx)
 *   sections  = Array of section titles
 *   settings appear on the screen according to position in the array
 */

function PolicySettingsRefTypes()
{  this.typeArray;    
   this.sections;     
}

/*
 * Appends data
 */
PolicySettingsRefTypes.prototype.add = function(tval, si, url, activatable)
{
    if (null == activatable)
        activatable = true;
	this.typeArray.push({  typeval:tval,
		                   secndx:si,
						   lnk_url:url,
                           activatable:activatable    });

}

// Populate
PolicySettingsRefTypes.prototype.populate = function() 
{
	 this.sections=new Array( resolveString( cse_pp_st,  "__basic_settings"),
		                      resolveString( cse_pp_st,  "__filters_settings"),
		                      resolveString( cse_pp_st,  "__miscellaneous")
		                    );

     this.typeArray = new Array();

     //Basic Settings
     this.add("AV",  0, "PolSettingView_AV.html");
     this.add("AS",  0, "PolSettingView_AS.html");
     this.add("CS",  0, "PolSettingView_CS.html");
	 this.add("FF",  0, "PolSettingView_FF.html");
     this.add("AF",  0, "DefPolSettingView.html?type=AF");
     this.add("PX",  0, "DefPolSettingView.html?type=PX");
	 this.add("MAILURL", 0, "DefPolSettingView.html?type=MailURL");
     this.add("URL", 0, "");
     //Filters
     this.add("CM",   1, "DefPolSettingView.html?type=CM", false);
     this.add("PM",   1, "DefPolSettingView.html?type=PM", false);
     this.add("EM",   1, "DefPolSettingView.html?type=EM", false);
     this.add("SM",   1, "DefPolSettingView.html?type=SM", false);
     this.add("PPF",   1, "DefPolSettingView.html?type=PPF", false);
     this.add("MF",   1, "DefPolSettingView.html?type=MF");
     this.add("SS",  1, "DefPolSettingView.html?type=SS", false);
     this.add("MIME", 1, "DefPolSettingView.html?type=MIME", false);
     this.add("HTML", 1, "DefPolSettingView.html?type=HTML", false);	 
     //this.add("HTTP", 1, "");
     //Alert Settings
	 this.add("ALERT", 2, "DefPolSettingView.html?type=ALERT", false);
	 if(!IsMBOnlyInstalled()) //BZ: 584272, MB only setup should not have Disclaimer setting 
		 this.add("DISC",  2, "DefPolSettingView.html?type=DISC");
   
}
