// Copyright (C) 2009 McAfee, Inc.  All rights reserved.

var gPolPPStr;
var gPbIn;
var K_NOROOT  = 0


function PW3_DrawSettingsList(pbIn, pp_str)
{

    var pset = top.polctx.myPolicySet
    var settingsList = new PolicySettingsList("myPolicySettingsList");
    settingsList.populate(pbIn, pp_str);
    var len = settingsList.index.length;

    var div = document.getElementById("settings_div");
    div.innerHTML="";
    var tbl=document.createElement("table");
    div.appendChild(tbl);
    tbl.width="100%";
    var tbody = document.createElement("tbody");
    tbl.appendChild(tbody);
    var row=document.createElement("tr");
    tbody.appendChild(row);
    var cell=document.createElement("td");
    row.appendChild(cell);
    cell.vAlign="top";

    var nb=0;
    var half_len=len/2;
    for (var i=0;i<len ; i++)
    {

                var setting_pp_str=settingsList.settings[settingsList.index[i]].pp_local;
                if(setting_pp_str=="")
                {   setting_pp_str=settingsList.settings[settingsList.index[i]].pp_ancestor;
                }


                var cb=document.createElement("input");
                cb.setAttribute("type","checkbox");
                cell.appendChild(cb);

                cb.value=setting_pp_str;


                var item = settingsList.settings[settingsList.index[i]];
                var content= document.createTextNode(item.name);
                cell.appendChild(content);

                if(item.time && item.time !="" && item.time != "T:ALLTHETIME")
                {    var txt= gTimeRestriction.GetDisplayName(item.time);
                     content = document.createTextNode(" (" + txt + ")");
                     cell.appendChild(content);
                }


                var br=document.createElement("br");
                cell.appendChild(br);


               //second column
               nb++;

               if(nb>half_len)
               {   cell=document.createElement("td");
                   row.appendChild(cell);
                   cell.vAlign="top";
                   nb=0;
               }

    }
}

function PW3_onParentSel()
{
    var sel = document.getElementById("selParent");
    var pp_str = sel.options[sel.selectedIndex].value;
    var ppT = new PropertyPath(pp_str);
    if(!gPbIn.GetProperty(ppT))
    {   alert("__path not found");
        return;
    }

    PW3_DrawSettingsList(gPbIn, pp_str)
}


function DrawParentCombo()
{
    var pset = top.polctx.myPolicySet
    var len=pset.treeNdx.length
    var j;
    var pol_indent="";

    var data_html="";

    //set up next priority order for future use
    next_order = len+1;

    var div = document.getElementById("parents");
    if (!div) return;

    div.innerHTML = "";

    var sel=document.createElement("select");
    div.appendChild(sel);
    sel.className="policyWidth";
    sel.id="selParent";

    sel.onchange=PW3_onParentSel;

    for (var i=0; i<len; i++)
    {
        var ndx=pset.treeNdx[i];
        if (ndx==-1) continue;

        var opt=document.createElement("option");
        sel.appendChild(opt);
        opt.value=pset.policies[ndx].pp_path;
        if (ndx == pset.selection) opt.selected=true;


        var pol_indent="";

        for (var j=0; j<pset.policies[ndx].indent; j++)
        {
            if (j<=7)
            {
               pol_indent+='\u00A0'+'\u00A0';
            }
        }

        opt.appendChild(document.createTextNode(pol_indent+' '+pset.policies[ndx].name));

    }
}

//@pbOut: pb we are wrinting into
//@policy_pp_str: pp of new policy
//@old_pp_str: setting pp in old policy

function PW3_CopyOneSetting(pbOut, policy_pp_str, old_pp_str)
{
         var index_dot = old_pp_str.lastIndexOf(".")
        var setting_node =  old_pp_str.substr(index_dot)
        setting_node = RemoveLeafEnum(setting_node);

        var new_pp_str = policy_pp_str+setting_node;
        new_pp_str = pbOut.GetNextElementEnum(new_pp_str);

        var ppT= new PropertyPath(new_pp_str);
        pbOut.SetProperty(ppT);

        var test=gPbIn;
        for (var pp in gPbIn.propValues)
        {
            if (IsAncestorPathOf(old_pp_str, pp))
            {
               var c_ppT= new PropertyPath(new_pp_str);
               var tail=pp.substr(1+old_pp_str.length)
               c_ppT.Append(tail);
               pbOut.SetProperty(c_ppT, gPbIn.propValues[pp])
            }
        }

        ppT.SetTempLeaf("root");
        pbOut.SetProperty(ppT, K_NOROOT)
        ppT.SetTempLeaf("");

}


function PW3_CopySettings(pbOut, ppOut)
{
    //check if settings should be copied
    var f=document.forms["pw3_form"];
    if(!f) return;

    var src="inherit";

    for(var i=0;i<f.src.length;i++)
    {   if (f.src[i].checked)
        src=f.src[i].value;
    }

    if(src!="copy")
    {   return;
    }


    //copy selected settings
    var elems = f.elements;
    for (var i = 0; i<elems.length; i++)
    {
         if (elems[i].type == "checkbox")
         {
             if(elems[i].checked)
             {
                 PW3_CopyOneSetting(pbOut, ppOut, elems[i].value)

             }
         }
    }

}

//Show Hide the settings checkbox selection
//@value="inherit" or "copy"
function PW3_ToggleSrc(value)
{

     var div = document.getElementById("settings_div");
     var sel = document.getElementById("selParent");

     if (value=="copy")
     {    div.style.display="";
          sel.disabled=false;
          PW3_onParentSel();
     }
     else
     {    div.style.display="none";
          sel.disabled=true;
     }
}



function Show(pb,pp)
{
    if ("string" == typeof(pp))
    {
        gPolPPStr = pp;
    }
    else
    {   pp.SetTempLeaf("");
        gPolPPStr=pp.GetPath();
    }
    gPbIn=top.gPB;
    gTimeRestriction = new TimeRestriction(gPbIn);
    DrawParentCombo();
    PW3_ToggleSrc("inherit");
}

function Validate()
{
    return true;
}

function Apply(pbOut,pp)
{
    //copy settings if needed
    PW3_CopySettings(pbOut, gPolPPStr);
    return pbOut;
}
