//Copyright (C) 2009 McAfee, Inc.  All rights reserved
var gFilterNames=new Array
gFilterNames[0]="av"
gFilterNames[1]="content"
gFilterNames[2]="file"
gFilterNames[3]="spam"
gFilterNames[4]="ec"
gFilterNames[5]="mailsize"
gFilterNames[6]="phish"
gFilterNames[7]="spyware"
gFilterNames[8]="pup"
gFilterNames[9]="pa"
gFilterNames[10]="url";
gFilterNames[11]="other"

//////////////////////////////////////////////////
//
// Identities
//
//////////////////////////////////////////////////
var gIdentityTemplates = new Array(
"(ato IN %1g OR acc IN %1g)",
"NOT (ato IN %1g OR acc IN %1g)",
"(ato IS %1e OR acc IS %1e)",
"NOT (ato IS %1e OR acc IS %1e)")

/////////////////////////////////////////////////
//
// GraphFilterRule - Object Constructor
//
function GraphFilterRule(nID, sRuleDescription, sGraphType, sFilter, sQueryOn, nNumber)
{
	// ID of the graph, this must be unique.
	this.nID				= nID;
	// Type of graph to generate. Currently supports bar or pie.
	this.nGraphType			= sGraphType;
	// Description of the rule, localisable, should not be blank
	this.sRuleDescription 	= sRuleDescription;
	// Filter to use on the data, should not be blank. For example to you wanted a graph giving the
	// top 10 viruses you would set this to rsn=\"av\"
	this.sFilter 			= sFilter;
	// The following is used to drill the graph to a type, for example to you wanted a graph giving the
	// top 10 viruses you would set this to vrs. Note: This is currently only used for pie charts
	this.sQueryOn 			= sQueryOn;
	// The following is used to define the maximum number of a given query to return, for example if
	// you wanted a graph giving the top 10 viruses you would set this to 10. Note: This is currently
	// only used for pie charts.
	this.nNumber			= nNumber;
}


//these two functions 'DropDownChanged' and 'FilterChanged' are used by the graphical reports page
//and results table page to render a drop down list of possible detection reasons if the user tries
//to filter on reason
var gsReasons;
function DropdownChanged(theDropdown)
{
	//whenever we change a value in the dropdown, copy it into the hidden text box to allow
	//the query generation and cookie load/save to work without changes

	var dropdownId = theDropdown.id;
	var textBoxId = (typeof gsPageId != 'undefined' && gsPageId == "productlog" ? "p" : "") + "searchField" + dropdownId.charAt(dropdownId.length-1);
	var fieldList = (typeof gsPageId != 'undefined' && gsPageId == "productlog" ? "p" : "") + "fieldList" + dropdownId.charAt(dropdownId.length-1);
	var val = "";

	if(theDropdown.selectedIndex > 0)
	{
		var theFilter = document.getElementById(fieldList);
		var isBStateField = theFilter.options[theFilter.selectedIndex].text;
		if (isBStateField == gStoreCols["trs"])
		{
			val = theDropdown.selectedIndex-1;
		}
		else
		{
			val = gsReasons[theDropdown.selectedIndex-1];
		}
	}

	var textBox = document.getElementById(textBoxId);
	if(textBox != undefined)
		textBox.value = val;


}

function FilterChanged(theFilter)
{
	//each filter option will have a corresponding edit box and dropdown with the same number
	//e.g. fieldList1 will have an associated edit box called searchField1 and a dropdown
	//called dropdown1
	var filterId = theFilter.id;
	var textBoxId = (typeof gsPageId != 'undefined' && gsPageId == "productlog" ? "p" : "") + "searchField" + filterId.charAt(filterId.length-1);
	var dropdownId = (typeof gsPageId != 'undefined' && gsPageId == "productlog" ? "p" : "") + "dropdown" + filterId.charAt(filterId.length-1);

	var textBox = document.getElementById(textBoxId);
	var dropdown = document.getElementById(dropdownId);

	//if we couldn't find the controls just exit
	if(dropdown == undefined || textBox == undefined)
		return;

	var entryNames;


	if(theFilter.options[theFilter.selectedIndex].text == gStoreCols["rsn"] && theFilter.options[theFilter.selectedIndex].value == "rsn")
	{
		gsReasons = new Array;
		for(var x in gsReason)
		{
			if(gbAntiSpamInstalled)
			{
				if(!((typeof gsPageId != 'undefined' && gsPageId == "allitems") && (x == "ip")))
					gsReasons.push(x);
			}
			else
			{
				if((x == "spam") || (x == "ip") || (x == "phish"))
					continue;
				else
					gsReasons.push(x);	
			}
		}
		entryNames=gsReason;
	}

	if(theFilter.options[theFilter.selectedIndex].text == gStoreCols["ssc"])
	{
		document.getElementById(textBoxId).value = "";
		document.getElementById(textBoxId).onkeypress = cb_decimalOnlyNN;
		var ignoreCheckbox = "ignoreCase" + filterId.charAt(filterId.length-1);

		if(document.getElementById(ignoreCheckbox) != null)
			document.getElementById(ignoreCheckbox).disabled = true;
	}
	else
	{
		document.getElementById(textBoxId).onkeypress = "";
	}

	if(theFilter.options[theFilter.selectedIndex].text != gStoreCols["trs"])
	{
		if(document.getElementById("ignoreCase" + filterId.charAt(filterId.length-1)) != null)
			document.getElementById("ignoreCase" + filterId.charAt(filterId.length-1)).checked = false;	
	}
	if(theFilter.options[theFilter.selectedIndex].text == gProductLogCols["lvl"])
	{
		gsReasons=[0,1,2];
		entryNames=gLogLevels;
	}

	if (entryNames)
	{

		var currentValue;

		if(textBox.value != undefined && textBox.value != "")
			currentValue = textBox.value;

		textBox.style.display="none";
		dropdown.style.display="";

		var indexCache = dropdown.selectedIndex;
		if (dropdown.hasChildNodes())
		{
			while (dropdown.childNodes.length >= 1)
			{
				dropdown.removeChild( dropdown.firstChild);
			}
		}

		if(dropdown.options.length == 0)
		{
			//add a blank option (i.e. all items)
			dropdown.appendChild(document.createElement("OPTION"));
			dropdown.selectedIndex=0;

			for (var i=0; i < gsReasons.length; i++)
			{
				var optionEl=document.createElement("OPTION");
				var name = document.createTextNode(entryNames[gsReasons[i]]);

				optionEl.appendChild(name);
				optionEl.selected = (currentValue != undefined && currentValue == gsReasons[i]) ? true : false;
				dropdown.appendChild(optionEl);
			}
			dropdown.selectedIndex = indexCache < 0 ? 0 : indexCache > gsReasons.length ? gsReasons.length : indexCache;
		}
	}
	else
	{
		//if we changed it to a reason drop down last time, change it back
		if(textBox.style.display=="none")
		{
			dropdown.style.display="none";
			textBox.value="";
			textBox.style.display="";
		}
	}
}

// Personal Preferences, used by the dashboard and Graphical reports
var bGraph3D			= true;
var bGraphTrans			= false;
var bGraphAntiAlias		= true;
var bGraphExplodePie		= false;
var sPieAngle			= "45";
var sScale			= "100";
var sReportFor			= "7";

function LoadGraphSettings(pb)
{
	var pp = new PropertyPath("UIPreferences");

	pp.SetTempLeaf("GraphReport3D");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "1";

	if( value == "1" )
		bGraph3D = true;
	else
		bGraph3D = false;

	pp.SetTempLeaf("GraphReportTransparent");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "1";

	if( value == "1" )
		bGraphTrans = true;
	else
		bGraphTrans= false;

	pp.SetTempLeaf("GraphReportAntiAlias");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "1";

	if( value == "1" )
		bGraphAntiAlias = true;
	else
		bGraphAntiAlias = false;

	pp.SetTempLeaf("GraphReportExplodePie");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "0";

	if( value == "1" )
		bGraphExplodePie = true;
	else
		bGraphExplodePie = false;

	pp.SetTempLeaf("GraphReportPieAngle");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "45";

	sPieAngle = value;

	pp.SetTempLeaf("SysMetricsGraphScale");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "100";

	sScale = value;

	pp.SetTempLeaf("SysMetricsReportFor");
	var value = pb.GetProperty(pp);
	if( value == McUndefined )
		value = "7";

	sReportFor = value;
}

