/**
 * JavaScript for the SSSettings page; this file needs to be included
 * if the SCOptionsDlg component is used.
 * Defines ss_init() for page initialization along with Show(), Validate()
 * and Apply() functions
 * Note: include it last.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var vframeworks = new Object();
var dataBindings = new Array();
var qparams = queryParameters();
var newInstance = false;
var newId = null;

var basePP = "Settings.SSSettings";
var ss_pb = null;
var origName="";
var settingsId = qparams["id"];
var ssOptsForm = "sc_options";

var g_changeNotifyFn = "top.gPageStack.Active().SetModified(true);";

// Initializes the page's forms
function ss_forms_init() {
    shs_affectedPolicyReport(newInstance, "SS", settingsId, ss_pb);

    var form = ssOptsForm;
    vframeworks["InstanceSettings"]= new ValidationFramework("InstanceSettings");
	vframeworks["InstanceSettings"].formAction = std_val_form_action;
    vframeworks["InstanceSettings"].fieldAction = std_val_field_action;
    vframeworks["InstanceSettings"].addValidator("displayName", new RequiredValidator());
    //vframeworks["InstanceSettings"].addValidator("displayName", new ScriptValidator());
	vframeworks["InstanceSettings"].addValidator("displayName", new InputTextValidator());
	vframeworks["InstanceSettings"].labelMap["displayName"] =  resolveString(cse_pp_field_st, "__instancename");

    var inputArray= new Array();
	inputArray["SECTION"]="Scanners";
	inputArray["origName"]=origName;
	inputArray["basePP"]="Settings.SSSettings";
	vframeworks["InstanceSettings"].addValidator("displayName",new DuplicatesValidator(ss_pb,inputArray));
	vframeworks["InstanceSettings"].addValidator("displayName",new LengthValidator());

    if (document.forms[form]) {
        vframeworks[form] = new ValidationFramework(form);
        var vf = vframeworks[form];
        vf.formAction = std_val_form_action;
        vf.fieldAction = std_val_field_action;
        var valInfo = {};
        valInfo["maxdepth"] = {min:2, max:100, lbl:"lm_maxdepth"};
        valInfo["maxwidth"] = {min:1, max:2047, lbl:"lm_maxwidth",
            key:"__max_width_err"};
        valInfo["ScannerTimeout"] = {min:1, max:999, lbl:"lm_ScannerTimeout",
            key:"__scanner_timeout_err"};
        var reqV = new RequiredValidator();
        var iList = [];
        for (var eName in valInfo) {
            var vI = valInfo[eName];
            vf.labelMap[eName] = resolveString(page_st, vI.lbl);
            vf.addValidator(eName, reqV);
            var rangeV = new RangeValidator(vI.min, vI.max);
            if (vI.key) {
                rangeV.errorMessage = new Function("return '" +
                    resolveString(cse_pp_st, vI.key) + "';");
            }
            vf.addValidator(eName, rangeV);
            iList.push(eName);
        }
        // Restrict input to integer values only
        setNumeric(ssOptsForm, iList, false, false);
    }
    addChangeNotification(g_changeNotifyFn);
}

// Sets form data and enables / disables controls as appropriate
function ss_init() {
    ss_forms_init();
    Reset();
}

/**
 * Asynchronous reset function
 */
function Reset() {
    var defValues = top.defValues["SS"];
    var ss_pp = new PropertyPath(basePP);
    for (var i = 0; i < dataBindings.length; i++) {
        dataBindings[i].set(ss_pp, ss_pb);
    }
    top.gPageStack.Active().SetModified(false);
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {
    if (null == pbIn) {
        pbIn = top.gPB;
    }
    newInstance = shs_initPB(pbIn, pp, "SS");
    ss_pb = pbIn;
    if (settingsId) {
        // Search for the settings blob to use
        basePP = top.GetBasePath(pbIn, basePP, "id", settingsId);
        if (null == basePP) {
            top.gPageStack.Active().Cancel();
            return;
        }
    }
    else {
        // Assume that we've been set up with the correct property path
        // and property bag
        basePP = pp.GetPath();
        settingsId = pbIn.GetPropertyDef(basePP + ".id", "");
        origName=pbIn.GetPropertyDef(basePP + ".displayName", "");
    }
    ss_init();
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    return shs_Validate();
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    if (null == pb) {
        pb = ss_pb;
    }
    shs_Apply(pb, basePP, dataBindings, newInstance);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    if (newInstance) {
        // Remove the new instance from the property bag
        ss_pb.DeleteElement(basePP);
    }
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
    return [];
}
