//Copyright (C) 2009 McAfee, Inc.  All rights reserved.

var gDaysOfWeekIDs = new Array("Sunday", "Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")
var gMonthsOfYearIDs = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")

var BitMask = new Array(0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800)

//useful times
var oneMinute = 60 * 1000
var oneHour = oneMinute * 60


/////////////////////////////////////////////////////////////////////
//
// Validate data in controls
//
//
function ScheduleValidate()
{

	if (document.getElementById("Once").checked)
	{
		if (!ScheduleValidateOnce()) return false
		if (!ScheduleValidateTime()) return false
	}

	if (document.getElementById("Hourly").checked)
	{
		if (!ScheduleValidateHourly()) return false
	}

	if (document.getElementById("Daily").checked)
	{
		if (!ScheduleValidateDailyRecur()) return false
		if (!ScheduleValidateTime()) return false
	}

	if (document.getElementById("Weekly").checked)
	{
		if (!ScheduleValidateWeeklyRecur()) return false
		if (!ScheduleValidateWeekdays()) return false
		if (!ScheduleValidateTime()) return false
	}

	if (document.getElementById("Monthly").checked)
	{
 		if (!ScheduleValidateMonthly()) return false
		if (!ScheduleValidateTime()) return false
	}

	if (document.getElementById("stopAfter").checked)
	{
		if (!ScheduleValidateStopAfter()) return false
	}
	return true;
}

////////////////////////////////////////////////////////////////////
//
// Transfer values from controls to wizard property bag
//
function ScheduleApply(pb,ppIn)
{

	// Go to correct place in propery bag and add root elements)
	var pp = new PropertyPath(ppIn.GetPath())

	// Add when
	pp.Append("When")
	pb.DeleteElement(pp)
	pb.SetProperty(pp)

	// Stop after
	if (document.getElementById("stopAfter").checked)
	{
		var mins= parseInt(document.getElementById("stopAfterHours").value,10)*60;
		mins+=parseInt(document.getElementById("stopAfterMinutes").value);
		pp.SetTempLeaf("StopAfterMinutes");
		mins=pb.SetProperty(pp,mins);
		pp.SetTempLeaf("");
	}

	// Remove What.startup
	var ppStartup = new PropertyPath(ppIn.GetPath());
	ppStartup.Append("What.OnDemand");
	ppStartup.SetTempLeaf("Startup");
	pb.DeleteElement(ppStartup)


	// Add nothing else if we are set to "never"
	if (document.getElementById("Never").checked)
		return true

	// Set up path for storing interval type
	var ppInterval = new PropertyPath(pp.GetPath())
	ppInterval.SetTempLeaf("Interval")
	pb.SetProperty(pp.GetPath())

	// Date time
	var dt = new Date()

	// Once
	if (document.getElementById("Once").checked)
	{
		pb.SetProperty(ppInterval.GetPath(), "once")
		dt = ScheduleDateFromControls();
	}

	// Hourly
	if (document.getElementById("Hourly").checked)
	{
		pb.SetProperty(ppInterval.GetPath(), "hourly")
		pp.SetTempLeaf("RepHours")
		pb.SetProperty(pp.GetPath(),parseInt(document.getElementById("RecurHourly").value, 10))
	}

	// Daily
	if (document.getElementById("Daily").checked)
	{
		pb.SetProperty(ppInterval.GetPath(), "daily")
		pp.SetTempLeaf("RepDays")
		pb.SetProperty(pp.GetPath(),parseInt(document.getElementById("RecurDaily").value, 10))
	}

	// Weekly
	if (document.getElementById("Weekly").checked)
	{
		pb.SetProperty(ppInterval.GetPath(), "weekly")
		pp.SetTempLeaf("RepWeeks")
		pb.SetProperty(pp.GetPath(),parseInt(document.getElementById("RecurWeekly").value, 10))
		var dayMask = 0
		for (var i=0; i < 7; i++)
		{
			if (document.getElementById(gDaysOfWeekIDs[i]).checked)
				dayMask = dayMask | BitMask[i]
		}
		pp.SetTempLeaf("DaysMask")
		pb.SetProperty(pp.GetPath(),dayMask)
	}

	// Monthly
	if (document.getElementById("Monthly").checked)
	{
		pb.SetProperty(ppInterval.GetPath(), "monthly")
		pp.SetTempLeaf("WeekOfMonth")
		pb.SetProperty(pp.GetPath(),document.getElementById("MonthlyWeek").selectedIndex+1)
		pp.SetTempLeaf("DaysMask")
		pb.SetProperty(pp.GetPath(), BitMask[document.getElementById("MonthlyDay").selectedIndex])
		var monthMask = 0
		for (var i=0; i < 12; i++)
		{
			if (document.getElementById(gMonthsOfYearIDs[i]).checked)
				monthMask = monthMask | BitMask[i]
		}
		pp.SetTempLeaf("MonthsMask")
		pb.SetProperty(pp.GetPath(), monthMask)
	}



	//Date Time
	dt.setHours(document.getElementById("dtHour").selectedIndex)
	dt.setMinutes(document.getElementById("Hourly").checked ? document.getElementById("RepMinsPast").selectedIndex : document.getElementById("dtMin").selectedIndex)
	dt.setSeconds(0)
	pp.SetTempLeaf("StartDT")
	pb.SetProperty(pp.GetPath(),DateToXML(dt))
	pp.SetTempLeaf("")
	return pb;
}

function ScheduleDateFromControls()
{
	return new Date(parseInt(document.getElementById("dtYear").selectedIndex + 2006,10),document.getElementById("dtMonth").selectedIndex,document.getElementById("dtDay").selectedIndex + 1);
}


function AddNumericOnlyValidation()
{
var fn =  cb_numOnlyNN;
document.getElementById("RecurHourly").onkeypress	= fn;
document.getElementById("RecurDaily").onkeypress		= fn;
document.getElementById("RecurWeekly").onkeypress	= fn;
document.getElementById("stopAfterHours").onkeypress = fn;
document.getElementById("stopAfterMinutes").onkeypress	 = fn;
}

////////////////////////////////////////////////////////////////////
//
// Transfers data from wizard property bag to controls when page
// is first loaded
//
var gShowStopAfter=false;
function ScheduleShow(ppIn,pb,bStopAfter)
{
	AddNumericOnlyValidation();
	// Move to when element
	gShowStopAfter=bStopAfter;
	var pp = new PropertyPath(ppIn.GetPath())
	pp.Append("When")

	// Get datetime
	pp.SetTempLeaf("StartDT")
	var value = pb.GetProperty(pp)
	var dt;
	var tmpdt;
	if (value != McUndefined)
	{
		tmpdt = pb.GetProperty(pp.GetPath())
		dt = XMLToDate(tmpdt)
	}
	pp.SetTempLeaf("");

	// Read interval type and set controls accordingly
	var option = 0
	pp.SetTempLeaf("Interval")
	var interval = pb.GetProperty(pp.GetPath())
	switch (interval)
	{

		case "once":
			document.getElementById("Once").checked = true
			option = 1
		break

		case "hourly":
			option = 2
			document.getElementById("Hourly").checked = true
			pp.SetTempLeaf("RepHours")
			document.getElementById("RecurHourly").value = pb.GetProperty(pp.GetPath())
			var dtMinIndex = tmpdt.substring(tmpdt.indexOf(":")+1,tmpdt.lastIndexOf(":"))
			document.getElementById("RepMinsPast").selectedIndex = dtMinIndex;
		break

		case "daily":
			option = 3
			document.getElementById("Daily").checked = true
			pp.SetTempLeaf("RepDays")
			document.getElementById("RecurDaily").value = pb.GetProperty(pp.GetPath())
		break

		case "weekly":
			option = 4
			document.getElementById("Weekly").checked = true
			pp.SetTempLeaf("RepWeeks")
			document.getElementById("RecurWeekly").value = pb.GetProperty(pp.GetPath())
			pp.SetTempLeaf("DaysMask")
			var daysMask = pb.GetProperty(pp.GetPath())
			for (var i=0; i < 7; i++)
			{
				 document.getElementById(gDaysOfWeekIDs[i]).checked = (daysMask & BitMask[i])
			}
		break

		case "monthly":
			option = 5
			document.getElementById("Monthly").checked = true
			pp.SetTempLeaf("WeekOfMonth")
			document.getElementById("MonthlyWeek").selectedIndex = parseInt(pb.GetProperty(pp.GetPath())) -1
			pp.SetTempLeaf("DaysMask")
			var mask= pb.GetProperty(pp.GetPath())
			for (var i=0; i < 7; i++)
			{
				if (mask & BitMask[i])
				  document.getElementById("MonthlyDay").selectedIndex =i
			}
			pp.SetTempLeaf("MonthsMask")
			var mask = pb.GetProperty(pp.GetPath())
			for (var i=0; i < 12; i++)
			{
				  document.getElementById(gMonthsOfYearIDs[i]).checked =(mask & BitMask[i])
			}
		break

		default: // never or startup
			var ppStartup = new PropertyPath(ppIn.GetPath())
			ppStartup.Append("What.OnDemand");
			ppStartup.SetTempLeaf("Startup");
			var startUpTask = pb.GetProperty(ppStartup);
			if( startUpTask )
			{
				option = 0
				document.getElementById("Startup").checked = true
			}
			else
			{
				option = 0
				document.getElementById("Never").checked = true
			}
		break

	}

	// Stop after
	pp.SetTempLeaf("StopAfterMinutes");
	var mins=pb.GetProperty(pp);
	if (mins != null)
	{
		document.getElementById("stopAfter").checked = true;
		document.getElementById("stopAfterHours").value = Math.floor(mins/60);
		document.getElementById("stopAfterMinutes").value = Math.round(mins%60);
	}
	pp.SetTempLeaf("")
	pp.RemoveLeaf()

	// Hide unwanted controls
	ScheduleShowHide(option,dt)
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Validates time
//
function ScheduleValidateTime()
{
	return true
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// The following function will make sure that if scheduling weekly at least one day of the
// week has been selected.
//
// Input: 	None
// Output:	boolean	- false = weekdays not validated successfully. true = weekdays validated successfully.
//
function ScheduleValidateWeekdays()
{
	var bSuccess = false;

	// Weekly schedule has been selected, check that at least one
	// day has been selected.
	if(document.getElementById("Monday").checked == true ||
	   document.getElementById("Tuesday").checked == true ||
	   document.getElementById("Wednesday").checked == true ||
	   document.getElementById("Thursday").checked == true ||
	   document.getElementById("Friday").checked == true ||
           document.getElementById("Saturday").checked == true ||
	   document.getElementById("Sunday").checked == true)
	{
		bSuccess = true
	}
	else
	{
		alert(gsOneDay)
		document.getElementById("Monday").focus()
	}
	return bSuccess;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Validates hourly
//
function ScheduleValidateHourly()
{
	var hourlyVal = document.getElementById("RecurHourly").value

	if(hourlyVal < 1 || hourlyVal > 23 || isNaN(hourlyVal))
	{
		alert(formatString(strRange, new Array(1,23)))
		return false;
	}

	return true
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Validates one off
//
function ScheduleValidateOnce()
{
	var dt= ScheduleDateFromControls();
	dt.setHours(document.getElementById("dtHour").selectedIndex);
	dt.setMinutes(document.getElementById("dtMin").selectedIndex);
	var now = new Date();
	now.setSeconds(0);
	now.setMilliseconds(0);
	if (dt <= now)
	{
		alert(gsInvalidDateTime);
		return false;
	}
	return true
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// The following function will make sure that if scheduling daily that something has been entered for the
// recur and it does not contain an invalid character
//
// Input: 	None
// Output:	boolean	- false = not validated successfully. true = validated successfully.
//
function ScheduleValidateDailyRecur()
{
	var bSuccess = false;

	// First check that the value is not null (or empty)
	if( document.getElementById("RecurDaily").value == null ||
		document.getElementById("RecurDaily").value == '' )
	{
		alert(gsRecurrance);
	}
	else
	{
		var xdays = parseInt(document.getElementById("RecurDaily").value, 10)
		if( isNaN ( document.getElementById("RecurDaily").value ) || xdays < 1 || xdays > 365 )
		{
			alert(formatString(strRange, new Array(1,365)))
			var ctrl = document.getElementById("RecurDaily")
			ctrl.focus()
		}
		else
			bSuccess = true;

	}

	// If the validation failed set focus to the input box
	if( bSuccess == false )
	{
		document.getElementById("RecurDaily").focus();
	}

	return bSuccess;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// The following function will make sure that if scheduling Weekly that something has been entered for the
// recur and it does not contain an invalid characters.
//
// Input: 	None
// Output:	boolean	- false = not validated successfully. true = validated successfully.
//
function ScheduleValidateWeeklyRecur()
{
	var bSuccess = false;

	// First check that the value is not null (or empty)
	if( document.getElementById("RecurWeekly").value == null ||
		document.getElementById("RecurWeekly").value == '' )
	{
		alert(gsRecurrance);
	}
	else
	{
		var xweeks = parseInt(document.getElementById("RecurWeekly").value, 10)
		if( isNaN ( document.getElementById("RecurWeekly").value ) || xweeks < 1 || xweeks > 52 )
		{
			alert(formatString(strRange, new Array(1,52)))
			var ctrl = document.getElementById("RecurWeekly")
			ctrl.focus()
		}
		else
			bSuccess = true;
	}

	// If the validation failed set focus to the input box
	if( bSuccess == false )
	{
		document.getElementById("RecurWeekly").focus();
	}

	return bSuccess;
}

///////////////////////////////////////////////////////////
//
// Validates monthly schedule
//
function ScheduleValidateMonthly()
{
	if(document.getElementById("Jan").checked == false &&
	   document.getElementById("Feb").checked == false &&
	   document.getElementById("Mar").checked == false &&
	   document.getElementById("Apr").checked == false &&
	   document.getElementById("May").checked == false &&
           document.getElementById("Jun").checked == false &&
	   document.getElementById("Jul").checked == false &&
	   document.getElementById("Aug").checked == false &&
	   document.getElementById("Sep").checked == false &&
	   document.getElementById("Oct").checked == false &&
           document.getElementById("Nov").checked == false &&
	   document.getElementById("Dec").checked == false)
	{
		alert(gsOneMonth)
		document.getElementById("Jan").focus()
		return false
	}
	return true
}

function ScheduleValidateStopAfter()
{
	var ctrl=document.getElementById("stopAfterHours");
	var hours = parseInt(ctrl.value, 10)
	if(hours  < 0 || hours > 99 || isNaN(hours))
	{
		alert(formatString(strRange, new Array(0,99)))
		ctrl.focus()
		return false;
	}
	var ctrl=document.getElementById("stopAfterMinutes");
	var mins = parseInt(ctrl.value, 10)
	if(mins  < 0 || mins > 59 || isNaN(mins))
	{
		alert(formatString(strRange, new Array(0,59)))
		ctrl.focus()
		return false;
	}
	if(mins==0 && hours==0)
	{
		alert(gsNoStopAfter);
		ctrl.focus();
		return false;
	}
	return true;
}

function SetDescription(desc)
{
	document.getElementById("description").innerHTML = desc
}

//////////////////////////////////////////////////////////
//
// Shows/hides controls based on current option selected
//
function ScheduleShowHide(option,dt)
{
	// Hide everything
	HideElement("divOnce")
	HideElement("divHourly")
	HideElement("divDaily")
	HideElement("divWeekly")
	HideElement("divMonthly")
	HideElement("divTime")

	// Show what we need
	switch (option)
	{
		case 1:
			ShowElement("divOnce")
			ShowElement("divTime")
		break
		case 2:
			ShowElement("divHourly")
			ShowElement("divStopAfter")
		break
		case 3:
			ShowElement("divDaily")
			ShowElement("divTime")
		break
		case 4:
			ShowElement("divWeekly")
			ShowElement("divTime")
		break
		case 5:
			ShowElement("divMonthly")
			ShowElement("divTime")
		break
		default:
		break
	}
	if (gShowStopAfter)
	{
		ShowElement("divStopAfter");
		ScheduleEnableStopAfter();
	}
	else
		HideElement("divStopAfter");



	// Use current datetime if none provided
	if (!dt)
	{
		dt = new Date();
		dt.setMilliseconds(dt.getMilliseconds() + 300000);
	}

	// Set contols
	document.getElementById("dtHour").selectedIndex = dt.getHours();
	document.getElementById("dtMin").selectedIndex = dt.getMinutes();
	document.getElementById("dtDay").selectedIndex = dt.getDate() - 1;
	document.getElementById("dtMonth").selectedIndex = dt.getMonth();
	document.getElementById("dtYear").selectedIndex = dt.getFullYear() - 2006;
}

//////////////////////////////////////////////////////////
//
// Updates days in month on month change
//
function OnMonthChange()
{
	var month= document.getElementById("dtMonth").selectedIndex
	var year= document.getElementById("dtYear").selectedIndex
	var day = document.getElementById("dtDay").selectedIndex
	var numDays = getMonthLength(month+1,year+2006)
	var ctrl = document.getElementById("dtDay")
	while (ctrl.childNodes.length > 0)
	{
		ctrl.removeChild(ctrl.childNodes[0])
	}

	for (var i =1; i <= numDays; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		ctrl.appendChild(opt)
		if (i == day+1)
		    opt.selected=true
	}
}

//////////////////////////////////////////////////////////
//
// Updates days in month on month change
//
function ScheduleEnableStopAfter()
{
	var checked = document.getElementById("stopAfter").checked;
	document.getElementById("stopAfterHours").disabled = !checked;
	document.getElementById("stopAfterMinutes").disabled = !checked;
}
