//Copyright (C) 2017 McAfee, Inc.  All rights reserved.
// Gives unique Ids, even if there is more than one
// selector on the page
var gID =0

/////////////////////////////////////////////////
//
// Handles click on a table entry
//
function SelectorSelect(e)
{
	var ctrl=window.event?window.event.ctrlKey:e.ctrlKey;
	var target=window.event?window.event.srcElement:e.target;
	selector.Select(target.idRaw,ctrl);
	return false;
}

/////////////////////////////////////////////////
//
// Constructor for selector entry
//
function SelectorEntry(path,icon)
{
	this.path = path
	this.bSubfolders = true
	this.Render=RenderEntry
	this.id = gID++
	this.icon = icon
}

/////////////////////////////////////////////////
//
// Renders an entry as HTML within the sector
// element
//
function RenderEntry(selector)
{
	// Create wrapping div
	var elem=document.createElement("DIV")
	elem.className = "pickerNode"
	elem.id = "e_" +  this.id

	// Add icon if available
	if (this.icon != McUndefined)
	{
		var fdrEl=document.createElement("IMG")
		if(gIsEPO4)
		{
			if(this.icon == "TwoStackedClosedFolders.gif")
			{
				fdrEl.setAttribute("src","../../../MSME____8600/DATA/Locale/images/picker/" + this.icon)
			}
			else if(this.icon == "twostackedclosedfolders.gif")
			{
				fdrEl.setAttribute("src","../../../MSME____8600/DATA/Locale/images/picker/TwoStackedClosedFolders.gif")
			}
			else if(this.icon == "ClosedFolder.gif")
			{
				fdrEl.setAttribute("src","../../../MSME____8600/DATA/Locale/images/picker/" + this.icon)
			}
			else if(this.icon == "closedfolder.gif")
			{
				fdrEl.setAttribute("src","../../../MSME____8600/DATA/Locale/images/picker/ClosedFolder.gif")
			}			
		}
		else
		{
			fdrEl.setAttribute("src","../../images/picker/" + this.icon)
		}
		elem.appendChild(fdrEl)
	}

	// Add Label
	var nameEl=document.createElement("SPAN")
	nameEl.onclick = SelectorSelect;
	if (selector.selectCallback != McUndefined)
		nameEl.ondblclick = new Function(selector.selectCallback);
	nameEl.className = this == selector.selected ? "nodeLabelSelected" : "nodeLabel"
	nameEl.innerHTML = this.path
	nameEl.id ="el_" + this.id
	nameEl.idRaw=this.id;
	elem.appendChild(nameEl)
	return elem
}

/////////////////////////////////////////////////
//
// Constructor for selector class
//
// Callback is called each time a new item is
// highlighted
//
function Selector(name,selectCallback)
{
	// Member data
	this.entries = new Array
	this.selected = McUndefined
	this.selectedIndex = -1
	this.name = name

	// Member functions
	this.Add = AddEntry
	this.Select = SelectEntry
	this.SelectOnIndex = SelectOnIndex
	this.selectCallback = selectCallback
	this.OnKeyPress = OnKeyPress
}

/////////////////////////////////////////////////
//
// Add an entry to the list
//
function AddEntry(path,icon)
{
	var ne = new SelectorEntry(path,icon)
	this.entries[this.entries.length] = ne
	document.getElementById(this.name).appendChild(ne.Render(this))
}

/////////////////////////////////////////////////
//
// Remove an entry from the list
//
Selector.prototype.RemoveSelection=function()
{
	var nes = new Array
	for (var i in this.entries)
	{
		if (this.entries[i].selected)
			// Remove display element
			document.getElementById(this.name).removeChild(document.getElementById("e_" + this.entries[i].id))
		else
			nes[nes.length] = this.entries[i];
	}
	this.entries = nes;
}

/////////////////////////////////////////////////
//
// Select an entry in the list
//
function SelectEntry(id,ctrl)
{
	// Select new node
	if (!ctrl)
		this.SelectNone();
	for (var i=0; i < this.entries.length; i++)
		if (this.entries[i].id == id)
			this.SelectOnIndex(i)
}
function SelectOnIndex(i,ctrl)
{
	if (this.entries[i].selected)
	{
		document.getElementById("el_" + this.entries[i].id).className="nodeLabel"
		this.entries[i].selected=false;
	}
	else
	{
		this.entries[i].selected=true;
		document.getElementById("el_" + this.entries[i].id).className="nodeLabelSelected"
	}
}

Selector.prototype.FirstSelection=function()
{
	for (var i in this.entries)
		if (this.entries[i].selected)
			return parseInt(i,10);
	return -1;
}
Selector.prototype.SelectNone=function()
{
	for (var i in this.entries)
	{
		if (this.entries[i].selected)
		{
			this.entries[i].selected=false;
			document.getElementById("el_" + this.entries[i].id).className="nodeLabel"
		}
	}
}

////////////////////////////////////////////////////
//
// Allows keyboard navigation of list
//
function OnKeyPress(event)
{
	// up
	if (event.keyCode == 38)
	{
		var i=this.FirstSelection();
		this.SelectNone();
		if (i==-1)
		{
			if (this.entries.length>0)
				this.SelectOnIndex(this.entries.length-1)
		}
		else
		{
			if (i > 0)
				this.SelectOnIndex(i-1,true)
		}
		return false
	}

	//down
	if (event.keyCode == 40)
	{
		var i=this.FirstSelection();
		this.SelectNone();
		if (i==-1)
		{
			if (this.entries.length>0)
				this.SelectOnIndex(0)
		}
		else
		{
			if (i < this.entries.length-1)
				this.SelectOnIndex(i+1,true)
		}
		return false
	}
	return true
}

