//Copyright (C) 2017 McAfee, Inc.  All rights reserved.
// Validators
var vfAntiSpam	  = new ValidationFramework("antispamForm");
//var bIsEPO        = (typeof(gEPOMode) != "undefined" && gEPOMode)
var labelMap      = new Object();
labelMap["updateinterval"] = "updateinterval";
labelMap["idTSThreshold"] = gsErrTrustedSource;

////////////////////////////////////////////////
//
// Writes current config settings into controls 
// and then reset modified flag
//

function AddNumericOnlyValidation()
{
   	var fn =   cb_numOnlyNN ;
	document.getElementById("idTSThreshold").onkeypress =  fn ;
}


function Show(pbIn)
{
		//BZ 263087
		parent.Get(pbIn)
		// Initialize validators
		var rv = new RequiredValidator();
		var nv = new NumericValidator();
		var rangeVtor = new RangeValidator(1, 5000);
		var inputVtor = new InputTextValidator(true);
		
		
		var emailVtorSdr = new EmailValidator(false);
		vfAntiSpam.addValidator("spamsysfolder", emailVtorSdr);
		
	//	var cvScanTimeout	= new CrossValidator("value >= 0 && value <= 5000", gsScanTimeout); 

		vfAntiSpam.addValidator("updateinterval", rv);
		vfAntiSpam.addValidator("updateinterval", nv);
		vfAntiSpam.addValidator("updateinterval", rangeVtor);
		vfAntiSpam.addValidator("spamsysfolder", inputVtor);
		
	//	vfOnAccess.addValidator("Timeout", cvScanTimeout);

		setNumeric("antispamForm", ["updateinterval"], true, false);

		vfAntiSpam.labelMap = labelMap;
		vfAntiSpam.formAction = std_val_form_action;
		vfAntiSpam.fieldAction = std_val_field_action;
	
	//if(!bIsEPO) // Show the Junk mail routing ui only for ePO & not E2K10
	//{
	//	document.getElementById("UsrJunkFldrRouting_div").style.display = "none";
	//}

	if( IsAntiSpamLicenseValid())
	{
		// Transfer properties from given bag to
		// page controls using current property path ...
	
		var pp = new PropertyPath("SpamSettings")
		pp.SetTempLeaf("SpamSysFolder")
		
		document.getElementById("spamsysfolder").value = pbIn.GetProperty(pp)

		pp.SetTempLeaf("TSEnabled")
		document.getElementById("idEnableTS").checked = pbIn.GetProperty(pp)

		pp.SetTempLeaf("TSAction")
		document.getElementById("idTSAction").selectedIndex = pbIn.GetProperty(pp)

		pp.SetTempLeaf("TSThreshold")
		document.getElementById("idTSThreshold").value = pbIn.GetProperty(pp)
		
		pp.SetTempLeaf("TSAfterAS")
		document.getElementById("idTSAfterAS").checked = pbIn.GetProperty(pp)
		
		if(pbIn.GetProperty(pp) == "1")
		{
			document.getElementById("idTSAction").style.display = "none"
			document.getElementById("idTSActionOnly").style.display = "block"
		}
		else
		{
			document.getElementById("idTSAction").style.display = "block"
			document.getElementById("idTSActionOnly").style.display = "none"
		}
		EnableDisableCheck();
		AddNumericOnlyValidation();
		vfAntiSpam.addValidator("idTSThreshold", new CrossValidator("value >=0 && value <=999", formatString(strRange, new Array("0", "999"))));
		pp.SetTempLeaf("")
	
	//display fields related to IP reputation
		pp.SetTempLeaf("TSIPEnabled")
		document.getElementById("idEnableTSIPR").checked = pbIn.GetProperty(pp)
	// IP reputation classes are defined by TS as follows:
		// <0  		: Trusted IP
		//  0 - 14 	: Neutral IP
		// 15 - 29 	: Unverified IP
		// 30 - 49 	: Suspicious IP
		// >50	 	: Malicious IP
	//Hence, assign the lower bound as the threshold value in config file for a ">=" comparison in the backend.
	//However, the Trusted IP threshold has to be kept as -1 and do a "<=" comparison in backend.
		pp.SetTempLeaf("TSIPRClass")
		if( pbIn.GetProperty(pp) == -1) {
			document.getElementById("idTSIPRClass").selectedIndex = 4;
		}
		else if( pbIn.GetProperty(pp) == 0) {
			document.getElementById("idTSIPRClass").selectedIndex = 3;
		}		
		else if( pbIn.GetProperty(pp) == 15) {
			document.getElementById("idTSIPRClass").selectedIndex = 2;
		}
		else if( pbIn.GetProperty(pp) == 30) {
			document.getElementById("idTSIPRClass").selectedIndex = 1;
		}
		else {
			document.getElementById("idTSIPRClass").selectedIndex = 0;
		}

		pp.SetTempLeaf("TSIPAction")
		document.getElementById("idTSActionIP").selectedIndex = pbIn.GetProperty(pp)
		
		IPEnableDisableCheck();		
		pp.SetTempLeaf("SPFEnabled")
		document.getElementById("idEnableSPF").checked = pbIn.GetProperty(pp)
		SPFEnableDisableCheck();
			
		pp.SetTempLeaf("OnSPFSoftFail")
		var onSoftFail = parseInt(pbIn.GetProperty(pp));
		var spfsoftfailSelectEl = document.getElementById("spfsoftfailSelect");
		spfsoftfailSelectEl.value = onSoftFail;
		
		pp.SetTempLeaf("OnSPFHardFail")
		var onHardFail = parseInt(pbIn.GetProperty(pp));
		var spfhardfailSelectEl = document.getElementById("spfhardfailSelect");
		spfhardfailSelectEl.value = onHardFail;
/*		//Commenting since User Level B/W lists functionality is moved to MQM
		pp.SetTempLeaf("UserAllowDenyLists")
		
		document.getElementById("userallowdenylists").checked = pbIn.GetProperty(pp)
		
		pp.SetTempLeaf("UserAllowDenyListServerURL")
		
		document.getElementById("listserverurl").value = pbIn.GetProperty(pp)
					
		pp.SetTempLeaf("UserAllowDenyListUpdateInterval")
		
		document.getElementById("updateinterval").value = pbIn.GetProperty(pp)
*/		
		// Reset property path
		pp.SetTempLeaf("")

		DisableControlsAsPerExRole()

	}
	else
	{
		document.getElementById("spamsysfolder").disabled = true
        
		// Disable TS elements
		document.getElementById("idEnableTS").disabled  = true
		document.getElementById("idTSThreshold").disabled = true
		document.getElementById("idTSAction").style.display = "block";
		document.getElementById("idTSAction").disabled  = true;
		document.getElementById("idTSAfterAS").disabled  = true;		
		document.getElementById("idEnableSPF").disabled  = true;	
		SPFEnableDisableCheck();		
		
		document.getElementById("idEnableTSIPR").disabled  = true
		document.getElementById("idTSIPRClass").disabled = true
		document.getElementById("idTSActionIP").disabled  = true;

/*		//Commenting since User Level B/W lists functionality is moved to MQM
        // User-level lists
		document.getElementById("listserverurl").disabled = true
		document.getElementById("updateinterval").disabled = true
		document.getElementById("userallowdenylists").disabled = true
*/
	}


}

////////////////////////////////////////////////
// 
// Validates values in controls before applying
//
function Validate()
{
	var address = document.getElementById("spamsysfolder").value	
	
	if ( !ValidateTextInput(address))
	{
		alert(gsScriptNotAllowed);
		document.getElementById("spamsysfolder").focus()
		return false;
	}
	
	if(!ValidateAlertTextInput(address))
	{
		alert(gsScriptNotAllowed);
		document.getElementById("spamsysfolder").focus()
		return false;
	}
	
/*		//Commenting since User Level B/W lists functionality is moved to MQM
	if ( document.getElementById("userallowdenylists").checked )
    {
        var ctrl  = document.getElementById("updateinterval")
        var inter = parseInt(ctrl.value,10)
        
        if (inter <1 || inter >1440 || isNaN(inter))
        {
            alert(SubstituteTokens(gstrRange, new Array(1,1440)))
            ctrl.focus()
            return false
        }
    }
*/

	return vfAntiSpam.onsubmit();	
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function Apply(pbOut)
{

	var pp = new PropertyPath("SpamSettings")
	pbOut.SetProperty(pp);
	
	pp.SetTempLeaf("SpamSysFolder")
	pbOut.SetProperty(pp, document.getElementById("spamsysfolder").value)
	
	pp.SetTempLeaf("TSEnabled")
	pbOut.SetProperty(pp, document.getElementById("idEnableTS").checked ? 1 : 0)

	pp.SetTempLeaf("TSAfterAS")
	pbOut.SetProperty(pp, document.getElementById("idTSAfterAS").checked ? 1 : 0)

	pp.SetTempLeaf("SPFEnabled")
	pbOut.SetProperty(pp, document.getElementById("idEnableSPF").checked ? 1 : 0)
	pp.SetTempLeaf("TSAction")
	pbOut.SetProperty(pp, document.getElementById("idTSAction").selectedIndex)

	var TSThresholdval = document.getElementById("idTSThreshold").value;
	if (document.getElementById("idEnableTS").checked)
	{
		if (document.getElementById("idTSAction").selectedIndex == 0)
		{
			pp.SetTempLeaf("TSThreshold")
			pbOut.SetProperty(pp, TSThresholdval)
		}
		else if(TSThresholdval <0 || TSThresholdval > 999)
		{
			pp.SetTempLeaf("TSThreshold")
			pbOut.SetProperty(pp, 80) // if it is not valid then assign it to default
		}
		else
		{
			pp.SetTempLeaf("TSThreshold")
			pbOut.SetProperty(pp, TSThresholdval) 
		}
	}
	else if(TSThresholdval <0 || TSThresholdval > 999)
	{
		pp.SetTempLeaf("TSThreshold")
		pbOut.SetProperty(pp, 80) // if it is not valid then assign it to default
	}
	else
	{
		pp.SetTempLeaf("TSThreshold")
		pbOut.SetProperty(pp, TSThresholdval) 
	}
/*	//Commenting since User Level B/W lists functionality is moved to MQM	
	// User-level lists
	pp.SetTempLeaf("UserAllowDenyLists")
	pbOut.SetProperty(pp, document.getElementById("userallowdenylists").checked ? 1 : 0)
	
	pp.SetTempLeaf("UserAllowDenyListServerURL")
	pbOut.SetProperty(pp, document.getElementById("listserverurl").value)

	pp.SetTempLeaf("UserAllowDenyListUpdateInterval")
	pbOut.SetProperty(pp, document.getElementById("updateinterval").value)
*/	

	pp.SetTempLeaf("TSIPEnabled")
	pbOut.SetProperty(pp, document.getElementById("idEnableTSIPR").checked ? 1 : 0)	
	
	pp.SetTempLeaf("TSIPRClass")
	if( document.getElementById("idTSIPRClass").selectedIndex == 4) {
		pbOut.SetProperty(pp, -1)
	}
	else if ( document.getElementById("idTSIPRClass").selectedIndex == 3) {
		pbOut.SetProperty(pp, 0)		
	}
	else if ( document.getElementById("idTSIPRClass").selectedIndex == 2) {
		pbOut.SetProperty(pp, 15)
	}
	else if ( document.getElementById("idTSIPRClass").selectedIndex == 1) {
		pbOut.SetProperty(pp, 30)
	}
	else {
		pbOut.SetProperty(pp, 50)
	}
	
	pp.SetTempLeaf("TSIPAction")
	pbOut.SetProperty(pp, document.getElementById("idTSActionIP").selectedIndex)
	var spfsoftfailSelectEl = document.getElementById("spfsoftfailSelect");
	var spfsoftfailSelectValue = parseInt(spfsoftfailSelectEl.options[spfsoftfailSelectEl.selectedIndex].value);	
	pp.SetTempLeaf("OnSPFSoftFail");
	pbOut.SetProperty(pp, spfsoftfailSelectValue);

	var spfhardfailSelectEl = document.getElementById("spfhardfailSelect");
	var spfhardfailSelectValue = parseInt(spfhardfailSelectEl.options[spfhardfailSelectEl.selectedIndex].value);		
	pp.SetTempLeaf("OnSPFHardFail");
	pbOut.SetProperty(pp, spfhardfailSelectValue);
	
	pp.SetTempLeaf("")

	top.SetModified(false);
	return(pbOut);
/*
	// Remove all settings
	pbOut.DeleteElement(parent.gPP.GetPath())
		
	parent.gPP.SetTempLeaf("SpamSysFolder")
	pbOut.SetProperty(parent.gPP.GetPath(),document.getElementById("spamsysfolder").value)

    // User-level lists
	parent.gPP.SetTempLeaf("UserAllowDenyLists")
	pbOut.SetProperty(parent.gPP.GetPath(),document.getElementById("userallowdenylists").checked ? 1 : 0)	

	parent.gPP.SetTempLeaf("UserAllowDenyListServerURL")
	pbOut.SetProperty(parent.gPP.GetPath(),document.getElementById("listserverurl").value)

	parent.gPP.SetTempLeaf("UserAllowDenyListUpdateInterval")
	pbOut.SetProperty(parent.gPP.GetPath(),document.getElementById("updateinterval").value)

	parent.gPP.SetTempLeaf("")
	return true
*/
}

function IsAntiSpamLicenseValid()
{
	// Assume valid if in ePO console
	if ((gEPOMode != "undefined") && (gEPOMode == true))
		return true

	var valid = false;

	var pp = new PropertyPath( "systemstate.license")
	pp.Append( gsLicenseTypes[1] )
	pp.SetTempLeaf("licenseexpiry")

	var expires = parent.gSystemStatePB.GetProperty( pp.GetPath() )
	if((expires != undefined))
	{
		if( expires != 0 )
		{
			var date = new Date( expires * 1000 )
			var now = new Date()
			if( now < date )
			{
				valid = true;
			}
		}
		else
		{
			// License never expires
			valid = true;
		}
	}

	return valid;
}

function EnableDisableCheck()
{
	//To disable the TSAction & TSThreshold if TS is not enabled
	if(document.getElementById("idEnableTS").checked == 0)
	{
		var ctrlArray = new Array("idTSAction","idTSActionOnly","idTSThreshold","idTSAfterAS");//Disable and grey all these controls
		for(var i=0;i<ctrlArray.length;i++)
		{
			var ctrl = document.getElementById(ctrlArray[i]);
			ctrl.disabled = true;
		}
	}
	else
	{
		if(document.getElementById("idTSAfterAS").checked == 0)
		{
			document.getElementById("idTSAction").style.display = "block"
			document.getElementById("idTSActionOnly").style.display = "none"
			
			// If TSAction is drop & quarantine i.e 0 then only enable threshold id
			if(document.getElementById("idTSAction").selectedIndex == 0)
			{
				document.getElementById("idTSThreshold").disabled = false
				document.getElementById("idTSThreshold").style.backgroundColor = "#FFFFFF";//Force to Ungrey
			}
			else
			{
				document.getElementById("idTSThreshold").disabled = true
				document.getElementById("idTSThreshold").style.backgroundColor = "#D4D0C8";//Force to Grey
			}
		}
		else
		{
			document.getElementById("idTSAction").style.display = "none"
			document.getElementById("idTSActionOnly").style.display = "block"
			document.getElementById("idTSThreshold").disabled = false
			document.getElementById("idTSThreshold").style.backgroundColor = "#FFFFFF";//Force to Ungrey
		}
		
		var ctrlArray = new Array("idTSAction","idTSActionOnly","idTSAfterAS");//Enable and ungrey all these controls
		for(var i=0;i<ctrlArray.length;i++)
		{
			var ctrl = document.getElementById(ctrlArray[i]);
			ctrl.disabled = false;
		}
	}
}

function SPFEnableDisableCheck()
{
	var checkedState = document.getElementById("idEnableSPF").checked;
	var ctrlArray = new Array( "spfhardfailSelect", "spfsoftfailSelect" );//[Disable & grey] OR [Enable and ungrey] these controls based on checked state of checkbox
	for(var i=0;i<ctrlArray.length;i++)
	{
		var ctrl = document.getElementById(ctrlArray[i]);
		ctrl.disabled = !checkedState;
	}
}
function IPEnableDisableCheck()
{
	//To disable the TSAction & TSThreshold if TS is not enabled	
	var checkedState = document.getElementById("idEnableTSIPR").checked;
	var ctrlArray = new Array("idTSIPRClass","idTSActionIP");//[Disable & grey] OR [Enable and ungrey] these controls based on checked state of checkbox
	for(var i=0;i<ctrlArray.length;i++)
	{
		var ctrl = document.getElementById(ctrlArray[i]);
		ctrl.disabled = !checkedState;
		ctrl.style.backgroundColor = checkedState ? "#FFFFFF" : "#D4D0C8";//Force to Ungrey or Grey
	}
}

function AlertEmailsBlocked()
{
	if(document.getElementById("idEnableTSIPR").checked)
	{
		var indx = document.getElementById("idTSIPRClass").selectedIndex;
		if(indx == 3 || indx == 4) //Show Warning if a class with threshold below 15 is selected
			alert(gsEmailsBlocked);
	}
}

// This function disables controls based on installed Exchange server roles.
function DisableControlsAsPerExRole() {
	var bSystemJunk = false, bUserJunk = false, bTrustedSrc = false
	
	if(IsBHInstalled() || IsGWInstalled()) {
		bSystemJunk = true
	}
	
	if(IsBHInstalled() || IsGWInstalled()){
		bTrustedSrc = true
	}
	
	if(!bSystemJunk) {
		DisableFormControls(document.getElementById("gatewayspamfilter_div"))
		document.getElementById("gatewayspamfilter_disabledmsg").style.display = ""
	}
	
	if(!bTrustedSrc){
		DisableFormControls(document.getElementById("TrustedSource_div"))
		document.getElementById("Trustedsrc_disabledmsg").style.display = ""
	}
}