/**
 * JavaScript for the SpamSettings page; this file needs to be included
 * if any of the following components are used:
 * BasicSpamOptionsDlg.xml, AadvancedSpamOptionsDlg.xml, SpamBlackAndWhiteListsPanel.xml
 * Defines spam_init() for page initialization along with Show(), Validate()
 * and Apply() functions
 * Note: include it last.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var vframeworks = new Object();
var dataBindings = new Array();
var inputLists = new Object();
var qparams = queryParameters();
var newInstance = false;
var newId = null;
var g_changeNotifyFnStr = "top.gPageStack.Active().SetModified(true);";
var engineNetworkTestsEnabled = false;
var networkTestsEnabled = false;


var sp_bOptsForm = "basic_spam_options";
var sp_aOptsForm = "advanced_spam_options";

var basePP = "Settings.ASSettings";
var spam_pb = null;
var origName="";
var settingsId = qparams["id"];

var sp_reqV = null;
var sp_floatV = null;
var sp_scoreV = null;
var sp_scriptV = null;
var sp_rulescoreV = null;

var sp_highscoreV = null;
var sp_mediumscoreV = null;
var sp_lowscoreV = null;

// Step size for processing spam rules
var stepSize = 100;

// Lots of work to do on this page, so hide the save / cancel buttons
shs_showSave(false);

var g_spamRulesDoc = null;

// Specialized data-binding class for the BayesIdentities string
function BayesIdDataBinding() {
}

BayesIdDataBinding.prototype = new DataBinding("", "", "");

BayesIdDataBinding.prototype.set = function(pp, pbIn) {
    var bayesIdStr = sProfGetProfiles(pbIn).join(",");
    pbIn.SetProperty(pp.toString() + ".BayesIdentities", bayesIdStr);
}

BayesIdDataBinding.prototype.get = function(pp, pbOut) {
    // We need to propagate the string to all ASSettings blobs
    var bayesIdStr = sProfGetProfiles(pbOut).join(",");
    pSuffix = ".BayesIdentities";
    var ppT = new PropertyPath("Settings.ASSettings");
    for (ppT.BeginEnum(); null != pbOut.GetProperty(ppT); ppT.IncrementEnum()) {
        pbOut.SetProperty(ppT.toString() + pSuffix, bayesIdStr);
    }
    return false;
}


// Specialized input list widget for black / white list entries; add an
// enabled / disabled checkbox next to each text input
function BWInputList(initialValues, divId, objectName, properties, instance, settingsID) {
    this.currentValue = initialValues;
    this.fieldCount = (null != initialValues) ? this.currentValue.length : 0;
    this.divId = divId;
    this.objectName = objectName ? objectName : "inputList";
    this.enabled = true;
	this.instance = instance;
	this.settingsID = settingsID;

    il_init(properties, this);
	this.listName = this.getListName();
	if( !gEPOMode )	{
		this.CreateImportPopup();
	}
	var popid = this.objectName + 'popdiv';
	this.pop = document.getElementById(popid);
	this.scrollAfter = 9;
}

BWInputList.prototype = new InputList(null, "", "", null);
BWInputList.prototype.drawEmptyRowA = BWInputList.prototype.drawEmptyRow;
BWInputList.prototype.drawCurrentInputRowA = BWInputList.prototype.drawCurrentInputRow;

BWInputList.prototype.getInputValue = function(index) {
    var inputId = this.uniquifier + "_" + this.baseFieldName + "_" + index;
    var text = this.currentValue[index].substring(1);
    /*if (this.filter) {
        text = this.filter(text);
    }*/
    var cbId = this.uniquifier + "_cb_" + index;
    //put invalid mail character for checkbox validation "(" for 1 and ")" for 0
    var eFlag = document.getElementById(cbId).checked ? "(" : ")";
    return eFlag + text;
}

BWInputList.prototype.getListName = function() {
	var bwListWidgets = ["wlFrom", "wlTo", "blFrom", "blTo"];
	var objName = this.objectName;
	
	for( var i=0; i < bwListWidgets.length; i++)
	{
		var index = objName.indexOf(bwListWidgets[i]);
		
		if(index != -1)
		return bwListWidgets[i];
	}
}

BWInputList.prototype.getValue = function() {
    var ret = new Array();
    // Get the existing values
    for (var i = 0; i < this.fieldCount; i++) {
        ret.push(this.getInputValue(i));
    }
    if (this.getUncommitted && this.enabled) {
        var currEntry = this.getCurrentInputValue();
        if (currEntry) {
            ret.push("(" + currEntry);
        }
    }
    return ret;
}

BWInputList.prototype.draw = function(enabled) {
    this.enabled = enabled;
    var html = "";
    // The control is drawn in a single column unless the number of values
    // plus any empty text field at the end exceeds four, in which case the
    // control is drawn as two columns
    var dimensions = this.getDimensions(enabled);
    var inputCount = dimensions.fields;
    var colCount = dimensions.columns;
    var rowCount = dimensions.rows;

	
	html += "<div align=\"right\" style=\"width:90%\" >	";
	if( !this.instance && !gEPOMode)
	{
		html += "<a href=\"javascript:" + this.objectName + ".ShowImportPopup()\" class=\"blueLink\">" +
				resolveString(il_st, "gsImport") + "</a>&nbsp;&nbsp;&nbsp;";
		html += "<a href=\"javascript:" + this.objectName + ".Export()\" class=\"blueLink\">" +
				resolveString(il_st, "gsExport") + "</a>&nbsp;&nbsp;&nbsp;";
	}
	html += "<a href=\"javascript:" + this.objectName + ".DeleteAll()\" class=\"blueLink\">" +
            resolveString(il_st, "gsDeleteAll") + "</a>";
	html += "	</div>";
	
	html += "	<div style=\"padding:10px 0px 0px 10px;\" >"; 
	html += "		<textarea id=\"" + this.objectName + "_txtareaid" 
				+"\" cols=\"60\" rows=\"4\" value=\"\" align=\"left\"/> </textarea>&nbsp;&nbsp;&nbsp;";
	html += "<a href=\"javascript:" + this.objectName + ".add()\" class=\"blueLink\">" +
            resolveString(il_st, "gsAdd") + "</a>";
	html += "	</div>";
	html += "<div style=\"padding:10px 10px 10px 10px;\">" +
            ReplaceSpecialHTMLChars(this.directive) + "</div>";
	html += "	</div>";
	
    html += "<div ";
    if (this.scrolling && rowCount > this.scrollAfter) {
        var height = this.rowHeight * this.scrollAfter;
        html += " style=\"height:" + height + "px; overflow:auto;\"";
    }

    html += ">";

	if(this.currentValue.length > 0) {
		// Specify 95% width to avoid horizontal scrollbar in Mozilla browsers
		html += "<table class=\"blockallow\" cellpadding=\"1\" cellspacing=\"8\" width=\"95%\" >";
		html += "<tbody>";
		html += "<tr > <th >" + resolveString(il_st, "gsHDEnable");
		html += "</th><th align=\"left\">" + resolveString(il_st, "gsHDAddress");
		html += "</th><th >" + resolveString(il_st, "gsHDAction") +"</th></tr>";
		for (var i = 0; i < rowCount; i++) {
			html += "<tr>";
			for (var j = 0; j < 2; j++) {
				if (j > 0 && this.singleColumn)
					continue;
				var index = 0;
				if (j == 0) {
					index = i;
				}
				else {
					index = i + rowCount;
				}
				if (index < this.currentValue.length) {
					html += this.drawInputRow(enabled, index);
				}
				//html += "<td width=\"10\">&nbsp;</td>";
			}
			//html += "<td class=\"mw\">&nbsp;</td>";
			html += "</tr>";
		}
	}
    html += "</tbody>";
    html += "</table>";
    html += "</div>";
    /*if (enabled && this.directive) {
        html += "<div style=\"padding:0px 0px 0px 4px\">" +
            ReplaceSpecialHTMLChars(this.directive) + "</div>";
    }*/
    var div = document.getElementById(this.divId);
    if (div) {

        div.innerHTML = html;
    }
}

BWInputList.prototype.drawInputRow = function(enabled, index) {
    var html = "<td>";
    var value = this.currentValue[index];
    var cVal = "(";
    var tVal = "";
    try {
        // If the XML is malformed, it is possible that value is not a string
        // (hence no charAt method and the try / catch block)
        var ch = value.charAt(0);
        // Whether the address is enabled is indicated by a 1 or 0 at the
        // start of the value
        if (")" == ch || "(" == ch) {
            cVal = ch;
            tVal = value.substring(1);
        }
        else {
            tVal = value;
        }
    }
    catch(e) {
    }
    var cbName = "cb_" + index;
    var cbId = this.uniquifier + "_" + cbName;
    var fieldName = this.baseFieldName + "_" + index;
    var fieldId = this.uniquifier + "_" + fieldName;
    var fieldFlag = "";
    if (!this.hasValidator(fieldName)) {
        if (!this.nullsPermitted) {
            this.vframework.addValidator(fieldName, this.stdValidator);
        }
        for (var i = 0; i < this.additionalValidators.length; i++) {
            this.vframework.addValidator(fieldName, this.additionalValidators[i]);
        }
        this.vframework.labelMap[fieldName] = formatString(
            this.inputNamePattern, [index + 1]);
    }
    if (!enabled) {
        fieldFlag = " disabled";
    }
    //Replace Javascript Escape Sequence with HTML Escape Sequence
    tVal=tVal.replace(/ /g,"&#32");
    tVal=tVal.replace(/\"/g,"&#34");
    var className = "checkbox";
    var checked = "(" == cVal ? " checked" : "";
    html += "<input type=\"checkbox\" name=\"" + cbName +
        "\" id=\"" + cbId + "\"" + fieldFlag + checked +
        " class=\"" + className + "\"";
    // Add change notification to the checkbox
    if (this.changeNotify) {
        html += " onfocus=\"" + this.objectName + ".changeNotify()\"";
    }
    html += ">";
    html += "</td>";
    html += "<td class=\"" + this.fieldClass + "\">";
    var className = "mw textField";
	html += tVal
    html += "</td>";
    html += "<td nowrap class=\"" + this.fieldClass + "_l\">";
    if (enabled) {
        html += "<a href=\"javascript:" + this.objectName + ".deleteItem(" + index +
            ")\" class=\"blueLink\">" + gsDelete + "</a>";
    }
    html += "</td>";
    return html;
}

BWInputList.prototype.drawCurrentInputRow = function(enabled) {
	return "";
}

/**
 * Adds an item to the list; does nothing if there is no value in the bottom edit control
 * and null values are not permitted
 */
BWInputList.prototype.add = function() {

	var txtAreaID = this.objectName + "_txtareaid";
	var text = document.getElementById(txtAreaID).value;
	
	entries = text.split(/\s|,/g);
	validEntries = new Array();
	invalidEntries = new Array();
	
	for( var i=0; i < entries.length; i++ )
	{
		if(entries[i].length > 0 )
		{
			var valid = this.Validate(entries[i]);
			
			if(valid)
			{
				validEntries.push(entries[i]);
			}
			else
			{
				invalidEntries.push(entries[i]);
			}
		}
	}
	
	if( validEntries.length > 0 )
	{
		var unc = this.getUncommitted;
        this.getUncommitted = false;
        var currVal = this.getValue();
        this.getUncommitted = unc;
		
		for( var i=0; i<validEntries.length; i++ )
		{
			currVal.push( "(" + validEntries[i]);
		}
        this.setValue(currVal);
        this.draw(true);
        if (this.changeNotify) {
			this.changeNotify();
        }
	}
	
	if( invalidEntries.length > 0 )
	{
		alert( gsInvalidBWEmailAlert + invalidEntries.toString() );
	}
	//document.getElementById(txtAreaID).value = invalidEntries.toString();
}

/**
 * Deletes an item from the list
 * @param index the index of the item to remove
 */
BWInputList.prototype.deleteItem = function(index) {
    // Remove the item in the middle
    this.currentValue.splice(index, 1);
    this.fieldCount--;
    this.draw(true);
    if (this.changeNotify) {
        this.changeNotify();
    }
    //this.focus();
}

/**
 * Deletes All items from the list
 */
BWInputList.prototype.DeleteAll = function() {

	if(this.currentValue.length > 0) {
	
		var ans = confirm( gsConfirmDeleteAll );
		if( ans) {
			this.currentValue.splice(0,this.currentValue.length);
			this.draw(true);
			this.fieldCount = -1;
			if (this.changeNotify) {
				this.changeNotify();
			}
		}
	}
}

BWInputList.prototype.GetNodeName = function() {
	var list = "";
	switch(this.listName)
	{
		case 'blFrom':
		list = "BlackListFrom";
		break;
		
		case 'wlFrom':
		list = "WhiteListFrom";
		break;
		
		case 'blTo':
		list = "BlackListTo";
		break;
		
		case 'wlTo':
		list = "WhiteListTo";
		break;
	}
	return list;
}

BWInputList.prototype.CreateImportPopup = function() {
	var html = "";
	var popid = this.listName + '_popspan';
	var pop = document.getElementById(popid);
	var sDynamicPage = GetDynamicPageUrl("UIUpload&importbw=" + this.GetNodeName() + "&op=reloadbw" + "&settingsID=" + this.settingsID );
	
	html += '	<form METHOD="post" enctype="multipart/form-data" name="' + this.objectName + 'ImportForm" id="' + this.objectName + 'Importid" action="'+sDynamicPage+'" >';
	html += '	<div id="' + this.objectName + 'popdiv" class="simplePop" style="top:-1px; right:-1px;display:none;width:250px">';
	html += '	<center>';
	html += '	<br>';
	html += '	<table border="0" cellspacing="0" cellpadding="4" width="80%">';
	html += '		<tr><input type="file" id="'+ this.listName +'ListFileNameID" name="'+ this.GetNodeName() +'ListFileName" onchange="'+ this.objectName
			+'.ChangeImportFile()" value="" class="btnSmall"/></tr>';
	html += '		<tr><td align="center">';
	html += '		<input type="button" id="'+ this.listName + '_Submit" class="btnSmall" value="'+ gstrOK +'" onclick="'
			+ this.objectName +'.Import()" disabled/>';
	html += '		&nbsp;<input type="button" class="btnSmall" value="'+ gstrCancel +'" onclick="'+ this.objectName +'.HideImportPopup()" />';
	html += '		</td></tr>';
	html += '	</table>';
	html += '	<br>';
	html += '	</center>';
	html += '	</div>';
	html += '	</form>';
	
	if(pop) {
		pop.innerHTML = html;
	}
	
}

BWInputList.prototype.ChangeImportFile = function() {
	var submitbtn = document.getElementById(this.listName + '_Submit');
	var fileinput = document.getElementById(this.listName + 'ListFileNameID');
	
	if( fileinput.value != "" ) {
		if( IsValidFilePath( fileinput.value, false ) == null ) {
			if( this.IsValidFileExtn( fileinput.value ) ) {
				submitbtn.disabled = false;
				return;
			}
			else {
				alert(gsInvalidFileExtn);
			}
		}
	} 
	submitbtn.disabled = true;
}

BWInputList.prototype.IsValidFileExtn  = function(value) {

	var extn = value.substring( value.lastIndexOf('.') + 1, value.length);
	
	extn = extn.toLowerCase();
	if( extn == "txt" || extn == "csv" ) {
		return true;
	}
	return false;
}

BWInputList.prototype.ShowImportPopup = function() {
	this.pop.style.display = "block";
	//document.getElementById(this.listName + 'ListFileName').focus();
}

BWInputList.prototype.HideImportPopup = function() {
	this.pop.style.display = "none";
}

BWInputList.prototype.Import = function() {
	var importform = document.getElementById(this.objectName + 'Importid');
	if( importform ) {
		importform.submit();
		top.gPBContainer = new Object();
	}
}

BWInputList.prototype.Export = function() {
	if(this.currentValue.length > 0) {
		parent.config.location.href = GetDynamicPageUrl("UIUpload&op=exportbw&list=" + this.GetNodeName() + "&settingsID=" + this.settingsID );
	}
}

BWInputList.prototype.Validate = function(value) {
	var ret = true;
	
	var strEmail = "("+value;
	
	if((this.divId == dataBindings[36].listObject.divId) || (this.divId == dataBindings[34].listObject.divId))
	{
		var str34 = dataBindings[34].initialValue.split(",");
		for (var i=0 ; i < str34.length; i++)
		{
			if (str34[i].toLowerCase() == strEmail.toLowerCase())
				return false;
		}
		
		var str36 = dataBindings[36].initialValue.split(",");
		for (var i=0 ; i < str36.length; i++)
		{
			if (str36[i].toLowerCase() == strEmail.toLowerCase())
				return false;
		}
	}

	if((this.divId == dataBindings[37].listObject.divId) || (this.divId == dataBindings[35].listObject.divId))
	{
		var str35 = dataBindings[35].initialValue.split(",");
		for (var i=0 ; i < str35.length; i++)
		{
			if (str35[i].toLowerCase() == strEmail.toLowerCase())
				return false;
		}
		
		var str37 = dataBindings[37].initialValue.split(",");
		for (var i=0 ; i < str37.length; i++)
		{
			if (str37[i].toLowerCase() == strEmail.toLowerCase())
				return false;
		}
	}

    if (value)
        ret = (value == "*") ? true : ValidEmail(value, false);
    return ret;
}

function BWInputListValidator() {
    this.name = "BWInputListValidator";
}

BWInputListValidator.prototype = new EmailValidator();

BWInputListValidator.prototype.validate = function(value) {
    var ret = true;
    if (value)
        ret = (value == "*") ? true : ValidEmail(value, false);
    return ret;
}

// Gets the spam profiles that have been defined
function sProfGetProfiles(pb) {
    var ppT = new PropertyPath("Settings.ASSettings");
    var pSuffix = ".SpamProfileName";
    var bayesIdList = [];
    for (ppT.BeginEnum(); null != pb.GetProperty(ppT); ppT.IncrementEnum()) {
        var spProfile = pb.GetPropertyDef(ppT.toString() + pSuffix, "");
        // Add the profile name if it is both present and unique
        if (spProfile && !bayesIdList[spProfile]) {
            bayesIdList.push(spProfile);
            bayesIdList[spProfile] = 1;
        }
    }
    return bayesIdList.sort();
}

// Enables / disables the custom score for spam levels
function enableSpamScoreCtl(b, level, focus) {
    var fieldName = "ScoreBasedActionValue" + level;
    var vframework = vframeworks[sp_bOptsForm];
    var e = document.forms[sp_bOptsForm].elements[fieldName];
    if (b) {
        vframework.addValidator(fieldName, sp_reqV);
        //vframework.addValidator(fieldName, sp_floatV);
        vframework.addValidator(fieldName, sp_scoreV);
		if(fieldName == "ScoreBasedActionValue1")
			vframework.addValidator(fieldName, sp_highscoreV);
		if(fieldName == "ScoreBasedActionValue2")
			vframework.addValidator(fieldName, sp_mediumscoreV);
		if(fieldName == "ScoreBasedActionValue3")
			vframework.addValidator(fieldName, sp_lowscoreV);
        if (focus)
            setTimeout("document.forms['" + sp_bOptsForm +
                "'].elements['ScoreBasedActionValue" + level + "'].focus();", 50);
    }
    else {
        e.value = top.defValues["AS"][fieldName];
        vframework.onchange(fieldName);
        vframework.clearValidators(fieldName);
    }
    e.disabled = !b;
}

// Gets the language specified for the page (this affects the spam rules loaded)
function ss_getLanguage() {
    var ret = "en_US";
    if (qparams["lang"]) {
        ret = qparams["lang"][0];
    }
    else {
        try {
            if( t_locale_id == "en_US")
            	ret = "en";
            else if ( t_locale_id == "zh_CN")
            	ret = "chs";
            else
            	ret = t_locale_id;
            
        }
        catch(e) {}
    }
    return ret;
}

// Sets the selection in the reporting threshold pick list
function initReportingThresholdList() {
    var scores = [15.0, 10.0, 5.0];
    var repThreshold = spam_pb.GetPropertyDef(basePP + ".SpamThreshold", 10.0) - 0;
    var selIdx = scores.length;
    for (var i = 0; i < scores.length; i++) {
        var idx = i + 1;
        if ("Custom" == spam_pb.GetProperty(basePP + ".ScoreBasedActionLevel" + idx)) {
            scores[i] = spam_pb.GetPropertyDef(basePP + ".ScoreBasedActionValue" + idx,
                scores[i]) - 0;
        }
        if (Math.abs(repThreshold - scores[i]) < 0.05) {
            selIdx = i;
        }
    }
    var selCtl = document.forms[sp_bOptsForm].elements["RTL"];
    if (selCtl) {
        selCtl.options[selIdx].selected = true;
    }
}

// Enables / disables the custom score input for spam
// reporting threshold and sets the score according to the selection
function setSpamThresholdCtl(rtlVal, focus) {
    var b = ("Custom" == rtlVal);
    var sp = document.getElementById("spam_threshold_label");
    var cl = sp ? sp.className : "";
    var fieldName = "SpamThreshold";
    var vframework = vframeworks[sp_bOptsForm];
    var e = document.forms[sp_bOptsForm].elements[fieldName];
    if (!e)
        return;
    if (b) {
        cl = removeClass(cl, "disabled");
        vframework.addValidator(fieldName, sp_reqV);
        //vframework.addValidator(fieldName, sp_floatV);
        vframework.addValidator(fieldName, sp_scoreV);
        if (focus)
            setTimeout("document.forms['" + sp_bOptsForm +
                "'].elements['SpamThreshold'].focus();", 50);
    }
    else {
        cl = addClass(cl, "disabled");
        if (!vframework.check(fieldName)) {
            document.forms[sp_bOptsForm].elements[fieldName].value =
                spam_pb.GetProperty(basePP + "." + fieldName);
            vframework.onchange(fieldName);
        }
        vframework.clearValidators(fieldName);
        // Set the score according to the selection
        fieldName = "ScoreBasedActionValue" + rtlVal;
        var e2 = document.forms[sp_bOptsForm].elements[fieldName];
        if (e2)
            e.value = e2.value;
    }
    if (sp)
        sp.className = cl;
    e.disabled = !b;
}

// Handles change in the score thresholds, causing the reporting threshold score
// to reflect the value if necessary
function handleScoreChange(scoreIdx) {
    var form = document.forms[sp_bOptsForm];
    var sel = form.elements["RTL"];
    if (!sel)
        return;
    if (scoreIdx == sel.value) {
        var e = form.elements["SpamThreshold"];
        var e2 = form.elements["ScoreBasedActionValue" + scoreIdx];
        if (e && e2)
            e.value = e2.value;
    }
}


// Enables / disables the spam prefix text control
function enableSpamPrefixTextCtl(b) {
    var fieldName = "PrefixSubjectText";
    var e = document.forms[sp_bOptsForm].elements[fieldName];
    var vframework = vframeworks[sp_bOptsForm];
    if (b) {
        vframework.addValidator(fieldName, sp_reqV);
        vframework.addValidator(fieldName, sp_scriptV);
    }
    else {
        if (!vframework.check(fieldName)) {
            e.value = spam_pb.GetPropertyDef(basePP + "." + fieldName, "");
            vframework.onchange(fieldName);
        }
        vframework.clearValidators(fieldName);
    }
    e.disabled = !b;
}

// Enables and shows / disables and hides the text input for specifying the
// spam indicator
function enableSpamIndicatorTextCtl(b) {
    var tr = document.getElementById("score_indicator_row");
    var fieldName = "SpamIndicatorText";
    var vframework = vframeworks[sp_bOptsForm];
    if (b) {
        tr.style.display = "";
        vframework.addValidator(fieldName, sp_reqV);
    }
    else {
        tr.style.display = "none";
        if (!vframework.check(fieldName)) {
            document.forms[sp_bOptsForm].elements[fieldName].value =
                spam_pb.GetProperty(basePP + "." + fieldName);
            vframework.onchange(fieldName);
        }
        vframework.clearValidators(fieldName);
    }
}

// Enables and shows / disables and hides the verbose reporting checkbox
function enableVerboseCtl(b) {
    var fieldName = "VerboseLogging";
    var e = document.getElementById("verbose_ctl");
    var display = "none";
    if (b) {
        display = "";
    }
    e.style.display = display;
}

// Populates the spam profile select control
function populateProfileSelect() {
    var selCtl = document.forms[sp_aOptsForm].elements["SpamProfileName"];
    if (!selCtl)
        return;
    var browserInfo = IdentifyBrowser();
    var options = [];
    var option = document.createElement("option");
    option.value = "";
    option.text = resolveString(cse_pp_st, "__default");
    options.push(option);
    var maxBayes = SpamGetMaximumBayes(1);
    if (maxBayes > 1) {
        var profiles = sProfGetProfiles(spam_pb);
        for (var i = 2; i <= maxBayes; i++) {
            var profIdx = i - 2;
            option = document.createElement("option");
            option.text = resolveString(cse_pp_st, "__prof_name", [i]);
            option.value = profIdx < profiles.length ? profiles[profIdx] : "p" + i;
            options.push(option);
        }

        for (var i = 0; i < options.length; i++) {
            if (browserInfo.isIE) {
                selCtl.add(options[i]);
            }
            else {
                selCtl.add(options[i], null);
            }
        }
    }
    else {
        var rowsToHide = {"sp_prof1":1, "sp_prof2":1};
        for (var eName in rowsToHide) {
            var e = document.getElementById(eName);
            if (e)
                e.style.display = "none";
        }
    }
}

// Initializes the page's forms
function spam_forms_init() {
    var useTabs = (undefined !== this.spam_tabs);
    var forms = [sp_bOptsForm, sp_aOptsForm, "whitelists", "blacklists",
        "std_add_rule_form", "net_add_rule_form"];

    sp_reqV = new RequiredValidator();
    sp_scriptV = new ScriptValidator ();

    vframeworks["InstanceSettings"]= new ValidationFramework("InstanceSettings");
	vframeworks["InstanceSettings"].formAction = std_val_form_action;
    vframeworks["InstanceSettings"].fieldAction = std_val_field_action;
    vframeworks["InstanceSettings"].addValidator("displayName", sp_reqV);
    vframeworks["InstanceSettings"].addValidator("displayName", sp_scriptV);
	vframeworks["InstanceSettings"].labelMap["displayName"] = resolveString(cse_pp_field_st, "__instancename");

    var inputArray= new Array();
	inputArray["SECTION"]="Scanners";
	inputArray["origName"]=origName;
	inputArray["basePP"]="Settings.ASSettings";
	vframeworks["InstanceSettings"].addValidator("displayName",new DuplicatesValidator(spam_pb,inputArray));
	vframeworks["InstanceSettings"].addValidator("displayName",new LengthValidator());
    shs_affectedPolicyReport(newInstance, "AS", settingsId, spam_pb);

    for (var i = 0; i < forms.length; i++) {
        var form = forms[i];
        if (document.forms[form]) {
            vframeworks[form] = new ValidationFramework(form);
            vframeworks[form].formAction = std_val_form_action;
            vframeworks[form].fieldAction = std_val_field_action;
        }
    }

    sp_floatV = new FloatValidator();
    sp_scoreV = new FloatRangeValidator(0, 99.9, 1);
	sp_rulescoreV = new FloatRangeValidator(-1000.00, +1000.00);
	var code = "(value > Number(document.forms[sp_bOptsForm].elements[\"ScoreBasedActionValue2\"].value)) && (value > Number(document.forms[sp_bOptsForm].elements[\"ScoreBasedActionValue3\"].value))";
	sp_highscoreV  = new CrossValidator(code,resolveString(page_st, "lm_highscore"));
	var code = "(value > Number(document.forms[sp_bOptsForm].elements[\"ScoreBasedActionValue3\"].value)) && (value < Number(document.forms[sp_bOptsForm].elements[\"ScoreBasedActionValue1\"].value))";
	sp_mediumscoreV  = new CrossValidator(code,resolveString(page_st, "lm_mediumscore"));
	var code = "(value < Number(document.forms[sp_bOptsForm].elements[\"ScoreBasedActionValue1\"].value)) && (value < Number(document.forms[sp_bOptsForm].elements[\"ScoreBasedActionValue2\"].value))";
	sp_lowscoreV  = new CrossValidator(code,resolveString(page_st, "lm_lowscore"));

	var addruleforms = ["std_add_rule_form", "net_add_rule_form"];
	var fieldId = ["std_new_score","net_new_score"];

	for(var i = 0; i < addruleforms.length ; i++) {
		var form = addruleforms[i];
		if(document.forms[form]) {
		// Create a validator for this field; must have a value and must be valid decimal
		vframeworks[form].addValidator(fieldId[i], sp_reqV);
		vframeworks[form].addValidator(fieldId[i], sp_floatV);
		vframeworks[form].addValidator(fieldId[i], sp_rulescoreV);
		vframeworks[form].labelMap[fieldId[i]] = resolveString(page_st, "lm_score");
	    }
	}

	var form = sp_bOptsForm;
    var tabIdx = 0;
    if (document.forms[form]) {
        var decimalFields = ["SpamThreshold"];
        vframeworks[form].labelMap["SpamThreshold"] =
            resolveString(page_st, "lm_SpamThreshold");
        vframeworks[form].labelMap["PrefixSubjectText"] =
            resolveString(page_st, "lm_SpamPrefixSubjectText");
        vframeworks[form].labelMap["SpamIndicatorText"] =
            resolveString(page_st, "lm_SpamIndicatorText");
        for (var i = 1; i <= 3; i++) {
            var s = "ScoreBasedActionValue" + i;
            vframeworks[form].labelMap[s] =
                resolveString(page_st, "lm_ScoreLevel", [i]);
            decimalFields.push(s);
        }

        setNumeric(form, decimalFields, true, false);

        if (engineNetworkTestsEnabled) {
            vframeworks[form].labelMap["TimeoutRBLTests"] =
                resolveString(page_st, "lm_TimeoutRBLTests");
            var ntRows = ["ntLabel", "ntEnable", "ntEnableWarning", "ntRBLTests", "ntRBLTimeout"];
            for (var i = ntRows.length - 1; i >= 0; i--) {
                var e = document.getElementById(ntRows[i]);
                if (e)
                    e.style.display = "";
            }
            setNumeric(form, ["TimeoutRBLTests"], false, false);
        }
        if (useTabs) {
            spam_tabs.addValidation(tabIdx++, vframeworks[form]);
        }
    }

    form = sp_aOptsForm;
    if (document.forms[sp_aOptsForm]) {
		var aso_headerName = "MsgHeaderName";
		var aso_headerValue = "MsgHeaderValue";

		vframeworks[form].labelMap[aso_headerName] = resolveString(page_st, "lm_header_name");
        vframeworks[form].labelMap[aso_headerValue] = resolveString(page_st, "lm_header_value");

		vframeworks[form].addValidator(aso_headerName, sp_scriptV);
		vframeworks[form].addValidator(aso_headerValue, sp_scriptV);

        var aso_fieldName = "MaxMailScanSize";
        vframeworks[form].labelMap[aso_fieldName] =
            resolveString(page_st, "lm_MaxMessageSize");
        var aso_rangev = new RangeValidator(1, 999);
        var aso_headerRangev = new RangeValidator(40, 999);
        vframeworks[form].addValidator(aso_fieldName, sp_reqV);
        var aso_rv = new RangeValidator(1, 999999999);
        aso_rv.errorMessage = function() {return resolveString(page_st, "mms_err");};
        vframeworks[form].addValidator(aso_fieldName, aso_rv);

        aso_fieldName = "MaxHeaderWidth";
        vframeworks[form].labelMap[aso_fieldName] =
            resolveString(page_st, "lm_MaxHeaderWidth");
        vframeworks[form].addValidator(aso_fieldName, sp_reqV);
        vframeworks[form].addValidator(aso_fieldName, aso_headerRangev);

        aso_fieldName = "MaxReportedRules";
        vframeworks[form].labelMap[aso_fieldName] =
            resolveString(page_st, "lm_MaxReportedRules");
        vframeworks[form].addValidator(aso_fieldName, sp_reqV);
        vframeworks[form].addValidator(aso_fieldName, aso_rangev);
        if (useTabs) {
            spam_tabs.addValidation(tabIdx++, vframeworks[form]);
        }
        setNumeric(form, ["MaxMailScanSize", "MaxHeaderWidth", "MaxReportedRules"], false, false);

        // Spam profile support
        dataBindings.push(new BayesIdDataBinding());
        populateProfileSelect();
    }

    if (document.getElementById("bwlists_div")) {
        var ilProps = { compulsory:false, directive:resolveString(page_st, "il_directive"),
             additionalValidators:[new BWInputListValidator()], singleColumn:true,
             changeNotify:g_changeNotifyFnStr};
        var bwListData = [{ base:"white", base2:"w", prop:"White" },
            { base:"black", base2:"b", prop:"Black" }];
        for (var i = 0; i < bwListData.length; i++) {
            var lData = bwListData[i];
            var keys = ["from", "to"];
            /*for (var j = 0; j < keys.length; j++) {
                var stKey = lData.base + "_list_" + keys[j];
                var labelId = lData.base + "_" + keys[j] + "_label";
                var e = document.getElementById(labelId);
                if (e)
                    e.appendChild(document.createTextNode(resolveString(cse_pp_st, stKey)));
            }*/

            var formName = lData.base + "lists";
            ilProps.vframework = vframeworks[formName];
            var lKey = lData.base2 + "lFrom";
            ilProps.baseFieldName = lKey;
            ilProps.inputNamePattern = resolveString(page_st, "sender_pattern");
            inputLists[lKey] = new BWInputList([], lData.base + "list_from_names_div",
                "inputLists['" + lKey + "']", ilProps, newInstance, settingsId);
            dataBindings.push(new InputListDataBinding(inputLists[lKey], lData.prop + "ListFrom.Addr"));

            lKey = lData.base2 + "lTo";
            ilProps.baseFieldName = lKey;
            ilProps.inputNamePattern = resolveString(page_st, "recipient_pattern");
            inputLists[lKey] = new BWInputList([], lData.base + "list_to_names_div",
                "inputLists['" + lKey + "']", ilProps, newInstance, settingsId);
            dataBindings.push(new InputListDataBinding(inputLists[lKey], lData.prop + "ListTo.Addr"));
        }
        if (undefined !== this.bwl_links) {
            bwl_links.addValidation(0, vframeworks["blacklists"]);
            bwl_links.addValidation(1, vframeworks["whitelists"]);
        }
        if (useTabs) {
            spam_tabs.addValidation(tabIdx, vframeworks["blacklists"]);
            spam_tabs.addValidation(tabIdx++, vframeworks["whitelists"]);
        }
    }

    var ruleForms = ["std", "net"];
    for (var i = 0; i < ruleForms.length; i++) {
        var pfx = ruleForms[i];
        form = pfx + "_add_rule_form";
        if (vframeworks[form]) {
            var vf = vframeworks[form];
            // Something must be entered for the rule name
            var fieldName = pfx + "_new_name";
            vf.addValidator(fieldName, sp_reqV);
            // ...but duplicates are not permitted
            var code = "undefined === " + pfx + "Rules[value]";
            vf.addValidator(fieldName, new CrossValidator(code,
                resolveString(cse_pp_st, "__rule_exists")));
            vf.labelMap[fieldName] = resolveString(page_st, "lm_rulename");
            fieldName = pfx + "_new_score";
            vf.addValidator(fieldName, sp_floatV);
            vf.labelMap[fieldName] = resolveString(page_st, "lm_score");
        }
    }

    addChangeNotification(g_changeNotifyFn);
}

// Sets form data and enables / disables controls as appropriate
function spam_init() {
    engineNetworkTestsEnabled = engine_SpamNetworkTestsEnabled(false);
    spam_forms_init();
    Reset();
}

/**
 * Asynchronous reset function
 */
function Reset() {
    var defValues = top.defValues["AS"];
    var spam_pp = new PropertyPath(basePP);
    for (var i = 0; i < dataBindings.length; i++) {
        dataBindings[i].set(spam_pp, spam_pb);
    }

    if (document.forms[sp_bOptsForm]) {
        // Basic spam options dialog included
        for (var i = 1; i <= 3; i++) {
            spam_pp.SetTempLeaf("ScoreBasedActionLevel" + i);
            enableSpamScoreCtl("Custom" == spam_pb.GetPropertyDef(spam_pp,
                defValues["ScoreBasedActionLevel" + i]), i, false);
        }

        // Force the score level to be "Custom"
        var form = document.forms[sp_bOptsForm];
        var e = form.elements["ScoreLevel"];
        if (e)
            e.value = "Custom";

        // Set the selection on the reporting threshold dropdown
        initReportingThresholdList();
        // Set the value and enabled / disabled state of the reporting
        // threshold value
        var e = form.elements["RTL"];
        if (e)
            setSpamThresholdCtl(e.value, false);
        spam_pp.SetTempLeaf("PrefixSubject");
        enableSpamPrefixTextCtl("1" == spam_pb.GetPropertyDef(spam_pp,
            defValues["PrefixSubject"]));
        spam_pp.SetTempLeaf("SpamIndicator");
        enableSpamIndicatorTextCtl("Never" != spam_pb.GetPropertyDef(spam_pp,
            defValues["SpamIndicator"]));
        spam_pp.SetTempLeaf("AttachReport");
        enableVerboseCtl("Never" != spam_pb.GetPropertyDef(spam_pp,
            defValues["AttachReport"]));
        if (document.getElementById("tbl_advanced_spam_options")) {
            //document.getElementById("tbl_advanced_spam_options").style.marginTop = "10px";
        }
        if (engineNetworkTestsEnabled) {
            spam_pp.SetTempLeaf("EnableNetworkTests");
            networkTestsEnabled = ("1" == spam_pb.GetPropertyDef(
                spam_pp, defValues["EnableNetworkTests"]));
            ChangeENTState(networkTestsEnabled);
            if (networkTestsEnabled) {
                spam_pp.SetTempLeaf("EnableRBLTests");
                ChangeRBLTState("1" == spam_pb.GetPropertyDef(spam_pp,
                    defValues["EnableRBLTests"]));
            }
        }
    }

    if (document.forms[sp_aOptsForm]) {

    }

    if (document.getElementById("bwlists")) {
        // Spam black/whitelist dialogs included
        var bwListWidgets = ["wlFrom", "wlTo", "blFrom", "blTo"];
        for (var i = 0; i < bwListWidgets.length; i++) {
            inputLists[bwListWidgets[i]].draw(true);
        }
    }

    var nSpamRules = countPreDefRules(ss_getLanguage(), g_spamRulesDoc);
    var end = stepSize;
    var tbp = (end < nSpamRules) ? end : nSpamRules;
    var progressMsg = resolveString(cse_pp_st, "as_pm_rules_msg");
    window.status = progressMsg;
    setTimeout("delayedReset(0, " + end + ", " + nSpamRules + ")", 10);
}

// Processes spam rules bit-by-bit to avoid "slow script" warnings
function delayedReset(startRule, endRule, total) {
    //var defStatus = resolveString(cse_pp_st, "as_pm_def_msg");
    //var stdRStatus = resolveString(cse_pp_st, "as_pm_std_rules");
    //var netRStatus = resolveString(cse_pp_st, "as_pm_net_rules");

    if (document.getElementById(ssrDivId) || document.getElementById(nsrDivId)) {
        var locale_id = ss_getLanguage();
        var rulesToProcess = (endRule - startRule);
        ProcessPreDefRules(locale_id, startRule, endRule, total, g_spamRulesDoc);
        var rulesProcessed = startRule + rulesToProcess;
        if (rulesProcessed < total) {
            // Do another round
            var newStart = startRule + rulesToProcess;
            var newEnd = endRule + rulesToProcess;
            var tbp = (newEnd < total) ? newEnd : total;
            window.status += '.';
            var fnStr = "delayedReset(" + newStart + ", " + newEnd + ", " + total + ")";
            setTimeout(fnStr, 10);
            return;
        }

        // Finished processing spam rules - at last!
        ProcessCustomRules(spam_pb, basePP);
        if (engineNetworkTestsEnabled) {
            networkTestsEnabled = ("1" == spam_pb.GetPropertyDef(
                basePP + ".EnableNetworkTests", "0"));
        }
        // Sort the rules lists
        window.status = resolveString(cse_pp_st, "as_pm_sort_rules");
        setTimeout("rstSortRules()", 10);
    }
}

// Sorts rules with fedback
function rstSortRules() {
    var sdFlag = GetSpamRulesPref("sortDir_s", "A");
    var sField = GetSpamRulesPref("sortField_s", "Name");
    SortRuleList(sdFlag, sField, false);
    if (engineNetworkTestsEnabled) {
        sdFlag = GetSpamRulesPref("sortDir_n", "A");
        sField = GetSpamRulesPref("sortField_n", "Name");
        SortRuleList(sdFlag, sField, true);
    }
    window.status = resolveString(cse_pp_st, "as_pm_std_rules");

    setTimeout("rstTabulateStd()", 10);
}

// Tabulates the standard rules, shows feedback
function rstTabulateStd() {
    if (document.getElementById(ssrDivId)) {
        var tblId = ssrTableId;
        var perPage = GetSpamRulesPref("perPage", 25);
        InitRulesTable(ssrListId, tblId, perPage, false, networkTestsEnabled);
        var startIdx = GetSpamRulesPref("stdIdx", 0);
        ShowSpamRules(tblId, false, startIdx, perPage, networkTestsEnabled);
    }
    if (document.getElementById(nsrDivId) && engineNetworkTestsEnabled) {
        window.status = resolveString(cse_pp_st, "as_pm_net_rules");
        setTimeout("rstTabulateNet()", 10);
        return;
    }
    setTimeout("rstComplete()", 10);
}

// Tabulates the network rules, shows feedback
function rstTabulateNet() {
    // Add a new tab for the network rules
    if (this.spam_tabs) {
        var addTab = true;
        var tLabel = resolveString(cse_pp_st, "__network_rules");
        for (var i = spam_tabs.length() - 1; i >= 0; i--) {
            if (tLabel == spam_tabs.get(i).label) {
                addTab = false;
                break;
            }
        }
        if (addTab) {
            spam_tabs.add(tLabel, "t5");
            spam_tabs.drawTabs(spam_tabs.getCurrent());
        }
    }
    var tblId = nsrTableId;
    var perPage = GetSpamRulesPref("perPage", 25);
    InitRulesTable(nsrListId, tblId, perPage, true, networkTestsEnabled);
    var startIdx = GetSpamRulesPref("netIdx", 0);
    ShowSpamRules(tblId, true, startIdx, perPage, networkTestsEnabled);
    setTimeout("rstComplete()", 10);
}

function rstComplete() {
    window.status = "";
    var div = document.getElementById("notification_area");
    if (div)
        div.style.display = "none";
    div = document.getElementById("whole_page");
    if (div)
        div.style.display = "block";
    // Reveal the save / cancel buttons in all their glory
    shs_showSave(true);
}

function SwitchToList(list)
{
	var ret = -1;
	if( list != null )
	{
		switch(list.toString())
		{
		case 'BlackListFrom':
			ret = 0;
			break;
		case 'WhiteListFrom':
			ret = 1;
			break;
		case 'BlackListTo':
			ret = 2;
			break;
		case 'WhiteListTo':
			ret = 3;
			break;
		default:
			ret = -1;
			break;
		}
	}
	return ret;
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {

	var params = queryParameters();
	var result = params["r"];
	var list = params["importbw"];
	var sID = params["settingsID"];
	
	if( result == 0)
	{
		pbIn = top.gPB;
	}
	
	if(list)
	{
		var lt = SwitchToList(list);
		bwl_links.handler(lt);
		spam_tabs.handler(2);
	}
	
	if (null == pbIn) {
        pbIn = top.gPB;
    }

    newInstance = shs_initPB(pbIn, pp, "AS");
    spam_pb = pbIn;
    if (settingsId) {
        // Search for the settings blob to use
        basePP = top.GetBasePath(pbIn, basePP, "id", settingsId);
        if (null == basePP) {
            top.gPageStack.Active().Cancel();
            return;
        }
    }
    else {
        // Assume that we've been set up with the correct property path
        // and property bag
        basePP = pp.GetPath();
        settingsId = pbIn.GetPropertyDef(basePP + ".id", "");
        origName=pbIn.GetPropertyDef(basePP + ".displayName", "");
    }
	//Handling expansion issues for i18N
	var MsgHeaderIndicator = document.getElementById("sel_MsgHeaderIndicator")
	MsgHeaderIndicator.style.width = "220px";

	var SpamProfileName = document.getElementById("sel_SpamProfileName")
	SpamProfileName.style.width = "220px";

    spam_init();

	if(gLinux)
	{
    	// Spam profile filed is not required in Camelus, So hiding the control.
		var SpamProfileHdr1 = document.getElementById("sp_prof1");
		SpamProfileHdr1.style.display = "none";
		var SpamProfileHdr2 = document.getElementById("sp_prof2");
		SpamProfileHdr2.style.display = "none";
	}
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    // Remove validation from the add spam rule forms so that empty fields
    // don't throw erroneous errors on apply
    var rTypes = ["std", "net"];
    var x = {};
    for (var i = 0; i < rTypes.length; i++) {
        var rType = rTypes[i];
        var form = rType + "_add_rule_form";
        var vf = vframeworks[form];
        if (null == vf)
            continue;
        // Temporarily save the validation object
        x[rType] = vf;
        // Delete it from the main container
        delete vframeworks[form];
    }
    var ret = shs_Validate(this.spam_tabs);
    if (!ret) {
        // Restore validation for the add rules forms
        for (var i = 0; i < rTypes.length; i++) {
            var rType = rTypes[i];
            var form = rType + "_add_rule_form";
            var vf = x[rType];
            if (null == vf)
                continue;
            vframeworks[form] = vf;
        }
    }
    return ret;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb) {
    if (null == pb) {
        pb = spam_pb;
    }
    var changed = SaveCustomRules(pb, basePP, engineNetworkTestsEnabled);
    shs_Apply(pb, basePP, dataBindings, newInstance, changed);
}

/**
 * Asynchronous cancel function
 */
function Cancel() {
    if (newInstance) {
        // Remove the new instance from the property bag
        spam_pb.DeleteElement(basePP);
    }
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
    return ["SpamRules_" + ss_getLanguage(), "Engine"];
    //return ["Engine"];
}

/**
 * Callback function to process custom configuration
 * @param xml the config XML as a raw string
 * @param dataSource the name of the data source
 * @param pb a property bag in which to place processed config, if required
 */
function ProcessCustomConfig(xml, dataSource, pb) {
    if (dataSource.match(/^SpamRules_/)) {
        // No need to parse the XML into a property bag
        pb.SetProperty("Dummy");
        try {
            g_spamRulesDoc = xmlStr2DocObject(xml, dataSource);
            if (null != g_spamRulesDoc && "EngineSet" != g_spamRulesDoc.documentElement.nodeName) {
                throw new Error(resolveString(pm_st, "__xml_parse_err", [dataSource]));
            }
        }
        catch(e) {
            g_spamRulesDoc = null;
            alert((e.message ? e.message : e));
        }
        return true;
    }
    // Use the default handler
    return false;
}

/**
 * Processes the add rule submission
 * @param pfx the rule prefix, "std" or "net"
 */
function ProcessAddRule(pfx) {
    var formName = pfx + "_add_rule_form";
    var vf = vframeworks[formName];
    if (vf && vf.onsubmit()) {
        var f = document.forms[formName];
        var fieldName = pfx + "_new_name";
        var ruleField = f.elements[fieldName];
        var ruleName = ruleField.value;
        fieldName = pfx + "_new_enabled";
        var cb = f.elements[fieldName];
        var enabled = cb.checked;
        fieldName = pfx + "_new_score";
        var scoreField = f.elements[fieldName];
        var score = parseFloat(scoreField.value);
        AddRule(("net" == pfx), ruleName, enabled, score, networkTestsEnabled);
        ruleField.value = "";
        cb.checked = true;
        scoreField.value = "0";
        ruleField.focus();
    }
}

/**
 * Processes the user checking / unchecking the network tests checkbox
 * @param enabled true if the box is checked, false otherwise.
 */
function ChangeENTState(enabled) {
    // Enabling / disabling network tests affects spam score
    // weighting for standard rules, so that table needs redrawing
    if (document.getElementById(ssrTableId)) {
        var perPage = GetSpamRulesPref("perPage", 25);
        var startIdx = GetSpamRulesPref("stdIdx", 0);
        ShowSpamRules(ssrTableId, false, startIdx, perPage, enabled);
    }
    var disabled = !enabled;
    var fieldName = "EnableRBLTests";
    var e = document.forms[sp_bOptsForm].elements[fieldName];
    if (e)
        e.disabled = disabled;
    // Enable or disable the RBL timeout controls
    if (enabled) {
        enabled = document.forms[sp_bOptsForm].elements[fieldName].checked;
    }
    ChangeRBLTState(enabled);
}

/**
 * Processes the user checking / unchecking the RBL tests checkbox
 * @param formName the name of the form containing the control
 * @param enabled true if the box is checked, false otherwise.
 */
function ChangeRBLTState(enabled) {
    var disabled = !enabled;
    // Enable or disable the timeout control
    var tmOutLbl = document.getElementById("ntRBLTimeoutLbl");
    if (tmOutLbl) {
        var dClass = "disabled";
        var currClass = tmOutLbl.className;
        if (disabled) {
            tmOutLbl.className = addClass(currClass, dClass);
        }
        else {
            tmOutLbl.className = removeClass(currClass, dClass);
        }
    }
    var fieldName = "TimeoutRBLTests";
    var e = document.forms[sp_bOptsForm].elements[fieldName];
    if (e)
        e.disabled = disabled;

    var vframework = vframeworks[sp_bOptsForm];
    if (enabled) {
        vframework.addValidator(fieldName, new RequiredValidator());
        vframework.addValidator(fieldName, new RangeValidator(1, 99));
    }
    else {
        if (!vframework.check(fieldName)) {
            dataBindings[sp_bOptsForm + "_" + fieldName].set(
                new PropertyPath(basePP), spam_pb);
            vframework.onchange(fieldName);
        }
        vframework.clearValidators(fieldName);
    }
}

