/*
 * status_icons.js
 * Class definition for the StatusIcon class.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved.
 */

/**
 * Constructor for the StatusIcon class
 * @param image_id the ID of the image controlled by this object
 * @param status a status indicator ("OK", "SOSO", "NOTOK", "OFF")
 */
function StatusIcon(image_id, status) {
    this.image_id = image_id;
    this.status = status;
}

/**
 * Class method for creating a status icon control
 * @param image_id the ID of the icon in the control.
 */
StatusIcon.makeControl = function(image_id) {
    var html = "<img id=\"" + image_id +
	"\" width=14 height=14 border=0 hspace=5 vspace=3>";
    document.write(html);
}


/**
 * Displays the status icon
 * @param iconMap an Object mapping a status to an image
 */
StatusIcon.prototype.show = function(iconMap) {
    var icon = document.getElementById(this.image_id);
    if (icon && this.status) {
	icon.src = iconMap[this.status];
    }
}

