// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Validators
var vfOnAccess = new ValidationFramework("tieSettingsForm");
var tiesettings = {};

// call this method once the web page completes loading (say, by calling this method in window.onload function callback).
tiesettings.onload = function () {

	this.enablechk = document.getElementById('enablechk');
	this.tietrust = document.getElementById('tietrust');
	this.sendatd = document.getElementById('sendatd');
	this.atdtrust = document.getElementById('atdtrust');
	this.maxfilesize = document.getElementById('maxfilesize');
	this.enablechk.onclick = function () {
		parent.SetModified(true);
	};
	this.tietrust.onchange = function () {
		parent.SetModified(true);
	}
	this.sendatd.onclick = function () {
		parent.SetModified(true);
	};
	this.atdtrust.onchange = function () {
		parent.SetModified(true);
	};
	this.maxfilesize.oninput = this.maxfilesize.onchange = this.maxfilesize.onkeyup = this.maxfilesize.onpaste = function () { //oninput is not enough. this covers all bases.
		parent.SetModified(true);
	};
	
	this.primaryActionControl = document.getElementsByName('pri_actions')[0];
	this.secondaryActionControlMap = { };
	var secondaryActionForm = document.getElementsByName('tieactions_s')[0];
	var controlArray = secondaryActionForm.getElementsByTagName('input');
	for (var i = 0; i < controlArray.length; ++i) {
		var control = controlArray[i];
		this.secondaryActionControlMap[control.value] = control;
	}
}

function Show (pbIn) {

	var nv = new NumericValidator();	
	var sizeRange = new RangeValidator(1, 50000);  //limit the range of ATD file sizes

	vfOnAccess.addValidator("maxfilesize", nv);
	vfOnAccess.addValidator("maxfilesize", sizeRange);
    vfOnAccess.formAction = std_val_form_action;
	vfOnAccess.fieldAction = std_val_field_action;

	var pp = new PropertyPath('TIESettings');
	
	pp.SetTempLeaf('TIEEnabled');
	tiesettings.enablechk.checked = pbIn.GetProperty(pp);
	
	pp.SetTempLeaf('TIEThreshold');
	tiesettings.tietrust.value = Number(pbIn.GetProperty(pp));

	pp.SetTempLeaf('ATDEnabled');
	tiesettings.sendatd.checked = pbIn.GetProperty(pp);
	
	pp.SetTempLeaf('ATDThreshold');
	tiesettings.atdtrust.value = Number(pbIn.GetProperty(pp));
	
	pp.SetTempLeaf('ATDMaxSize');
	tiesettings.maxfilesize.value = parseInt(pbIn.GetProperty(pp), 10); //parseInt strips off the trailing 'MB'
		
	pp.SetTempLeaf('TIEAction');
	var actions = pbIn.GetProperty(pp);

	if (actions.length) {
		var delimPosition = actions.indexOf(',');
		var primaryAction = actions.substr(0, delimPosition === -1 ? undefined : delimPosition);
		tiesettings.primaryActionControl.value = primaryAction;
		while (delimPosition !== -1) {
			var prevPosition = delimPosition;
			delimPosition = actions.indexOf(',', delimPosition + 1);
			var secondaryAction = actions.substr(prevPosition + 1, delimPosition === -1 ? undefined : delimPosition - prevPosition - 1);
			tiesettings.secondaryActionControlMap[secondaryAction].checked = true;
		}
	}
	QtnCheck('tieactions_s'); // defined in Actions.js file
}



function Apply (pbOut) {

	var pp = new PropertyPath('TIESettings');
	pbOut.SetProperty(pp);
	
	pp.SetTempLeaf('TIEEnabled');
	pbOut.SetProperty(pp, tiesettings.enablechk.checked);

	pp.SetTempLeaf('TIEThreshold');
	pbOut.SetProperty(pp, Number(tiesettings.tietrust.value));

	pp.SetTempLeaf('ATDEnabled');
	pbOut.SetProperty(pp, tiesettings.sendatd.checked);

	pp.SetTempLeaf('ATDThreshold');
	pbOut.SetProperty(pp, Number(tiesettings.atdtrust.value));

	var appendMB = tiesettings.maxfilesize.value+"MB"
	pp.SetTempLeaf('ATDMaxSize');	
	pbOut.SetProperty(pp, appendMB);
		
	var actions = tiesettings.primaryActionControl.value;
	for (var controlValue in tiesettings.secondaryActionControlMap) {
		if (tiesettings.secondaryActionControlMap[controlValue].checked) {
			actions += ',' + controlValue;
		}
	}
	pp.SetTempLeaf('TIEAction');
	pbOut.SetProperty(pp, actions);

	parent.SetModified(false);
}

function Validate()
{	
	return(vfOnAccess.onsubmit());
}

