// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Display list of content rules
// Assumes CSRules is included in the master page
//


var gRefList;


//====================================================================================
// Const, globals and Flags
//=====================================================================================

function TimeList_BuildRefList()
{
    var pb = new PropertyBag();
    top.gPB.GetElement("Policies", pb);
    var regexStr="^Policies\\..+\\.(\\w+)PolicySettings(:\\d{8})*$";
    var pattern=new RegExp(regexStr);
    gRefList=pb.GetMatchingPaths(pattern);
}

function TimeList_GetRefCount( id)
{   var found=0;
    var res=gRefList;
    var pb = new PropertyBag();
    top.gPB.GetElement("Policies", pb);

    for(var i=0;i<res.length;i++)
    {    var ppT=new PropertyPath(res[i][0]);
         ppT.SetTempLeaf("RefTimeRestriction");
         var ref=pb.GetPropertyDef(ppT,"T:ALLTHETIME");
         if(ref==id)
         {   found++;
         }
    }
    return found;
}



//table drawing utilities
function TimeList_CreateTable( div_id, id)
{
   var div = document.getElementById(div_id);
   if(div==undefined) return;
   div.innerHTML = "";

   var tbl=document.createElement("table");
   div.appendChild(tbl);
   tbl.width="100%";
   tbl.id=id;
   tbl.border=tbl.cellPadding=tbl.cellSpacing="0";
   tbl.style.width="100%";

   return tbl;
}

function TimeList_CreateTableCell(tbody, width,  text)
{
    var cell=document.createElement("th");
    tbody.appendChild(cell);
    if (width) cell.style.width=width;
    cell.appendChild( document.createTextNode(text) );
    return cell;
}

//initialise the CSRule object that sotres lists of rules in memory
function TimeList_Init(pbIn)
{
    gTimeRestriction = new TimeRestriction(pbIn);
    gTimeRestriction.GetList([]);
    TimeList_BuildRefList();
}

//open CSRule configuration page
function TimeList_LoadTime(create, t_id)
{
    var pp_str="";
    var title= resolveString(cse_pp_st, "__time_slot" );

    var target= 'TimeSettings.html'

    if (create)
    {
		pp_str = gTimeRestriction.GetNextPP();
    }
    else
    {
        pp_str=gTimeRestriction.GetPPFromId(t_id);
	    target += '?id='+t_id;
    }

    var page = new DialogPage(target, title);
    top.gPageStack.Forward(page, pp_str);

}

//draw one rules group table
//SettingsList.prototype.draw = function(links, nameHeader) {
function  TimeList_DrawList(div_id, cat, gr_id, ndx_null)
{
    var lst=gTimeRestriction.list;
    var ndx=0;
    var max_len=5;
    var html="";
    nameHeader = resolveString(cse_pp_st, "__name");

    var linkCount = lst.length;
    var tblId = "trlst";

    var tbl= TimeList_CreateTable( div_id, tblId);
    var thead = document.createElement("thead");
    tbl.appendChild(thead);
    var row=document.createElement("tr");
    thead.appendChild(row);

    //var th=TimeList_CreateTableCell(row, "5%",  "");
    var th=TimeList_CreateTableCell(row, "45%",  nameHeader);
    th=TimeList_CreateTableCell(row, "20%",  resolveString(cse_pp_st, "__timerefcount"));
    th.style.textAlign="center";
    th=TimeList_CreateTableCell(row, "35%",  resolveString(cse_pp_st, "__actions"));

    var tbody = document.createElement("tbody");
    tbl.appendChild(tbody);

    var grp_size=0;

    //display all rules for a group
    for (var i = 0; i < linkCount; i++) {

		//init
        var t_id = lst[i].id;
        var link = lst[i];
        link.refCount= TimeList_GetRefCount(t_id);
        link_refcount=0;
        link.root=TimeList_IsRoot(t_id);
        link.href='javascript:TimeList_LoadTime(false,\''+ t_id +'\')';
        link.delLink='javascript:TimeList_DeleteTime(\''+ t_id +'\')';
        if(link.root)
        {   txt=resolveString(cse_pp_st,"__notapplicable");
        }
        else
        {
		    txt = (link.refCount==1)?resolveString(cse_pp_st,"__one_scanner"):resolveString(cse_pp_st,"__n_scanners",[link.refCount])
        }


        //draw rule row
        row=document.createElement("tr");
        tbody.appendChild(row);

        cell = document.createElement("td");
        row.appendChild(cell);
        cell.appendChild(document.createTextNode(resolveString(cse_pp_st,link.name)));

        cell = document.createElement("td");
        row.appendChild(cell);
        cell.appendChild(document.createTextNode(txt))
        cell.style.textAlign="center";

		if (!((link.root == false) && (link.refCount==0)))
		{
			html = "<a href=\"" + link.href + "\">" + resolveString(cse_pp_st, "__view") + "</a>";
		}
		else
        {
			html = "<a href=\"" + link.href + "\">" + resolveString(cse_pp_st, "__edit") + "</a>";
            html += " | " + "<a href=\"" + link.delLink + "\">" + resolveString(cse_pp_st, "__delete") + "</a>";
        }
        cell = document.createElement("td");
        row.appendChild(cell);
        cell.innerHTML=html;
    }
//apply style
    makeSDL(tblId, true);
}

//Draw list of rules as a list of tables, one table per category
function TimeList_DrawTable(div_id)
{

  var div = document.getElementById(div_id);
  if(div==undefined) return;


  var html="";
  html+='<table border="0" cellpadding="0" cellspacing="0" id="csr_lst" class="shadedTable" style="width:100%;">'
  html+='<tr class="noBottom ">';
  html+='<td class="st bold" nowrap colspan="2">';
  html+=resolveString(cse_pp_st, '__time_slots');
  html+='</td>';
  html+='<td class="st rightAligned"></td></tr>';

  //create row

 var lnk='javascript:TimeList_LoadTime(true, 0)';

 html += '<tr><td class="bordered noLeft" colspan="2" width="88%">';
 html += '<div id="trlst_div" style="padding:5px 10px;"></div>';
 html += '</td>';

 // Create a new instance button
 html += '<td class="bordered noLeft rightAligned" style="padding:10px;" valign="top">';
 html += '<input type="button" class="btnSmall" value="' +
 resolveString(cse_pp_st, "__create_new") +
 '" onclick="' + lnk + '" />';
 html += '</td></tr>';

  html+="</table>"
  div.innerHTML = html;

 //draw list
 TimeList_DrawList("trlst_div",[],"","",0);


}

function TimeList_DeleteTime(t_id )
{

    var res= confirm( resolveString(cse_pp_st,"__del_time_prompt"));
    if(!res) return;

    var pp_str=gTimeRestriction.GetPPFromId( t_id);
    top.SetModified(true);

    gTimeRestriction.time_pb.DeleteElement(pp_str);

    gTimeRestriction.GetList([]);
    TimeList_DrawTable("trListsDiv");

}

function TimeList_IsRoot(t_id)
{
    if(t_id=="T:ALLTHETIME")
    {    return true;
    }
    return false;
}



function TimeList_GrpMember(is_member, t_id, save)
{
    var res=is_member;
    var pp_str=gContentRules.GetPPFromId("RefRule", t_id);
    var ppT = new PropertyPath(pp_str);

    ppT.SetTempLeaf("enabled");

    if(save)
    {
        gContentRules.rules_pb.SetProperty(ppT, is_member?1:0);
        TimeList_DrawTable("csr_lst_div");
    }
    else
    {   res = gContentRules.rules_pb.GetPropertyDef(ppT, is_member);
    }
    return res;
}

//====================================================================================
// Const, globals and Flags
//=====================================================================================
/**
 * Asynchronous data load function
 * //initialise and display list of rules
 */
function TimeList_Show(pbIn)
{   TimeList_Init(pbIn);
    TimeList_DrawTable("trListsDiv");
}

/**
 * Asynchronous data validation function
 */
function TimeList_Validate() {

	return true;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function TimeList_Apply(pbOut)
{
    gTimeRestriction.SaveAll(pbOut);
}

