// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//
var gTimeRestriction;
//days are numbered in this order
var gDaysOrder=["__sunday", "__monday", "__tuesday","__wednesday", "__thursday", "__friday", "__saturday"];


//extract data from local property bag if they are there,
//or use global otherwise
//List= list of items that can go in a combo 9subset of all items)
//max_rank = total nb of items in pb
function TimeRestriction(pbIn)
{
this.list;
this.max_rank=0;
this.pp_str="";

this.name="";
this.days=""
this.start_time="";
this.end_time="";
this.vf=null;

this.time_pb = new PropertyBag();

        if (undefined === pbIn.GetProperty("TimeRestrictions"))
        {
            top.gPB.GetElement("TimeRestrictions", this.time_pb);
        }
        else
        {
            pbIn.GetElement("TimeRestrictions", this.time_pb);
        }
}

//Extract part of a list from property bag
TimeRestriction.prototype.GetList = function(skiparray)
{
    this.list= new Array;
    var time_pp = new PropertyPath("TimeRestrictions.TimeRestriction");
    var the_name="";
    var the_id="";
    var the_rank=0;

    time_pp.BeginEnum();
    while(this.time_pb.GetProperty(time_pp) !== undefined) {
       time_pp.SetTempLeaf("name");
       the_name = this.time_pb.GetProperty(time_pp);
       time_pp.SetTempLeaf("id");
       the_id = this.time_pb.GetProperty(time_pp);
       the_rank++;

       var found=false;
       for (var x=0;x<skiparray.length;x++)
       {   if (skiparray[x]==the_id)
           {  found=true;
              break;
           }
       }

       if (!found)
       {  this.list.push({name:the_name, id:the_id, rank:the_rank});
       }

       time_pp.SetTempLeaf("");
       time_pp.IncrementEnum();

    }
    time_pp.EndEnum();

    this.max_rank=the_rank;
}


//Build strings from the form elements
TimeRestriction.prototype.BuildTimeStrings = function(f)
{
    this.name=f.time_name.value;
    this.days="";
	this.start_time="";
	this.end_time="";

    var elems = f.elements;
    for (var i = 0; i < elems.length; i++)
    {
        var e = elems[i];
        if (e.name.substr(0,5) == "days_" && e.checked) {
            this.days+=e.name.charAt(5);
        }
    }

    if (this.GetHrsSrc(f)!="all")
    {

		this.start_time= f.start_h.options[f.start_h.selectedIndex].value + ":" + f.start_mn.options[f.start_mn.selectedIndex].value;
        this.end_time=f.end_h.options[f.end_h.selectedIndex].value + ":" + f.end_mn.options[f.end_mn.selectedIndex].value;
    }
}

//Check if specified time already exists -
//returns path if it does
//Assumes the time strings have been set up (eg, using BuildTimeString)
TimeRestriction.prototype.TimeClash = function()
{
    var time_pp = new PropertyPath("TimeRestrictions.TimeRestriction");
    var the_days="";
    var the_starttime="";
    var the_endtime="";

    time_pp.BeginEnum();
    while(this.time_pb.GetProperty(time_pp) !== undefined) {
       time_pp.SetTempLeaf("daysofweek");
       the_days = this.time_pb.GetPropertyDef(time_pp,"");
       time_pp.SetTempLeaf("starttime");
       the_starttime = this.time_pb.GetPropertyDef(time_pp,"");
       time_pp.SetTempLeaf("endtime");
       the_endtime = this.time_pb.GetPropertyDef(time_pp,"");
       time_pp.SetTempLeaf("");

       if ( this.days==the_days && this.start_time==the_starttime && this.end_time==the_endtime)
       {    return time_pp;
       }

       time_pp.IncrementEnum();
    }
    time_pp.EndEnum();

    return "";
}

//checks if an item with the same name exists
//returns pp of existing item or ""
TimeRestriction.prototype.NameClash = function(name)
{
    var time_pp = new PropertyPath("TimeRestrictions.TimeRestriction");
    var the_name="";
	name = trim_string(name);

    time_pp.BeginEnum();
    while(this.time_pb.GetProperty(time_pp) !== undefined) {
       time_pp.SetTempLeaf("name");
       the_name = resolveString(cse_pp_st, this.time_pb.GetPropertyDef(time_pp,""));
       the_name = trim_string(the_name);
       time_pp.SetTempLeaf("");
       if ( name==the_name )
       {    return time_pp;
       }

       time_pp.IncrementEnum();
    }
    time_pp.EndEnum();

    return "";
}

//Get property path from the time id
TimeRestriction.prototype.GetNextPP = function()
{
    var pp_str = this.time_pb.GetNextElementEnum("TimeRestrictions.TimeRestriction")
    return pp_str;
}

//Get property path from the time id
TimeRestriction.prototype.GetPPFromId = function(key)
{
    var time_id;
    var name="";
    var time_pp = new PropertyPath("TimeRestrictions.TimeRestriction");
    time_pp.BeginEnum();

    while(this.time_pb.GetProperty(time_pp) !== undefined) {
       time_pp.SetTempLeaf("id");
       time_id = this.time_pb.GetProperty(time_pp);
       if(time_id==key)
       {    time_pp.SetTempLeaf("");
            return time_pp.GetPath();

       }
       time_pp.SetTempLeaf("");
       time_pp.IncrementEnum();
    }

    time_pp.EndEnum();
    return "";
}


//convert time key into a string for the settings combo
TimeRestriction.prototype.GetDisplayName = function(key)
{
    var time_id;
    var name="";
    var time_pp = new PropertyPath("TimeRestrictions.TimeRestriction");
    time_pp.BeginEnum();

    while(this.time_pb.GetProperty(time_pp) !== undefined) {
       time_pp.SetTempLeaf("id");
       time_id = this.time_pb.GetProperty(time_pp);
       if(time_id==key)
       {
           time_pp.SetTempLeaf("name");
           name = this.time_pb.GetProperty(time_pp);
       }
       time_pp.SetTempLeaf("");
       time_pp.IncrementEnum();
    }

    time_pp.EndEnum();

    return resolveString(cse_pp_st, name);

}

//extract time restriction reference from time slot name selection in combo
//if selection is incorrect, the path will not exist and the function returns undefined
// key= property leave
TimeRestriction.prototype.GetSelProperty = function(key)
{
    //get selection from the combo
    var the_combo=document.getElementById("TIME_SEL");
    var sel=the_combo.length;
    var time_pp = new PropertyPath("TimeRestrictions");
    var level_name="TimeRestriction"

    if (the_combo)
    { sel = the_combo.selectedIndex
      if ( sel < this.list.length)
           sel = this.list[sel].rank;
    }

    var str_enum = ""
    if (sel>1)
    {   str_enum = GetPaddedEnum(sel);
        level_name+= ":" + str_enum;
    }

    time_pp.Append(level_name);
    time_pp.SetTempLeaf(key);
    var val = this.time_pb.GetProperty(time_pp);
    time_pp.SetTempLeaf("");
    return val;
}

//called when selection change in time restriction
TimeRestriction.prototype.SelectFromTime = function(the_combo)
{
    top.gPageStack.Active().SetModified(true);
    var sel = the_combo.selectedIndex;
    if (sel>=this.list.length)
    {   //Create a new time period
        return "";
    }
}

//Get whether time is selected from combo or a new time slot
TimeRestriction.prototype.CheckHrsSrc = function( elt )
{
	  var sel_sh = document.getElementById("start_h");
      var sel_smn = document.getElementById("start_mn");
      var sel_eh = document.getElementById("end_h");
      var sel_emn = document.getElementById("end_mn");
      var hide=false;

      if (elt.value == "all")
      {   hide=true;
      }

      sel_sh.disabled=hide;
      sel_smn.disabled=hide;
      sel_eh.disabled=hide;
      sel_emn.disabled=hide;

}

//Draw the combo for time restrictions
TimeRestriction.prototype.DrawTimeCombo = function( label, sel, div_id, add_new, skiparray)
{
    var name;
    var id;
    var dhtml = label ;

    this.GetList(skiparray)

    dhtml += '<select onChange=javascript:gTimeRestriction.SelectFromTime(this) '
    dhtml += ' id=\"TIME_SEL\" >'

    for (var i=0;i<this.list.length;i++)
    {
       if (this.list[i].id==sel) dhtml += "<option selected> "
       else dhtml += "<option>"
       dhtml += ReplaceSpecialHTMLChars(resolveString(cse_pp_st, this.list[i].name));

    }
    if(add_new)
    {  dhtml += "<option> " + '&lt; ' + resolveString(cse_pp_st, "__create_time") + ' &gt;';
    }
    dhtml += "</select>&nbsp;&nbsp;"

    //summary popup
    dhtml+=    '<img src="../../images/icons/info_popup.gif" width="14" height="14" border="0" ';
    dhtml+=        'onmouseover=\" TimeSummaryPop(\'TIME_POP_DIV\', true)\" ' ;
    dhtml+=        'onmouseout =\" TimeSummaryPop(\'TIME_POP_DIV\', false)\" ' ;
    dhtml+=        'style="vertical-align:middle;margin-right:7px" > ';

    //dhtml output
    var div = document.getElementById(div_id);
    if (div) {
    div.innerHTML = dhtml;
    }
}

//Get hours depending on selection of radio buttons
TimeRestriction.prototype.GetHrsSrc = function( f )
{
var ret;

    if (!f)
        return ret;
    var elems = f.elements;
    for (var i = 0; i < elems.length; i++) {
        var e = elems[i];
        if (e.name == "hrs_src" && e.checked) {
            ret = e.value;
            break;
        }
    }
    return ret;
}

//select days depending on string
TimeRestriction.prototype.DrawFormDays = function(f, days_str)
{
    var elems = f.elements;
    for (var i = 0; i < elems.length; i++)
    {
        var e = elems[i];
        if (e.name.substr(0,5) == "days_")
        {
            var day=e.name.charAt(5);
            if(days_str.indexOf(day)<0)
            {  e.checked=false;
            }
            else
            {  e.checked=true;
            }
        }
    }
}

//select days depending on string
TimeRestriction.prototype.DrawFormTime = function(f, start_time_str, end_time_str)
{   var hrs_src="hrs";
    if(start_time_str=="") start_time_str="00:00";
    if(end_time_str=="") end_time_str="23:59";

    if(start_time_str=="00:00" && end_time_str=="23:59")
    {  hrs_src="all"
    }

    //check src
    var elems = f.elements;
    for (var i = 0; i < elems.length; i++) {
        var e = elems[i];
        if (e.name == "hrs_src" && e.value==hrs_src) {
            e.checked=true;
            break;
        }
    }

    //select start time and end time

    if (hrs_src=="hrs")
    {
         var stime=[];
         var etime=[];
         stime[0]=start_time_str.substr(0,2);
         stime[1]=start_time_str.substr(3);
         etime[0]=end_time_str.substr(0,2);
         etime[1]=end_time_str.substr(3);

         f.start_h.disabled=false;
         f.start_mn.disabled=false;
         f.end_h.disabled=false;
         f.end_mn.disabled=false;

         for(var i=0;i<f.start_h.options.length;i++)
         {  if (f.start_h.options[i].value==stime[0]) f.start_h.selectedIndex=i;
         }
         for(var i=0;i<f.start_mn.options.length;i++)
         {  if (f.start_mn.options[i].value==stime[1]) f.start_mn.selectedIndex=i;
         }
         for(var i=0;i<f.end_h.options.length;i++)
         {  if (f.end_h.options[i].value==etime[0]) f.end_h.selectedIndex=i;
         }
         for(var i=0;i<f.end_mn.options.length;i++)
         {  if (f.end_mn.options[i].value==etime[1]) f.end_mn.selectedIndex=i;
         }
    }

}


//Build days string from checkbox selection
TimeRestriction.prototype.ReadFormDays = function(f)
{   var days_str="";
    var elems = f.elements;
    for (var i = 0; i < elems.length; i++)
    {
        var e = elems[i];
        if (e.name.substr(0,5) == "days_" && e.checked) {
            days_str+=e.name.charAt(5);
        }
    }
    return days_str;
}

//Build days string from values in config file for selected time
TimeRestriction.prototype.GetTimeHtmlStr = function()
{	var days= this.GetSelProperty("daysofweek");
    var start_time= this.GetSelProperty("starttime");
	var end_time= this.GetSelProperty("endtime");
    var dhtml = "";

	for(var i=0;i<days.length ; i++)
	{   if(dhtml!="")  dhtml+=", ";
		dhtml+= resolveString(cse_pp_st, gDaysOrder[days.charAt(i)-0]);
	}


    dhtml+="<BR>"

    if (start_time=="" || start_time==undefined)
    {   start_time="00:00"
	}

    if (end_time=="" || end_time==undefined)
    {   end_time="23:59"
	}

    dhtml+=resolveString(cse_pp_st, "__from")
	dhtml+=" "+start_time+" ";
    dhtml+=resolveString(cse_pp_st, "__to")
	dhtml+=" "+end_time;

	return dhtml;
}

//Extract part of a list from property bag
TimeRestriction.prototype.SetFormValues = function(f, pp_str)
{
    var ppT=new PropertyPath(pp_str);
    if (!this.time_pb.GetProperty(pp_str))
    {  this.pp_str=""
        return;
    }
    else
    {   this.pp_str=pp_str;
    }


    ppT.SetTempLeaf("id");
    f.time_uid_value=this.time_pb.GetProperty(ppT);
    ppT.SetTempLeaf("name")
    f.time_name.value=resolveString(cse_pp_st, this.time_pb.GetProperty(ppT));

	if( f.time_uid_value == "T:ALLTHETIME" )
	{
		var inputArray = document.getElementsByTagName('input');
		for(var i=0; i<inputArray.length;i++)
			inputArray[i].disabled = true;
	}
	ppT.SetTempLeaf("daysofweek");
    var days_str=this.time_pb.GetProperty(ppT);
    this.DrawFormDays(f, days_str);
    ppT.SetTempLeaf("starttime");
    var stime=this.time_pb.GetPropertyDef(ppT,"");
    ppT.SetTempLeaf("endtime");
    var etime=this.time_pb.GetPropertyDef(ppT,"");
    ppT.SetTempLeaf("");
    this.DrawFormTime(f, stime, etime);
}

//initialise form amd associated validationframework
//param:
//f=the form, vf = array of validators for the page,
//flag=flag allowing to chose validators
TimeRestriction.prototype.Init= function(f, vf, flag_null)
{   this.vf=vf;
    var reqV=new RequiredValidator();
    var lenV=new LengthValidator();
    //var scriptV = new ScriptValidator();
	var scriptV = new InputTextValidator();
    var tnv = new TimeNameValidator( this );
	var tdv = new TimeDaysValidator( this );
	var thv = new TimeHrsValidator( this );
    this.vf.addLabeledValidator("time_name", resolveString (cse_pp_field_st,"__TimeSlotName"), reqV);
    this.vf.addLabeledValidator("time_name",  resolveString (cse_pp_field_st,"__TimeSlotName"), tnv);
    this.vf.addLabeledValidator("time_name",  resolveString (cse_pp_field_st,"__TimeSlotName"), lenV);
    this.vf.addLabeledValidator("time_name",  resolveString (cse_pp_field_st,"__TimeSlotName"), scriptV);

    this.vf.addLabeledValidator("days_0", resolveString (cse_pp_field_st,"__TimeSlotDays"), tdv);
	this.vf.addLabeledValidator("start_h",  resolveString (cse_pp_field_st,"__TimeSlotHrs"), thv);
}


//Save the time information
//Assumes the time strings are already built (eg, using BuildTimeString)
//parameter
//pbOut: property bag to save time slot
//pp_str: property path where time slot is saved, null if new
TimeRestriction.prototype.SaveTimeSlot = function(pbOut, pp_str)
{
    var t_id="";

	if (pp_str=="")
	{
        pp_str=this.GetNextPP();
		t_id=MakeGuid("T")
	}
    else
    {   var ppT=new PropertyPath(pp_str);
        ppT.SetTempLeaf("id");
        t_id = this.time_pb.GetProperty(ppT);

        //remove any existing start time and end time
        ppT.SetTempLeaf("starttime");
        this.time_pb.DeleteElement(ppT.GetPath());
        ppT.SetTempLeaf("endtime");
        this.time_pb.DeleteElement(ppT.GetPath());
        ppT.SetTempLeaf("");
    }

	var ppT=new PropertyPath(pp_str);
    this.time_pb.SetProperty(ppT);
    ppT.SetTempLeaf("id");
    this.time_pb.SetProperty(ppT, t_id);
    ppT.SetTempLeaf("name")
    this.time_pb.SetProperty(ppT, this.name);
    ppT.SetTempLeaf("daysofweek");
    this.time_pb.SetProperty(ppT, this.days);
    ppT.SetTempLeaf("starttime");
    if(this.start_time.length>0)
    {   this.time_pb.SetProperty(ppT, this.start_time);
    }
    ppT.SetTempLeaf("endtime");
    if(this.start_time.length>0)
    {  this.time_pb.SetProperty(ppT, this.end_time);
    }

	//create the new element
	this.CopyPb(this.time_pb, pbOut);
    return t_id;
}

//======================================================================
// Time restriction field validators
//======================================================================

//ctr
//param : tr is a TimeRestriction Object
function TimeNameValidator(tr) {
    this.name = "TimeNameValidator";
	this.msg="";
	this.tr = tr;
}

// Validate method - returns true if the value does not clash
//with any other existing name, false otherwise
//does not check for empty string, need required validator for this
TimeNameValidator.prototype.validate = function(val_null) {
var pp1;
var pp2;
var value = this.tr.name;

    if ( (!value) || value=="" )  return true;

	pp1=gTimeRestriction.NameClash(value);

	if(pp1!="" && pp1!=this.tr.pp_str)
    {
	    this.msg=vfr_resolveString("name_clash");
		return false;
	}
	return true;
}

//Returns a error message
TimeNameValidator.prototype.errorMessage = function() {
    return this.msg;
}

//======================================================================
//validator for days slot
// tr is a TimeRestriction object
function TimeDaysValidator(tr) {
    this.name = "TimeDaysValidator";
	this.msg="";
	this.tr = tr;
}

// Validate method
TimeDaysValidator.prototype.validate = function(value) {
    if (this.tr.days=="")
    {   this.msg= resolveString(cse_pp_vf_st, "__invalid_days");
        return false;
    }

    return true;
}

//Returns a error message
TimeDaysValidator.prototype.errorMessage = function() {
    return this.msg;
}


//======================================================================
//validator for hours slot
// tr is a TimeRestriction object
function TimeHrsValidator(tr) {
    this.name = "TimeHrsValidator";
	this.msg="";
	this.tr = tr;
}

// Validate method
TimeHrsValidator.prototype.validate = function(value) {

    if ( this.tr.start_time=="" &&  this.tr.end_time=="")
		 return true;

	var start=this.tr.start_time;
	var end=this.tr.end_time;
	a=start.split(":")
    start=a[0]+a[1];
	b=end.split(":")
    end=b[0]+b[1];

	if (start>=end)
	{   this.msg= resolveString(cse_pp_vf_st, "__invalid_hours");
		return false
	}

	return true;
}

//Returns a error message
TimeHrsValidator.prototype.errorMessage = function() {
    return this.msg;
}


/*===============================================
   hide/show summary popup
  ===============================================
*/
var t_mouseX = 0;
var t_mouseY = 0;

function t_mouseTrack(e) {
		if (e) {
			t_mouseX = e.pageX;
			t_mouseY = e.pageY;
		} else {
			if (event) {
				t_mouseX = event.x;
				t_mouseY = event.y;
			}
		}
}

document.onmousemove=t_mouseTrack;

function TimeSummaryPop(layerKey, onState) {
		dhtmlSummary = document.getElementById(layerKey);

		if(!dhtmlSummary)
	    {
		   return;
	    }

        var txt=gTimeRestriction.GetTimeHtmlStr();
		var t_name=resolveString(cse_pp_st, gTimeRestriction.GetSelProperty("name"));

        var dhtml='<table border="0" cellspacing="0" cellpadding="0" class="dhtmlSummary">'
        dhtml+='<tr class="titleRow"><td>'
		dhtml+= ReplaceSpecialHTMLChars(t_name);
		dhtml+='</td></tr>'
        dhtml+='<tr class="dataRow firstRow lastRow">'
        dhtml+='<td class="eor">' + txt + '<BR>'
        dhtml+='</td>'
        dhtml+='</tr>'
        dhtml+='</table>';
        dhtmlSummary.innerHTML = dhtml;

		dhtmlSummary.style.display = (onState) ? "block" : "none";
		if (onState) {
			dhtmlSummary.style.left = (t_mouseX-100) + "px";
			dhtmlSummary.style.top = (t_mouseY+2) + "px";
		}
}


//deep copy of the time restriction items in pbOut
TimeRestriction.prototype.CopyPb = function(pbIn, pbOut)
{
	if (pbIn != pbOut)
	{   var pp_str = "TimeRestrictions";
        pbOut.DeleteElement(pp_str);
		pbIn.GetElement(pp_str,pbOut);
	}
}

//Save all time restrictions in pbOut
TimeRestriction.prototype.SaveAll = function(pbOut)
{
    this.CopyPb(this.time_pb, pbOut);
}
