//
//Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//

// Exchange address format validator
function ValidateDominoAddress(address)
{
	var cannonicalRegEx = /^CN=.+\/(OU=.+\/)?O=.+(\/C=.+)?/i
	var abbreviatedRegEx = /^.+(?=\/)\/.+/
	var result = address.match(cannonicalRegEx)
	if( result == null ) {
		if( address.search(/^CN=/i) == -1 && 
			address.search(/\/OU=/i) == -1 && 
			address.search(/\/O=/i) == -1 &&
			address.search(/\/C=/i) == -1 && !IsEmpty(address) ) {
			result = address.match(abbreviatedRegEx)
		}
	}
	return result
}
//////////////////////////////////////////////////////////////
//
// Validate email address with wild cards
//
function ValidEmail1(address, verbose)
{
	var invalid = false;
	if (null == verbose)
        verbose = true;
	// Check for invalid characters
	if (address.indexOf(';') != -1  ||
	    address.indexOf(',') != -1  ||
	    address.length == 0 	||
	    address.indexOf('@') == -1)
	{
		errValue+="\n"+address+"\n"+misUsageAlert+"\n"
		invalid = true;
	}
	if (!invalid) {
        if (IsDuplicate1(address ,'@'))
        {
			errValue+="\n"+address+"\n"+moreThanOnceAlert+"\n"
			invalid = true;
        }
    }
    if (!invalid) {
        // Check for something before and after the @
        var at1 = address.indexOf('@')
        if (at1 == 0 || at1 == address.length-1)
        {
            invalid = true;
        }
    }
	if (!invalid) {
        // Check for presence of . at start and end point
		var at2 = address.lastIndexOf('.')
        if (at2 == 0 || at2 == address.length-1)
        {
			errValue+="\n"+address+"\n"+appropriateAlert+"\n"
            invalid = true;
        }
		

    }
	if (!invalid) {
        // Check for the space before @ symbol
        var at1 = address.indexOf(' ')
        if (at1 > 0 && at1 < address.indexOf('@'))
        {
			errValue+="\n"+address+"\n"+spaceAlert+"\n"
			invalid = true;
     
        }
    }
	 if (!invalid) {
        // Check whether domain name included in quotes or not 
        var at1 = address.indexOf('@')
        if (address[at1+1] == '"' || address[address.length-1]=='"')
        {
			errValue+="\n"+address+"\n"+quoteAlert+"\n"
            invalid = true;
        }
    }
	if (!invalid) {
        // Check for special characters in Domain Name
		var flag=0
		var at1=address.indexOf('@')
		if(address.indexOf('$',at1)>at1 || address.indexOf('?',at1)>at1 || address.indexOf('`',at1)>at1 || address.indexOf('~',at1)>at1 || address.indexOf('&',at1)>at1 || address.indexOf('%',at1)>at1 || address.indexOf('^',at1)>at1 || address.indexOf('#',at1)>at1 || address.indexOf('!',at1)>at1 || address.indexOf('|',at1)>at1 || address.indexOf('*',at1)>at1)
				flag=1
        if (flag==1)
        {
			errValue+="\n"+address+"\n"+specialCharAlert+"\n"
            invalid = true;
        }
	}
   if (invalid && verbose)
        alert(gsInvalidEmail);
	return !invalid;
}

function IsDuplicate1(strIn , item2)
{
	var icount =0;
	for(var i = 0; i < strIn.length; i++)
	{
		if (strIn.charAt(i)== item2 )
		{	
			i++;
			icount++;
		}
	}
	if (icount > 1) return true;
	
	return false 
	
}


// Picker
var gPickerEntries = new Object();
gPickerEntries["g"] = null
gPickerEntries["s"] = null

var gPickerName = new Object();
gPickerName["g"] = "GroupPicker"
gPickerName["s"] = "ServerPicker"

function OnChangeOfPickerList()
{
	document.getElementById(K_IPK_CTL).value = document.getElementById("IPK_CTL_LIST").value
}

function DrawPickerList(tplType)
{
   // Create select object
   var ctl= document.createElement("select");
   ctl.className = "textField"; 
   ctl.size=10;
   ctl.id = "IPK_CTL_LIST";
   ctl.style.verticalAlign="text-top";
   ctl.onchange = OnChangeOfPickerList;

   var div = document.getElementById(K_IPK_DIV);
   if(div){
     div.innerHTML = "";
	 div.appendChild(DrawPickerInput())
   }

   if( gPickerEntries[tplType] == null ) {
	 gPickerEntries[tplType] = new Array()
	 top.hiddenFrame.location.href = GetDynamicPageUrl( gPickerName[tplType] );
   } else {

	   for( var i = 0; i < gPickerEntries[tplType].length; ++i ) {
			var serverList = document.createElement("option")
			if( !IsEmpty( gPickerEntries[tplType][i] ) ) {
				serverList.value = gPickerEntries[tplType][i];
				serverList.appendChild(document.createTextNode(gPickerEntries[tplType][i]));
				ctl.appendChild(serverList)
			}
	   }
   }
   return ctl;
}

function DrawPickerInput()
{
	var ctl= document.createElement("input");
	ctl.type = "text";
	ctl.className = "textField";
	ctl.id = K_IPK_CTL;
	return ctl;
}

// Validator clases for all type of Picker

// Server picker
function sPicker(){}
sPicker.prototype = new DefaultPicker
sPicker.prototype.constructor = sPicker
sPicker.prototype.Draw=function() {
	return DrawPickerList("s")
}
sPicker.prototype.Validate=function(){
	if( ValidateDominoAddress(this.Selection()[0]) == null ) {
		alert(gsDominoServerName)
		return false
	}
	return true
}
sPicker.prototype.AddPickerEntries=function( tplType, list ){
	for( var i = 0; i < list.length; ++i )
		gPickerEntries[tplType][i] = list[i]

    var div = document.getElementById(K_IPK_DIV);
	if(div)	{
		div.appendChild(this.Draw())
	}
}

// Group picker
function gPicker(){}
gPicker.prototype = new DefaultPicker
gPicker.prototype.constructor = gPicker
gPicker.prototype.Draw=function(){
	return DrawPickerList("g")
}
gPicker.prototype.Validate=function(){
	if( IsEmpty(this.Selection()[0]) ) {
		alert(gsDominoGroup)
		return false
	}
	return true
}
gPicker.prototype.AddPickerEntries=function( tplType, list ){
	for( var i = 0; i < list.length; ++i )
		gPickerEntries[tplType][i] = list[i]

    var div = document.getElementById(K_IPK_DIV);
	if(div)	{
		div.appendChild(this.Draw())
	}
}

// Email address picker(Sender & Recepients)
function mPicker(){}
mPicker.prototype = new DefaultPicker
mPicker.prototype.constructor = mPicker
mPicker.prototype.Validate=function(){
	errValue=gsInvalidEmail
	if( (ValidateDominoAddress(this.Selection()[0]) == null) && !ValidEmail1(this.Selection()[0], false) ){
		alert(errValue)
		return false
	}
	return true
}

// Folder picker
function hPicker(){}
hPicker.prototype = new DefaultPicker
hPicker.prototype.constructor = hPicker
hPicker.prototype.Validate=function(){
	if( IsEmpty(this.Selection()[0]) ) {
		alert(gsDominoDB)
		return false
	}
	return true
}

// Database picker
function dPicker(){}
dPicker.prototype = new DefaultPicker
dPicker.prototype.constructor = dPicker
dPicker.prototype.Validate=function(){
	if( IsEmpty(this.Selection()[0]) ) {
		alert(gsDominoDB)
		return false
	}
	return true
}
