var calendarMonth = -1;
var calendarYear = -1;
var minYear = 2004;
var maxYear = 2020;
var currentMonth = -1;
var currentYear = -1;
var selectedMonth = -1;
var selectedDate = -1;
var selectedYear = -1;
var gElementsToShow 
var startingBox = -1;
var gIdRoot = ""

////////////////////////////////////////////////////////////
//
// Initalize datatime controls using given date
//
function InitDTControls(idRoot, date)
{
	// Min
	var ctrl = document.getElementById(idRoot+"Min")
	var mins = date.getMinutes()
	for (var i =1; i <= 59; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(FormatNum(i,2))
		opt.appendChild(name)
		if (i==mins)
			opt.selected=true
		ctrl.appendChild(opt)	
	}

	// Hour
	var ctrl = document.getElementById(idRoot+"Hour")
	var hour = date.getHours()
	for (var i =1; i <= 23; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(FormatNum(i,2))
		opt.appendChild(name)
		if (i==hour)
			opt.selected=true
		ctrl.appendChild(opt)	
	}

	// Day
	var month = date.getMonth()
	var year = date.getFullYear()
	var numDays = getMonthLength(month+1,year)
	var ctrl = document.getElementById(idRoot+"Day")
	var day = date.getDate()
	for (var i =2; i <= numDays; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		if (i==day)
			opt.selected=true
		ctrl.appendChild(opt)	
	}
		
	// Month
	var ctrl = document.getElementById(idRoot+"Month")
	ctrl.selectedIndex = month 
	
	// Year
	var ctrl = document.getElementById(idRoot+"Year")
	for (var i =2005; i < 2021; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		if (i==year)
			opt.selected=true
		ctrl.appendChild(opt)
	}
}

//////////////////////////////////////////////////////////
//
// Updates days in month on month change
//
function OnMonthChange(idRoot, selectedDay)
{
	if (typeof selectedDay == "undefined") {
		selectedDay = document.getElementById(idRoot+"Day").selectedIndex
	}
	var month= document.getElementById(idRoot+"Month").selectedIndex
	var year= document.getElementById(idRoot+"Year").selectedIndex
	
	var numDays = getMonthLength(month+1,year+2004)
	var ctrl = document.getElementById(idRoot+"Day")
	while (ctrl.childNodes.length > 0)
	{
		ctrl.removeChild(ctrl.childNodes[0])
	}

	for (var i =1; i <= numDays; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		ctrl.appendChild(opt)
		if (i == selectedDay+1)
		    opt.selected=true
	}	
}

////////////////////////////////////////////////
//
// Switches betweem all and date range
// 


////////////////////////////////////////////////
//
// Writes give date value into controls
// 
//
function ToControls(idRoot,dt,doTime)
{
	document.getElementById(idRoot+"Year").selectedIndex  = dt.getFullYear()-2004
	document.getElementById(idRoot+"Month").selectedIndex = dt.getMonth()
	OnMonthChange(idRoot, dt.getDate()-1)
	if (doTime != McUndefined)
	{
		document.getElementById(idRoot+"Hour").selectedIndex = dt.getHours()	
		document.getElementById(idRoot+"Min").selectedIndex = dt.getMinutes()	
	}
}

////////////////////////////////////////////////
//
// Writes give date value into controls
// 
function EnableControls(idRoot,enable)
{
	EnableControl(idRoot+"Day",enable)
	EnableControl(idRoot+"Month",enable)
	EnableControl(idRoot+"Year",enable)
	EnableControl(idRoot+"Hour",enable)	
	EnableControl(idRoot+"Min",enable)
}

////////////////////////////////////////////////
//
// Retrieves value from dt controls
// and returns as a Date object
//
function FromControls(idRoot)
{
	if (idRoot==McUndefined)
		idRoot = gIdRoot
	var dt = new Date()
	dt.setDate(document.getElementById(idRoot+"Day").selectedIndex+1)
	dt.setMonth(document.getElementById(idRoot+"Month").selectedIndex)
	dt.setFullYear(document.getElementById(idRoot+"Year").selectedIndex+2004)		
	dt.setHours(document.getElementById(idRoot+"Hour").selectedIndex)
	dt.setMinutes(document.getElementById(idRoot+"Min").selectedIndex)
	dt.setSeconds( 0 )
	return dt
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
// Open calendar control
//
function openCalendar(caption, idRoot,elementIdsToHide) {

	for (x=0;x<elementIdsToHide.length;x++)
		document.getElementById(elementIdsToHide[x]).style.visibility="hidden";
	gElementsToShow = elementIdsToHide
	document.getElementById("caption").innerHTML = caption;
	gIdRoot = idRoot
	dateToPopulate = FromControls(gIdRoot)
	selectedMonth = parseInt(dateToPopulate.getMonth());
	selectedDate = parseInt(dateToPopulate.getDate());
	selectedYear = parseInt(dateToPopulate.getYear());
	if (selectedYear<1900) 
		selectedYear += 1900;
	populateCalendar(parseInt(dateToPopulate.getMonth())+1, selectedYear);
	
	document.getElementById("calendarDiv").style.display = "block";	
	document.getElementById("calendarDiv").style.right = "150px";
	yearSelector();
	
	// Stops Firefox centering the controls on a button press
	document.getElementById("Table7").style.display = "block"	


}

////////////////////////////////////////////////////////////////////////////////////////////////
//
// determine monthLength
//
function getMonthLength(cMonth,cYear)
{
	if (cMonth==1 || cMonth==3 || cMonth==5 || cMonth==7 || cMonth==8 || cMonth==10 || cMonth==12)
		monthLength = 31
	else
		if (cMonth==4 || cMonth==6 || cMonth==9 || cMonth==11)
			monthLength = 30
		else
			if (cYear % 100 == 0)
				monthLength = (cyear % 400 == 0) ? 29 : 28
			else
				if (cYear % 4 == 0)
					monthLength = 29
				else
					monthLength = 28;

       return monthLength
}

////////////////////////////////////////////////////////////////////////////////////////////////
//
// Render a calendar month
//
function populateCalendar(cMonth, cYear)
{
	currentMonth = cMonth;
	currentYear = cYear;
	firstDate = new Date(cYear, cMonth-1, 1);
	
	// determine starting day of the week
	startingBox = parseInt(firstDate.getDay()) + 1;
	monthLength = getMonthLength(cMonth,cYear)
	
	// fill grid
	for (x=1; x<=42; x++) {
		if (x<startingBox || (x-startingBox+1)>monthLength) 
			value = "&nbsp;"
		else
			value = x - startingBox + 1;
			
		document.getElementById("grid"+x).innerHTML = (value=="&nbsp;") ? value : "<a href=\"javascript:selectDate(new Date(" + cYear + ", " + (cMonth-1) + ", " + (x-startingBox+1) + "));\">" + value + "</a>";
	}

	// set monthName label
	document.getElementById("monthName").innerHTML = strMOnths[cMonth-1];

	// set year select box
	for (x=0; x<document.forms["calendar"].year.length; x++)
		if (document.forms["calendar"].year[x].value == cYear)
			document.forms["calendar"].year.selectedIndex = x;
		
	// set previous and next month links
	if (cMonth==1) {
		previousMonth = 12; previousYear = cYear-1;
	} else {
		previousMonth = cMonth-1; previousYear = cYear;
	}

	if (cMonth==12) {
		nextMonth = 1; nextYear = cYear+1;
	} else {
		nextMonth = cMonth+1; nextYear = cYear;
	}

	document.getElementById("previousMonthLink").href = (previousYear >= minYear) ? "javascript:populateCalendar(" + previousMonth + ", " + previousYear + ");" : "javascript://";
	document.getElementById("nextMonthLink").href = (nextYear <= maxYear) ?"javascript:populateCalendar(" + nextMonth + ", " + nextYear + ");" : "javascript://";

	// refreshes highlight
	selectDate(new Date(selectedYear, selectedMonth, selectedDate), 0);
	
}

function yearSelector() {
	populateCalendar(currentMonth, document.forms["calendar"].year[document.forms["calendar"].year.selectedIndex].value);
}

function selectDate(selectedDateValue) {
	selectedDate = parseInt(selectedDateValue.getDate());
	selectedMonth = parseInt(selectedDateValue.getMonth());
	selectedYear = parseInt(selectedDateValue.getYear());
	if (selectedYear<1900)
		selectedYear += 1900;
	gridId = startingBox + parseInt(selectedDateValue.getDate()) - 1;
	
	for (x=1; x<=42; x++) {
		if (x % 7 == 1)
			className = "sunday"
		else
			if (x % 7 == 0)
				className = "saturday"
			else
				className = "weekday";
		if (gridId==x && (selectedMonth==currentMonth-1) && selectedYear==currentYear)
			className = className + " selected";
		document.getElementById("grid"+x).className = className;
	}
}

function dateOK() 
{
	finalDate = new Date(Date.parse(currentMonth + "/" + selectedDate + "/" + currentYear));
	finalDateYear = parseInt(finalDate.getYear());
	if (finalDateYear<1900)
		finalDateYear += 1900;
	ToControls(gIdRoot,finalDate)
	document.getElementById("calendarDiv").style.display = "none";
	for (x=0;x<gElementsToShow .length;x++)
		document.getElementById(gElementsToShow [x]).style.visibility="visible";
}

function dateCancel() 
{
	document.getElementById("calendarDiv").style.display = "none";
	for (x=0;x<gElementsToShow.length;x++)
		document.getElementById(gElementsToShow [x]).style.visibility="visible";
}