//
// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//
var gIsePO35 = false
var vfOnAccess		= new ValidationFramework("odreportsettings_form");

function StatusReportTaskPage()
{
	// Initialize member functions
	this.Show = Show
	this.Validate = Validate
	this.Apply = Apply
	this.EnableDisable = EnableDisable
	this.InheritUninherit = InheritUninherit
	this.ReportType1 = ReportType1;
	this.ReportType2 = ReportType2;

	// Initialize member data
	this.bEnabled = true
}

////////////////////////////////////////////////
//
// Enables or disables all controls on the page
//
function EnableDisable(bEnable)
{
	EnableControl("McNameRecipient", bEnable)
	EnableControl("McNameSubjectLine", bEnable)
	EnableControl("idNumRowsType", bEnable)	
	document.getElementById("McidStatusReportCSV").disabled = !bEnable
	document.getElementById("McidStatusReportHTML").disabled = !bEnable
}

function InheritUninherit()
{
	EnableDisable(!document.getElementById("inherit").checked)
}

function AddNumericOnlyValidation()
{
var fn =  cb_numOnlyNN;
document.getElementById("McidNumRows").onkeypress	= fn;
}


////////////////////////////////////////////////
//
// Writes current config settings into controls 
function Show()
{
// Load current settings
	AddNumericOnlyValidation();
	var ps = new PropertySource(true)
	var pb = new PropertyBag()
	ps.Get(pb, new Array("ePOTask"))
	var pp = new PropertyPath("ePOTask")
	pp.Append("What.Report")

	// Set all the report settings from DB
	// Set Recipient
	pp.SetTempLeaf("Recipient")
	document.getElementById("McIdRecipient").value = pb.GetProperty(pp.GetPath())
	pp.SetTempLeaf("")

	// Set subject	
	pp.SetTempLeaf("Subject")
	document.getElementById("McIdSubjectLine").value = pb.GetProperty(pp.GetPath())
	pp.SetTempLeaf("")
	
	// Set NumRows
	pp.SetTempLeaf("NumRows")
	document.getElementById("McidNumRows").value = pb.GetProperty(pp.GetPath())

	// Set CSV or HTML
	var isCSV  = true;
	var isHTML = false;
	pp.SetTempLeaf("")
	pp.SetTempLeaf("REPORT_CSV")
	 
	if( pb.GetProperty(pp.GetPath()) == "1" )
	{
		isCSV  = true;  // CSV Report
		isHTML = false;	
	}
	else
	{
		isCSV = false; // HTML Report
		isHTML = true;
	}

	document.getElementById("McidStatusReportHTML").checked = isHTML ; 
	document.getElementById("McidStatusReportCSV").checked = isCSV ;

	// Apply inherit state
	var bInherit = window.external.schedule_value_bool("ePOTask", "Inherit")
	document.getElementById("inherit").checked = bInherit
	EnableDisable(!bInherit)
}

function ReportType1()
{
	document.getElementById("McidStatusReportHTML").checked = false; 
	document.getElementById("McidStatusReportCSV").checked = true;
}

function ReportType2()
{
	document.getElementById("McidStatusReportHTML").checked = true; 
	document.getElementById("McidStatusReportCSV").checked = false;
}

////////////////////////////////////////////////
// 
// Validates values in controls before applying
//
function Validate()
{
	// Return false if any controls contain values which are invalid
	var recipient = document.getElementById("McIdRecipient").value
	var rx1 = /^.+\@.+\..+/

	if(recipient == "" || !recipient.match(rx1) )
	{
		alert(gsInvalidEmail)
		document.getElementById("McIdRecipient").focus()
		return false
	}

	var subject = document.getElementById("McIdSubjectLine").value
	if(subject == "")
	{
		alert(gsEnterSubject)
		document.getElementById("McIdSubjectLine").focus()
		return false
	}
	
	var numRows = toInteger(document.getElementById("McidNumRows").value)
	if( numRows <=0 || numRows > 365 )
	{
		var invalidNumRows = formatString(strRange, new Array(1,365));
		var errmsg = vfr_st["bad_form_one_error"]+ "\n" + "- " + gsErrNumDays + ": " + invalidNumRows + "\n" + vfr_st["one_error_resubmit"]; 
		document.getElementById("McidNumRows").focus()
		alert ( errmsg );
		return false; //num of rows invalid.	     
	}

	// Return success
	return true
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function Apply()
{
	// Set basic settings	
	var path = new PropertyPath("ePOTask")
	var pb = new PropertyBag()

	// Set task type
	pb.SetProperty(path)
	path.SetTempLeaf("What")
	pb.SetProperty(path) 
	path.SetTempLeaf("Type")
	pb.SetProperty(path,"StatusReportTask")
	path.SetTempLeaf("What.Report")
	pb.SetProperty(path)
	path.SetTempLeaf("Name")
	pb.SetProperty(path,"StatusReport Task")
	path.SetTempLeaf("")

	path.Append("What.Report")

	// Set recipient
	var recipient = document.getElementById("McIdRecipient").value
	path.SetTempLeaf("Recipient")
	pb.SetProperty(path.GetPath(), recipient)
	path.SetTempLeaf("")
	// Set subject
	var subject = document.getElementById("McIdSubjectLine").value
	path.SetTempLeaf("Subject")
	pb.SetProperty(path.GetPath(), subject)
	path.SetTempLeaf("")
	// Set NumRows
	var numRows = document.getElementById("McidNumRows").value
	path.SetTempLeaf("NumRows")
	pb.SetProperty(path.GetPath(), numRows)
	path.SetTempLeaf("")		
	// Set CSV Type into XML and into Cookie
	var reportCSV;
	if (document.getElementById("McidStatusReportCSV").checked)
		 reportCSV	 = true;
	else
		 reportCSV   = false;
		
	path.SetTempLeaf("REPORT_CSV")
	pb.SetProperty(path.GetPath(), reportCSV)
	path.SetTempLeaf("")

	var ps = new PropertySource(true)
	ps.Put(pb,document.getElementById("inherit").checked)
}