//Copyright (C) 2009 McAfee, Inc.  All rights reserved.
////////////////////////////////
//
// Constructor for picker tree
// class
//
function Picker(delimiter)
{
	// Member data
	this.delimiter = delimiter
	this.selected = new Array
	this.bEnabled = true

	// Member functions
	this.SetRoot = SetRoot
	this.GetPath = PickerGetPath
	this.Find = Find
	this.Show = ShowPicker
	this.DoSelect = DoSelect
	this.Enable = Enable
	this.RemoveSelection = RemoveSelection
}
function SetRoot(rootName, bHasChildren)
{
	this.root = new Node(rootName,"0",McUndefined,bHasChildren)
	return this.root
}


///////////////////////////////////
//
// Enables/disables the clicking
// of nodes on the tree
//
function Enable(bEnable)
{
	this.bEnabled = bEnable
}

///////////////////////////////////
//
// Makes node represented by
// the given id, the current
// selection
//
function SelectNode(e)
{
	var ctrl=window.event?window.event.ctrlKey:e.ctrlKey;
	var target=window.event?window.event.srcElement:e.target;
	gP.DoSelect(target.idRaw,ctrl);
	return false;
}
function DoSelect(id,bMultiple)
{

	// Do nothing if not enabled
	if (!this.bEnabled)
		return

	// Stop selection of root node
	var ns = this.Find(id)
	if (ns.parent == McUndefined)
		return

	// Select new node
	if (!bMultiple)
	{
		this.RemoveSelection()
	}
	if (this.selected[ns.id])
	{
		document.getElementById("n_" + id).className = "nodeLabel";
		delete this.selected[ns.id];
	}
	else
	{
		document.getElementById("n_" + id).className = "nodeLabelSelected";
		this.selected[ns.id]=ns;
	}
}

///////////////////////////////////
//
// Builds full path represented by
// selected node
//
function PickerGetPath(node)
{
	var path = ""
	if (node == McUndefined)
		node = this.selected
	var levels = node.id.split("_")
	var n = this.root
	for (var i = 1; i < levels.length; i++)
	{
		n = n.children[levels[i]]
		path += n.name + this.delimiter
	}
	return path
}

///////////////////////////////////
//
// Finds node object within tree
// structure using its id
//
function Find(id)
{
	var levels = id.split("_")
	var n = this.root
	for (var i = 1; i < levels.length; i++)
		n = n.children[levels[i]]
	return n
}

///////////////////////////////////
//
// Shows picker
//
function ShowPicker()
{
	var picker= document.getElementById("picker")
	var nn= this.root.Render(0)
	picker.appendChild(nn)
}

/////////////////////////////////////
//
// Remove all current selections
//
function RemoveSelection()
{
	for (var sel in this.selected)
	{
		var elem = document.getElementById("n_" + sel)
		if (elem != McUndefined)
			elem.className = "nodeLabel"
	}
	this.selected = new Array;
}

